
class CherenkovBuffer {
private:
  int iStart;  // where to pick the first sample in eventòf
  int spillNumber;// spill# in Run, set prior to calling of the GetSpillFIle
  double *CherenkovTime;
  double dT;
  double CherenkovMax;
  double CherenkovMin;
  double MaxCycle; // maximum Cherenkov Sum within single accelerator cycle (5us)e
  double MinCycle; // minimum Cherenkov Sum within single accelerator       (5us)
  bool   CherenkovRunAvailable;
  bool   CherenkovSpillAvailable;
  bool   CherenkovEventAvailable;
  bool   CherenkovQualityAvailable;
  bool   slopesLoaded;
  bool   Dbg;
  double PSall;
  double CherenkovFactor;
  double HVcorrection; // Gated ADC -> Tracks
  double HVspill;
  int eventsAccepted;
  bool filledSample[30];
  bool filledSampleD[30];
  double filledSum[30];
  double filledWgh[30];
  double filledSum1Tail[30];
  double filledSum2Tail[30];
  double filledWghTail[30];
  double filledSum1TailEvt[30];
  double filledSum2TailEvt[30];
  double filledWghTailEvt[30];

  std::vector<int>    spillNum;
  std::vector<int>    eventGADC;
  std::vector<int>    sampleGADC;
  std::vector<int>    sampleRATE;
  std::vector<double> sampleMEAN;
  std::vector<double> sampleRMS;
  
  double filledAvr100[3000]; // 30x100 slices of spill to monitor the quality
  double filledRMS100[3000]; // 30x100 slices of spill to monitor the quality
  double filledWgh100[3000]; // 30x100 slices of spill to monitor the quality
  bool   filledOK_100[100];  // 100 slices of the sample
  int    signalFound[100];   // how many samples out of 30 got signal
  int    firstOf100, lastOf100; // slices has signal
  double EmptyRMS; // spread of empty bunches in the event //

  int nEvtOff;      // number of odd events, normaly 0, scarcely 1
  int iEvtMPI[200]; // arrays with odd event alignment; 
  int iEvtCG[200];  // if any, event #0 has shift of 1 RF cycle - who cares, it is blank anyway
  int iCorr[200];   // othervise program stops
  int jOffBest;

  int iqq;

  TH1D *Spectrum;
  TH1D *SpectrumPed;

  TH1D *StreamToMPI;
  TH1D *StreamToMPI1;
  TH1D *StreamToMPI2;
  TH1D *StreamToMPIspill;
  TH2D *StreamToMPI2D;
  TH2D *StreamVSMPI2D;
  TH2D *StreamVSMPI2X;
  TH2D *StreamVSMPI;
  TProfile *StreamToMPIProf;
  TProfile *StreamToMPIProf1;
  TProfile *StreamToMPIProf2;

  TH1D *StreamToMPIspread;
  TH1D *StreamdT;
  TH2D *StreamdTvsRatio;
  TH2D *StreamRatioVStime;
  TH2D *StreamdTVStime;
  
  TH1D *SampleSpectrum;
  TH2F *SampleProfile;

  TH2F     *SampleSignalLeak;
  TProfile *SampleSignalLeakProf;
  double SampleLeakDyn[10];
  double SampleLeakSta[10];


  TLine  *myLine;
  TLatex *myLatex;

  TCanvas *StreamCanvas;
  TCanvas *StreamCanvas1;
  double evtRatioSpread[3];

  ProcessingStatus *ProcStatus;
  EventHeader *EH;
  BurstHeader *BH;
  RunHeader   *RH;

  bool HistogramsPrepared;

  std::ofstream spill_report;
  std::ifstream cherenkovData;
  std::ifstream cherenkovQuality;
  int runOld;

  char SpillFileName[100];
  char SpillQualityName[100];
  char SpillDirectory[100];
  char HistName[100];
  char HistTitle[100];

// Read in Kozelov Cerenkov data, find pointers
// to event flags, and summarize history
  int nw16; // Number of Cerenkov ADC words in file 
// Cherenkov file header data
  short	voltm_type;	// 11
  int	voltm_length;
  double	voltm_data[8];
  //	0	unused
  //	1	Cerenkov HV
  //	2	S1 HV
  //	3	S2 HV
  //	4	S3 HV
  //	5	S4 HV
  //	6	S5 HV
  //	7	S6 HV
  short	time_type;	// 12
  int	time_length;
  int	time_data;
  short	adcbuf_type;	// 15
  int BufSize; 
  int ns30; // number of laps
  unsigned short * Cbuf; // Cerenkov ADC data 
  unsigned  char * Cflg; // Begin-event flag
  unsigned  char * Covf; // Overflow flag
  double         * Cbuff;// CHerenkov with static pedestal subtracted         
  double         * Cbufd;// CHerenkov with dynamic pedestal subtracted (samples 3 and 4 assuming 0 as peak)
  double         * Cbufft;// CHerenkov with subtraction of the "shadow" into next 2 samples
  double         * Cbufdt;// CHerenkov with subtraction of the "shadow" into next 2 samples
  float          * Sum30;// sum of all FILLED of 30 samples == Full Acclerator Loop
  float          * Sum31;// average sample amplitude within FILLED of 30 samples == Full Acclerator Loop
  double         * Fzz30;// local fuzziness: Var(5)/(Var(5)+Amp(5)) for -2..+2 laps;
  double         * Max30;// largest of 30 samples in the Accelrator lap
  double         * Bgr30;// average sample amplitude within EMPTY of 30 samples == Full Acclerator Loop
  double         * Noi30;// rms sample amplitude within EMPTY of 30 samples == Full Acclerator Loop
  int            * Hot30;// hot zone index (adjascent+1 with Noise>3*spillNoise);
  int nh30;              // number of hot lap Zones noise>3*spillNoise
  int nh30max;
  double         * Zone30noise; // average Zone noise
  int            * Izone0;      // beginning of the hot Zone
  int            * Izone1;      // end of the hot Zone

  double  fuzz0; // spill 'fuzziness' - lap-to-lap variation, integral over spill
  double  fuzz1;
  double  fuzz2;
  int     cutMode;  // -1 not set
                    //  0 no rejection if spill is there
                    //  1 rejection in empty
                    //  2 rejection if empty or parazitic
                    //  3 rejection if empty or parazitic or fuzzy
                    //  10 all rejections ON

  int EvtPnt[2000];   // Point to beginning of bunches with event flag set
  int PkPntr[2000];   // Point to first peak in event
  int PdPntr[2000];   // Pointer to pedestal in event
  int PedC[2000];     // Pedestal for Cerenkov in this event
  int NoCflg[2000];   // Number of readings with event flag set
  int kevents;       // Number of events in spill seen in Cherenkov data
  RingBuffer *OverflowSum;
  RingBuffer *ringPed;

  double spillPedestal;
  double spillNoise0; // total noise RMS
  double spillNoise;  // 'core' noise after 3*Sigma cut
  double spillNoise3;  //  3*spillNoise;
  int    nPedestal;
  int    nDrop;
  int    nDropH;
  int    nDropL;
/*-------------------------- data from Quality File -------------*/
  double spillPedestalFile;
  double spillNoiseFile;
  int    nPedestalFile;

  int    eventOffset; // offset between EventFlag in GatedCherenkov and 6MHz clock
  int    eventCount;  // events in GatedCherenkov record
  int    eventSpill;  // events count in spill
  int    nOffset;     // number of events with offset==eventOffset

  double sum30max;
  double max30max;
  int    i30max;
  double sum30samples[4000]; // sum of every 30 samples = accelerator filling prior to the event;
  int    nSpike;
  double topA[700]; // max amplitude within 1.7ms (spike)
  double topT[700];
  double lowA[700]; // min amplitude within 1.7ms (valley)
  double lowT[700];

  double SpillIntegral;
  double SpillIntegralTail;       // tail - uses "leakage" correction 0.155 & 0.05
  double SpillIntegralFilled;
  double SpillIntegralFilledTail; // dynamic subtraction

  double SpillIntegralStatic;
  double SpillIntegralStaticTail;
  double SpillIntegralStaticFilled;
  double SpillIntegralStaticFilledTail; // static subtraction

/*
  double SumIsol[10];
  double SumIsolStatic[10];
  double SumIsolCut[10];
  double SumIsolStaticCut[10];
  double SumIsolRegr[40];
*/
  myCovariance tailCovDyn[10];
  myCovariance tailCovSta[10];
  double ym1[10];


  int nIsol0; // number of isolated bunches in spill
  int nIsol1; // number of isolated bunches in spill without overflows and underflows
  int ns100;

  int isec1;
  int imin1;
  int ihour1;
  int iday1;
  int imonth1;
  int iyear1;
    

  double SpillStart;
  double SpillEnd;
  double SpillCG;
  double SpillRMS;
  double SpillWWW;

  TCanvas *SpillCanvas;
  TCanvas *SpillCanvas1;
  TH1F    *SpillDummy;
  bool spillCanvasShown;

public:
  
  CherenkovBuffer(ProcessingStatus *Proc) {

    OverflowSum = new RingBuffer(25000);
    ringPed = new RingBuffer(30);
    SpillCanvas  = new TCanvas("SpillCanvas",  "Leak",  Proc->GetDisplayWidth()/2,     0,  800, 1200);
    SpillCanvas1 = new TCanvas("SpillCanvas1", "Spill", Proc->GetDisplayWidth()/2+800, 0,  800, 1200);
    printf("[CherenkovBuffer->Constructor] creating new canvas %s\n", SpillCanvas->GetName());
    SpillDummy  = new TH1F("SpillDummy", "Spill", 50000, 0., 1400.);
    myLine  = new TLine();
    myLatex = new TLatex();
    SpillCanvas->Iconify();
    spillCanvasShown=false;
    BufSize=1024*1024*16; 
    nw16=0;
    sum30max=0.;
    nSpike=0;
    for (int i=0;i<4000;i++) sum30samples[i]=0.;
    for (int i=0;i<700;i++) {
      topA[i]=0.;
      topT[i]=0.;
      lowA[i]=0.;
      lowT[i]=0.;
    }

    Cbuf   = (unsigned short*) calloc(BufSize, sizeof(unsigned short));
    Cflg   = (unsigned char*)  calloc(BufSize, sizeof(unsigned char));
    Covf   = (unsigned char*)  calloc(BufSize, sizeof(unsigned char));
    Cbuff  = (double*)         calloc(BufSize, sizeof(double));
    Cbufd  = (double*)         calloc(BufSize, sizeof(double));
    Cbufft = (double*)         calloc(BufSize, sizeof(double));
    Cbufdt = (double*)         calloc(BufSize, sizeof(double));
    Sum30 = (float*)          calloc(BufSize/30+1, sizeof(float));
    Sum31 = (float*)          calloc(BufSize/30+1, sizeof(float));
    Max30 = (double*)         calloc(BufSize/30+1, sizeof(double));
    Bgr30 = (double*)         calloc(BufSize/30+1, sizeof(double));
    Noi30 = (double*)         calloc(BufSize/30+1, sizeof(double));
    Fzz30 = (double*)         calloc(BufSize/30+1, sizeof(double));
    Hot30 = (int*)            calloc(BufSize/30+1, sizeof(int));
    ns30=0;
    nh30=0;
    nh30max=BufSize/100;
    Izone0 = (int*)           calloc(BufSize/100+1, sizeof(int)); 
    Izone1 = (int*)           calloc(BufSize/100+1, sizeof(int)); 
    Zone30noise = (double*)   calloc(BufSize/100+1, sizeof(double)); 

    ProcStatus=Proc;
    EH = ProcStatus->GetEventHeader();
    BH = ProcStatus->GetBurstHeader();
    RH = ProcStatus->GetRunHeader();
    sprintf(SpillDirectory, "../cherenkov/data/");
    CherenkovRunAvailable=true;
    CherenkovSpillAvailable=true;
    CherenkovQualityAvailable=true;
    CherenkovEventAvailable=true;
    CherenkovMax=0.0;
    CherenkovMax=0.0;
    Dbg=false;
    HistogramsPrepared=false;
    iStart=27;
    //iStart=56;    // used to try shift by a full cycle ether direction 
    //iStart=-4;   
    //iStart=-34;   
    //iStart=86;
    CherenkovTime = new double[50];
    for (int i=0; i<BufSize; i++) {
      Cbuff[i]=0.0;
      Cbufd[i]=0.0;
      Cbufft[i]=0.0;
      Cbufdt[i]=0.0;
    }
    runOld=-1;
    eventsAccepted=0;
    spillPedestal=0.0;
    spillNoise=0.0;
    spillNoise0=0.0;
    nPedestal=0;
    CherenkovFactor=1.0;
    for (int i=0; i<30; i++) {
      filledSum[i]=0.0;
      filledWgh[i]=0.0;
      filledSample[i]=false;
      filledSampleD[i]=false;
      filledSum1Tail[i]=0.0;
      filledSum2Tail[i]=0.0;
      filledWghTail[i] =0.0;
      filledSum1TailEvt[i]=0.0;
      filledSum2TailEvt[i]=0.0;
      filledWghTailEvt[i] =0.0;
    }
    for (int i=0; i<100; i++) filledOK_100[i]=true;
    for (int i=0; i<3000; i++) {
      filledAvr100[i]=0.;
      filledRMS100[i]=0.;
      filledWgh100[i]=0.;
    }
    SpillIntegral=0;
    SpillIntegralTail=0;
    SpillIntegralFilled=0;
    SpillIntegralFilledTail=0;

    SpillIntegralStatic=0;
    SpillIntegralStaticTail=0;
    SpillIntegralStaticFilled=0;
    SpillIntegralStaticFilledTail=0;
    SpillStart=0.0;
    SpillEnd=0.0;
    SpillCG=0.0;
    SpillRMS=0.0;
    SpillWWW=0.0;

    cutMode=-1;

    for (int i=0; i<10; i++) {
      tailCovDyn[i].Clear();
      tailCovSta[i].Clear();
    }

    Spectrum    = new TH1D("GADCspectrumFilled", "GADC spectrum, filled bunches", 440, -300., 4100.);
    SpectrumPed = new TH1D("GADCspectrumPed",    "GADC spectrum, empty bunches", 440, -300., 4100.);
  }

  CherenkovBuffer(const char* CherenkovDataDir, const char* CherenkovSpillLists, ProcessingStatus *Proc) {
    OverflowSum = new RingBuffer(25000);
    ringPed = new RingBuffer(30);
    SpillCanvas  = new TCanvas("SpillCanvas",  "Leak",  Proc->GetDisplayWidth()/2,     0,  800, 1200);
    SpillCanvas1 = new TCanvas("SpillCanvas1", "Spill", Proc->GetDisplayWidth()/2+800, 0,  800, 1200);
    printf("[CherenkovBuffer->Constructor] creating new canvas %s\n", SpillCanvas->GetName());
    SpillDummy  = new TH1F("SpillDummy", "Spill", 50000, 0., 1400.);
    myLine = new TLine();
    myLatex = new TLatex();
    SpillCanvas->Iconify();
    spillCanvasShown=false;
    BufSize=1024*1024*16; 

    Cbuf  = (unsigned short*) calloc(BufSize, sizeof(unsigned short));
    Cflg  = (unsigned char*) calloc(BufSize, sizeof(unsigned char));
    Covf  = (unsigned char*) calloc(BufSize, sizeof(unsigned char));
    Cbuff = (double*)         calloc(BufSize, sizeof(double));
    Cbufd = (double*)         calloc(BufSize, sizeof(double));
    Cbufft = (double*)         calloc(BufSize, sizeof(double));
    Cbufdt = (double*)         calloc(BufSize, sizeof(double));
    Sum30 =  (float*)          calloc(BufSize/30+1, sizeof(float));
    Sum31 =  (float*)          calloc(BufSize/30+1, sizeof(float));
    Max30 = (double*)         calloc(BufSize/30+1, sizeof(double));
    Bgr30 = (double*)         calloc(BufSize/30+1, sizeof(double));
    Noi30 = (double*)         calloc(BufSize/30+1, sizeof(double));
    Fzz30 = (double*)         calloc(BufSize/30+1, sizeof(double));
    Hot30 = (int*)            calloc(BufSize/30+1, sizeof(int));
    nh30=0;
    nh30max=BufSize/100;
    Izone0 = (int*)           calloc(BufSize/100+1, sizeof(int)); 
    Izone1 = (int*)           calloc(BufSize/100+1, sizeof(int)); 
    Zone30noise = (double*)   calloc(BufSize/100+1, sizeof(double)); 

    nw16=0;
    ns30=0;
    nSpike=0;
    ProcStatus=Proc;
    EH = ProcStatus->GetEventHeader();
    BH = ProcStatus->GetBurstHeader();
    RH = ProcStatus->GetRunHeader();
    sprintf(SpillDirectory, "%s", CherenkovDataDir);
    CherenkovRunAvailable=true;
    CherenkovSpillAvailable=true;
    CherenkovQualityAvailable=true;
    CherenkovEventAvailable=true;
    CherenkovMax=0.0;
    CherenkovMax=0.0;
    Dbg=false;
    iStart=27;
    //iStart=56;  // used to try shift by a full cycle ether direction   
    //iStart=-4;    
    //iStart=-34;   
    //iStart=86;   
    CherenkovTime = new double[50];
    for (int i=0; i<BufSize; i++) {
      Cbuff[i]=0.0;
      Cbufd[i]=0.0;
      Cbufft[i]=0.0;
      Cbufdt[i]=0.0;
    }
    printf("[CherenkovBuffer] Created! Working directories -> %s, %s\n", CherenkovDataDir, CherenkovSpillLists);
    HistogramsPrepared=false;
    runOld=-1;
    eventsAccepted=0;
    spillPedestal=0.0;
    spillNoise=0.0;
    spillNoise0=0.0;
    nPedestal=0;
    CherenkovFactor=1.0;
    sum30max=0.;
    for (int i=0;i<4000;i++) sum30samples[i]=0.;
    for (int i=0;i<700;i++) {
      topA[i]=0.;
      topT[i]=0.;
      lowA[i]=0.;
      lowT[i]=0.;
    }
    for (int i=0; i<30; i++) {
      filledSum[i]=0.0;
      filledWgh[i]=0.0;
      filledSum1Tail[i]=0.0;
      filledSum2Tail[i]=0.0;
      filledWghTail[i] =0.0;
      filledSum1TailEvt[i]=0.0;
      filledSum2TailEvt[i]=0.0;
      filledWghTailEvt[i] =0.0;
      filledSample[i]=false;
      filledSampleD[i]=false;
    }
    for (int i=0; i<3000; i++) {
      filledAvr100[i]=0.;
      filledRMS100[i]=0.;
      filledWgh100[i]=0.;
    }
    SpillIntegral=0;
    SpillIntegralTail=0;
    SpillIntegralFilled=0;
    SpillIntegralFilledTail=0;

    SpillIntegralStatic=0;
    SpillIntegralStaticTail=0;
    SpillIntegralStaticFilled=0;
    SpillIntegralStaticFilledTail=0;

    for (int i=0; i<10; i++) {
      tailCovDyn[i].Clear();
      tailCovSta[i].Clear();
    }

    SpillStart=0.0;
    SpillEnd=0.0;
    SpillCG=0.0;
    SpillRMS=0.0;
    SpillWWW=0.0;

    cutMode=-1;

    Spectrum    = new TH1D("GADC spectrum",         "GADC spectrum",          440, -300., 4100.);
    SpectrumPed = new TH1D("GADCspectrumPed", "GADC spectrum, empty bunches", 440, -300., 4100.);

  }

  bool GetHistogramsPrepared() {return HistogramsPrepared;}

  void GetTimeStamp(int *timeStamp) {
    timeStamp[0]=iyear1;
    timeStamp[1]=imonth1;
    timeStamp[2]=iday1;
    timeStamp[3]=ihour1;
    timeStamp[4]=imin1;
    timeStamp[5]=isec1;
  }

  double GetFilledSum(int i) {
    if (i<0 || i>29) return 0.;
    return filledSum[i];
  }
  double* GetFilledSumPointer()    {return &filledSum[0];}
  bool*   GetFilledSamplePointer() {return &filledSampleD[0];}

  void SetdT(double dTx) {dT=dTx;}
  double GetDT() {return dT;}

  void SetCutMode(int mode) {
    if (mode<0 || mode>2) {
      printf("[CherenkovBuffer->SetCutMode] wrong mode#%d. Bye!\n", mode);
      exit(-1);
    }
    cutMode=mode;
    printf("[CherenkovBuffer->SetCutMode] spill rejection mode set to %d\n", mode);
  }


  void   SetGainCorrection(double A) {HVcorrection=A;}
  double GetGainCorrection()         {return HVcorrection;}

  double GetSpillStart() {return SpillStart;}
  double GetSpillCOG()   {return SpillCG;}
  double GetSpillWDTH()  {return SpillRMS*sqrt(12.);}
  double GetSpillEnd()   {return SpillEnd;}

  char* GetSpillFileName() {return SpillFileName;}

  void ClearFileName() {sprintf(SpillFileName, "missing");}

  TH1D* GetSpectrum()    {return Spectrum;}
  TH1D* GetSpectrumPed() {return SpectrumPed;}

  void SetSpillNumber(int n) {spillNumber=n;}

  bool GetSpillFile(int iyear, int imonth, int iday, int ihour, int imin, int isec) {
    unsigned char Bite1,Bite2; 
    unsigned short word1,word2;
    union mix_t {double D; unsigned short sc[4]; unsigned int ic[2]; unsigned char c[8];} mix; 

    slopesLoaded=false;

    OverflowSum->Clear();
    Spectrum   ->Reset();
    SpectrumPed->Reset();
    CherenkovSpillAvailable=true; // presupttion of innosence, no more ///
    SpillIntegral=0;
    SpillIntegralTail=0;
    SpillIntegralFilled=0;
    SpillIntegralFilledTail=0;

    SpillIntegralStatic=0;
    SpillIntegralStaticTail=0;
    SpillIntegralStaticFilled=0;
    SpillIntegralStaticFilledTail=0;

    for (int i=0; i<10; i++) {
      tailCovDyn[i].Clear();
      tailCovSta[i].Clear();
    }

    for (int i=0; i<30; i++) {
      SampleSpectrum[i].Reset();
      SampleProfile[i].Reset();
    }

    for (int i=0; i<10; i++) {
      SampleSignalLeak[i].Reset();
      SampleSignalLeakProf[i].Reset();
      tailCovSta[i].Clear();
      tailCovDyn[i].Clear();
    }
    printf("[CherenkofBuffer->GetSpillFile] BH->GetGoodSpill()=%d\n",BH->GetGoodSpill()); 

    if (!BH->GetGoodSpill()) {
      printf("[CherenkofBuffer->GetSpillFile] unacceptable spill structure from ProcessingStatus->LoadSpillSummary\n");
      CherenkovSpillAvailable=false;
      return false;
    }

    if (cutMode==-1) {
      printf("[CherenkofBuffer->GetSpillFile] rejection mode was not set by SetCutMode(int), bye!\n");
      exit(-1);
    }

    nw16=0;
    ns30=0;
    nSpike=0;
    eventsAccepted=0;
    spillPedestal=0.0;
    spillNoise=0.0;
    spillNoise0=0.0;
    nPedestal=0;
    CherenkovFactor=1.0;
    sum30max=0.;
    max30max=0.;
    for (int i=0;i<4000;i++) sum30samples[i]=0.;
    for (int i=0;i<700;i++) {
      topA[i]=0.;
      topT[i]=0.;
      lowA[i]=0.;
      lowT[i]=0.;
    }
    for (int i=0; i<30; i++) {
      filledSum[i]=0.0;
      filledWgh[i]=0.0;
      filledSum1Tail[i]=0.0;
      filledSum2Tail[i]=0.0;
      filledWghTail[i] =0.0;
      filledSum1TailEvt[i]=0.0;
      filledSum2TailEvt[i]=0.0;
      filledWghTailEvt[i] =0.0;
      filledSample[i]=false;
      filledSampleD[i]=false;
    }
    for (int i=0; i<3000; i++) {
      filledAvr100[i]=0.;
      filledRMS100[i]=0.;
      filledWgh100[i]=0.;
    }
    for (int i=0; i<100; i++) filledOK_100[i]=true;

    if (iyear==2009) {
      sprintf(SpillFileName, "%srun_%3d/spill-%4d-%02d-%02d-%02d-%02d-%02d.raw", 
              SpillDirectory, ProcStatus->GetRun(), iyear, imonth, iday, ihour, imin, isec);
    } else if (iyear==2010 || iyear==2012 || iyear==2013) {
      sprintf(SpillFileName, "%sspill-%4d-%02d-%02d-%02d-%02d-%02d.dat", 
              SpillDirectory, iyear, imonth, iday, ihour, imin, isec);
    } else {
      printf("[CherenkovBuffet->GetSpillFile] no Cherenkov data for year %d\n", iyear);
      CherenkovSpillAvailable=false;
      BH->CherenkovLoaded=false;
      return false;
    }

    iyear1=iyear;
    imonth1=imonth;
    iday1=iday;
    ihour1=ihour;
    imin1=imin;
    isec1=isec;

    cherenkovData.open(SpillFileName, ios::binary);
    nPedestal=-1;

    int iAddSeconds=1;

    while (!cherenkovData.is_open() && iAddSeconds<6) { //try to add iAddSeconds 
      printf("[CherenkovBuffet->GetSpillFile] failed to open file %s\n", SpillFileName);
      cherenkovData.clear();
      
      isec1=isec+iAddSeconds;
      imin1=imin;
      ihour1=ihour;
      iday1=iday;
      if (isec1>59) {
        isec1-=60;
        imin1++;
        if (imin1>59) {
          imin1-=60;
          ihour1++;
          if (ihour1>23) {
            ihour1+=24;
            iday1++;
          }
        }
      } 
      if (iyear==2009) {
        sprintf(SpillFileName, "%srun_%3d/spill-%4d-%02d-%02d-%02d-%02d-%02d.raw", 
                SpillDirectory, ProcStatus->GetRun(), iyear, imonth, iday1, ihour1, imin1, isec1);
      } else if (iyear==2010 || iyear==2012 || iyear==2013) {
        sprintf(SpillFileName, "%sspill-%4d-%02d-%02d-%02d-%02d-%02d.dat", 
                SpillDirectory, iyear, imonth, iday1, ihour1, imin1, isec1);
      } else {
        printf("[CherenkovBuffer->GetSpillFile] no Cherenkov data for year %d\n", iyear);
        //exit(-1);
        CherenkovSpillAvailable=false;
        BH->CherenkovLoaded=false;
        return false;
      }
      printf("[CherenkovBuffer->GetSpillFile] trying  +2sec file %s\n", SpillFileName);
      cherenkovData.open(SpillFileName, ios::binary);

      iAddSeconds++;
    }
    

    iAddSeconds=1;
    
    if (!cherenkovData.is_open()) { //try to subtract iAddSeconds
      printf("[CherenkovBuffet->GetSpillFile] failed to open file %s\n", SpillFileName);
      cherenkovData.clear();
      
      isec1=isec-iAddSeconds;
      imin1=imin;
      ihour1=ihour;
      iday1=iday;
      if (isec1<0) {
        isec1+=60;
        imin1--;
        if (imin1<0) {
          imin1+=60;
          ihour1--;
          if (ihour1<0) {
            ihour1+=24;
            iday1--;
          }
        }
      }
      if (iyear==2009) {
        sprintf(SpillFileName, "%srun_%3d/spill-%4d-%02d-%02d-%02d-%02d-%02d.raw", 
                SpillDirectory, ProcStatus->GetRun(), iyear, imonth, iday1, ihour1, imin1, isec1);
      } else if (iyear==2010 || iyear==2012 || iyear==2013) {
        sprintf(SpillFileName, "%sspill-%4d-%02d-%02d-%02d-%02d-%02d.dat", 
                SpillDirectory, iyear, imonth, iday1, ihour1, imin1, isec1);
      } else {
        printf("[CherenkovBuffer->GetSpillFile] no Cherenkov data for year %d\n", iyear);
        //exit(-1);
        CherenkovSpillAvailable=false;
        BH->CherenkovLoaded=false;
        return false;
      }
      printf("[CherenkovBuffer->GetSpillFile] trying  -1sec file %s\n", SpillFileName);
      cherenkovData.open(SpillFileName, ios::binary);

      iAddSeconds++;
    }
    
    if (!cherenkovData.is_open()) { // failed
      printf("[CherenkovBuffer->GetSpillFile] failed to open  -2sec file %s\n", SpillFileName);
      cherenkovData.clear();
      CherenkovSpillAvailable=false;
      BH->CherenkovLoaded=false;
      return false;
    }
 
    if (!cherenkovData.good()) {
      printf("[CherenkovBuffer->GetSpillFile] file %s is not good ;(\n", SpillFileName);
      cherenkovData.close();
      cherenkovData.clear();
      CherenkovSpillAvailable=false;
      BH->CherenkovLoaded=false;
      return false;
    }

    //sprintf(SpillQualityName, "%s.quality", SpillFileName); 


    if (EH->run>651) { // November 2009 data and older has no voltmeter records!

      Bite1=cherenkovData.get(); Bite2=cherenkovData.get(); voltm_type=256*Bite2+Bite1;
      Bite1=cherenkovData.get(); Bite2=cherenkovData.get(); word1=256*Bite2+Bite1; 
      Bite1=cherenkovData.get(); Bite2=cherenkovData.get(); word2=256*Bite2+Bite1; 
      voltm_length=65536*word2+word1; 
      for(int j=0;j<8;j++) {
        for(int i=0;i<4;i++) {
          mix.c[2*i]   = cherenkovData.get(); 
          mix.c[2*i+1] = cherenkovData.get();
          //cout <<"   i=" << i << " j=" << j << " c0=" << mix.c[2*i] << " c1=" <<  mix.c[2*i+1] << endl;
        } 
        voltm_data[j]=0.001*mix.D; 
        while (voltm_data[j]>10.) voltm_data[j]/=1000.;
        
        if (j==1 || true) cout << "HV#" << j << "=" << voltm_data[j] << "kV raw=" << mix.D << endl;
      }

      HVspill = voltm_data[1];
      if (RH->run>850 && RH->run<1070) {// 2012 data
        printf("[CherenkovBuffer] 2012 corrected HV=%.2fkV\n", HVspill);
        HVspill=0.973*HVspill+0.023; 
      } else if (RH->run>1070 && RH->run<1195) {// 2013 data
        HVspill=0.955*HVspill+0.018; 
        printf("[CherenkovBuffer] 2013 corrected HV=%.2fkV\n", HVspill);
      }
      RH->HVbeam[0]=voltm_data[2];
      RH->HVbeam[1]=voltm_data[3];
      RH->HVbeam[2]=voltm_data[4];
      RH->HVbeam[3]=HVspill;  

      Bite1=cherenkovData.get(); Bite2=cherenkovData.get(); time_type=256*Bite2+Bite1;
      Bite1=cherenkovData.get(); Bite2=cherenkovData.get(); word1=256*Bite2+Bite1; 
      Bite1=cherenkovData.get(); Bite2=cherenkovData.get(); word2=256*Bite2+Bite1; 
      time_length=65536*word2+word1; 

      Bite1=cherenkovData.get(); Bite2=cherenkovData.get(); word1=256*Bite2+Bite1; 
      Bite1=cherenkovData.get(); Bite2=cherenkovData.get(); word2=256*Bite2+Bite1; 
      time_data=65536*word2+word1; 

      Bite1=cherenkovData.get(); Bite2=cherenkovData.get(); adcbuf_type=256*Bite2+Bite1;
    }

    Bite1=cherenkovData.get(); Bite2=cherenkovData.get(); word1=256*Bite2+Bite1; 
    Bite1=cherenkovData.get(); Bite2=cherenkovData.get(); word2=256*Bite2+Bite1; 
    nw16=65536*word2+word1; // adcbuf_length
    cout <<"[GetSpillFile] Loading Cerenkov Data, nw16=" << nw16 << " reserved buffer=" << BufSize << endl; 
    int k=0;     //int Offset=25; // Bunches to go backwards to align with MPI samples
    int ModBin[30]; // Histogram of remainders when dividing bunch counter by 30
    for(int j=0;j<30;j++) {ModBin[j]=0;}

    for(int i=0;i<nw16;i++) { 
      Bite1=cherenkovData.get(); Bite2=cherenkovData.get();
      Cbuf[i]=((256*Bite2+Bite1)&0x0FFF); 
      Cflg[i]=(Bite2/16)&0x0001; 
      Covf[i]=(Bite2/32)&0x0001;
      if(Cbuf[i]>2048) {ModBin[i%30]++;}
      bool EvtFlag = false;
      if (i==0) EvtFlag = (Cflg[0]==1);
      else      EvtFlag = (Cflg[i]==1)&&(Cflg[i-1]==0);
      if(EvtFlag) {
        EvtPnt[k]=i; // Mark event
        //if(EvtPnt[k]>Offset) {EvtPnt[k]-=Offset;} // Go backwards to bunches corresponding to MPI samples
        //printf("[CherenkovBuffer->GetSpillFile] Evt#%03d start=%7d", k, i);
        //if (k>0) printf(" diff=%5d",  EvtPnt[k]-EvtPnt[k-1]);
        //printf("\n");
        k++;
      }
    }
    kevents=k;
    //cout <<" ModMax = "; for(int j=0;j<30;j++) {cout<<ModBin[j]<<"  ";} cout <<endl;
    cherenkovData.close();
    cherenkovData.clear();
    BH->CherenkovLoaded=true;
    CherenkovFactor=3.03;
    if (EH->run>1070) {
      CherenkovFactor=2.5;
    }

    if (EH->run>1188) {
      iStart=24;
    } else if (EH->run>1185) {
      iStart=26;
    } else if (EH->run>1181) {
      iStart=24;
    } else if (EH->run>1168) {
      iStart=26;
    } else if (EH->run>1157) {
      iStart=24;
    } else if (EH->run>1151) {
      iStart=26;
    } else if (EH->run>1129) {
      iStart=24;
    } else if (EH->run>1070) {
      iStart=26;
    } else if (EH->run>843) {
      iStart=25;
    } else if (EH->run>651) {
      iStart=25;
    } else {
      iStart=26;
      CherenkovFactor=0.9;
    }


    printf("[CherenkovBuffet->GetSpillFile] %d event flags\n", kevents);
    spillPedestal=0.0;
    spillNoise=0.0;
    spillNoise0=0.0;
    nPedestal=2000;
    nDrop=0;
    nDropH=0;
    nDropL=0;
    double spillNoiseMax=1.0e6;
    double spillNoiseMin=0.;
    double cutAssimetry=1.;
    int nTrim=0;
    while (nTrim<4 && nPedestal>1000 && cutAssimetry>0.25) {
      spillPedestal=0.0;
      spillNoise=0.0;
      spillNoise0=0.0;
      nPedestal=0;
      nDrop=0;
      nDropH=0;
      nDropL=0;
      for (int i=0; i<EvtPnt[1]; i++) {
        if (Cbuf[i]>spillNoiseMin && Cbuf[i]<spillNoiseMax) {
          nPedestal++;
          spillPedestal+=Cbuf[i];
          spillNoise+=Cbuf[i]*Cbuf[i];
        } else { 
          nDrop++;
          if (Cbuf[i]<spillNoiseMin) nDropL++; 
          if (Cbuf[i]>spillNoiseMax) nDropH++; 
        }
      }
      if (nPedestal>10) {   
        spillPedestal/=(double)nPedestal;
        spillNoise /= (double)nPedestal;
        spillNoise -= spillPedestal*spillPedestal;
        spillNoise = sqrt(spillNoise);
        if (nTrim>0) {
          cutAssimetry=double(nDropH-nDropL)/double(nDropL+nDropH);
          spillNoise=0.5*(spillNoise+spillNoise0);  
          printf("[GetSpillFile] %d Nped=%d Ndrop=%4d(L=%4d H=%4d)\t CutAss=%.2f\t Ped=%.1f\t RMS=%.1f\n", 
                 nTrim, nPedestal, nDrop, nDropL, nDropH, cutAssimetry, spillPedestal, spillNoise); 
        } else {
          spillNoise0=spillNoise;
        }
        spillNoiseMax=spillPedestal+3.0*spillNoise;
        spillNoiseMin=spillPedestal-3.0*spillNoise;
      } 
      nTrim++; 
    } 
    //printf("cherenkov factor=%f\n", CherenkovFactor);
    spillNoise3=spillNoise; // MPI ADC, like Cbufd!
    

    if (nPedestal<10 && cutMode>3) {   
      printf("[GetSpillFile] 3*Sigma cut failed for %s\b", SpillFileName);
      printf("[GetSpillFile] Trim#%d Nped=%d Ped=%.1f RMS=%.1f\n", 
                               nTrim-1, nPedestal, spillPedestal, spillNoise);
      CherenkovSpillAvailable=false;
      return false;
    } 


    for (int i=0; i<30; i++) {
      filledSum[i]=0.0;
      filledWgh[i]=0.0;
      filledSum1Tail[i]=0.0;
      filledSum2Tail[i]=0.0;
      filledWghTail[i] =0.0;
      filledSum1TailEvt[i]=0.0;
      filledSum2TailEvt[i]=0.0;
      filledWghTailEvt[i] =0.0;
    }
    for (int i=0; i<3000; i++) {
      filledAvr100[i]=0.;
      filledRMS100[i]=0.;
      filledWgh100[i]=0.;
    }
    for (int i=0; i<nw16; i++) {
      Cbuff[i]=Cbuf[i]-spillPedestal;
      filledSum[i%30]+=Cbuff[i];
      filledWgh[i%30]+=1.0;
    }
    printf("Static Bunch Sums ->\n");
    double filledMax=-100.;
    int    iFilledMax=0;
    for (int i=0; i<30; i++) {
      if (filledWgh[i]==0.0) {
        printf("\n\n[GetSpillFile] Mod(30) calculation, Entries is zero!\n\n");
        exit(-1);
      }

      filledSum[i]/=filledWgh[i];
      if (filledSum[i]>filledMax) {
        filledMax=filledSum[i];
        iFilledMax=i;
      }
    }

    for (int i=0; i<30; i++) printf("  #%2d", i);                             printf("\n");
    for (int i=0; i<30; i++) printf(" %4.0f", filledSum[i]);                  printf("\n");
    for (int i=0; i<30; i++) printf("  %3d",  ProcStatus->GetBunchAction(i)); printf("\n");
/*
    if (RH->run == 1167) {
      std::ofstream bunches;
      sprintf(SpillFileName, "../data0/Cherenkov/bunches/bunches-%4d-%02d-%02d-%02d-%02d-%02d.dat", 
              iyear, imonth, iday, ihour, imin, isec); 
      bunches.open(SpillFileName, ios::out);
      bunches << voltm_data[1]*1000. << endl;
      for (int i=0; i<30; i++) bunches << filledSum[i] << endl;
      bunches.close();
      bunches.clear();  
      printf("[GetSpillFile] bunches file %s created\n",  SpillFileName);  
      return true;
    }
*/
    
    printf("[GetSpillFile] ===== Max Filled bunch -> %d\n", iFilledMax);
// get information about filled bunches from bunchAction at ProcessingStatus!
    for (int i=0;i<30;i++) {
      if (ProcStatus->GetBunchAction(i)==1) {
        filledSample[i]=true;
        filledSampleD[i]=true;
        //printf("*");
      } else {
        //printf("-");
      }
      filledSum[i]=0.0; 
      filledWgh[i]=0.0;
      filledSum1Tail[i]=0.0;
      filledSum2Tail[i]=0.0;
      filledWghTail[i] =0.0;
      filledSum1TailEvt[i]=0.0;
      filledSum2TailEvt[i]=0.0;
      filledWghTailEvt[i] =0.0;
    }
    //printf("\n");

    double dynaPedestal=spillPedestal;
    double w30=0.;
    i30max=-1;
    sum30max=-1.0e6;
    for (int i=0; i<3; i++) ringPed->Push(spillPedestal);

    double s301=0.;
    double s300=0.;
    double s302=0.;

    int ns10=0;
    SpillStart=0.0;
    SpillCG=0.0;
    SpillRMS=0.0;
    SpillWWW=0.0;
    SpillIntegral=0;
    SpillIntegralTail=0;
    SpillIntegralFilled=0;
    SpillIntegralFilledTail=0;

    SpillIntegralStatic=0;
    SpillIntegralStaticTail=0;
    SpillIntegralStaticFilled=0;
    SpillIntegralStaticFilledTail=0;

    for (int i=0; i<10; i++) {
      tailCovDyn[i].Clear();
      tailCovSta[i].Clear();
    }

    for (int i=0; i<nw16/30+1; i++) {
      Sum30[i]=0.0;
      Sum31[i]=0.0;
      Max30[i]=0.0;
      Noi30[i]=0.0;
      Fzz30[i]=0.0;
      Hot30[i]=-1;
    }
    
    OverflowSum->Clear();

    ns100=nw16/100;
    for (int i=0; i<nw16; i++) {
      if (i>3 && ProcStatus->GetBunchAction(i%30)==2) {
        double spillNoiseMaxD=dynaPedestal+spillNoise3;
        double spillNoiseMinD=dynaPedestal-spillNoise3;
          
        if (Cbuf[i]<spillNoiseMaxD &&
            Cbuf[i]>spillNoiseMinD ) {
          ringPed->Push(Cbuf[i]);
          dynaPedestal=ringPed->GetMean();
        }
      }

      Cbufd[i]=Cbuf[i]-dynaPedestal;
//      SampleSpectrum[i%30].Fill(Cbuf[i]);
      SampleSpectrum[i%30].Fill(Cbufd[i]);
      SampleProfile[i%30].Fill(i*165.0e-9, Cbufd[i]);
      if (Cbufd[i]<CherenkovMin) CherenkovMin=Cbufd[i];
      if (Cbufd[i]>CherenkovMax) CherenkovMax=Cbufd[i];

      filledSum[i%30]+=Cbufd[i];
      filledWgh[i%30]+=1.0;

      if (Cbuf[i]>50 && Cbuf[i]<3900 && Covf[i]==0) {
        int ig1=i/ns100;
        if (ig1>99) ig1=99;
        filledWgh100[ig1*30+i%30]+=1.0;
        filledAvr100[ig1*30+i%30]+=Cbufd[i];
        filledRMS100[ig1*30+i%30]+=Cbufd[i]*Cbufd[i];
      }
    
      if (i>0 && i%30==0) {
        if (s300==0.0) {
          printf("\n\n[GetSpillFile] Dynamic Pedestal S300 is zero! i=%d i%%30=%d w30=%f ped=%.1f\n", i, i%30, w30, dynaPedestal);
          for (int j=0; j<i+1; j++) {
            printf(" #%6d\t Araw=%5d\t Adyn=%.1f\n", j, Cbuf[j], Cbufd[j]);
          }
          exit(-1);
        }
        if (w30>0.0) {
          Sum31[ns30]=Sum30[ns30]/w30;
          //Sum30[ns30]/=w30;
        } else {
          Sum30[ns30]=0.0; // empty lap
          Sum31[ns30]=0.0; // empty lap
        }
        s301/=s300;
        s302/=s300;
        s302-=s301*s301;
        if (s302>0.0) s302=sqrt(s302);
        else s302=0.0;
        //printf("[Lap Signal/noise] t=%6.1fus Filled=%7.2f Blank=%6.2f BlankRMS=%6.2f ",
        //        i*dT/1000., Sum30[ns30], s301, s302);
        Bgr30[ns30]=s301;
        Noi30[ns30]=s302;

        if (ns10>50) {
          if (SpillStart==0.0) SpillStart=dT*i;
          SpillEnd=dT*i;
          ns10=50;
        }
 
        if (Sum30[ns30]>s301+3.0*s302) {
          ns10++;
          //printf("***");
        } else {
          ns10=0;
          //printf("   ");
        }
 
       //printf(" ns10=%2d Start=%8.1fms, End=%8.1fms\n",  ns10, SpillStart*1.0e-6, SpillEnd*1.0e-6);
       
       //if (ns30%100==99) {
       //   int iqq=0;
       //   printf("Push->");
       //   cin >> iqq;
       //   if (iqq==0) exit(-1);
       // }
        
        s300=0.0;
        s301=0.0;
        s302=0.0;
        if (Sum30[ns30]>sum30max) {
          sum30max=Sum30[ns30]; 
          i30max=ns30;
        }
        w30=0.0;
        ns30++;
      }
      SpillIntegral      +=Cbufd[i];
      SpillIntegralStatic+=Cbuff[i];

      int i1=i-1;
      int i2=i-2;
      int i3=i-3;
      if (i1<0) i1+=30;
      if (i2<0) i2+=30;
      if (i3<0) i3+=30;

      if (filledSample[i%30]) {
        SpillIntegralFilled      +=Cbufd[i];
        SpillIntegralStaticFilled+=Cbuff[i];

        if (Cbufd[i]>0.0) {
          SpillCG+=Cbufd[i]*dT*i;
          SpillRMS+=Cbufd[i]*dT*i*dT*i;
          SpillWWW+=Cbufd[i];
        }
        Sum30[ns30]+=Cbufd[i];
        if (Cbufd[i]>Max30[ns30]) { 
          Max30[ns30]=Cbufd[i];
          if (Cbufd[i]>max30max) max30max=Cbufd[i];
        }
        w30+=1.0;
      } else if (!filledSample[i1%30]&& 
                 !filledSample[i2%30]&& 
                 !filledSample[i3%30]) { // skip 3 after the filled bunch! it is high
        s300+=1.0;
        s301+=Cbufd[i];
        s302+=Cbufd[i]*Cbufd[i];
      }
      Cbufdt[i]=Cbufd[i];
      Cbufft[i]=Cbuff[i];
    }

    if (w30>0) {
      Sum30[ns30]/=w30;
      if (Sum30[ns30]>sum30max) {
        sum30max=Sum30[ns30]; 
        i30max=ns30;
      }
      ns30++; 
    }
    ns30++; /// add 1 to have a number of accelerator laps
    printf("[GetSpillFile] Accelerator Laps = %d\n", ns30);
//=====================================================================================    
    printf("[GetSpillFile] Dynamic Bunch Sums ->\n");
    filledMax=0.;

    for (int i=0; i<30; i++) {
      if (filledWgh[i]==0.) {
        printf("\n\n[GetSpillFile] Dynamic pedestal Mod(30) Entries is zero!\n\n");
        exit(-1);
      }
      filledSum[i]/=filledWgh[i];
      if (filledSum[i]>filledMax) {
        filledMax=filledSum[i];
      }
      //printf("        #%2d Sum=%.1f\t action=%d\n", i, filledSum[i], ProcStatus->GetBunchAction(i));
    } 

    for (int i=0; i<3000; i++) {
      int i1=i/30;
      if (filledWgh100[i]==0.) {
        printf("[GetSpillFile] Mod30 slices #%d (slice#%d bunch#%d) rate=0\n", i, i1, i%30);
        printf("[GetSpillFile]              S1=%f S2=%f\n", filledAvr100[i], filledRMS100[i]); 
        continue;
      }
      filledAvr100[i]/=filledWgh100[i];
      filledRMS100[i]/=filledWgh100[i];
      filledRMS100[i]-=filledAvr100[i]*filledAvr100[i];
      if (filledRMS100[i]>0.) {
        filledRMS100[i]=sqrt(filledRMS100[i]);
      } else {
        filledRMS100[i]=0.;
      }
    }
   
    for (int i100=0; i100<100; i100++) {
      double localNoise=1.0e15;
      signalFound[i100]=0;
      for (int is=0; is<30; is++) {
        int i=i100*30+is;
        if (filledWgh100[i]==0.) continue;
        if (filledRMS100[i]>0. && localNoise>filledRMS100[i]) localNoise=filledRMS100[i]; 
      }
      for (int is=0; is<30; is++) {
        int i=i100*30+is;
        if (filledAvr100[i]>3.0*localNoise) signalFound[i100]++;
      }
    }

    firstOf100=99;
    lastOf100=0;
    for (int i100=0; i100<100; i100++) {
      if (signalFound[i100]>3) {
        firstOf100=i100;
        break;
      }
    }
    for (int i100=99; i100>-1; i100--) {
      if (signalFound[i100]>3) {
        lastOf100=i100;
        break;
      }
    }

    printf("[CherenkovBuffer->GetSpillFile] filled segments are %d...%d of 100\n", firstOf100, lastOf100);

    double rmsHISTmin=1.0e10;
    for (int i=0; i<30; i++) {
      if (SampleSpectrum[i].GetRMS() < rmsHISTmin) rmsHISTmin=SampleSpectrum[i].GetRMS();
    }
    
    for (int i=0; i<30; i++) printf("  #%2d", i);                            printf("\n");
    for (int i=0; i<30; i++) printf(" %4.0f", filledSum[i]);                 printf("\n");
    for (int i=0; i<30; i++) printf(" %4.0f", SampleSpectrum[i].GetRMS());   printf("\n");
    for (int i=0; i<30; i++) {
      double frac=0.;
      for (int is=1; is<SampleSpectrum[i].GetNbinsX(); is++) {
        if (SampleSpectrum[i].GetBinCenter(is)<5.0*rmsHISTmin) continue;
//        if (SampleSpectrum[i].GetBinCenter(is)> 5.0*rmsHISTmin)  break;
        frac+=SampleSpectrum[i].GetBinContent(is);
      }
      frac/=SampleSpectrum[i].GetEntries();
      printf(" %4.1f", 100.*frac);
    }    printf("\n");
    for (int i=0; i<30; i++) printf("  %3d", ProcStatus->GetBunchAction(i)); printf("\n");

    double s1=0.;
    double s2=0.;
//////////////////////////////// fix the rejection of bad spills /////////////////////////

//    int iNext=filledSampleD+1;
//    int iPrev=filledSampleD-1;
//    if (iNext==30) iNext=0;
//    if (iPrev==-1) iPrev=5;
/* 
    for  (int i=0; i<30; i++) {
      s1+=filledSum[i];
      s2+=filledSum[i]*filledSum[i];
      if (i==iNext) {
         if (filledSum[i]>0.3*filledSum[filledSampleD]) {
           printf("[GetSpillFile] XXXXXXXX Spill rejected for parazitic bunch suspicion! Next Sample#%d=%.1f > 0.3*Filled=%.1f\n",
                  i, filledSum[i], filledSum[filledSampleD]);
           CherenkovSpillAvailable=false;
         }
      } else if (i!=filledSampleD && filledSum[i]>0.1*filledSum[filledSampleD]) {
         if (HVcorrection*SpillIntegralFilled>2.0e7) { // use on high rate only!
           printf("[GetSpillFile] XXXXXXXX Spill rejected for parazitic bunch suspicion! Sample#%d=%.1f > 0.1*Filled=%.1f\n",
           i, filledSum[i], filledSum[filledSampleD]);
           CherenkovSpillAvailable=false;
         }
      }
      if (filledSum[i]<-0.025*filledSum[filledSampleD] && filledSum[i]<-5.5) {
         printf("[GetSpillFile] XXXXXXXX Spill rejected for parazitic bunch suspicion! Negative Sample#%d=%.1f < -0.025q*Filled=%.1f\n",
         i, filledSum[i], filledSum[filledSampleD]);
         CherenkovSpillAvailable=false;
      }
    }
*/
    for  (int i=0; i<30; i++) {
      s1+=filledSum[i];
      s2+=filledSum[i]*filledSum[i];
    }
    s1/=30.;
    s2/=30.;
    s2-=s1*s1;
    if (s2>0.0) s2=sqrt(s2);
     else s2=0.0;
    double ratio=10.0;
    if (s2>0.0) ratio=filledMax/s2;

    printf("[GetSpillFile]   ===== FilledMax=%.2f Cycle Variance = %.1f Max/Variance=%.2f\n", filledMax, s2, ratio);
    if (s2==0.0 && cutMode>0) {
      printf("[GetSpillFile] XXXXXXXX  Spill is empty! Cycle Variance=0.0\n");
      CherenkovSpillAvailable=false;
    } else if (ratio<2.0 && cutMode>0) {
      printf("[GetSpillFile] XXXXXXXX   Spill is empty! Ratio=%.2f\n", ratio);
      CherenkovSpillAvailable=false;
    }

//////////////////////////////// fix the rejection of bad spills /////////////////////////
/*
    if (filledSampleD != filledSample) {
      printf("[GetSpillFile] XXXXXXXX   Filled Sample conflict: Static=%d, Dynamic=%d\n", filledSample, filledSampleD);
      CherenkovSpillAvailable=false;
    }
*/
    if (SpillWWW>0.0) {
      SpillCG/=SpillWWW;
      SpillRMS/=SpillWWW;
      SpillRMS-=SpillCG*SpillCG;
      SpillRMS=sqrt(SpillRMS);
    } else {
      SpillCG=-1000.0;
      SpillRMS=0.0;
    }

    printf("[GetSpillFile] ===== SpillStart=%.1fms SpillCOG=%.1fms SpillEnd=%.1fms Noise=%.1f GADC\n", 
            SpillStart*1.0e-6, SpillCG*1.0e-6, SpillEnd*1.0e-6, spillNoise);
//////////////////////////////// fix the rejection of bad spills /////////////////////////
/*
    if (SpillStart>135.0e6 || // spill with late start!
        (SpillEnd!=0.0 && SpillEnd  <800.0e6 && (EH->run<672 || EH->run>678)) || // spill with early end!
        (SpillEnd!=0.0 && SpillEnd  <650.0e6 && (EH->run>671 && EH->run<679)) || // spill with early end!
        SpillCG  <350.0e6  || // spill with early COG!
        SpillCG  >900.0e6 ) { // spill with late COG!
      //CherenkovSpillAvailable=false; 
      //printf("[GetSpillFile] XXXXXXXX   Spill rejected for bad timing!\n");
    }
*/   
    spillNoise3=3.0*spillNoise;     
    fuzz0=0.;
    fuzz1=0.;
    fuzz2=0.;
    nh30=0;

    for (int i=2; i<ns30-3; i++) {
      
      double diff=Sum31[i]-0.5*(Sum31[i-1]+Sum31[i+1]);
      double avrg=(Sum31[i-1]+Sum31[i+1]+Sum31[i])/3.0;

      //printf("[GetSpillFile] checking hot zones i=%8d Sum31=%6.1f avrg=%6.1f diff=%6.1f\n",
      //       i, Sum31[i], avrg, diff);

      double r1=0.;
      double r2=0.;
      for (int j=i-2; j<i+3; j++) {
        r1+=Sum31[j];
        r2+=Sum31[j]*Sum31[j];
      }
      r2/=5.;
      r1/=5.;
      r2-=r1*r1;
      if (r2>0.0) r2=sqrt(r2);
      else r2=0.0;
      Fzz30[i]=r2/spillNoise;
      Fzz30[i]=fabs(diff)/spillNoise;
//      if (avrg<-50.) {
      if (Noi30[i]>spillNoise3 && Hot30[i]==-1) { // NEW hot zone
        int nQuiet=0;
        int ilast=i;
        double zzz=0.;
        //int ipr=0;
        for (int j=i; j<ns30 && nQuiet<2; j++) {
          if (Noi30[j]>spillNoise3) {
            nQuiet=0;
          } else { 
            nQuiet++;
          }
          Hot30[j]=nh30;
          ilast=j;
        }
// drop last 2 quiet laps
        Hot30[ilast]=-1;
        Hot30[ilast-1]=-1;
        ilast-=2;
        for (int j=i; j<=ilast; j++) {
          zzz+=Noi30[j];
        }
        zzz/=spillNoise;       
        zzz/=double(ilast-i+1);

        if (zzz<6.0 || ilast==i) {
          for (int j=i; j<=ilast; j++) Hot30[j]=-1; // erase pigmeys
          zzz=0.0;
        } else {
          //for (int j=i; j<=ilast; j++) {
          //  printf("       hot group#%d start=%d\t j=%d\t noise=%.2f\t noise/noise0=%.2f\t noise3=%.2f\n",
          //         nh30, i, j, Noi30[j], Noi30[j]/spillNoise, spillNoise3);
          //}
          Zone30noise[nh30]=zzz;
          Izone0[nh30]=i;
          Izone1[nh30]=ilast;
          nh30++;
          
//          printf("[CherenkovBuffer->GetSpillFile] spill#%d found group#%d of %d(%d) hot laps, noise/noise0=%.1f\n", 
//                 ProcStatus->GetBurstHeader()->burst, nh30, nh30max, ilast-i+1, zzz);
          if (nh30==nh30max) {
            printf("[CherenkovBuffer->GetSpillFile] ******* too many hot zones, bye!\n");
            exit(-1);
          }
        }

      } // done with hot zone

      diff/=(fabs(avrg)+spillNoise);
      fuzz0+=1.0;
      fuzz1+=diff;
      fuzz2+=diff*diff;
    }
    if (fuzz0==0.) {
      printf("[GetSpillFile] fuzz0 is zero!\n");
      if (CherenkovSpillAvailable) exit(-1);
    } else {
      fuzz1/=fuzz0;
      fuzz2/=fuzz0;
      fuzz2-=fuzz1*fuzz1;
      fuzz2=sqrt(fuzz2);
    }

    printf("[GetSpillFile] Spill fuzziness=%f\n", fuzz2);
    double add=0.2;
   
    if (HVcorrection==0.) {
      printf("[GetSpillFile] HVcorrection is zero!\n");
      //exit(-1);
    }
 

    if (ProcStatus->CheckSlopesLoaded()) {
      for (int i=0; i<10; i++) {
        SampleLeakDyn[i]=ProcStatus->GetBunchSlope(i); // they are very close, use same value
        SampleLeakSta[i]=ProcStatus->GetBunchSlope(i);
      }
      printf("[GetSpillFile] slopes from file ->\n");
      for (int i=0; i<10; i++) {
//        tailCovDyn[i].SetWeight(i, 1000.);
        printf(" Leakage#%d %7.4f\t %7.4f\n",
                   i, SampleLeakDyn[i], SampleLeakSta[i]);
      }
    } else {
      printf("[GetSpillFile] computing leak sums\n");  
      nIsol0=0;
      nIsol1=0;

      for (int i=0; i<10; i++) {
        tailCovDyn[i].Clear();
        tailCovSta[i].Clear();
      }

      for (int i=10; i<nw16-10; i++) {
        if (!filledSample[i%30]) continue;
        if (!ProcStatus->GetBunchIsolated(i%30)) continue;
  
        nIsol0++;

        if (Cbuf[i]>3950   || Covf[i]>0)   continue; // exclude overflows

        nIsol1++;
        for (int j=1; j<10 && i+j<nw16; j++) {
          if (Cbuf[i+j]>3900   || Covf[i+j]>0)   continue; // exclude overflows
          if (filledSample[(i+j)%30]) break;
          tailCovDyn[j-1].Fill(Cbufd[i], Cbufd[i+j]);
          tailCovSta[j-1].Fill(Cbuff[i], Cbuff[i+j]);
          SampleSignalLeak[j-1].Fill(Cbufd[i], Cbufd[i+j]);
          SampleSignalLeakProf[j-1].Fill(Cbufd[i], Cbufd[i+j]);
        }      
      }

      printf("[GetSpillFile] %d good isolated bunches counted of %d\n", nIsol1, nIsol0);
      if (nIsol1==0) { // no good isolated bunches
        CherenkovSpillAvailable=false;
        printf("[GetSpillFile] XXXXXXXX Spill rejected for luck of isolated bunches\n");
        for (int i=0; i<10; i++) {
          SampleLeakDyn[i]=0.;
          SampleLeakSta[i]=0.;
        }      

      } else { // calculate slopes and apply correction!
        printf("[GetSpillFile] slopes from fit ->\n");
        bool collision=false;
        double wMax=0.;
        for (int i=0; i<10; i++) {
          if (wMax<tailCovSta[i].GetWeight(10)) wMax=tailCovSta[i].GetWeight(10);
          if (tailCovSta[i].GetWeight(10)==0. || 
              tailCovSta[i].GetWeight(10)<0.75*wMax) {
            tailCovSta[i].Clear();
            tailCovDyn[i].Clear();
            continue;
          }
          if (i>1 && !collision && tailCovDyn[i].GetSlopeX0(10)>0.15) collision=true;
          if (!collision) {
            SampleLeakDyn[i]=tailCovDyn[i].GetSlopeX0(10);
            SampleLeakSta[i]=tailCovSta[i].GetSlopeX0(10);
          } else {
            SampleLeakDyn[i]=0.0;
            SampleLeakSta[i]=0.0;
          }
          printf(" Leakage#%d w=%10.0f %7.4f+/-%.4f\t %7.4f+/-%.5f\n",
                   i, tailCovSta[i].GetWeight(10), 
                   SampleLeakDyn[i], tailCovDyn[i].GetSlopeX0Variance(),
                   SampleLeakSta[i], tailCovSta[i].GetSlopeX0Variance());
        }
      }

// do second iteration in a narrow corridor


//=================== end of second iteration
    }

    int EventNumber=0;
    spillNum.clear();
    eventGADC.clear();
    sampleGADC.clear();
    sampleRMS.clear();
    sampleMEAN.clear();
    sampleRATE.clear();


    for (int i=0; i<nw16; i++) {

      for (int j=0; j<10 && i+j+1<nw16; j++) {
        if (SampleLeakDyn[j]==0.) break;
        Cbufdt[i+j+1]-=SampleLeakDyn[j]*Cbufdt[i];
        Cbufft[i+j+1]-=SampleLeakSta[j]*Cbufft[i];
      }

      SpillIntegralTail      +=Cbufdt[i];
      SpillIntegralStaticTail+=Cbufft[i];

      if (filledSample[i%30]) {
        Spectrum->Fill(Cbufdt[i]);
        SpillIntegralFilledTail      +=Cbufdt[i];
        SpillIntegralStaticFilledTail+=Cbufft[i];
      } else if (i>5) {
        if (!filledSample[(i-1)%30] && 
            !filledSample[(i-2)%30] && 
            !filledSample[(i-3)%30]) {
          SpectrumPed->Fill(Cbufdt[i]);
        }
      }

      filledWghTail[i%30]+=1.0;
      filledSum1Tail[i%30]+=Cbufdt[i];
      filledSum2Tail[i%30]+=Cbufdt[i]*Cbufdt[i];
      filledWghTailEvt[i%30]+=1.0;
      filledSum1TailEvt[i%30]+=Cbufdt[i];
      filledSum2TailEvt[i%30]+=Cbufdt[i]*Cbufdt[i];

      bool EvtFlag = false;
      bool StatOK  = true;
      if (i==0) EvtFlag = (Cflg[0]==1);
      else      EvtFlag = (Cflg[i]==1) && (Cflg[i-1]==0);

      if (EvtFlag) {
//        if (ProcStatus->GetReportMode()<2) printf(" event flag at sample#%d\n", i);
        for (int j=0; j<30; j++) {
          StatOK = StatOK && (filledWghTailEvt[j]>100.0);
        }
        if (StatOK) {
          double rmsMin=1.0e10;
          double rmsMax=0.0;
          double ampMax=0.0;
          for (int is=0; is<30; is++) {
            filledSum1TailEvt[is]/=filledWghTailEvt[is];
            filledSum2TailEvt[is]/=filledWghTailEvt[is];
            filledSum2TailEvt[is]-=filledSum1TailEvt[is]*filledSum1TailEvt[is];
            if (filledSum2TailEvt[is]>0.) {
              filledSum2TailEvt[is]=sqrt(filledSum2TailEvt[is]);
              if (rmsMin>filledSum2TailEvt[is]) rmsMin=filledSum2TailEvt[is];
              if (rmsMax<filledSum2TailEvt[is]) rmsMax=filledSum2TailEvt[is];
              if (ampMax<filledSum1TailEvt[is]) ampMax=filledSum1TailEvt[is];
            } else {
              filledSum2TailEvt[is]=0.;
            }
            spillNum. push_back(ProcStatus->GetBurstHeader()->burst);
            eventGADC. push_back(EventNumber);
            sampleGADC.push_back(is);
            sampleRMS. push_back(filledSum2TailEvt[is]);
            sampleMEAN.push_back(filledSum1TailEvt[is]);
            sampleRATE.push_back(int(filledWghTailEvt[is]));
          }

          if (ProcStatus->GetReportMode()==1 && false) {
              printf("\nEvent#%03d (%5.2f, %5.2f) spill structure ->\n", 
                      EventNumber, ampMax/(ampMax+rmsMin), (rmsMax-rmsMin)/(rmsMax+rmsMin));
              for (int is=0; is<30; is++) printf("   %3d",  ProcStatus->GetBunchAction(is)); printf("\n");
              for (int is=0; is<30; is++) printf(" %5.1f", filledSum1TailEvt[is]); printf("\n");
              for (int is=0; is<30; is++) printf(" %5.1f", filledSum2TailEvt[is]); printf("\n");
              for (int is=0; is<30; is++) {
                printf(" %5.2f", filledSum1TailEvt[is]/(filledSum1TailEvt[is]+rmsMin)); 
              } printf("\n");
              for (int is=0; is<30; is++) {
                printf(" %5.2f", (filledSum2TailEvt[is]-rmsMin)/(filledSum2TailEvt[is]+rmsMin)); 
              } printf("\n");

          }
          for (int is=0; is<30; is++) {
            filledSum1TailEvt[is]=0.0;
            filledSum2TailEvt[is]=0.0;
            filledWghTailEvt[is] =0.0;
          }
        } else { // StatOK
          printf("Event#%03d low statistics ->\n", EventNumber);
          for (int is=0; is<30; is++) printf(" %5d", int(filledWghTailEvt[is])); printf("\n");

        } // !StatOK

        EventNumber++;
      } // EvtFlag

    } // sample looper

    for (int i=0; i<30; i++) {
      filledSum1Tail[i]/=filledWghTail[i];
      filledSum2Tail[i]/=filledWghTail[i];
      filledSum2Tail[i]-=filledSum1Tail[i]*filledSum1Tail[i];
      if (filledSum2Tail[i]>0.) filledSum2Tail[i]=sqrt(filledSum2Tail[i]);
      else                      filledSum2Tail[i]=0.;
      spillNum.  push_back(ProcStatus->GetBurstHeader()->burst);
      eventGADC. push_back(-1);
      sampleGADC.push_back(i);
      sampleRMS. push_back(filledSum2Tail[i]);
      sampleMEAN.push_back(filledSum1Tail[i]);
      sampleRATE.push_back(int(filledWghTail[i]));
    }

    printf("Tail fixed spill structure ->\n");
    for (int i=0; i<30; i++) printf("   #%2d", i);                printf("\n");
    for (int i=0; i<30; i++) printf(" %5.1f", filledSum1Tail[i]); printf("\n");
    for (int i=0; i<30; i++) printf(" %5.1f", filledSum2Tail[i]); printf("\n");


//    printf("Push->");
//    cin>>iqq;
//    if (iqq==-1) exit(-1);

    

    if (SpillIntegralFilled>0.0) add=0.2*sqrt(4.e6/HVcorrection/SpillIntegralFilled);
    if (fuzz2>0.7+add && cutMode>2) {
      CherenkovSpillAvailable=false;
      printf("[GetSpillFile] XXXXXXXX Spill rejected for excessive fuzziness %.3f\n", fuzz2);
    }
    printf("[GetSpillFile] ******************************** \n");
    printf("[GetSpillFile] Max30=%1.2e protons/bunch @ %d T=%.1fms\n", 
            HVcorrection*sum30max, i30max, i30max*30*dT/1000000.);
    printf("[GetSpillFile]               Static         Dynamic      s\n"); 
    printf("[GetSpillFile]  all           %1.3e   %1.3e protons\n", 
                              HVcorrection*SpillIntegralStatic,                 HVcorrection*SpillIntegral);
    printf("[GetSpillFile]  filled        %1.3e   %1.3e protons\n", 
                              HVcorrection*SpillIntegralStaticFilled,           HVcorrection*SpillIntegralFilled);
    printf("[GetSpillFile]  all-tail      %1.3e   %1.3e protons\n", 
                              HVcorrection*SpillIntegralStaticTail,             HVcorrection*SpillIntegralTail);
    printf("[GetSpillFile]  filled-tail   %1.3e   %1.3e protons\n", 
                              HVcorrection*SpillIntegralStaticFilledTail,       HVcorrection*SpillIntegralFilledTail);
    printf("[GetSpillFile] ******************************** \n");
    if (SpillIntegralFilled !=0.0) {
      if (SpillIntegral/SpillIntegralFilled>1.4 && cutMode>1) {
        CherenkovSpillAvailable=false;
        printf("[GetSpillFile] XXXXXXXX Spill rejected for parasitic bunch suspition, All/Filled=%.2f\n", SpillIntegral/SpillIntegralFilled);
      }
    } 
    int iP=699;
    topA[iP]=sum30max;
    topT[iP]=i30max*30*dT;

    if (sum30max<0. && cutMode>0) {
      printf("[GetSpillFile]  XXXXXXXX Bad Spill, negative sum30max!\n");
      CherenkovSpillAvailable=false;
    }  

    CherenkovQualityAvailable=true;
/*
    cherenkovQuality.open(SpillQualityName, ios::in);
    if (!cherenkovQuality.is_open()) { 
      printf("[GetSpillFile]  XXXXXXXX failed to open file %s\n", SpillQualityName);
      cherenkovQuality.clear();
      CherenkovQualityAvailable=false;
      CherenkovSpillAvailable=false;
    } 
    if (!cherenkovData.good()) {
      printf("[GetSpillFile]  XXXXXXXX file %s is not good ;(\n", SpillQualityName);
      cherenkovQuality.close();
      cherenkovQuality.clear();    
      CherenkovQualityAvailable=false;
      CherenkovSpillAvailable=false;
    }

    printf("[CherenkovBuffer->GetSpillFile] old offset=%d\n",eventOffset);
    cherenkovQuality >> eventOffset >> 
                        eventCount  >> 
                        eventSpill  >> 
                        nOffset     >> 
                        nPedestalFile     >> 
                        spillPedestalFile >> 
                        spillNoiseFile;
    cherenkovQuality.close();    
    cherenkovQuality.clear();    
    printf("[CherenkovBuffer->GetSpillFile] file %s loaded\n", SpillQualityName);
    printf("                                events: %3d, %3d, %3d, offset=%d\n",
            eventCount, eventSpill, nOffset, eventOffset);
    printf("                                pedestal=%.1f noise=%.1f nped=%d\n",
            spillPedestalFile, spillNoiseFile, nPedestalFile);
*/

/*
    if (!CherenkovSpillAvailable) {
      printf("what to do? ->");
      cin >> iqq;
      if (iqq==0) exit(-1);
    }
*/
    return CherenkovSpillAvailable;
  }
  
  bool LoadAlignment(int run, int burst) { // loads 2012-style MPI-Gated event RF clock offset
    bool result=true;
    char ALIGNname[200];
    double s2=0.0;
    double shiftBest=0.0;
    
    jOffBest=0;

    sprintf(ALIGNname, "reports/MPI_Gated_alignment/run%dburst%d.dat", run, burst);
    cherenkovQuality.open(ALIGNname, ios::in);
    if (!cherenkovQuality.is_open()) { 
      printf("[CherenkovBuffer->LoadAlignment]  XXXXXXXX failed to open file %s\n", ALIGNname);
      cherenkovQuality.clear();
      CherenkovQualityAvailable=false;
      CherenkovSpillAvailable=false;
      return false;
    } 
    if (!cherenkovQuality.good()) { 
      printf("[CherenkovBuffer->LoadAlignment]  XXXXXXXX failed to open file %s\n", ALIGNname);
      cherenkovQuality.close();
      cherenkovQuality.clear();
      CherenkovQualityAvailable=false;
      CherenkovSpillAvailable=false;
      return false;
    } 

    
    cherenkovQuality >> s2 >> jOffBest >> shiftBest;
    nEvtOff=0;
    do {
      cherenkovQuality >> iEvtMPI[nEvtOff] >> iEvtCG[nEvtOff] >> iCorr[nEvtOff];
    } while (iEvtMPI[nEvtOff++] != -1);
    nEvtOff--;
    
    eventOffset=int(shiftBest+0.5);
    if (nEvtOff>1 && iEvtMPI[0]!=0) {
      printf("[CherenkovBuffer->LoadAlignment] Odd case found!!!! See list of shifted events below->\n");
      printf("[CherenkovBuffer->LoadAlignment] file: %s\n", ALIGNname);
      for (int i=0; i<nEvtOff; i++) {
        printf("    odd event MPI#%d CG#%d shift=%d RF cycles\n", iEvtMPI[i], iEvtCG[i], iCorr[i]);
      }
      printf("[CherenkovBuffer->LoadAlignment] case not implemented yet, bye!\n");
      cherenkovQuality.close();
      cherenkovQuality.clear();
      return false;
      //exit(-1);
    }
    
    cherenkovQuality.close();
    cherenkovQuality.clear();
    return result;
  }

  int    GetEventOffset()            {return eventOffset;}
  void   SetEventOffset(int iOffNew) {eventOffset=iOffNew;}

  double GetSpillIntegral()           {return HVcorrection*SpillIntegral;}
  double GetSpillIntegralFilled()     {return HVcorrection*SpillIntegralFilled;}
  double GetSpillIntegralTail()       {return HVcorrection*SpillIntegralTail;}
  double GetSpillIntegralFilledTail() {return HVcorrection*SpillIntegralFilledTail;}

  double GetSpillIntegralStatic()           {return HVcorrection*SpillIntegralStatic;}
  double GetSpillIntegralStaticFilled()     {return HVcorrection*SpillIntegralStaticFilled;}
  double GetSpillIntegralStaticTail()       {return HVcorrection*SpillIntegralStaticTail;}
  double GetSpillIntegralStaticFilledTail() {return HVcorrection*SpillIntegralStaticFilledTail;}

  double GetSpillIntegralRaw()           {return SpillIntegral;}
  double GetSpillIntegralFilledRaw()     {return SpillIntegralFilled;}
  double GetSpillIntegralTailRaw()       {return SpillIntegralTail;}
  double GetSpillIntegralFilledTailRaw() {return SpillIntegralFilledTail;}

  double GetSpillIntegralStaticRaw()           {return SpillIntegralStatic;}
  double GetSpillIntegralStaticFilledRaw()     {return SpillIntegralStaticFilled;}
  double GetSpillIntegralStaticTailRaw()       {return SpillIntegralStaticTail;}
  double GetSpillIntegralStaticFilledTailRaw() {return SpillIntegralStaticFilledTail;}

//  double GetSumIsolStatic(int i)    {return HVcorrection*SumIsolStatic[i];}
//  double GetSumIsol(int i)          {return HVcorrection*SumIsol[i];}
//  double GetSumIsolStaticCut(int i) {return HVcorrection*SumIsolStaticCut[i];}
//  double GetSumIsolCut(int i)       {return HVcorrection*SumIsolCut[i];}


  double GetSpillPedestal()    {return spillPedestal;}

//  double GetSpillNoiseRAW() {return spillNoise/CherenkovFactor;} // Raw Gated  ADC
  double GetSpillNoiseRAW()    {return spillNoise;} // Raw Gated  ADC
  double GetSpillNoise()       {return spillNoise;}                 // MPI ADC
  double GetSpillNoiseHV()     {return HVcorrection*spillNoise;}    // tracks
  int    GetPedestalCount()    {return nPedestal;}

  const char* GetQualityFile() {return SpillQualityName;}
  const char* GetSpillFile()   {return SpillFileName;}

  double GetSampleLeakDyn(int i) {
    if (i<0 || i>9) {
      printf("[CherenkovBuffer->GetSampleLeakDyn] Bad index #%d, ciao!\n", i);
      exit(-1);
    }
    return SampleLeakDyn[i];
  }
  double GetSampleLeakSta(int i) {
    if (i<0 || i>9) {
      printf("[CherenkovBuffer->GetSampleLeakSta] Bad index #%d, ciao!\n", i);
      exit(-1);
    }
    return SampleLeakSta[i];
  }

  double GetSample(int iSample) {
    return Cbuff[iSample];
  }

  double GetSampleAdjust(double T) {
    int jSample=int(T/dT)+EH->scaler6mhz-iStart-eventOffset;
    if (jSample>-1 && jSample<nw16) return Cbuff[jSample];
    else return 0.0;
  }

  int GetSampleIndex(double T) {
    int jSample=int(T/dT)+EH->scaler6mhz-iStart-eventOffset;
    if (jSample>-1 && jSample<nw16) return jSample;
    else return -1;
  }
  int GetSampleIndex(int is) { // event sample to file index 
    int jSample=is+EH->scaler6mhz-iStart-eventOffset;
    if (jSample>-1 && jSample<nw16) return jSample;
    else return -1;
  }

  bool CheckFilledSegmet() { // checks if the event is within the filled part of Spill
    int i100=(EH->scaler6mhz-iStart-eventOffset)/ns100;
//    printf("[CherenkovBuffer->CheckFilledSegmet] first=%d evt100=%d last=%d\n", firstOf100, i100, lastOf100);
    if (i100<firstOf100) return false;
    if (i100>lastOf100) return false;
    return true;
  }


  double GetSampleAdjust(int iSample) {
    int jSample=iSample+EH->scaler6mhz-iStart-eventOffset;
    if (jSample>-1 && jSample<nw16) return Cbuff[jSample];
    else return 0.0;
  }

  double GetSampleAdjustD(int iSample) { // returns Gated amplitude matching the sample inside the event
//    if (iSample==0) {
//      printf("[CherenkovBuffer->GetSampleAdjustD(int)] evt#%d(%d) EH->6mhz=%d EH->6mhz-Offset=%d\n", 
//           EH->event, EH->burstEvent, EH->scaler6mhz,  EH->scaler6mhz-eventOffset);
//    }
    int jSample=iSample+EH->scaler6mhz-iStart-eventOffset;
    if (jSample>-1 && jSample<nw16) return Cbufd[jSample];
    else return 0.0;
  }
  double GetSampleAdjustD(double T) { // positioned by time T relative to the event start, normaly Tbunch //
    int jSample=int(T/dT)+EH->scaler6mhz-iStart-eventOffset;
    if (jSample>-1 && jSample<nw16) return Cbufd[jSample];
    else return 0.0;
  }

  double GetSampleAdjustHV(int iSample) {
    int jSample=iSample+EH->scaler6mhz-iStart-eventOffset;
    if (jSample>-1 && jSample<nw16) return HVcorrection*Cbuff[jSample];
    else return 0.0;
  }
  double GetSampleAdjustHV(double T) {
    int jSample=int(T/dT)+EH->scaler6mhz-iStart-eventOffset;
    if (jSample>-1 && jSample<nw16) return HVcorrection*Cbuff[jSample];
    else return 0.0;
  }


  double GetSampleAdjustDHV(int iSample) {
    int jSample=iSample+EH->scaler6mhz-iStart-eventOffset;
    if (jSample>-1 && jSample<nw16) return HVcorrection*Cbufd[jSample];
    else return 0.0;
  }
  double GetSampleAdjustDHV(double T) {
    int jSample=int(T/dT)+EH->scaler6mhz-iStart-eventOffset;
    if (jSample>-1 && jSample<nw16) return HVcorrection*Cbufd[jSample];
    else return 0.0;
  }

  int    GetNlaps()           {return ns30;}
  int*   GetNlapsPointer()    {return &ns30;}
  float* GetLapsSumPointer()  {return &Sum30[0];} // sum of all fulled bunches in the lap
  float* GetLapsAvrPointer()  {return &Sum31[0];} // average rate (per filled bunch) in the lap

  int GetLapIndex(int iSample) { // lap index for sample# in the event
    int jSample=iSample+EH->scaler6mhz-iStart-eventOffset;
    int jLap=jSample/30;
    if (jLap>-1 && jLap<ns30) return jLap;
    return 0;    
  }

  double GetLap(int iLap) { // returns accelerator lap SUM
    if (iLap>-1 && iLap<ns30) return Sum30[iLap];
    return 0.;    
  }
  double GetLap1(int iLap) { // returns accelerator lap average
    if (iLap>-1 && iLap<ns30) return Sum31[iLap];
    return 0.;    
  }

  int GetLapIndex(double t) {
     double s=t/dT-iStart-eventOffset;
     int iLap=int((s-15.)/30.);
     if (iLap<0) return 0;
     if (iLap>=ns30) return ns30;
     return iLap;
  }

  double GetLapHV(int iLap) { // returns accelerator lap sum 
    if (iLap>-1 && iLap<ns30) return HVcorrection*Sum30[iLap];
    return 0.;    
  }
  double GetLapHV1(int iLap) { // returns accelerator lap average
    if (iLap>-1 && iLap<ns30) return HVcorrection*Sum31[iLap];
    return 0.;    
  }
  double GetMaxHV(int iLap) { // returns accelerator lap max
    if (iLap>-1 && iLap<ns30) return HVcorrection*Max30[iLap];
    return 0.;    
  }
  double GetNoiseHV(int iLap) { // returns accelerator lap average
    if (iLap>-1 && iLap<ns30) return HVcorrection*Noi30[iLap];
    return 0.;    
  }
  double GetFuzziness(int iLap) { // returns accelerator lap average
    if (iLap>-1 && iLap<ns30) return Fzz30[iLap];
    return 0.;    
  }
 

  double GetLapSample(int iSample) { // returns accelerator lap sum
    int jSample=iSample+EH->scaler6mhz-iStart-eventOffset;
    int jLap=jSample/30;
    if (jLap>-1 && jLap<ns30) return Sum30[jLap];
    return 0.;    
  }
  double GetLapSample1(int iSample) { // returns accelerator lap average
    int jSample=iSample+EH->scaler6mhz-iStart-eventOffset;
    int jLap=jSample/30;
    if (jLap>-1 && jLap<ns30) return Sum31[jLap];
    return 0.;    
  }


  double GetLapTime(int iLap) { // returns accelerator lap TIME average
    if (iLap<0 || iLap>=ns30) return -1000.;
    int iSample=iLap*30+15;
    //printf("[GetLapTime] dT=%f RF=%f\n", dT, EH->GetRFperiod());
    return EH->GetRFperiod()*(iSample+iStart+eventOffset);    
  }

   int GetIndexAdjust(int iSample) {
    int jSample=iSample+EH->scaler6mhz-iStart-eventOffset;
    return jSample;
  }

  bool CheckSampleFilled(int iSample) {
    if (CheckSampleAdjust(iSample)) {
      int jSample=iSample+EH->scaler6mhz-iStart-eventOffset;
      return (filledSample[jSample%30]);
    } else {
      return false;
    }
  }

  double GetCherenkovHV() {return voltm_data[1];}

  bool CheckSampleAdjust(int iSample) {
    int jSample=iSample+EH->scaler6mhz-iStart-eventOffset;
    if (jSample>-1 && jSample<nw16) return true;
    else return false;
  }


  int GetSampleRaw(int iSample) {
    return Cbuf[iSample];
  }

  int GetEventCount() {
    return kevents;
  }
  int GetEventPointerCurrent() { // pointer to current event // be alerted of missing flags!
    if (EH->event<kevents) return EvtPnt[EH->burstEvent];
    else return -1;
  }

  int GetEventPointer(int iChEvt) { // pointer to event in Gated Stream
    //printf("[CherenkovBuffer->GetEventPointer] iChEvt=%d pointer=%d\n",
    //      iChEvt, EvtPnt[iChEvt]);
    if (iChEvt<kevents && iChEvt>-1) return EvtPnt[iChEvt];
    else return -1;
  }

  int GetEventPointerMPI(int iChEvt) { // pointer to MPI event in Gated Stream
    int iEvt=iChEvt+jOffBest;
//    int iEvt=iChEvt+eventCount-eventSpill;
    printf("[CherenkovBuffer->GetEventPointerMPI] not tuned yet, sorry!\n");
    exit(-1);
    if (iEvt<0) {
      printf("[CherenkovBuffer->GetEventPointerMPI] Requested wrong event number iEvt=%d > kevent=%d\n",
             iEvt, kevents);
      //exit(-1);
      iEvt=0;
      return -1;
    }
    if (iEvt>=kevents) {
      printf("[CherenkovBuffer->GetEventPointerMPI] Requested wrong event number iEvt=%d > kevent=%d\n",
             iEvt, kevents);
      exit(-1);
      iEvt=kevents-1;
    }
    printf("[CherenkovBuffer->GetEventPointerMPI] iChEvt=%d eventCount=%d  eventSpill=%d iEvt=%d pointer=%d\n",
          iChEvt, eventCount, eventSpill, iEvt, EvtPnt[iEvt]);
    return EvtPnt[iEvt];
  }



  void SetEvent6mhz() {
    Dbg=false;
    if (Dbg) {
      printf("[CherenkovBuffer->SetEvent6mhz] Evt#%5d", EH->event);
      printf(" clock 6MHZ = %10d", EH->scaler6mhz);
      if (EH->event==0) {
        for (int j=0; j<4; j++) {
          printf(" Event Marker = %6d diff=%6d offset=%d\n", 
                 EvtPnt[EH->event+j], EH->scaler6mhz - EvtPnt[EH->event+j], eventOffset);
        }
      } else { 
        for (int j=-1; j<4; j++) {
          printf(" Event Marker = %6d diff=%6d offset=%d\n", 
                 EvtPnt[EH->event+j], EH->scaler6mhz - EvtPnt[EH->event+j], eventOffset);
        }
      }
    }
    Dbg=false;
    return;
  }

  bool GetCherenkovAvailable () {
    return CherenkovRunAvailable && CherenkovSpillAvailable && CherenkovEventAvailable;
  }

  bool GetCherenkovRunAvailable () {
    return CherenkovRunAvailable;
  }

  bool GetCherenkovSpillAvailable () {
    return CherenkovSpillAvailable;
  }

  bool GetCherenkovEventAvailable () {
    return CherenkovEventAvailable;
  }

  void SetCherenkovEventAvailable (bool val) {
    CherenkovEventAvailable=val;
  }


  double GetIntegralRaw(double t0, double T, int iOpt) { 
// t0   - time where integal needed relative to the event start (normally, bunch time)
//  T   - integration time (nsec);
// iOpt = 0 flat integral
// iOpt = 1 exponent integral
// iOpt = 2 triangular integral
    //Dbg=true;

    
    if (iOpt<0) printf("[CherenkovBuffer->GetIntegral] Available=%d t0=%f T=%f opt=%d\n", CherenkovEventAvailable, t0, T, iOpt);
    
    if (!BH->CherenkovLoaded) return 0.0;
    if (T==0.) {
      printf("[GetIntegral] Integration Time=0.! What are you thinking?!\n");
      //exit(-1);
      return 0.;
    }
    double Asum=0.;
    double Wsum=0.;  // to have intensity normalysed to filled bunch 

    int iChEVT=EH->scaler6mhz-iStart-eventOffset; // first sample of the event
    int iCh=iChEVT+int((t0-330.)/dT); // step back 500ns to exclude current bunch

    if (iChEVT>=nw16 || iCh>=nw16 || iChEVT<0 || iCh<0) {
      //printf("[GetIntegral] ERROR \n[GetIntegral] Evt#%d(%d) t0=%.1fns T=%.1fns 6MHz=%d iStart=%d eventOffset=%d EventSample=%d StartSample==%d\n",
      //       EH->event, EH->burstEvent, t0, T, EH->scaler6mhz, iStart, eventOffset, iChEVT, iCh);
      //printf("push!");
      //cin >> iqq;
      //if (iqq==0) exit(-1);
      return 0.;
      //exit(-1);
    }
    if (iOpt<0) {
      printf("[GetIntegral] t0=%.1fns T=%.1fns 6MHz=%d iStart=%d eventOffset=%d EventSample=%d StartSample==%d\n",
             t0, T, EH->scaler6mhz, iStart, eventOffset, iChEVT, iCh);
    }

    

    int iCh0=0;
    if (iOpt==0) {// simple integral //
      iCh0 = iCh - int(T/dT);
      if (iCh0<0) iCh0=0;
      for(int i=iCh0; i<iCh && i<nw16; i++) {
//        if (filledSample[i%30]) {
          Asum+=Cbufd[i];
          Wsum+=1.0;
//        }
      }
    } else if (iOpt==1 || iOpt==-1) { // exponential integral 
      double dw=exp(-6.0*dT/T); // 6, since only filled samples counted //
      if (iOpt<0) printf("[GetIntegral] dT=%.3f dT/T=%.3f W=%.3f\n", dT, dT/T, dw);
      double w=1.0;
      int i=iCh;
      
      while (i>0 && w>1.0e-6) {
        if (iOpt<0) printf("[GetIntegral] sample#%d A=%.1f(%.1f) ", i, Cbufd[i], Cbuff[i]); 
//        if (filledSample[i%30]) {
          Asum+=w*Cbufd[i];
          Wsum+=w;
          if (iOpt<0) printf("adding with w=%.3e Asum=%.1f Wsum=%.2f I=%.1f",
                             w, Asum, Wsum, Asum/Wsum); 
          w*=dw;
//        }
        if (iOpt<0) printf("\n");
        i--;
      }
      if (iOpt<0) printf("------------------------------------------------------------\n");

    } else if (iOpt==2 || iOpt==-2) { // triangle integral 
      double w=1.0;
      double dw=dT/T;
      int i=iCh;
      while (i>0 && w>0.) {
        //if (iOpt==-2) printf(" #%d Ad=%6.1f As=%6.1f", i, Cbufd[i], Cbuff[i]);
//        if (filledSample[i%30]) {
          //if (iOpt==-2) printf(" added as %6.1f, w=%7.5f", w*Cbufd[i], w);   
          Asum+=w*Cbufd[i];
          Wsum+=w;
//        }
        //if (iOpt==-2) printf("\n");
        w-=dw;
        i--;
/*
        if (iOpt==-2 && iCh-i==20) {
          int iqq=0;
          printf("push->");
          cin >> iqq;
          if (iqq==0) exit(-1);
          if (iqq==2) iOpt=2;
        }
*/
      }
      if (iOpt==-2) {
        //int iqq=0;
        printf("i=%d iCh-i=%d T=%.0f\n", i, iCh-i, dT*double(iCh-i));
        //cin >> iqq;
        //if (iqq==0) exit(-1);
      }


    } else {
      printf("[CherenkovBuffer -> GetCherenkovIntegral] Integral Option %d not implemented. Bye\n", iOpt);
      Dbg=false;
      return 0.0;
    }

    if (Wsum>0.) {
      Asum/=Wsum;
    } else {
      Asum=0.0;
    }

    if (iOpt<0.0) printf("[ComputeIntegral] Wsum=%f Asum=%f HVcorrection=%f\n", Wsum, Asum, HVcorrection);
    Dbg=false;
    return Asum;

  }



  double GetIntegral(double t0, double T, int iOpt) { 
// t0   - time where integal needed relative to the event start (normally, bunch time)
//  T   - integration time (nsec);
// iOpt = 0 flat integral
// iOpt = 1 exponent integral
// iOpt = 2 triangular integral
    //Dbg=true;

    
    if (iOpt<0) printf("[CherenkovBuffer->GetIntegral] Available=%d t0=%f T=%f opt=%d\n", CherenkovEventAvailable, t0, T, iOpt);
    
    //if (!CherenkovEventAvailable) return 0.0;
    if (!BH->CherenkovLoaded) return 0.0;
    if (T==0.) {
      //printf("[GetIntegral] Integration Time=0.! What are you thinking?!\n");
      //exit(-1);
      return 0.;
    }
    double Asum=0.;
    double Wsum=0.;  // to have intensity normalysed to filled bunch 
    //if (!CherenkovSpillAvailable) {
    //  //Dbg=false;
    //  return 0.;
    //}
    int iChEVT=EH->scaler6mhz-iStart-eventOffset; // first sample of the event
    //int iCh=iChEVT+int((t0+500.)/dT); // step back 500ns to include current bunch
    int iCh=iChEVT+int((t0-500.)/dT); // step back 500ns to exclude current bunch

    if (iChEVT>=nw16 || iCh>=nw16 || iChEVT<0 || iCh<0) {
      //printf("[GetIntegral] ERROR \n[GetIntegral] Evt#%d(%d) t0=%.1fns T=%.1fns 6MHz=%d iStart=%d eventOffset=%d EventSample=%d StartSample==%d\n",
      //       EH->event, EH->burstEvent, t0, T, EH->scaler6mhz, iStart, eventOffset, iChEVT, iCh);
      //printf("push!");
      //cin >> iqq;
      //if (iqq==0) exit(-1);
      return 0.;
      //exit(-1);
    }
    if (iOpt<0) {
      printf("[GetIntegral] t0=%.1fns T=%.1fns 6MHz=%d iStart=%d eventOffset=%d EventSample=%d StartSample==%d\n",
             t0, T, EH->scaler6mhz, iStart, eventOffset, iChEVT, iCh);
    }

    

    int iCh0=0;
    if (iOpt==0) {// simple integral //
      iCh0 = iCh - int(T/dT);
      if (iCh0<0) iCh0=0;
      for(int i=iCh0; i<iCh && i<nw16; i++) {
        if (filledSample[i%30]) {
          Asum+=Cbufd[i];
          Wsum+=1.0;
        }
      }
    } else if (iOpt==1 || iOpt==-1) { // exponential integral 
      double dw=exp(-6.0*dT/T); // 6, since only filled samples counted //
      if (iOpt<0) printf("[GetIntegral] dT=%.3f dT/T=%.3f W=%.3f\n", dT, dT/T, dw);
      double w=1.0;
      int i=iCh;
      
      while (i>0 && w>1.0e-6) {
        if (iOpt<0) printf("[GetIntegral] sample#%d A=%.1f(%.1f) ", i, Cbufd[i], Cbuff[i]); 
        if (filledSample[i%30]) {
          Asum+=w*Cbufd[i];
          Wsum+=w;
          if (iOpt<0) printf("adding with w=%.3e Asum=%.1f Wsum=%.2f I=%.1f",
                             w, Asum, Wsum, Asum/Wsum); 
          w*=dw;
        }
        if (iOpt<0) printf("\n");
        i--;
      }
      if (iOpt<0) printf("------------------------------------------------------------\n");

    } else if (iOpt==2 || iOpt==-2) { // triangle integral 
      double w=1.0;
      double dw=dT/T;
      int i=iCh;
      while (i>0 && w>0.) {
        //if (iOpt==-2) printf(" #%d Ad=%6.1f As=%6.1f", i, Cbufd[i], Cbuff[i]);
        if (filledSample[i%30]) {
          //if (iOpt==-2) printf(" added as %6.1f, w=%7.5f", w*Cbufd[i], w);   
          Asum+=w*Cbufd[i];
          Wsum+=w;
        }
        //if (iOpt==-2) printf("\n");
        w-=dw;
        i--;
/*
        if (iOpt==-2 && iCh-i==20) {
          int iqq=0;
          printf("push->");
          cin >> iqq;
          if (iqq==0) exit(-1);
          if (iqq==2) iOpt=2;
        }
*/
      }
      if (iOpt==-2) {
        //int iqq=0;
        printf("i=%d iCh-i=%d T=%.0f\n", i, iCh-i, dT*double(iCh-i));
        //cin >> iqq;
        //if (iqq==0) exit(-1);
      }


    } else {
      printf("[CherenkovBuffer -> GetCherenkovIntegral] Integral Option %d not implemented. Bye\n", iOpt);
      Dbg=false;
      return 0.0;
    }

    if (Wsum>0.) {
      Asum/=Wsum;
    } else {
      Asum=0.0;
    }

    if (iOpt<0.0) printf("[ComputeIntegral] Wsum=%f Asum=%f HVcorrection=%f\n", Wsum, Asum, HVcorrection);
    Dbg=false;
    return HVcorrection*Asum;

  }


  bool SetCherenkovTime(int i, double t) {
    if (i<0 || i>=50) return false;
    CherenkovTime[i]=t;
    return true;
  }

  void SetCherenkovTimeLine(double T0) {
    for (int i=0; i<50; i++) {
      CherenkovTime[i]=i*dT+T0;
    }
  }

  double GetCbuff(int i) {
    if (!HistogramsPrepared) return 0.0;
    if (i<0 || i>=nw16) {
      printf("[GetCbuff] index=%d\n", i);
      exit(-1);
    } else {
      if (CherenkovEventAvailable) {
        return Cbuff[i];
      } else {
        return 0.0;
      }
    }      
  }

  double GetCherenkovTime(int i) {
    if (!HistogramsPrepared) return 0.0;
    if (i<0 || i>=nw16) {
      printf("[GetCherenkovTime] index=%d\n", i);
      exit(-1);
    } else {
      return CherenkovTime[i];
    }      
  }

  void SetCherenkovMin(double a) {CherenkovMin=a;}
  void SetCherenkovMax(double a) {CherenkovMax=a;}
  double GetCherenkovMin()       {
    if (CherenkovEventAvailable) return CherenkovMin;
    else return 0.0;
  }
  double GetCherenkovMax()       {
    if (CherenkovEventAvailable) return CherenkovMax;
    else return 0.0;
  }
  double ComputeCherenkovMin()   {
    CherenkovMin=40000.;
    if (!HistogramsPrepared) return CherenkovMin;
    for (int i=0;i<nw16;i++) if (Cbufd[i]<CherenkovMin) CherenkovMin=Cbufd[i];
    return CherenkovMin;
  }

  double ComputeCherenkovMax()   {
    CherenkovMax=-400000.;
    if (!HistogramsPrepared) return CherenkovMax;
    for (int i=0;i<nw16;i++) if (Cbufd[i]>CherenkovMax) CherenkovMax=Cbufd[i];
    return CherenkovMax;
  }

  void PrepareHistograms() {
    HistogramsPrepared=true;
// canvas and histograms for IHEP Cherenkov Stream ADC
   
    StreamCanvas =      new TCanvas("Stream", "Stream Canvas",  0,   0, 600, 400);
    StreamCanvas1 =     new TCanvas("Stream1", "Stream Canvas", 0, 400, 600, 400);
    printf("[CherenkovBuffer->PrepareHistograms] creating new canvas %s\n", StreamCanvas->GetName());
    StreamCanvas->Iconify();
    StreamCanvas1->Iconify();
    StreamToMPI =       new TH1D("StreamToMPI",       "Stream to MPI Cherenkov ratio", 400, 0.5, 2.5);
    StreamToMPIspill =  new TH1D("StreamToMPIoneSpill",       "Stream to MPI Cherenkov ratio, single spill", 400, 0., 2.5);
    StreamToMPI1 =      new TH1D("StreamToMPI1",      "Stream to MPI Cherenkov ratio", 400, 0., 2.5);
    StreamToMPI2 =      new TH1D("StreamToMPI2",      "Stream to MPI Cherenkov ratio", 400, 0., 2.5);
    StreamVSMPI =       new TH2D("StreamVSMPI",       "Stream vs MPI Cherenkov ratio", 200, 0., 6000., 200, 0.5, 2.5);
    StreamVSMPI2D =     new TH2D("StreamVSMPI00",     "Stream vs MPI Cherenkov", 1200, -30., 5970., 1200, -30., 5970.);
    StreamVSMPI2X =     new TH2D("StreamVSMPI0X",     "Difference vs MPI Cherenkov", 1200, -30., 5970., 200, -100., 100.);
    StreamVSMPI2D->GetXaxis()->SetTitle("MPI ADC Peak, ADC counts");
    StreamVSMPI2D->GetYaxis()->SetTitle("IHEP Stream, ADC counts");
    StreamToMPI2D =     new TH2D("StreamToMPI 2D",    "Stream to MPI Cherenkov ratio", 200, 0., 7000., 200, 0., 2.5);
    StreamdT    =       new TH1D("StreamdT",          "Stream-MPI dT",                 200, -100., 100.);
    StreamToMPIspread = new TH1D("StreamMPIspread",   "Stream/MPI spread in event",    200, 0., 1.);
    StreamdTvsRatio =   new TH2D("RatiodTStream",     "Ratio vs dT",                   100, -30., 50., 100, 0., 2.5);
    StreamRatioVStime = new TH2D("StreamRatioVStime", "Ratio vs time",                 200, 50., 1500., 50, 0., 2.5);
    StreamdTVStime =    new TH2D("StreamdTVStime",    "dT vs time",                    200, 50., 1500., 50,-30., 50.);
    StreamToMPIProf =   new TProfile("StreamVSMPIp0", "Stream vs MPI Cherenkov",  200, 0., 6000.);
    StreamToMPIProf1 =  new TProfile("StreamVSMPIp1", "Stream1 vs MPI Cherenkov", 200, 0., 6000.);
    StreamToMPIProf2 =  new TProfile("StreamVSMPIp2", "Stream1 vs MPI Cherenkov", 200, 0., 6000.);

    SampleSpectrum = new TH1D[30];
    SampleProfile = new TH2F[30];
    for (int i=0; i<30; i++) {
      sprintf(HistName,  "bunch#%02dspectrum",  i);
      sprintf(HistTitle, "Bunch#%02d spectrum", i);
      SampleSpectrum[i].SetName(HistName);
      SampleSpectrum[i].SetTitle(HistTitle);
      SampleSpectrum[i].SetBins(4500, -500., 4000.);

      sprintf(HistName,  "bunch#%02dvsTime",  i);
      sprintf(HistTitle, "Bunch#%02d vs Time", i);
      SampleProfile[i].SetName(HistName);
      SampleProfile[i].SetTitle(HistTitle);
      SampleProfile[i].SetBins(400, 0.0, 1.6,  1500, -500., 4000.);

    }

    SampleSignalLeak = new TH2F[10];    
    SampleSignalLeakProf = new TProfile[10];    
    double ymm[10]={0.200, 0.10, 0.03, 0.02, 0.015,
                    0.012, 0.01, 0.01, 0.01, 0.01};
    for (int i=0; i<10; i++) {
      ym1[i]=3750.*ymm[i];
      if (ym1[i]<100.) ym1[i]=100.;
      sprintf(HistName,  "leak_to_bunch#%d",  i+1);
      sprintf(HistTitle, "Leak to bunch#%d", i+1);
      SampleSignalLeak[i].SetName(HistName);
      SampleSignalLeak[i].SetTitle(HistTitle);
      SampleSignalLeak[i].SetBins(190, -50., 3750., 200, -50., ym1[i]);
      sprintf(HistName,  "leak_to_bunch#%d_profile",  i+1);
      sprintf(HistTitle, "Leak to bunch#%d", i+1);
      SampleSignalLeakProf[i].SetName(HistName);
      SampleSignalLeakProf[i].SetTitle(HistTitle);
      SampleSignalLeakProf[i].SetBins(95, -50., 3750.);
      SampleSignalLeakProf[i].SetMarkerStyle(20);
      SampleSignalLeakProf[i].SetMarkerColor(kRed);
    }
  } 

  TH1D* GetStreamToMPI() {
    return StreamToMPI;
  }

  TH2D* GetStreamToMPI2D() {
    return StreamToMPI2D;
  }

  TProfile* GetStreamToMPIProf() {
    return StreamToMPIProf;
  }
  

  double GetHVspill() {
    return HVspill;
  }
  double GetHVjack() {
    return voltm_data[1];
  }


  void ShowStreamPlots() {

    if (!HistogramsPrepared) {
      printf("[ShowStreamPlots] Histograms not prepared!\n");
      exit(-1);
      return ;
    }
    if (!CherenkovRunAvailable) {
      StreamCanvas->Iconify();
      StreamCanvas1->Iconify();
      printf("[ShowStreamPlots] CherenkovRun not available!\n");
      exit(-1);
      return;
    } else {
      //if (CherenkovSpillAvailable && eventsAccepted>0) { // show plots only if some events were accepted
      //  StreamCanvas->Show();
      //  StreamCanvas1->Show();
      //} else {
      //  printf("[ShowStreamPlots] CherenkovSpillAvailable=%d eventsAccepted=%d\n", CherenkovSpillAvailable, eventsAccepted);
      //  return;
      //}      
    } 

    if (StreamVSMPI->GetEntries()<100) return;

    StreamCanvas->Clear();
    StreamCanvas->Divide(2,2);
    StreamCanvas1->Clear();
    StreamCanvas1->Divide(2,2);

    StreamCanvas->cd(1);
    gStyle->SetOptStat(111110);
    double ymax=0.; 
    if (StreamToMPI ->GetMaximum()>ymax) ymax=StreamToMPI ->GetMaximum();
    if (StreamToMPI1->GetBinContent(StreamToMPI1->GetMaximumBin())>ymax) 
           ymax=StreamToMPI1->GetBinContent(StreamToMPI1->GetMaximumBin());
    if (StreamToMPI2->GetMaximum()>ymax) ymax=StreamToMPI2->GetMaximum();
    StreamToMPI1->GetYaxis()->SetRangeUser(0., 1.05*ymax);
    StreamToMPI1->Draw("fill");
    StreamToMPI ->Draw("same");
    StreamToMPI2->Draw("same");
    StreamToMPI1->SetLineColor(kGreen);
    StreamToMPI1->SetFillColor(kGreen);
    StreamToMPI2->SetLineColor(kBlue);
    StreamToMPI ->SetLineWidth(2);
    StreamToMPI1->SetLineWidth(2);
    StreamToMPI2->SetLineWidth(2);
    StreamToMPI->GetXaxis()->SetTitle("(IHEP Stream ADC)/(MPI ADC)");
    StreamToMPI->GetYaxis()->SetTitle("bunches");

    StreamCanvas->cd(2);
    gStyle->SetOptStat(111110);
    StreamVSMPI->GetYaxis()->SetRangeUser(0.7, 1.2);
    StreamVSMPI->GetXaxis()->SetTitle("Cherenkov measured by MPI ADC, counts");
    StreamVSMPI->GetYaxis()->SetTitle("(IHEP Stream ADC)/(MPI ADC)");
    StreamVSMPI->SetMarkerColor(kRed);
    StreamVSMPI->SetLineColor(kRed);
    StreamVSMPI->DrawCopy();
    StreamToMPIProf1->SetMarkerColor(kGreen);
    StreamToMPIProf2->SetMarkerColor(kBlue);
    StreamToMPIProf ->SetMarkerStyle(20);
    StreamToMPIProf1->SetMarkerStyle(20);
    StreamToMPIProf2->SetMarkerStyle(20);
    StreamToMPIProf ->SetMarkerSize(0.7);
    StreamToMPIProf1->SetMarkerSize(0.7);
    StreamToMPIProf2->SetMarkerSize(0.7);
    StreamToMPIProf->DrawCopy("same");
    StreamToMPIProf1->DrawCopy("same");
    StreamToMPIProf2->DrawCopy("same");

    StreamCanvas->cd(3);
    StreamVSMPI2D->GetXaxis()->SetTitle("MPI ADC, counts");
    StreamVSMPI2D->GetYaxis()->SetTitle("Stream ADC, counts");
    StreamVSMPI2D->DrawCopy();
 
    StreamCanvas->cd(4);
    StreamVSMPI2X->GetXaxis()->SetTitle("MPI ADC, counts");
    StreamVSMPI2X->GetYaxis()->SetTitle("Stream-Const*MPI, counts");
    StreamVSMPI2X->DrawCopy();
    StreamCanvas->Update();


    StreamCanvas1->cd(1);
    gStyle->SetOptStat(111110);
    StreamToMPI->SetLineWidth(2);
    StreamToMPI->GetXaxis()->SetTitle("(IHEP Stream ADC)/(MPI ADC)");
    StreamToMPI->GetYaxis()->SetTitle("bunches");
    StreamToMPI->DrawCopy();
    double P = StreamToMPI->GetBinCenter(StreamToMPI->GetMaximumBin());
    TLine *l01 = new TLine(P, 0., P, StreamToMPI->GetMaximum());
    l01->SetLineColor(kBlue);
    l01->Draw();

    StreamCanvas1->cd(2);
    gStyle->SetOptStat(111110);
    StreamVSMPI->GetYaxis()->SetRangeUser(0.7, 1.2);
    StreamVSMPI->GetXaxis()->SetTitle("Cherenkov measured by MPI ADC, counts");
    StreamVSMPI->GetYaxis()->SetTitle("(IHEP Stream ADC)/(MPI ADC)");
    StreamVSMPI->SetMarkerColor(kRed);
    StreamVSMPI->SetLineColor(kRed);
    StreamVSMPI->DrawCopy();
    StreamToMPIProf->SetMarkerStyle(20);
    StreamToMPIProf->SetMarkerSize(0.7);
    StreamToMPIProf->DrawCopy("same");
    TLine *l00 = new TLine(0., P, 6000., P);
    l00->SetLineColor(kBlue);
    l00->Draw();

    StreamCanvas1->cd(3);
    StreamVSMPI2D->Draw();
    TLine *lx = new TLine(0., 0., 6000., 6000.*P);
    lx->SetLineColor(kRed);
    lx->Draw();

    StreamCanvas1->cd(4);
    StreamVSMPI2X->Draw("box");
    TLine *ly = new TLine(0., 0., 6000., 6000.*(P-0.86));
    ly->SetLineColor(kRed);
    ly->Draw();
    StreamCanvas1->Update();


    char SpillReport[100];
    sprintf(SpillReport, "reports/SpillReports/Run%dSpill%03d.dat", 
            ProcStatus->GetBurstHeader()->run, ProcStatus->GetBurstHeader()->burst);
    spill_report.open(SpillReport, ios::out);
    double W = StreamToMPIspill->GetEntries();
    double A = StreamToMPIspill->GetMean();
    double R = StreamToMPIspill->GetRMS();
    double PS = StreamToMPIspill->GetBinCenter(StreamToMPIspill->GetMaximumBin());
    //printf("Maximum Bin = %d Peak=%.4f\n", StreamToMPI->GetMaximumBin(), P);
    spill_report << W << " " << A << " " << PS << " " << R;
    //cout << ProcStatus->GetBurstHeader()->run << " " << 
    //       ProcStatus->GetBurstHeader()->burst << " " << 
    //        W << " " << A << " " << PS << " " << R << endl;
    PSall = StreamToMPI->GetBinCenter(StreamToMPI->GetMaximumBin());
    StreamToMPIspill->Reset();
    spill_report.close();
    spill_report.clear();
  }

  int CountOverflows(double Tpast) { // counts in overflows in Tpast (ns);
    int overflows=0;
    int samples=0;
    int sample1=EH->scaler6mhz-iStart-eventOffset+1;
    int sample0=sample1-int(Tpast/dT);
    if (sample0<0) sample0=0;
    samples=sample1-sample0+1;
    for (int i=sample0; i<sample1; i++) {
      overflows+=Covf[i];
    }

    if (samples>0) {
      if (ProcStatus->GetReportMode()==1) printf("[CountOverflows] Tpast=%.3f Overflows %d of %d\n", Tpast/1.0e6, overflows, samples);
      return overflows;
    } else {
      return 0;
    }
  }

  double GetEmptyRMS() {
    return EmptyRMS;
  }
  void ComputeEmptyRMS() {
    double es0=0.;
    double es1=0.;
    double es2=0.;
    double ecorr=0.;
    //printf("[CherenkovBuffer->ComputeEmptyRMS] filled sample=%d\n", filledSampleD);
    for (int is=0;is<39;is++) {
      double a=GetSampleAdjustD(is);
      int    j=GetSampleIndex(is);
      //printf("[CherenkovBuffer->ComputeEmptyRMS] is=%2d js=%d\t a=%.1f", is, j, a);
      if (filledSample[j%30]) {
        ecorr=0.2*a;
      } else {
        es0+=1.0;
        es1+=a-ecorr;
        es2+=(a-ecorr)*(a-ecorr);
        //printf(" adding with corr=%5.1f a=%.1f", ecorr, a-ecorr);
        ecorr*=0.2;
      }
      //printf("\n");
    }
    es1/=es0;
    es2/=es0;
    es2-=es1*es1;
    if (es2<0.) es2=0.0;
    EmptyRMS=sqrt(es2);
    //printf("[CherenkovBuffer->ComputeEmptyRMS] result=%.2fADC\n", EmptyRMS);
    //printf("Push!");
    //int iqqq;
    //cin >> iqqq;
    return;
  }


  int FillStreamPlots(int Nbunchs, int bunch, double Tbunch, double cher0) {
    //Dbg=true;
    if (!HistogramsPrepared) {
      printf("[FillStreamPlots] Histograms not prepared!\n");
      exit(-1);
      return 0;
    }

    if (Dbg) printf("[FillStreamPlots]   Evt#%d bunch#%d Tbunch=%.1f CherMPI=%.1f\n",
           EH->event, bunch, Tbunch, cher0);  

    int result=0;

    if ( ProcStatus->GetEventHeader()->run != runOld) {  
      char nameC[100];
      sprintf(nameC,"StreamVSMPI/Run%d.root",  runOld);
      TFile f(nameC, "RECREATE");

      StreamToMPI ->Write();
      StreamToMPIspill->Write();
      StreamToMPI1->Write();
      StreamToMPI2->Write();
      StreamToMPIProf ->Write();
      StreamToMPIProf1->Write();
      StreamToMPIProf2->Write();
      StreamVSMPI     ->Write();      
      StreamVSMPI2D   ->Write();      
      StreamVSMPI2X   ->Write();     
      
      f.Close();

      StreamToMPI ->Reset();
      StreamToMPIspill->Reset();
      StreamToMPI1->Reset();
      StreamToMPI2->Reset();
      StreamToMPIProf ->Reset();
      StreamToMPIProf1->Reset();
      StreamToMPIProf2->Reset();
      StreamVSMPI     ->Reset();      
      StreamVSMPI2D   ->Reset();      
      StreamVSMPI2X   ->Reset();     
      runOld=ProcStatus->GetEventHeader()->run;
    }

    if (Dbg) printf ("[FillStreamPlots] Cherenkov stream 6MHz==%d \n", ProcStatus->Get6mhz());
   
    if (bunch==0) {
      evtRatioSpread[0]=0.0;
      evtRatioSpread[1]=0.0;
      evtRatioSpread[2]=0.0;
    }

    int iClosest=-1;
    double Tmin=100000.;
    for (int is=0;is<39;is++) {
      double Ts=CherenkovTime[is];
      if (Dbg) printf("    Tbunch=%.1f Ts=%.1f iClosest=%d Tmin=%.1f\n", Tbunch, Ts, iClosest, Tmin); 
      if (Tbunch-Ts>0. && Tbunch-Ts<Tmin) {
        Tmin=Tbunch-Ts;
        iClosest=is;
      }
      if (Ts-Tbunch>0. && Ts-Tbunch<Tmin) {
        Tmin=Ts-Tbunch;
        iClosest=is;
      }
    }
    if (Dbg) printf(" -------- result: iClosest=%d\n", iClosest);
    double CherGated=GetSampleAdjustD(iClosest);

    //if (cher0>100. && CherGated<20. ) {
    if (cher0>500. && CherGated>500.) {
      if (Dbg) printf("[FillStreamPlots] #1 cher0=%.1f CherGated=%.1f\n", cher0, CherGated);
      double ratio=CherGated/cher0;
      if (ratio>1.35 || ratio<0.70) {
        printf("\n**************************************\n");
        printf("[FillStreamPlots] event phase problem!\n");
        printf("[FillStreamPlots] Burst#%d Event#%d(%d) Bunch#%d\n", EH->burst, EH->event, EH->burstEvent, bunch);
        printf("[FillStreamPlots] cher0=%.1f Cbuff[iClosest]=%.1f\n", cher0, CherGated);
        printf("**************************************\n\n");
        //ProcStatus->SetReportMode(1);
        //CherenkovSpillAvailable=false; // skip the rest of the spill
        CherenkovEventAvailable=false; // skip the rest of the spill
        Dbg=false;
        return 1;
      }
    }
    CherenkovEventAvailable=true;

    double dTx=Tbunch-CherenkovTime[iClosest];

    if (dTx<-99.5) dTx=-99.5;
    if (dTx>99.5)  dTx=99.5;
    StreamdT->Fill(dTx);
    double ratio0=0.;
    double ratio1=0.;
    double ratio2=0.;
    if (Dbg) printf("[FillStreamPlots]     MPI = %6.1f Stream=%6.1f ", cher0, CherGated);
    StreamVSMPI2D->Fill(cher0, CherGated);
    StreamVSMPI2X->Fill(cher0, CherGated-cher0);

    eventsAccepted++;

    if (cher0>10. && CherGated>10.) {
      if (Dbg) printf("[FillStreamPlots] #2 cher0=%.1f CherGated=%.1f\n", cher0, CherGated);
      ratio0=CherGated/cher0;
      ratio1=CherGated/(cher0+5.);
      ratio2=CherGated/(cher0+10.);

      if (ratio0<0.001) ratio0=0.001;
      if (ratio0>4.999) ratio0=4.999;
      if (cher0>600.) StreamToMPI->Fill(ratio0);
      StreamToMPIspill->Fill(ratio0);
      StreamToMPI1->Fill(ratio1);
      StreamToMPI2->Fill(ratio2);
      StreamVSMPI->Fill(cher0, ratio0);
      StreamToMPI2D->Fill(cher0, ratio0);
      StreamToMPIProf->Fill(cher0, ratio0);
      StreamToMPIProf1->Fill(cher0, ratio1);
      StreamToMPIProf2->Fill(cher0, ratio2);
      StreamdTvsRatio->Fill(dTx, ratio0);
      StreamRatioVStime->Fill(1.0e-4*ProcStatus->Get10mhz(), ratio0);
      StreamdTVStime->Fill(1.0e-4*ProcStatus->Get10mhz(), dTx);
      evtRatioSpread[0]+=1.0;
      evtRatioSpread[1]+=ratio0;
      evtRatioSpread[2]+=ratio0*ratio0;
    }

    if (bunch==Nbunchs-1) {
      if (Dbg) printf("[FillStreamPlots] bunch#%d spread0=%f \n", bunch, evtRatioSpread[0]);
      if (evtRatioSpread[0] != 0.0) {
         evtRatioSpread[1]/=evtRatioSpread[0];
         evtRatioSpread[2]/=evtRatioSpread[0];
         evtRatioSpread[2]-=evtRatioSpread[1]*evtRatioSpread[1];
         StreamToMPIspread->Fill(sqrt(evtRatioSpread[2]));
      }    
    }
    Dbg=false;

    if (Dbg) printf("[FillStreamPlots] done, bye!\n");
    return result;
  }

  int GetIsolatedCount() {return nIsol1;}

  double GetFilledAverage100(int i) {
    if (i<0 || i>2999) {
      printf("[CherenkovBuffer->GetFilledAverage100] bad index i=%d, ciao!\n", i);
      exit(-1);
    }
    return filledAvr100[i];
  }
  double GetFilledSigma100(int i) {
    if (i<0 || i>2999) {
      printf("[CherenkovBuffer->GetFilledSigma100] bad index i=%d, ciao!\n", i);
      exit(-1);
    }
    return filledRMS100[i];
  }
  double GetFilledRate100(int i) {
    if (i<0 || i>2999) {
      printf("[CherenkovBuffer->GetFilledRate100] bad index i=%d, ciao!\n", i);
      exit(-1);
    }
    return filledWgh100[i];
  }

  TCanvas *GetSpillCanvas() {return SpillCanvas1;}


  TCanvas *GetSpillCanvas(int i) {
    if (i==0) return SpillCanvas;
    else      return SpillCanvas1;
  }

  void DisplaySpillSpectra() {
    SpillCanvas1->Show();
    SpillCanvas1->Clear();
    SpillCanvas1->Divide(5, 6);
    for (int i=0; i<30; i++) {
      SpillCanvas1->cd(i+1);
      //gPad->SetLogy(1);
      gStyle->SetOptStat(111110);
      //SampleSpectrum[i].DrawCopy();
      SampleProfile[i].DrawCopy();
    }
    SpillCanvas1->Update();
    SpillCanvas1->Show();
  }

  void DisplaySampleLeak() {
    SpillCanvas->Show();
    SpillCanvas->Clear();
    SpillCanvas->Divide(2,3);
    
    for (int i=0; i<6; i++) {
      SpillCanvas->cd(i+1);
//      gStyle->SetOptStat(0);
//      gStyle->SetOptStat(111110);
//      SampleSignalLeak[i].DrawCopy("box");
      sprintf(HistTitle, "Leakage to sample#%d, run#%04d spill#%03d",
              i+1, ProcStatus->GetRun(), spillNumber);
      SampleSignalLeak[i].SetTitle(HistTitle);
      SampleSignalLeak[i].DrawCopy();
      SampleSignalLeakProf[i].DrawCopy("same");


      myLine->SetLineWidth(1);
      myLine->SetLineColor(kBlack);
      myLine->SetLineStyle(2);
      myLine->DrawLine(-50., 0., 3750., 0.);
      double slope;

      myLine->SetLineWidth(2);
      myLine->SetLineColor(kBlue);
      myLine->SetLineStyle(1);
      slope=SampleLeakDyn[i];
      myLine->DrawLine(0., 0., 3550., slope*3550.);

      sprintf(HistTitle, "slope=%.5f", slope);
//      printf("%f %s\n", 0.5*ym1[i], HistTitle);
      myLatex->DrawLatex(100., 0.5*ym1[i], HistTitle);

    }

    SpillCanvas->Update();
    SpillCanvas->Show();
  }

   

  void DisplaySpill() {

    //SpillCanvas->Show();
    SpillCanvas->Clear();
    SpillCanvas->Divide(1,2);
    spillCanvasShown=true;
    SpillCanvas->cd(1);
    SpillDummy->GetYaxis()->SetRangeUser(0., 1.02*HVcorrection*max30max);
    SpillDummy->GetYaxis()->SetTitle("Bunch Rate, protons");
    SpillDummy->GetXaxis()->SetTitle("Time, ms");
    SpillDummy->SetStats(0);
    char TitleDummy[200];
    sprintf(TitleDummy, "Run#%d Burst#%d", ProcStatus->GetEventHeader()->run, ProcStatus->GetEventHeader()->burst);
    SpillDummy->SetTitle(TitleDummy);
    SpillDummy->DrawCopy();
    TLine *ll30 = new TLine();

    ll30->SetLineWidth(2);
    ll30->SetLineColor(kGray);
    for (int i30=1; i30<ns30; i30++) {
      ll30->DrawLine((i30-0.5)*30.*dT*1.0e-6, HVcorrection*Max30[i30-1], (i30+0.5)*30.*dT*1.0e-6, HVcorrection*Max30[i30]); 
    }
    SpillCanvas->Update();

    ll30->SetLineWidth(1);
    ll30->SetLineColor(kBlack);
    for (int i30=1; i30<ns30; i30++) {
      ll30->DrawLine((i30-0.5)*30.*dT*1.0e-6, HVcorrection*Sum31[i30-1], (i30+0.5)*30.*dT*1.0e-6, HVcorrection*Sum31[i30]); 
    }
    SpillCanvas->Update();

    double t0, t1, y0, y1;
/*
    ll30->SetLineWidth(1);
    ll30->SetLineColor(kRed);
    for (int i30=11; i30<ns30; i30+=10) {
      t0=(i30-9.5)*30.*dT;
      t1=(i30+0.5)*30.*dT;
      y0=GetIntegral(t0, 0.71e6, 2); // FCal-100 ion drift at full voltage ..
      y1=GetIntegral(t1, 0.71e6, 2);
      ll30->DrawLine(t0*1.0e-6, y0, t1*1.0e-6, y1); 
    }
    SpillCanvas->Update();

    ll30->SetLineWidth(1);
    ll30->SetLineColor(kBlue);
    for (int i30=21; i30<ns30; i30+=20) {
      t0=(i30-19.5)*30.*dT;
      t1=(i30+0.5)*30.*dT;
      y0=GetIntegral(t0, 1.5e6, 2); // FCal-250 ion drift at full voltage ..
      y1=GetIntegral(t1, 1.5e6, 2);
      ll30->DrawLine(t0*1.0e-6, y0, t1*1.0e-6, y1); 
    }
    SpillCanvas->Update();
*/
    ll30->SetLineWidth(3);
    ll30->SetLineColor(kRed);
    for (int i30=41; i30<ns30; i30+=40) {
      t0=(i30-39.5)*30.*dT;
      t1=(i30+0.5)*30.*dT;
      y0=GetIntegral(t0, 10.e6, 2); // HEC/EMEC ion drift at full voltage ..
      y1=GetIntegral(t1, 10.e6, 2);
      ll30->DrawLine(t0*1.0e-6, y0, t1*1.0e-6, y1); 
    }
    SpillCanvas->Update();
    ll30->Delete();
  }

  bool hotEvent() { // checks if the event is in a hot Gated ADC zone
    int ie0=EH->scaler6mhz-iStart-eventOffset; // sample!!!!
    for (int ihot=0; ihot<nh30; ihot++) {
      if (ie0+39<Izone0[ihot]*30) break;    // too early, zone is later than event, all other zones will fail
      if (ie0>Izone1[ihot]*30+30) continue; // too late, check next
      printf("[CherenkovBuffer->hotEvent] event RF=%d\t position in buffer=%d\t hot zone#%d\t zone noise/noise0=%.2f\n",
             EH->scaler6mhz, ie0, ihot, Zone30noise[ihot]);
      //for (int i=Izone0[ihot]; i<=Izone1[ihot]; i++) {
      //printf("                         lap#%d\t noise/noise0=%.1f\n", i, Noi30[i]/spillNoise);
      //}
      if (Zone30noise[ihot]>10.) return true;
    }
    return false;
  }
int GetSpillVectorSize() {return spillNum.size();}
int GetSpillVectorSpill(int i) {
  if (i<0 || i>=(int)spillNum.size()) {
    printf("[CherenkovBuffer->GetSpillVectorSpill] wrong index %d\n", i);
    exit(-1);
  }
  return spillNum[i];
}
int GetSpillVectorEvent(int i) {
  if (i<0 || i>=(int)spillNum.size()) {
    printf("[CherenkovBuffer->GetSpillVectorEvent] wrong index %d\n", i);
    exit(-1);
  }
  return eventGADC[i];
}
int GetSpillVectorSampleGADC(int i) {
  if (i<0 || i>=(int)spillNum.size()) {
    printf("[CherenkovBuffer->GetSpillVectorSampleGADC] wrong index %d\n", i);
    exit(-1);
  }
  return sampleGADC[i];
}
int GetSpillVectorSampleRATE(int i) {
  if (i<0 || i>=(int)spillNum.size()) {
    printf("[CherenkovBuffer->GetSpillVectorSampleRATE] wrong index %d\n", i);
    exit(-1);
  }
  return sampleRATE[i];
}
double GetSpillVectorSampleMEAN(int i) {
  if (i<0 || i>=(int)spillNum.size()) {
    printf("[CherenkovBuffer->GetSpillVectorSampleMEAN] wrong index %d\n", i);
    exit(-1);
  }
  return sampleMEAN[i];
}
double GetSpillVectorSampleRMS(int i) {
  if (i<0 || i>=(int)spillNum.size()) {
    printf("[CherenkovBuffer->GetSpillVectorSampleRMS] wrong index %d\n", i);
    exit(-1);
  }
  return sampleRMS[i];
}




double GetBeamHV(int i) { // returns HV from Cherenkov record for current spill //
  //	0	unused
  //	1	Cerenkov HV
  //	2	S1 HV
  //	3	S2 HV
  //	4	S3 HV
  //	5	S4 HV
  //	6	S5 HV
  //	7	S6 HV
  if (i<0 || i>7) {
    printf("[CherenkovBuffer->GetBeamHV] wrong HV channel index = %d\n", i);
    exit(-1);
  }
  return voltm_data[i];
}

bool hotDisplayRange() { // checks if any hot Gated ADC zone is in the event display scope
//  double EventTime=EH->scaler6mhz*EH->GetRFperiod(); // ns!
  double EventTime=EH->scaler10mhz*100.; // ns!
//  double Thist=1.1*ProcStatus->GetTdrift(1); // 50ms of history
  double T0=EventTime-1.0e6; // event-event interval 10ms
  double T1=EventTime+0.1e6;
  bool result=false;
  int iLap0=-1;
  int iLap1=0;
  for (int iLap=1; iLap<ns30; iLap++) {
    double t=GetLapTime(iLap);
    if (t>T0) {
      if (iLap0==-1) iLap0=iLap;
    }
    if (t>T1) break;
    iLap1=iLap;
  }
  for (int ihot=0; ihot<nh30; ihot++) {
    if (iLap1<Izone0[ihot]) break;    // too early, zone is later than event, all other zones will fail
    if (iLap0>Izone1[ihot]) continue; // too late, check next
    printf("[CherenkovBuffer->hotDisplayRange] evt#%d display: %d-%d\t %.1f-%.1f\t hhot range %d-%d\t t=%.f-%.1f\t NoiseFactor=%.1f\n ",
            EH->event, iLap0, iLap1, T0/1.0e6, T1/1.0e6, 
            Izone0[ihot], Izone1[ihot], GetLapTime(Izone0[ihot])*1.0e-6, GetLapTime(Izone1[ihot])*1.0e-6, Zone30noise[ihot]);
    if (Zone30noise[ihot]>10.) result=true;  
  }
  return result;     
}


};
