// ---- 2010-11 offline  event display ----//
int DisplayAllPulses201011(TModule* Setup, ProcessingStatus* ProcStatus, CherenkovBuffer* CherBuff) {

  bool Dbg=false;
  char TitleC[200];
  //char titleC[200];
  char NamecC[200];
  int Rep=0;

  EventHeader *EH = ProcStatus->GetEventHeader();
  BurstHeader *BH = ProcStatus->GetBurstHeader();
  int dWidth  = ProcStatus->GetDisplayWidth();
  //int dHeight = ProcStatus->GetDisplayHeight();
  int Nbunches = ProcStatus->GetNbunches();

  TLine  * displayLine  = new TLine(); 
  TLatex * displayLatex = new TLatex();

  Dbg=false;
  //Dbg=true;

  if (dWidth>1800) dWidth=1800;


  sprintf(TitleC, "Run #%d, Burst#%d, Event#%d(%d), 10MHz=%d Type=%02d SignalFactor=%.1f", 
	  EH->run, EH->burst, EH->event, EH->burstEvent, EH->scaler10mhz, EH->pattern[0], EH->SignalFactor); 
  sprintf(NamecC, "Run%d_Burst%d_Event%d_%d", EH->run, EH->burst, EH->event, EH->burstEvent); 

  TH1D    *dummy = new TH1D("dummy_display_new", "", 2500, -150., 150.+25.*EH->nSlice);
  dummy->GetXaxis()->SetTitle("Time, ns");

  EventCanvasNew->SetTitle(TitleC);
  EventCanvasNew->SetName(NamecC);
  EventCanvasNew->Clear();
  EventCanvasNew->Divide(1, 6, 0.002, 0.002);
  EventCanvasNew->Update();
  EventCanvasNew->Show();

  
  //if (EH->isClone) EventCanvas->SetFillColor(2);

  dummy->SetTitleSize(0.04);
  dummy->SetStats(0);
  dummy->GetYaxis()->SetTitleSize(.1);
  dummy->GetYaxis()->SetTitleOffset(.4);
  dummy->GetYaxis()->SetLabelSize(.08);
  dummy->GetXaxis()->SetTitleSize(.1);
  dummy->GetXaxis()->SetTitleOffset(.75);
  dummy->GetXaxis()->SetLabelSize(.08);
  dummy->SetLineStyle(2);

  for (int iMod=0;iMod<5;iMod++) {
    TModule *Module = &Setup[iMod];
    EventCanvasNew->cd(iMod+1);
    displayLine->SetLineWidth(1); 
    dummy->GetYaxis()->SetTitle("High Gain ADC");
    gPad->SetBottomMargin(0.2);
    gPad->SetRightMargin(0.01);
    gPad->SetTopMargin(0.02);

    int nSlice=Module->GetNslice();
 
    
    if (iMod<4) {// display modules sums //
      double amin=Module->GetSumMin();
      double amax=Module->GetSumMax();
      if (1.15*amax<5.0)  amax=5.0;
      if (1.05*amin>-5.0) amin=-5.0;

      //dummy->SetTitle(Module->GetName());
      dummy->GetYaxis()->SetRangeUser(1.15*amin, 1.05*amax);
      dummy->DrawCopy();

      int nWindows=Module->GetNPedWindows();
      for (int iw=0;iw<nWindows; iw++) { 
        int iCol=kYellow;
        //if (Module->GetPedWinX(iw)) iCol=kYellow; else iCol=kRed; // pedestal window
        displayLine->SetLineWidth(30);
        displayLine->SetLineStyle(1);
        displayLine->SetLineColor(iCol);
        displayLine->DrawLine(Module->GetPedWin0(iw), 0., Module->GetPedWin1(iw), 0.);
      }

      displayLine->SetLineWidth(1); // pure high gain sum //
      displayLine->SetLineColor(kRed);
      //Module->ScaleSumSampleH(amax); // scale HG sum to fit the plot scale //
      for (int is=1; is<nSlice; is++) {
        displayLine->DrawLine(Module->GetTime(is-1), Module->GetSumSampleH(is-1), 
                              Module->GetTime(is),   Module->GetSumSampleH(is));
      }
      



      if (Module->CheckLGoverflow()) {
        displayLine->SetLineColor(kRed);
      } else {
        displayLine->SetLineColor(kBlack);
      }
      if (Module->GetCold()) displayLine->SetLineColor(kBlue);

      displayLine->SetLineWidth(2);
      for (int is=1; is<nSlice; is++) {
        displayLine->DrawLine(Module->GetTime(is-1), Module->GetSumSample(is-1), 
                              Module->GetTime(is),   Module->GetSumSample(is));
      }

      displayLatex -> SetTextColor(kBlack);
      displayLatex -> SetTextSize(0.08);
      displayLatex -> SetTextAlign(13);
      sprintf(NamecC, "%8s Prehistory = %5.2e p/bunch", Module->GetName(), EH->GetGatedIntegral(iMod));
      displayLatex -> DrawLatex(0., amax, NamecC); 

      for (int bunch=0; bunch<Nbunches; bunch++) {
        double Tbunch=ProcStatus->GetBunchTime(bunch);
        double RateADC = Setup[4].GetChannel(3)->GetResponseADC(bunch);
        double Rate = RateADC*CherBuff->GetGainCorrection();
        double Sum = Setup[iMod].GetMySumRateCal(bunch);
        double SumRAW = Setup[iMod].GetMySumRate(bunch);
        printf("[DisplayEvent 2011] %10s bunch#%d Rate=%.2ep rawADC=%7.1f SumOld=%7.1f SumNew=%7.1f SumNewCal=%7.1f\n", 
                 Setup[iMod].GetName(), bunch, Rate, SumRAW, Sum, Setup[iMod].GetAnear(bunch), Setup[iMod].GetAnearCal(bunch)); 
        displayLatex -> SetTextColor(kBlack);
        displayLatex -> SetTextSize(0.08);
        displayLatex -> SetTextAlign(13);
        if (RateADC>15.) {
          sprintf(NamecC, "%.3f ADC/p", Sum/Rate);
          displayLatex -> DrawLatex(Tbunch+100., 0.8*amax, NamecC); 
        }
        displayLine->SetLineWidth(1); 
        displayLine->SetLineColor(kBlack);
        displayLine->SetLineStyle(2);
        displayLine->DrawLine(Tbunch, amax, Tbunch, amin);
        displayLine->DrawLine(Tbunch-50.,      SumRAW, Tbunch+50.,      SumRAW);
        displayLine->DrawLine(Tbunch-100., 0.5*SumRAW, Tbunch+100., 0.5*SumRAW);
        sprintf(NamecC, "%.1f ns", Setup[iMod].GetThalf(bunch));
        displayLatex -> SetTextSize(0.08);
        displayLatex -> SetTextAlign(11);
        displayLatex -> DrawLatex(Tbunch+100., 0.5*SumRAW, NamecC);
      }    

    } else if (iMod==4) { // cherenkov only

      TChannel *Channel = Module->GetChannel(3);
      TSignal *Signal;
      int iGain=0;
      int iColor = kBlack;
      if (Channel->HighGainOverflowDetected()) {
        Signal=Channel->GetSignalLong(0);
        dummy->GetYaxis()->SetTitle("Low Gain ADC");
      } else {
        Signal=Channel->GetSignalLong(1);
        dummy->GetYaxis()->SetTitle("High Gain ADC");
        iGain=1;
      }
      if (Channel->LowGainOverflowDetected()) {
        displayLine->SetLineColor(kRed);
        iColor = kRed;
      }
      double amax=Signal->GetMax();
      double amin=Signal->GetMin();
      //dummy->SetTitle("Cherenkov");
      dummy->GetYaxis()->SetRangeUser(1.05*amin, 1.05*amax);
      dummy->DrawCopy();
      int nWindows=Module->GetNPedWindows();
      for (int iw=0;iw<nWindows; iw++) { 
        int iCol;
        if (Module->GetPedWinX(iw)) iCol=kYellow; else iCol=kRed; // pedestal window
        displayLine->SetLineWidth(30);
        displayLine->SetLineStyle(1);
        displayLine->SetLineColor(iCol);
        displayLine->DrawLine(Module->GetPedWin0(iw), 0., Module->GetPedWin1(iw), 0.);
      }
      displayLine->SetLineWidth(2);
      TGraphErrors *Graph = Signal->GetGraph();
      Graph->SetMarkerColor(iColor);
      Graph->SetMarkerStyle(21); 
      Graph->SetMarkerSize(0.15);
      Graph->SetLineColor(iColor);
      Graph->SetLineWidth(2);
      Graph->Draw("LPZz same"); 
    
      printf("[main->DisplayAllPulses201011] GoodCherenkov=%d\n", BH->goodGatedCherenkov);
      if (BH->goodGatedCherenkov) {
        double cherScale=1.;
        if (iGain==0) cherScale=10.;
        for (int i=0; i<39; i++) {
          displayLine->SetLineWidth(1);
          displayLine->SetLineColor(kGray);
          displayLine->DrawLine(CherBuff->GetCherenkovTime(i)-82.481,  
                                CherBuff->GetSampleAdjustD(i)/cherScale, 
                                CherBuff->GetCherenkovTime(i)+82.481, 
                                CherBuff->GetSampleAdjustD(i)/cherScale);
          if (i<38) displayLine->DrawLine(CherBuff->GetCherenkovTime(i)+82.481, 
                                          CherBuff->GetSampleAdjustD(i)/cherScale, 
                                          CherBuff->GetCherenkovTime(i)+82.481, 
                                          CherBuff->GetSampleAdjustD(i+1)/cherScale); 
        }
      }

      for (int bunch=0; bunch<Nbunches; bunch++) {
        double Tbunch=ProcStatus->GetBunchTime(bunch);
        double RateADC=Setup[4].GetChannel(3)->GetResponseADC(bunch);
        if (RateADC>15.0) {
          double Rate=RateADC*CherBuff->GetGainCorrection();
          displayLatex -> SetTextColor(kBlack);
          displayLatex -> SetTextSize(0.08);
          displayLatex -> SetTextAlign(13);
          sprintf(NamecC, "%5.2ep", Rate);
          displayLatex -> DrawLatex(Tbunch+100., 0.8*amax, NamecC); 
          displayLine->SetLineWidth(1); 
          displayLine->SetLineColor(kBlack);
          displayLine->SetLineStyle(2);
          displayLine->DrawLine(Tbunch, amax, Tbunch, amin);
        }  
      }    
    }
    EventCanvasNew->Update();
  }

  EventCanvasNew->Update();

  EventCanvasNew->cd(6);
  displayLine->SetLineWidth(1); 
  gPad->SetBottomMargin(0.2);
  gPad->SetRightMargin(0.01);
  gPad->SetTopMargin(0.1);
  
  double Sum30max=-1.0e10;
  double Sum30min=1.0e10;
  double EventTime=EH->scaler10mhz*100; // ns!
  double Thist=1.1*ProcStatus->GetTdrift(1); // 50ms of history
  double T0=EventTime-Thist;
  double T1=EventTime+Thist/10.; 
  dummy->SetBins(1000, T0*1.0e-6, T1*1.0e-6);

  int nLaps=CherBuff->GetNlaps();
  int iLap0=-1;
  int iLap1=0;
  for (int iLap=1; iLap<nLaps; iLap++) {
    double t=CherBuff->GetLapTime(iLap);
    if (t>T0) {
      if (iLap0==-1) iLap0=iLap;
      if (CherBuff->GetLapHV(iLap)>Sum30max)     Sum30max=CherBuff->GetLapHV(iLap);
      if (CherBuff->GetLapHV(iLap)<Sum30min)     Sum30min=CherBuff->GetLapHV(iLap);
      if (CherBuff->GetMaxHV(iLap)>Sum30max)     Sum30max=CherBuff->GetMaxHV(iLap);
    }
    if (t>T1) break;
    iLap1=iLap;
  }
   
  if (Sum30max<50.) Sum30max=50.;
  gPad->SetGridy(1);
  dummy->GetXaxis()->SetTitle("Time, ms");
  dummy->GetYaxis()->SetTitle("Protons/Bunch");
  dummy->GetYaxis()->SetRangeUser(1.05*Sum30min, 1.05*Sum30max);
  dummy->SetStats(0);
  dummy->DrawCopy();
  //int i3spike=0;

  //double dt=0.;
  //double wdt=0.;

  displayLine->SetLineColor(kRed);
  displayLine->SetLineStyle(1);
  displayLine->SetLineWidth(4);
  for (int jEvt=EH->burstEvent; jEvt>-1; jEvt--) {
    double Tevt = CherBuff->GetDT() * double(CherBuff->GetEventPointerMPI(jEvt)); //
    if (Tevt<T0) break;
    displayLine->DrawLine(Tevt*1.0e-6, 1.05*Sum30min, Tevt*1.0e-6, 1.05*Sum30max);
    displayLine->SetLineWidth(2);
  }
  EventCanvasNew->Update();

  
  displayLine->SetLineStyle(1);
  displayLine->SetLineColor(kGray);
  displayLine->SetLineWidth(2);

  for (int iLap=iLap0+1; iLap<iLap1; iLap++) {
    displayLine->DrawLine(CherBuff->GetLapTime(iLap-1)*1.0e-6, CherBuff->GetMaxHV(iLap-1),
                          CherBuff->GetLapTime(iLap)*1.0e-6,   CherBuff->GetMaxHV(iLap));
  }
  EventCanvasNew->Update();

  displayLine->SetLineStyle(1);
  displayLine->SetLineColor(kBlack);
  displayLine->SetLineWidth(3);


  for (int iLap=iLap0+1; iLap<iLap1; iLap++) {
    displayLine->DrawLine(CherBuff->GetLapTime(iLap-1)*1.0e-6, CherBuff->GetLapHV(iLap-1),
                          CherBuff->GetLapTime(iLap)*1.0e-6,   CherBuff->GetLapHV(iLap));
  }

  for (int iMod=1; iMod<4; iMod++) {
    double Tdrift=ProcStatus->GetTdrift(iMod);
    displayLine->SetLineColor(iMod+1);
    displayLine->SetLineWidth(1);
    for (int iLap=iLap0+1; iLap<iLap1; iLap+=20) {
      if (iLap<20) continue;
      double T00=CherBuff->GetLapTime(iLap-20);
      double T10=CherBuff->GetLapTime(iLap);
      displayLine->DrawLine(T00*1.0e-6, CherBuff->GetIntegral(T00-EventTime, Tdrift, 2),
                            T10*1.0e-6, CherBuff->GetIntegral(T10-EventTime, Tdrift, 2));
    }    
    EventCanvasNew->Update();
  }
  

  EventCanvasNew->Update();
  EventCanvasNew->Show();
  EventCanvasNew->Update();
  

  if (EH->burst<2 && false) {
    sprintf(NamecC, "run%04dspill%03devt%05d_%03d.ps", 
            EH->run, EH->burst, EH->event, EH->burstEvent);
    EventCanvasNew->Print(NamecC, 0);
    //EventCanvasNew->Close();
    Rep=1;
  } else {
    Rep=ProcStatus->WhatToDo("[DisplayAllPusles]", -100);
  }
  ProcStatus->SetReportMode(Rep);

  dummy->Delete();
  displayLine->Delete();
  displayLatex->Delete();
  return Rep; 
}


