void DisplaySpike(ProcessingStatus* ProcStatus, CherenkovBuffer* CherBuff) {

  TPad* pad1 = (TPad*) CherBuff->GetSpillCanvas()->GetPrimitive("SpillCanvas_2");
  pad1->Clear(); // get rid of garbage from previous event //
  CherBuff->GetSpillCanvas()->cd(2);

  EventHeader *EH = ProcStatus->GetEventHeader();
  //int dWidth  = ProcStatus->GetDisplayWidth();
  //int dHeight = ProcStatus->GetDisplayHeight();
  //double Sum30[4000]={4000*0.0};
  double Max30d[4000]={4000*0.0};
  double Sum30d[4000]={4000*0.0};
  double Time30[4000]={4000*0.0};
  //int    n30[4000]={4000*0};


  double Sum30max=0.;
  double Sum30min=0.;
  //double t30max=0.;
  int    i30=0;
  TLine  * displayLine  = new TLine(); 
  TLatex * displayLatex = new TLatex();
  double EventTime=EH->scaler10mhz*100; // ns!
  TH1F   * dummy = new TH1F("SpikeDummy", "Spike", 600, EventTime/1.0e6-12.0, EventTime/1.0e6+0.5);
    
  int j30old=0;
  //int iqq=1;

  int iSample=-80000; // start with first Cherenkov Sample in the event //
  //printf("start i30=%d iSample=%d SampleCheck=%d Time=%.1f\n", i30, iSample, CherBuff->CheckSampleAdjust(iSample), iSample*CherBuff->GetDT());
  while (i30<4000 && CherBuff->CheckSampleAdjust(iSample) && iSample*CherBuff->GetDT()<2.5e6) {
    int j30=CherBuff->GetLapIndex(iSample);
    //printf("[DisplaySpike Debug] iSample=%8d Lap#%7d oldLap=%7d localIndex=%d\n", iSample, j30, j30old, i30);  
    if (j30 != j30old) {
      Sum30d[i30]=CherBuff->GetLapHV(j30);
      Max30d[i30]=CherBuff->GetMaxHV(j30);
      if (Sum30d[i30]>Sum30max) Sum30max=Sum30d[i30];
      if (Sum30d[i30]<Sum30min) Sum30min=Sum30d[i30];
      if (Max30d[i30]>Sum30max) Sum30max=Max30d[i30];
      Time30[i30]=EventTime+(iSample-15.)*CherBuff->GetDT();
//      printf("[DisplaySpike Debug] ------------- adding Sum30[%d]=%4.2e Max30=%4.2e Time30=%.3f    globalMax=%4.2e\n",
//            i30, Sum30d[i30], Max30d[i30], Time30[i30]*1.0e-6, Sum30max);
      j30old=j30;
      i30++;
//      if (iqq==1) {
//        printf("Push!--->");
//        cin>>iqq;
//        if (iqq==0) exit(-1);
//      }
    }
    

    iSample++;
  } 
  
//        printf("Push!--->");
//        cin>>iqq;
//        if (iqq==0) exit(-1);

  if (Sum30max<50.) Sum30max=50.;
  gPad->SetGridy(1);
  dummy->GetXaxis()->SetTitle("Time, ms");
  dummy->GetYaxis()->SetTitle("Beam Intensity, protons");
  dummy->GetYaxis()->SetRangeUser(1.05*Sum30min, 1.05*Sum30max);
  char TitleDummy[200];
  sprintf(TitleDummy, "Event#%d (%d)", EH->event, EH->burstEvent);
  dummy->SetTitle(TitleDummy);
  dummy->SetStats(0);
  dummy->DrawCopy();

  //int i3spike=0;
  //double dt=0.;
  //double wdt=0.;
  
  displayLine->SetLineStyle(1);
  displayLine->SetLineColor(kGray);
  displayLine->SetLineWidth(3);

  for (int i3x=2; i3x<i30; i3x++) {
    int i31=i3x-1;
    if (Time30[i31]>EventTime-12000000. && Time30[i3x]<EventTime+500000.) {
      displayLine->DrawLine(Time30[i31]/1000000., Max30d[i31], Time30[i3x]/1000000., Max30d[i3x]);
    }
  }

  displayLine->SetLineStyle(1);
  displayLine->SetLineColor(kBlack);
  displayLine->SetLineWidth(2);

  for (int i3x=2; i3x<i30-10; i3x++) {
    int i31=i3x-1;
    if (Time30[i31]>EventTime-12000000. && Time30[i3x]<EventTime+500000.) {
      displayLine->DrawLine(Time30[i31]/1000000., Sum30d[i31], Time30[i3x]/1000000., Sum30d[i3x]);
    }
  }

  displayLine->SetLineColor(kBlue);
  displayLine->SetLineWidth(2);
  for (int i3x=12; i3x<i30-10; i3x+=10) {
    int i31=i3x-10;
    if (Time30[i31]>EventTime-12000000. && Time30[i3x]<EventTime+500000.) {
      displayLine->DrawLine(Time30[i31]/1000000., CherBuff->GetIntegral(Time30[i31]-EventTime, 0.71e6, 2), 
                            Time30[i3x]/1000000., CherBuff->GetIntegral(Time30[i3x]-EventTime, 0.71e6, 2));
    }
  }

  displayLine->SetLineColor(kGreen);
  displayLine->SetLineWidth(2);
  for (int i3x=12; i3x<i30-10; i3x+=10) {
    int i31=i3x-10;
    if (Time30[i31]>EventTime-12000000. && Time30[i3x]<EventTime+500000.) {
      displayLine->DrawLine(Time30[i31]/1000000., CherBuff->GetIntegral(Time30[i31]-EventTime, 1.5e6, 2), 
                            Time30[i3x]/1000000., CherBuff->GetIntegral(Time30[i3x]-EventTime, 1.5e6, 2));
    }
  }


  displayLine->SetLineColor(kRed);
  displayLine->SetLineWidth(2);
  for (int i3x=12; i3x<i30-10; i3x+=10) {
    int i31=i3x-10;
    if (Time30[i31]>EventTime-12000000. && Time30[i3x]<EventTime+500000.) {
      displayLine->DrawLine(Time30[i31]/1000000., CherBuff->GetIntegral(Time30[i31]-EventTime, 10.0e6, 2), 
                            Time30[i3x]/1000000., CherBuff->GetIntegral(Time30[i3x]-EventTime, 10.0e6, 2));
    }
  }



  displayLine->SetLineStyle(2);
  displayLine->SetLineColor(kRed);
  displayLine->SetLineWidth(2);
  displayLine->DrawLine(EventTime/1.0e6, 1.05*Sum30min, EventTime/1.0e6, 1.05*Sum30max);

  CherBuff->GetSpillCanvas()->Update();

  dummy       ->Delete();
  displayLine ->Delete();
  displayLatex->Delete();
}




