
bool GlobalPhase2012(TModule* Setup, ProcessingStatus* ProcStat) {
// uses RF signal fit (Module#5, ch#3, low gain);
  double Tg=0;
  bool   ok=true;
  bool   ok1=true;
  TChannel *Channel=Setup[5].GetChannel(2);
  TSignal  *Signal0=Channel->GetSignalShort(0);
  TSignal  *Signal1=Channel->GetSignalShort(1);

  ok=ok && Signal0->computeSinParams201212();
  if (!ok) printf("[GlobalPhase2012] fit#0 failed\n");
  ok=ok && Signal1->computeSinParams201212();
  if (!ok) printf("[GlobalPhase2012] fit#1 failed\n");

  if (ProcStat->GetReportMode()==1) {
    printf("[GlobalPhase2012] Fit results--->\n");
    for (int ip=0; ip<5; ip++) {
      printf("     par#%d RF#0=%.2f\tRF#1=%.2f\n", ip, 
             Signal0->getSinParam(ip), 
             Signal1->getSinParam(ip));             
    }
  }

  double phase0=Signal0->getSinParam(3);
  double phase1=Signal1->getSinParam(3);
  //printf("[GlobalPhase2012] corrected#3 -> phase0=%.2f phase1=%.2f\n", phase0, phase1);

  if (phase0-phase1>Signal0->getSinParam(4)/2.) phase0-=Signal0->getSinParam(4);
  if (phase1-phase0>Signal1->getSinParam(4)/2.) phase1-=Signal1->getSinParam(4);
  //while (phase0-phase1>85.) phase0-=Signal0->getSinParam(4);
  //while (phase1-phase0>85.) phase1-=Signal1->getSinParam(4);



  double PhaseDiff=phase1-phase0;
  RFt0diff -> Fill(PhaseDiff);
  ok1 = PhaseDiff>-1.5 && PhaseDiff<1.5;
  ok = ok && ok1;
  if (!ok1) {
    printf("[GlobalPhase2012] phase shift %.2f shall be [-1.5...1.5]\n",
             PhaseDiff);
    ProcStat->SetReportMode(1);
    //exit(-1);
  }
 
  double PhaseRatio=Signal0->getSinParam(1)/Signal1->getSinParam(1);
  //printf("[GlobalPhase2012]-> ratio=%.5f\n", PhaseRatio);
  RFratio -> Fill(PhaseRatio);
  ok1 = PhaseRatio>0.90 && PhaseRatio<0.97;
  ok  = ok && ok1;
  if (!ok1) {
     printf("[GlobalPhase2012] amplitude ratio problem %.2f shall be [0.90...0.97]\n",
             PhaseRatio);
  }

  RFt0[0].Fill(phase0);
  RFt0[1].Fill(phase1);

//  ok1 = phase0>132.5 && phase1>132.5 
//     && phase0<169.5 && phase1<169.5;
//  ok = ok && ok1;
//  if ( !ok1 ) {
//     printf("[GlobalPhase2012] phase problem #0=%.1f  #1=%.1f  shall be [132.5...169.5]\n",
//             phase0, phase1);
//  }


  RFperiod[0]   .Fill(Signal0->getSinParam(4));
  RFperiod[1]   .Fill(Signal1->getSinParam(4));
  ok1 = Signal0->getSinParam(4) > 164.95 && Signal1->getSinParam(4) > 164.95
     && Signal0->getSinParam(4) < 166.05 && Signal1->getSinParam(4) < 166.05;
  ok = ok && ok1;
  if (!ok1) {
     printf("[GlobalPhase2012] period problem #0=%.1f  #1=%.1f  shall be [164.95...166.05]\n",
             Signal0->getSinParam(4), Signal1->getSinParam(4));

  }

  RFamplitude[0].Fill(Signal0->getSinParam(1));
  RFamplitude[1].Fill(Signal1->getSinParam(1));
  ok1 = Signal0->getSinParam(1)>400. && Signal1->getSinParam(1)>400. && 
        Signal0->getSinParam(1)<605. && Signal1->getSinParam(1)<605.;

  if (!ok1) {
     printf("[GlobalPhase2012] amplitude problem: #1=%.1f #2=%.1f\n",
               Signal0->getSinParam(1), Signal1->getSinParam(1));
  }
  ok = ok && ok1;

  double res0=Signal0->getSinRes();
  double res1=Signal1->getSinRes();
  RFresidual[0] .Fill(res0);
  RFresidual[1] .Fill(res1);
  ok = ok && Signal0->getSinRes()<6.5 && Signal1->getSinRes()<6.5;

  if (Signal0->getSinRes()>6.5 ||
      Signal1->getSinRes()>6.5) {
    printf("[GlobalPhase2012] residuals problem: #1=%.1f #2=%.1f\n",
                    Signal0->getSinRes(), Signal1->getSinRes());
  }

  Tg=res1*phase0+res0*phase1;
  Tg/=(res0+res1);
  double Trf=0.0;
  Trf=res1*Signal0->getSinParam(4)+res0*Signal1->getSinParam(4);
  Trf/=(res0+res1);

  while (Tg>Trf/2.)   Tg-=Trf;
  while (Tg<=-Trf/2.) Tg+=Trf;
  if (ProcStat->GetReportMode()==1) printf("[GlobalPhase2012]       Tg=%.1fns\n", Tg);

  double Arf=0.;
  Arf=res1*Signal0->getSinParam(1)+res0*Signal1->getSinParam(1);
  Arf/=(res0+res1);
  Signal0->Scale(Arf/Signal0->getSinParam(1));
  Signal1->Scale(Arf/Signal1->getSinParam(1));
  if (ProcStat->GetReportMode()==1) printf("[GlobalPhase2012]   amp RF=%.1fADC\n", Arf); 
  ProcStat->GetEventHeader()->SetTimeGlobal(Tg);
  ProcStat->GetEventHeader()->SetRFperiod(Trf);
  ProcStat->GetEventHeader()->SetRFamp(Arf);

  return ok;
}



