bool LoadFFTcorrection(Int_t run, TModule* Setup) {
bool result=true;
char titleC[200];
std::ifstream inFFTdata;

int nCount=0;
int im0=0;
int im1=0;
int ich0[7]={7*0};
int ich1[7]={7*0};
int imX=0;
int imT=0;
int ichX=0;
int igX=0;
int nSlice=0;

sprintf(titleC, "reports/pickupReduction/correctionData/FFTcorr00run%dmap.dat", run);
inFFTdata.open(titleC, ios::in);
  
inFFTdata >> im0 >> im1;
//printf("[LoadFFTcorrection] Run#%d indexing modules %d to %d\n", run, im0, im1);
for (int im=im0; im<im1; im++) {
  inFFTdata >> imX >> imT >> ich0[im] >> ich1[im] >> nSlice;
  //printf("[LoadFFTcorrection]    module#%d(%d) channels %d to %d, %d slices\n", imT, im, ich0[im], ich1[im], nSlice);
  if (imT != im || imT>6) {
    printf("[LoadFFTcorrection] imT...im error\n");
    exit(-1);
    return false;
  }
  for (int ich=ich0[im]; ich<ich1[im]; ich++) {
    for (int ig=0; ig<2; ig++) {
      inFFTdata >> ichX >> igX;
      if (ich != ichX || ig != igX) {
        printf("error, ich=%d(%d) ig=%d(%d)\n", ich, ichX, ig, igX);
        exit(-1);
        return false;
      }
      for (int i=0; i<nSlice/2+1; i++) {
        for (int kSum=0; kSum<11; kSum++) {
          nCount++;
        }
      }
    }
  }
}
inFFTdata.clear();
inFFTdata.close();
//printf("[LoadFFTcorrection]  %d sum values counted\n", nCount);

double *buffer1 = new double [nCount];

// loading buffer1 from binary file
sprintf(titleC, "reports/pickupReduction/correctionData/FFTcorr00run%ddouble.dat", run);
//printf("[LoadFFTcorrection] trying binary %s N=%d\n", titleC, nCount);
fstream FFTfile (titleC, ios::in | ios::binary);
FFTfile.read((char*)buffer1, sizeof (double)*nCount);
//printf("[LoadFFTcorrection] binary FFT sums file loaded\n");
FFTfile.close();

//for (int i=0; i<50; i++) cout << buffer1[i] << endl;

/* move data to the channels, as mapped above */
nCount=0;
for (int im=im0; im<im1; im++) {
 // printf("[LoadFFTcorrection]  loading FFT sums to  module#%d(%d) channels %d to %d, %d slices\n", 
 //         imT, im, ich0[im], ich1[im], nSlice);
  TModule *Module = &Setup[im];
  for (int ich=ich0[im]; ich<ich1[im]; ich++) {
    TChannel *Channel = Module->GetChannel(ich);
    for (int ig=0; ig<2; ig++) {
      TSignal *Signal = Channel->GetSignalLong(ig);
      for (int i=0; i<nSlice/2+1; i++) {
        for (int kSum=0; kSum<11; kSum++) {
          double a=buffer1[nCount];
          if (im==0 && ich==4 && ig==1 && i<20 && kSum==0) {
            //printf("  in>     i=%2d Nc=%10d a=%f a1=%lf\n", i, nCount, double (a), buffer1[nCount]);
           }
          Signal->SetSumFFT(kSum, i, a);
          nCount++;
        }
      }
      Signal->ComputeFFTparameters();
    }
  }
}




delete[] buffer1;

//exit(-1);

return result;
}



