// loads results of single MIP: thresholds and statistics
bool LoadMIP2data(Int_t Run, TModule* Setup) {
bool result=true;
bool lowStat=false;  
std::ifstream dFile;
char dFileName[100];
int nADC=0;
double w, dip0, mip, dip1, tot, pos, mips; 
sprintf(dFileName, "reports/MIP/timing/run%04dv0613step2.dat", Run);
dFile.open(dFileName);
if(dFile.is_open()) {
  for (int iCh=0; iCh<3; iCh++) {
    int jCh=-1;
    dFile >> jCh >> dip0 >> mip >> dip1 >> tot >> pos >> mips;
    dip0=.5*(dip0+mip);
    dip1=.5*(dip1+mip);
    Setup[4].GetChannel(jCh)->SetMIP2cuts(dip0, mip, dip1);
    printf("[LoadMIP2data] loaded for %10s MIP cits = (%5.1f, %5.1f, %5.1f) Stats = (%.0f, %.0f, %.0f)\n",
           Setup[4].GetChannel(jCh)->GetName(), dip0, mip, dip1, tot, pos, mips);
    if (mips<200) lowStat=true;
  }
  result=true;
} else {
  printf("[LoadMIP2data] No PMT MIP2 data found for Run#%d file->%s\n", Run, dFileName);
  dFile.clear();
  result=false;
}
if (lowStat) {
  printf("[LoadMIP2data] One of counters have low singles statistics!\n");
//  result=false;
}

dFile.close();
return result;
}


