void SavePulseShapes(Int_t Run, TModule* Setup) {
  std::ofstream shapesdata;
  char FileName[100];
  sprintf(FileName, "reports/ShapesQC/Shapes2012run%d.shapesQC", Run);
  shapesdata.open(FileName, ios::out);

  for (int iMod=0; iMod<6; iMod++) {
    for (int iChan=0; iChan<4; iChan++) {
      TChannel *Channel = Setup[iMod].GetChannel(iChan);
      if (!Channel->GetStatus()) {
	shapesdata << iMod << " " << iChan << " " << 0 << endl;
      } else {
	shapesdata << iMod << " " << iChan << " " << 1 << endl;
	for (int iGain=0; iGain<2; iGain++) {
	  shapesdata << iMod << " " << iChan << " " << iGain << endl;
          TSignal *SignalLong = Channel->GetSignalLong(iGain);
          TProfile *ShapeLong = SignalLong->GetPulseShape();
	  TH1D *relative1Dlocal = SignalLong-> GetPulse1Drelative();

          int Nbins=ShapeLong->GetNbinsX();
	  shapesdata << Nbins << " " << SignalLong->GetPeakAverage() << " " << SignalLong->GetZeroAverage() << endl;
          for (int ibin=1; ibin<Nbins+1; ibin++) {
	    shapesdata << ShapeLong->GetBinCenter(ibin)  << " " 
                       << ShapeLong->GetBinContent(ibin) << " " 
                       << ShapeLong->GetBinError(ibin)   << " " 
                       << ShapeLong->GetBinEntries(ibin) << endl;
	  }
          Nbins = relative1Dlocal->GetNbinsX();
	  shapesdata << Nbins << " " << relative1Dlocal->GetMean() << " " << relative1Dlocal->GetRMS() << endl;
          for (int ibin=1; ibin<Nbins+1; ibin++) {
	    shapesdata << relative1Dlocal->GetBinCenter(ibin)  << " " 
                       << relative1Dlocal->GetBinContent(ibin) << endl;
	  }


          for (int iDelay=0; iDelay<2; iDelay++) {
            TSignal *SignalShort = Channel->GetSignalShort(2*iGain+iDelay);
            TProfile *ShapeShort = SignalShort->GetPulseShape();
	    TH1D *relative1Dlocal1 = SignalShort-> GetPulse1Drelative();
            int Nbins1=ShapeShort->GetNbinsX();
	    shapesdata << iDelay << " " << Nbins1 << " " << SignalShort->GetPeakAverage() << " " << SignalShort->GetZeroAverage() << endl;
            for (int ibin=1; ibin<Nbins1+1; ibin++) {
	      shapesdata << ShapeShort->GetBinCenter(ibin)  << " " 
                         << ShapeShort->GetBinContent(ibin) << " " 
                         << ShapeShort->GetBinError(ibin)   << " " 
                         << ShapeShort->GetBinEntries(ibin) << endl;
	    }
            Nbins = relative1Dlocal1->GetNbinsX();
	    shapesdata << Nbins << " " << relative1Dlocal1->GetMean() << " " << relative1Dlocal1->GetRMS() << endl;
            for (int ibin=1; ibin<Nbins+1; ibin++) {
	      shapesdata << relative1Dlocal1->GetBinCenter(ibin)  << " " 
                         << relative1Dlocal1->GetBinContent(ibin) << endl;
	    }
	  }
	}
      }
    }
  }
  shapesdata.close();
  return;
}

