struct miniEventHeader {
  Double_t RFperiod;
  Double_t RFfreq;
  Double_t RFamp;
  Double_t TimeGlobal;  // event phase as found by GlobalPhase finder
  Double_t SignalFactor;// signal/noise ratio in GlobalPhase finder

  Int_t burst;
  Int_t event;
  Int_t burstEvent;
  Int_t scaler10mhz;
  Int_t scaler6mhz;
  Int_t firstGated;
  Int_t GADCoverflows; // GADC overfloes count in previous 4us

  Bool_t   isEmpty;
  Bool_t   notEmpty;
  Bool_t   filledSegment;
  Bool_t   inHotZone;
  Bool_t   isSpiky;
///////////////////////////////////////////////////////////////////////////////////
  void Print() {
    printf("\n----------------------------------------------------------------------------------------------\n");
    printf("[miniEventHeader->Print] burst#%03d event#%05d(%03d) scaler10=%07d scaler6=%07d firstGADCsample=%07d\n",
            burst, event, burstEvent, scaler10mhz, scaler6mhz, firstGated);
    printf("isEmpty=%1d notEmpty=%1d filledSegmen=%1d hotZone=%d isSpiky=%d\n ", isEmpty, notEmpty, filledSegment, inHotZone, isSpiky);
    printf("RFperiod=%.1lfns RFfreq=%6.1e RFamp=%5.1e Tglobal=%5.1e SignalFactor=%5.1e\n", 
            RFperiod, RFfreq, RFamp, TimeGlobal, SignalFactor);
    printf("----------------------------------------------------------------------------------------------\n");
  }
};


