// computes covariance, corrleation coefficient, slope and variance of all for 2 variables
struct myCovariance {
  double sumW[11]; //0...9 subsets, 10 - entire dataset
  double sumX[11];
  double sumY[11];
  double sumXX[11];
  double sumYY[11];
  double sumXY[11];
  int    indx;

  void Clear() {
    for (int i=0; i<11; i++) {
      sumW[i]=0.;
      sumX[i]=0.;
      sumY[i]=0.;
      sumXX[i]=0.;
      sumYY[i]=0.;
      sumXY[i]=0.;
      indx=0;
    }
  }

  void Fill(double x, double y, double w) {
    sumW[10]+=w;
    sumX[10]+=x*w;
    sumY[10]+=y*w;
    sumXX[10]+=x*x*w;
    sumYY[10]+=y*y*w;
    sumXY[10]+=x*y*w;
    sumW[indx]+=w;
    sumX[indx]+=x*w;
    sumY[indx]+=y*w;
    sumXX[indx]+=x*x*w;
    sumYY[indx]+=y*y*w;
    sumXY[indx]+=x*y*w;
//  printf("[myCovariance->Fill] filling indx=%d w=%.1f x=%1.f y=%.1f\n", indx, w, x, y);
    indx++;
    if (indx==10) indx=0;
  }

  void Fill(double x, double y) {
    Fill(x, y, 1.0);
  }

  double GetWeight(int i) {
    if (i<0 || i>10) {
      printf("[myCovariance->GetWeight] wrong index %d\n", i);
      exit(-1);
    }
    return sumW[i];
  }

  void SetWeight(int i, double w) {
    if (i<0 || i>10) {
      printf("[myCovariance->GetWeight] wrong index %d\n", i);
      exit(-1);
    }
    sumW[i]=w;
  }

   double GetAverageX(int i) {
    if (i<0 || i>10 || sumW[i]==0.) {
      printf("[myCovariance->GetAverageX] wrong weight=%f or index %d\n", sumW[i], i);
      exit(-1);
    }
    return sumX[i]/sumW[i];
  }

  double GetAverageY(int i) {
    if (i<0 || i>10 || sumW[i]==0.) {
      printf("[myCovariance->GetAverageY] wrong weight=%f or index %d\n", sumW[i], i);
      exit(-1);
    }
  return sumY[i]/sumW[i];
  }

  double GetAverageX2(int i) {
    if (i<0 || i>10 || sumW[i]==0.) {
      printf("[myCovariance->GetAverageX2] wrong weight=%f or index %d\n", sumW[i], i);
      exit(-1);
    }
    return sumXX[i]/sumW[i];
  }

  double GetAverageY2(int i) {
    if (i<0 || i>10 || sumW[i]==0.) {
      printf("[myCovariance->GetAverageY2] wrong weight=%f or index %d\n", sumW[i], i);
      exit(-1);
    }
    return sumYY[i]/sumW[i];
  }

  double GetSigmaX(int i) {
    if (i<0 || i>10 || sumW[i]==0.) {
      printf("[myCovariance->GetSigmaX] wrong weight=%f or index %d\n", sumW[i], i);
      exit(-1);
    }
    double result=sumXX[i]/sumW[i]-GetAverageX(i)*GetAverageX(i);
    if (result<0.) result=0.0;
    return sqrt(result);
  }

  double GetSigmaX2(int i) {
    if (i<0 || i>10 || sumW[i]==0.) {
      printf("[myCovariance->GetSigmaX2] wrong weight=%f or index %d\n", sumW[i], i);
      exit(-1);
    }
    double result=sumXX[i]/sumW[i]-GetAverageX(i)*GetAverageX(i);
    if (result<0.) result=0.0;
    return result;
  }

  double GetSigmaY(int i) {
    if (i<0 || i>10 || sumW[i]==0.) {
      printf("[myCovariance->GetSigmaY] wrong weight=%f or index %d\n", sumW[i], i);
      exit(-1);
    }
    double result=sumYY[i]/sumW[i]-GetAverageY(i)*GetAverageY(i);
    if (result<0.) result=0.0;
    return sqrt(result);
  }

  double GetSigmaY2(int i) {
    if (i<0 || i>10 || sumW[i]==0.) {
      printf("[myCovariance->GetSigmaY] wrong weight=%f or index %d\n", sumW[i], i);
      exit(-1);
    }
    double result=sumYY[i]/sumW[i]-GetAverageY(i)*GetAverageY(i);
    if (result<0.) result=0.0;
    return result;
  }

  double GetCorrelation(int i) {
    if (i<0 || i>10 || sumW[i]==0.) {
      printf("[myCovariance->GetCorrelation] wrong weight=%f or index %d\n", sumW[i], i);
      exit(-1);
    }
//  double result=sumW[i]/(sumW[i]-1.)*(sumXY[i]/sumW[i]-GetAverageY(i)*GetAverageX(i))/GetSigmaX(i)/GetSigmaY(i);
    double result=(sumXY[i]/sumW[i]-GetAverageY(i)*GetAverageX(i))/GetSigmaX(i)/GetSigmaY(i);
    return result;
  }  

  double GetCorrelationVariance() {
    double c;
    double c0=0.;
    double c1=0.;
    double c2=0.;
    for (int i=0; i<10; i++) {
      c=GetCorrelation(i);
      c0+=sumW[i];
      c1+=c*sumW[i];
      c2+=c*c*sumW[i];
    }
    c1/=c0;
    c2/=c0;
    c2-=c1*c1;
    if (c2>0.) c2=sqrt(c2);
    else       c2=0.;
    return c2;
  }

  double GetSlope(int i) {
    if (i<0 || i>10 || sumW[i]==0.) {
      printf("[myCovariance->GetSlope] wrong weight=%f or index %d\n", sumW[i], i);
      exit(-1);
    }
    double x=GetSigmaX(i)*GetSigmaX(i)-GetSigmaY(i)*GetSigmaY(i);
    double y=2.0*(sumXY[i]/sumW[i]-GetAverageY(i)*GetAverageX(i));
    double alpha=0.5*atan2(y, x);
    double slope=tan(alpha);
    return slope;
  }
  
  double GetAngle(int i) {
    if (i<0 || i>10 || sumW[i]==0.) {
      printf("[myCovariance->GetAngle] wrong weight=%f or index %d\n", sumW[i], i);
      exit(-1);
    }
    double x=GetSigmaX(i)*GetSigmaX(i)-GetSigmaY(i)*GetSigmaY(i);
    double y=2.0*(sumXY[i]/sumW[i]-GetAverageY(i)*GetAverageX(i));
    double alpha=0.5*atan2(y, x);
    return alpha;
  }
  
  double GetSlope0(int i) { // special case with line, going through (0,0)
    if (i<0 || i>10) {
      printf("[myCovariance->GetSlope0] wrong weight=%f or index %d\n", sumW[i], i);
      exit(-1);
    }
    if (sumW[i]==0.) return 0.; 

    double x=sumXX[i]/sumW[i]-sumYY[i]/sumW[i];
    double y=2.0*sumXY[i]/sumW[i];
    double alpha=0.5*atan2(y, x);
    double slope=tan(alpha);
    return slope;
  }  

  double GetSlope0Variance() { // special case with line, going through (0,0)
    double c0=0.;
    double c1=0.;
    double c2=0.;

    for (int i=0; i<11; i++) {
      if (sumW[i]<=0.) return 0.; 
    }

    for (int i=0; i<10; i++) {
      if (sumW[i]>0.) {
        double alpha=0.5*atan2(2.0*sumXY[i]/sumW[i], sumXX[i]/sumW[i]-sumYY[i]/sumW[i]);
        double slope=tan(alpha);
        c0+=sumW[i];
        c1+=slope*sumW[i];
        c2+=slope*slope*sumW[i];
      }
    }
    c1/=c0;
    c2/=c0;
    c2-=c1*c1;
    if (c2<0.) c2=0.;
    else c2=sqrt(c2);

    return c2;
  }  




  double GetAngle0(int i) {// special case with line, going through (0,0)
    if (i<0 || i>10 || sumW[i]==0.) {
      printf("[myCovariance->GetAngle0] wrong weight=%f or index %d\n", sumW[i], i);
      exit(-1);
    }
    double x=GetSigmaX(i)*GetSigmaX(i)-GetSigmaY(i)*GetSigmaY(i);
    double y=2.0*sumXY[i]/sumW[i];
    double alpha=0.5*atan2(y, x);
    return alpha;
  }  

  double GetSlopeX(int i) { // classic linear fit y=b+a*(x-<x>);
    if (i<0 || i>10 || sumW[i]==0.) {
      printf("[myCovariance->GetSlopeX] wrong weight=%f or index %d\n", sumW[i], i);
      exit(-1);
    }
    double slope=(sumXY[i]/sumW[i]-GetAverageY(i)*GetAverageX(i))/GetSigmaX2(i);
    return slope;
  }

  double GetSlopeXVariance() {
    double c;
    double c0=0.;
    double c1=0.;
    double c2=0.;
    for (int i=0; i<10; i++) {
      c=GetSlopeX(i);
      c0+=sumW[i];
      c1+=c*sumW[i];
      c2+=c*c*sumW[i];
    }
    c1/=c0;
    c2/=c0;
    c2-=c1*c1;
    if (c2>0.) c2=sqrt(c2);
    else       c2=0.;
    return c2;
  }
  
  double GetSlopeY(int i) { // classic linear fit y=b+a*(x-<x>);
    if (i<0 || i>10 || sumW[i]==0.) {
      printf("[myCovariance->GetSlopeX] wrong weight=%f or index %d\n", sumW[i], i);
      exit(-1);
    }
    double slope=(sumXY[i]/sumW[i]-GetAverageY(i)*GetAverageX(i))/GetSigmaY2(i);
    return slope;
  }
  
  double GetSlopeYVariance() {
    double c;
    double c0=0.;
    double c1=0.;
    double c2=0.;
    for (int i=0; i<10; i++) {
      c=GetSlopeY(i);
      c0+=sumW[i];
      c1+=c*sumW[i];
      c2+=c*c*sumW[i];
    }
    c1/=c0;
    c2/=c0;
    c2-=c1*c1;
    if (c2>0.) c2=sqrt(c2);
    else       c2=0.;
    return c2;
  }

  double GetSlopeX0(int i) { // classic linear fit y=b+a*(x-<x>);
    if (i<0 || i>10 || sumW[i]==0.) {
      printf("[myCovariance->GetSlopeX0] wrong weight=%f or index %d\n", sumW[i], i);
      exit(-1);
    }
    double slope=sumXY[i]/sumW[i]/GetAverageX2(i);
    return slope;
  }
  
  double GetSlopeX0Variance() {
    double c;
    double c0=0.;
    double c1=0.;
    double c2=0.;
    for (int i=0; i<10; i++) {
      if (sumW[i]==0.) continue;
      c=GetSlopeX0(i);
      c0+=sumW[i];
      c1+=c*sumW[i];
      c2+=c*c*sumW[i];
    }
    if (c0==0.0) return 0.0;
    c1/=c0;
    c2/=c0;
    c2-=c1*c1;
    if (c2>0.) c2=sqrt(c2);
    else       c2=0.;
    return c2;
  }

  double GetSlopeY0(int i) { // classic linear fit y=b+a*(x-<x>);
    if (i<0 || i>10 || sumW[i]==0.) {
      printf("[myCovariance->GetSlopeY0] wrong weight=%f or index %d\n", sumW[i], i);
      exit(-1);
    }
    double slope=sumXY[i]/sumW[i]/GetAverageY2(i);
    return slope;
  }
  
  double GetSlopeY0Variance() {
    double c;
    double c0=0.;
    double c1=0.;
    double c2=0.;
    for (int i=0; i<10; i++) {
      c=GetSlopeY0(i);
      c0+=sumW[i];
      c1+=c*sumW[i];
      c2+=c*c*sumW[i];
    }
    c1/=c0;
    c2/=c0;
    c2-=c1*c1;
    if (c2>0.) c2=sqrt(c2);
    else       c2=0.;
    return c2;
  }  
};


