struct eventEssentials {

int firstGADCsample; // dead! supposed to be same as miniEventHeader.firstGated!

float GADCevent[40];  // 40 Gated ADC samples (RF cycles), starting with firstGADCsample
float GADCevent1[40]; // 40 Gated ADC samples (RF cycles), starting with firstGADCsample, tails subtracted
float MPICevent[40]; // 40 MPI ADC samples for Cherenkov. NOT ALL FILLED! Integral after FFT
float tRFb[40];      // time fof RF bunches in the "MPI time frame"

int bunchAction[40]; // 0 - useless bunch 1 - signal 2 - pedestal
                     // ATTN~! for true electronc pedestals use events with isEmpty=true!

int mipCount[40];    // likelihood track counting; wokrs for Ntracks<100 actually <~80
int mipCount2[40];   // sqrt(Sx*Sy), where Sx and Sy are two smallest scintillator signals (in MIPs)
int mipCount3[40];   // (S1*S2*S3)^(1/3), Si in MIPs
//int mipCountX[40];   // hybrid of mipCount[] at low rate and  mipCount2[] at high rate

bool isIsolated[40]; // indicates isolated filled bunch (isCluster0=isCluster1=true);
bool isCluster0[40]; // first in cluster flag
bool isCluster1[40]; // last in cluster flag
bool inScope[40];

float scintFFT[120]; // scintillators in MPI.FFT units. id=3*iRF+iScint iRF RF cycle in event

bool  HGoverflow[4]; // module has HighGain overflow
bool  LGoverflow[4]; // module has LowGain overflow
int   RFclust0[5];   // RF# for clusters, as indicated by isCluster0 and isCluster1 
int   RFclust1[5];
float miniChannel[200]; //fC, 4mod*5chan*2gain*5clust

/*
void computeMIPcountX() {
  for (int i=0; i<40; i++) {
    if (mipCount[i]<40) {
      mipCountX[i]=mipCount[i];
    } else if (mipCount[i]<60) {
      mipCountX[i]=int(0.5+((60-i)*mipCount[i]+(i-40)*mipCount2[i])/20.);
    } else {
      mipCountX[i]=mipCount2[i];
    }
  }
}
*/
int mipCountX(int i) {
  if (i<0 || i>39) {
    printf("[eventEssentials->mipCountX] bad index#%d\n", i);
    exit(-1);
  }
  if (mipCount[i]<60) {
    return mipCount[i];
  } else if (mipCount[i]<80) {
    return int(0.5+((80-i)*mipCount[i]+(i-60)*mipCount2[i])/20.);
  }
  return mipCount2[i];
}

void CorrectGADCtail() {

  for (int i=0; i<40; i++) {
    GADCevent1[i]=GADCevent[i];
  } 
  for (int i=0; i<39; i++) { 
    GADCevent1[i+1]-=0.16*GADCevent[i];
    if (i<38) GADCevent1[i+2]-=0.04*GADCevent[i];
    if (i<37) GADCevent1[i+3]-=0.02*GADCevent[i];
  }
}

void Clear () {
  firstGADCsample=-1000;
  for (int i=0; i<120; i++) {
    scintFFT[i]=0.;
  }
  for (int i=0; i<40; i++) {
    GADCevent[i]=0.;
    MPICevent[i]=0.;

    tRFb[i]=-10000.;

    mipCount[i]=0;
    mipCount2[i]=0;
    mipCount3[i]=0;

    isIsolated[i]=false;
    isCluster0[i]=false;
    isCluster1[i]=false;
    inScope[i]=false;
  }
  for (int i=0; i<4; i++) {
    HGoverflow[i]=false;
    LGoverflow[i]=false;
  }
  for (int i=0; i<5; i++) {
    RFclust0[i]=-1;
    RFclust1[i]=-1;
  }
  for (int i=0; i<200; i++) {
    miniChannel[i]=0.;
  }
}
};



