struct miniEventHeader {
  Int_t burst;          // burst number in run (some may be missing due to 
                        // missing or rejected GADC data) 
  Int_t event;          // event# in run
  Int_t burstEvent;     // event# in burst
  Int_t scaler10mhz;    // 10MHz counter
  Int_t scaler6mhz;     // 6MHz (165ns, accelerator RF) counter
  Int_t firstGated;     // same as firstGADCsample above...???

  Bool_t   isEmpty;     // no activity in S123 and Cherenkov for low rate, 
                        // no activity in (some of) modules and Cherenkov for high rate
  Bool_t   notEmpty;    // some activity detected!
  Bool_t   S123inBeam;  // S123 are placed in the beam
  Bool_t   filledSegment;  // event is in 'active' part of GatedADC record

  Double_t RFperiod;    // RF A*sin(omega*(t+t0)) fit
  Double_t RFfreq;      // RF A*sin(omega*(t+t0)) fit
  Double_t RFamp;       // RF A*sin(omega*(t+t0)) fit
  Double_t TimeGlobal;  // RF A*sin(omega*(t+t0)) fit
  Double_t SignalFactor;// effective signal/noise ratio in GlobalPhase finder

  void Print() {
    printf("[miniEventHeader->Print] burst#%03d event#%05d(%03d) scaler10=%07d scaler6=%07d firstGADCsample=%07d ",
            burst, event, burstEvent, scaler10mhz, scaler6mhz, firstGated);
    printf("isEmpty=%1d notEmpty=%1d S123beam=%1d filledSegmen=%1d ", isEmpty, notEmpty, S123inBeam, filledSegment);
    printf("RFperiod=%.1lfns RFfreq=%6.1e RFamp=%5.1e Tglobal=%5.1e SignalFactor=%5.1e\n", 
            RFperiod, RFfreq, RFamp, TimeGlobal, SignalFactor);
  }
///////////////////////////////////////////////////////////////////////////////////
};

