struct Channel {
  int iChan;
  int iMod;
  double X;        // X center of gravity,  defined by geometry
  double Y;        // Y center of gravity,  defined by geometry
  double TphaseRF;
  Signal signal[2]; // 2 gains
  double maxFFT;
  double minFFT;
  double maxMPI;
  double minMPI;
  bool  maxminReadyMPI;
  bool  maxminReadyFFT;

//================================================================================
  void doMaxMinMPI() {
    maxminReadyMPI=true;
    for (int iG=0; iG<2; iG++) {
      signal[iG].doMaxMinMPI();
      if (maxMPI<signal[iG].maxMPI) maxMPI=signal[iG].maxMPI;
      if (minMPI>signal[iG].minMPI) minMPI=signal[iG].minMPI;
    }
  }
  
//================================================================================
  void doMaxMinFFT() {
    maxminReadyFFT=true;
    for (int iG=0; iG<2; iG++) {
      signal[iG].doMaxMinFFT();
      if (maxFFT<signal[iG].maxFFT) maxFFT=signal[iG].maxFFT;
      if (minFFT>signal[iG].minFFT) minFFT=signal[iG].minFFT;
    }
  }

//================================================================================
  void SetPhaseRF(double t) {
    TphaseRF=t;
    for (int i=0; i<2; i++) signal[i].SetPhaseRF(TphaseRF);
  }

//================================================================================
  void Clear() { 
    maxminReadyMPI=false;
    maxminReadyFFT=false;
    for (int i=0; i<2; i++) signal[i].Clear();
    maxFFT=5.;
    minFFT=5.;
    maxMPI=50.;
    minMPI=50.;
  }
  
//================================================================================
void AdjustLG(double ag) {
  signal[0].iGain=0;
  signal[1].iGain=1;
  signal[0].AdjustLG(ag);
}

//===========================================================================================
void FillEmptyPed(int i0, int i1) { // fill empty event pedestal window
  for (int i=0; i<2; i++) signal[i].FillEmptyPed(i0, i1);
}
 
//===========================================================================================
void FillPedWindow(int iw, int i0, int i1) { // fill filled  event pedestal window
  for (int i=0; i<2; i++) signal[i].FillPedWindow(iw, i0, i1);
}
 

//================================================================================
  void ClearSpill() { 
    Clear();
    for (int iG=0; iG<2; iG++) signal[iG].ClearSpill();
  }  
};


