
// --- old event display ---///
int DisplayAllPulses(TModule* Setup, ProcessingStatus* ProcStatus, CherenkovBuffer* CherBuff) {

  bool Dbg=false;
  //Dbg=true;
  EventHeader *EH = ProcStatus->GetEventHeader();
  BurstHeader *BH = ProcStatus->GetBurstHeader();
  int dWidth  = ProcStatus->GetDisplayWidth();
  //int dHeight = ProcStatus->GetDisplayHeight();
  TLine  * displayLine  = new TLine(); 
  TLatex * displayLatex = new TLatex();

  if (dWidth>1800) dWidth=1800;
  
  char TitleC[200];
  char NamecC[200];
  double integ0=Setup[6].GetChannel(0)->GetSignalShort(0)->GetIntegratorLevel();
  double integ1=Setup[6].GetChannel(1)->GetSignalShort(0)->GetIntegratorLevel();
  double integ2=Setup[6].GetChannel(2)->GetSignalShort(0)->GetIntegratorLevel();
  double integ3=Setup[6].GetChannel(3)->GetSignalShort(0)->GetIntegratorLevel();

  double CherAV=0.0;
  int Nbunches=ProcStatus->GetNbunches();
  int Ngb=0;
  for (int bunch=0; bunch<Nbunches; bunch++) {
    CherAV+=Setup[4].GetChannel(3)->GetResponseADC(bunch);
    Ngb++;
  }
  if (Ngb!=0) {
    CherAV/=Nbunches;
  } else {
    CherAV=0.;
  }

  double maxFuzz=0.0;
  for (int iMod=0; iMod<6; iMod++) {
    TModule *Module = &Setup[iMod];
    for (int iChan=0; iChan<4; iChan++) {
      for (int iGain=0; iGain<2; iGain++) {
        TChannel *Channel = Module->GetChannel(iChan);
        TSignal *Signal = Channel->GetSignalLong(iGain);
        if (Signal->GetStatus()) {
          //if (Signal->GetFuzz()>maxFuzz) maxFuzz=Signal->GetFuzz();  
          maxFuzz+=Signal->GetFuzz();  
          //printf("[DisplayAllChannels] %16s signalFuzz=%f \t maxFuzz=%f\n", 
                 //Signal->GetName(), Signal->GetFuzz(), maxFuzz);
        }
      }
    }
  }


  sprintf(TitleC, "Run #%d, Burst#%d, Event#%d(%d), 10MHz=%d Type=%02d <Ch(HG)>=%.1f Integrator=(%.1f, %.1f, %.1f, %.1f) SignalFactor=%.1f", 
	  EH->run, EH->burst, EH->event, EH->burstEvent, EH->scaler10mhz, EH->pattern[0], 
          CherAV, integ0, integ1, integ2, integ3, EH->SignalFactor); 
  sprintf(NamecC, "Run%d_Burst%d_Event%d_%d", EH->run, EH->burst, EH->event, EH->burstEvent); 

  //TCanvas * SpikeCanvas = new TCanvas("Spike", "Spike", int(dWidth/1.2)+1, 0, int(dWidth/2.), int (0.5*dHeight-10.));
  //SpikeCanvas->Divide(1,2);
 
  EventCanvas -> Connect("ProcessedEvent(Int_t,Int_t,Int_t,TObject*)", 0, 0, 
                        "MyExecuteEvent(Int_t,Int_t,Int_t,TObject*)");
  
  TH1D    *dummy = new TH1D("dummy", "dummy", 2500, -150., 150.+25.*EH->nSlice);

  EventCanvas->SetTitle(TitleC);
  EventCanvas->SetName(NamecC);
  EventCanvas->Clear();
  EventCanvas->Divide(2, 7, 0.002, 0.002);
  
  if (EH->isClone) EventCanvas->SetFillColor(2);


  for (int iMod=0;iMod<6;iMod++) {
    TModule *Module = &Setup[iMod];
    dummy->GetXaxis()->SetTitle("Time, ns");
    dummy->GetYaxis()->SetTitle("ADC");
    double AmpMax[2]={5., 5.}, AmpMin[2]={-5., -5.};

    for (int iGain=0;iGain<2;iGain++) {
      char Title[60];
      if (iGain) sprintf(Title, "%s, High Gain", Module->GetName());
      else  sprintf(Title, "%s, Low Gain", Module->GetName());
      dummy->SetTitle(Title);
      EventCanvas->cd(1+iMod*2+iGain);
      gStyle->SetOptStat(0);
      //gPad->SetFillStyle(2);
      //gPad->SetFillColor(kRed);
      dummy->SetTitleSize(0.04);
      gPad->SetBottomMargin(0.2);
      gPad->SetRightMargin(0.01);
      gPad->SetTopMargin(0.01);

      int iCh0=0;
      int iCh1=4;
      if (iMod==4 && EH->run<652) { // show cherenkov only! S1,2,3 - фтопку!
        iCh0=3;
      }

      for (int iChan=iCh0;iChan<iCh1;iChan++) {
        TChannel *Channel = Module->GetChannel(iChan);
        TSignal *Signal = Channel->GetSignalLong(iGain);
        if (Signal->GetStatus()) {
          double ama=Signal->GetMax();
          double ami=Signal->GetMin();
          if (Dbg) printf("[DisplayAllPulses]      %s min=%.2f max=%.2f\n",Signal->GetName(), ami, ama);
          if (ama>AmpMax[iGain]) AmpMax[iGain]=ama; 
          if (ami<AmpMin[iGain]) AmpMin[iGain]=ami; 
          //if (iMod==1) printf("[DisplayAllPulses] Long range: %.1f...%.1f\n", ami, ama);
	} else { // Check for the response from straight or delayed 
          for (int iDelay=0; iDelay<2; iDelay++) { 
            Signal = Channel->GetSignalShort(2*iGain+iDelay);
            if (Signal->GetStatus()) {
              double ama=Signal->GetMax();
              double ami=Signal->GetMin();
              if (Dbg) printf("[DisplayAllPulses]      %s min=%.2f max=%.2f\n",Signal->GetName(), ami, ama);
              if (ama>AmpMax[iGain]) AmpMax[iGain]=ama; 
              if (ami<AmpMin[iGain]) AmpMin[iGain]=ami;
              //if (iMod==1) printf("[DisplayAllPulses] Short range: %.1f...%.1f\n", ami, ama);
	    }
	  }
	}
      }

      
      if (iMod==4 && BH->goodGatedCherenkov) {
        double ChMax=CherBuff->GetCherenkovMax(); 
        double ChMin=CherBuff->GetCherenkovMin();
        ChMax=0.;
        ChMin=0.;
        //printf("[DisplayAllPulses] ChMax=%f ChMin=%f\n", ChMax,  ChMin);
        if (iGain==0) {
          if (ChMax/10.>AmpMax[iGain]) AmpMax[iGain]=ChMax/10.;
          if (ChMin/10.<AmpMin[iGain]) AmpMin[iGain]=ChMin/10.;
        } else {
          if (ChMax>AmpMax[iGain]) AmpMax[iGain]=ChMax;
          if (ChMin<AmpMin[iGain]) AmpMin[iGain]=ChMin;
        }
      }


      if (Dbg) printf("[DisplayAllPulses] %s Gain=%d min=%.2f max=%.2f\n", Module->GetName(), iGain, AmpMin[iGain], AmpMax[iGain]);
      dummy->GetYaxis()->SetRangeUser(1.05*AmpMin[iGain], 1.05*AmpMax[iGain]);
      dummy->GetYaxis()->SetTitleSize(.1);
      dummy->GetYaxis()->SetTitleOffset(.5);
      dummy->GetYaxis()->SetLabelSize(.08);
      dummy->GetXaxis()->SetTitleSize(.1);
      dummy->GetXaxis()->SetTitleOffset(.75);
      dummy->GetXaxis()->SetLabelSize(.08);
      
      dummy->DrawCopy();

      for (int i=0; EH->TimeGlobal+i*989.772<50.+25.*EH->nSlice; i++) {
        displayLine->SetLineColor(1);
        displayLine->SetLineStyle(2);
        if (i==0) displayLine->SetLineWidth(2);
        else      displayLine->SetLineWidth(1);
        displayLine->DrawLine(EH->TimeGlobal+i*989.772, 1.05*AmpMin[iGain], EH->TimeGlobal+i*989.772, 1.05*AmpMax[iGain]);
      }

      for (int bunch=0; bunch<Nbunches; bunch++) {
        double Tbunch=ProcStatus->GetBunchTime(bunch);
        displayLine->SetLineWidth(1);
        displayLine->SetLineColor(1);
        displayLine->DrawLine(Tbunch, 1.05*AmpMin[iGain], Tbunch, 1.05*AmpMax[iGain]);        
        for (int ifake=-6; ifake<6; ifake++) {
          double Tfake=Tbunch+ifake*989.772/6.;
          if (ifake!=0 && Tfake>0.0) {
            displayLine->SetLineWidth(1);
            displayLine->SetLineColor(6);
            displayLine->SetLineStyle(3);
            displayLine->DrawLine(Tfake, 0.5*AmpMin[iGain], Tfake, 0.5*AmpMax[iGain]);
          }
        }
      }

      int nWindows=Module->GetNPedWindows();

      for (int iw=0;iw<nWindows; iw++) {
        if (Dbg || ProcStatus->GetReportMode()==10006) {
          printf("[DisplayAllPulses] %s window#%d Status=%d (%.1f...%.1f)\n", 
                 Module->GetName(), iw, Module->GetPedWinX(iw), 
                 Module->GetPedWin0(iw), Module->GetPedWin1(iw));
          for (int iChan=iCh0;iChan<iCh1;iChan++) {
            TChannel *Channel = Module->GetChannel(iChan);
            if (Channel->GetStatus()) {
              printf("[DisplayAllPulses]     %s Status=%d (", Channel->GetName(), Channel->GetPedWinX(iw));
              for (int i=0;i<4;i++) {
                TSignal *Signal = Channel->GetSignalShort(i);
                if (i<3) printf("%d, ", Signal->GetPedWinX(iw)); 
		else  printf("%d)\n", Signal->GetPedWinX(iw));
	      }
	    }
	  }
	}

        int iCol;
        if (Module->GetPedWinX(iw)) iCol=kYellow; else iCol=kRed; // pedestal window
        displayLine->SetLineWidth(30);
        displayLine->SetLineStyle(1);
        displayLine->SetLineColor(iCol);
        displayLine->DrawLine(Module->GetPedWin0(iw), 0., Module->GetPedWin1(iw), 0.);

        if (iw==1) { 
          for (int iChan=iCh0; iChan<iCh1; iChan++) { 
            TChannel *Channel = Module->GetChannel(iChan);
            if (Channel->GetStatus()) {// dump the pedestal value for every channel
              char PedVal[100];
              //sprintf(PedVal, "%6.1f %6.1f, empty->(%6.1f %6.1f)",  
              //        Channel->GetSignalShort(2*iGain+0)->GetPed(),
              //        Channel->GetSignalShort(2*iGain+1)->GetPed(),
              //        Channel->GetSignalShort(2*iGain+0)->GetEmptyEventPedestal(),
              //        Channel->GetSignalShort(2*iGain+1)->GetEmptyEventPedestal());
              sprintf(PedVal, "current-empty->(%6.2f %6.2f)",  
                      Channel->GetSignalShort(2*iGain+0)->GetPed()-Channel->GetSignalShort(2*iGain+0)->GetEmptyEventPedestal(), 
                      Channel->GetSignalShort(2*iGain+1)->GetPed()-Channel->GetSignalShort(2*iGain+1)->GetEmptyEventPedestal());
              displayLatex -> SetTextSize(0.08);
              displayLatex -> SetTextAlign(32);
              displayLatex -> SetTextColor(kBlack);
              //displayLatex->DrawLatex(Module->GetPedWin0(iw), 
              //                        AmpMax[iGain]*(9.0-iChan)/10.+AmpMin[iGain]*iChan/10.0, PedVal); 
              //printf("Channel %s gain=%d pedestals->%s\n", Channel->GetName(), iGain, PedVal);            
	    }
            if (iMod==0 && iChan==0 && iGain==0 && iw==1) {
              if (maxFuzz>1.1) { 
                char FuzzVal[100];
                sprintf(FuzzVal, "Spikey=%f", maxFuzz);
                displayLatex -> SetTextSize(0.1);
                displayLatex -> SetTextAlign(12);
                displayLatex -> SetTextColor(kRed);
                displayLatex -> DrawLatex(0.9*Module->GetPedWin0(iw)+0.1*Module->GetPedWin0(iw+1),
                                             0.9*AmpMax[iGain]+0.1*AmpMin[iGain], FuzzVal);
              }
              if (EH->isClone) {
                displayLatex -> SetTextSize(0.2);
                displayLatex -> SetTextAlign(12);
                displayLatex -> SetTextColor(kRed);
                displayLatex -> DrawLatex(0.90*Module->GetPedWin0(iw)+0.10*Module->GetPedWin0(iw+1),
                                                 0.7*AmpMax[iGain]+0.3*AmpMin[iGain], "Clone !");
              }
            }
	  }
        }
      }    

      for (int iChan=iCh0;iChan<iCh1;iChan++) {
        TChannel *Channel = Module->GetChannel(iChan);
        TSignal *Signal = Channel->GetSignalLong(iGain);
        if (!Signal->GetStatus()) { // Check for the response from straight or delayed 
          for (int iDelay=0; iDelay<2; iDelay++) { 
            Signal = Channel->GetSignalShort(2*iGain+iDelay);
            if (Signal->GetStatus()) {
	      Signal->SetGraph();
              break;
	    }
	  }
	}
        if (Signal->GetStatus()) { // Check for the response from straight or delayed 
          TGraphErrors *Graph = Signal->GetGraph(); 
	  if (Graph->GetN()) {
            int iColor=iChan+1;
            if (Dbg && ProcStatus->GetReportMode()==10006) {
              printf("[DisplayAllPulses]  Drawing %s %s Nsample=%d Gain=%d\n", 
		     Module->GetName(), Channel->GetName(), Graph->GetN(), iGain);
	      for (int i=0;i<Graph->GetN();i++) {
                double x, y;
                Graph->GetPoint(i, x, y);
		printf("[DisplayAllPulses] %3d %6.1f %6.1f\n", 
		         i, x, y);
	      }
	    }
	    Graph->SetMarkerColor(iColor);
	    Graph->SetMarkerStyle(21);
	    Graph->SetMarkerSize(0.15);
	    Graph->SetLineColor(iColor);
            Graph->Draw("LPZz same");

            for (int bunch=0; bunch<Nbunches; bunch++) {
              double Tbunch=ProcStatus->GetBunchTime(bunch);
              char BunchVal[100];
              displayLatex -> SetTextSize(0.08);
              displayLatex -> SetTextAlign(12);
              displayLatex -> SetTextColor(iColor);
              sprintf(BunchVal, "%6.1f", Signal->GetResponseADC(bunch));
              displayLatex->DrawLatex(Tbunch+100., AmpMax[iGain]*(0.9-0.15*iChan), BunchVal);
   	    }
            
            printf("[main->DisplayAllPulses] GoodCherenkov=%d\n", BH->goodGatedCherenkov);

            if (iMod==4 && iChan==3 && BH->goodGatedCherenkov) {
              double cherScale=1.;
              if (iGain==0) cherScale=10.;
              for (int i=0; i<39; i++) {
                //printf("[DisplayAllChannels] #%2d t=%f6.1 A=%f6.1\n", i, CherBuff->GetCherenkovTime(i), CherBuff->GetSampleAdjust(i));
                displayLine->SetLineWidth(2);
                displayLine->SetLineColor(kBlue);
                displayLine->DrawLine(CherBuff->GetCherenkovTime(i)-82.481,  
                                        CherBuff->GetSampleAdjustD(i)/cherScale, 
                                        CherBuff->GetCherenkovTime(i)+82.481, 
                                        CherBuff->GetSampleAdjustD(i)/cherScale);
                if (i<38) displayLine->DrawLine(CherBuff->GetCherenkovTime(i)+82.481, 
                                        CherBuff->GetSampleAdjustD(i)/cherScale, 
                                        CherBuff->GetCherenkovTime(i)+82.481, 
                                        CherBuff->GetSampleAdjustD(i+1)/cherScale); 
             }
            }
	  } 
	}
      }
    }
    
    EventCanvas->Update(); 
  }

  TModule *Module = &Setup[6];
  dummy->GetXaxis()->SetTitle("Time, ns");
  dummy->GetYaxis()->SetTitle("ADC");
  double AmpMax[2]={5., 5.}, AmpMin[2]={-5., -5.};
  char Title[60];
  sprintf(Title, "%s", Module->GetName());
  dummy->SetTitle(Title);

  for (int iChan=0; iChan<4; iChan++) {
    TChannel *Channel = Module->GetChannel(iChan);
    TSignal *Signal = Channel->GetSignalShort(0);
    if (Channel->GetStatus()) {
      double ama=Signal->GetMax();
      double ami=Signal->GetMin();
      if (Dbg) printf("[DisplayAllPulses]      %s min=%.2f max=%.2f\n",Signal->GetName(), ami, ama);
      if (ama>AmpMax[0]) AmpMax[0]=ama; 
      if (ami<AmpMin[0]) AmpMin[0]=ami; 
    }
  }
 
  double t0=4500.;
  double t1=6300.;
  dummy->GetYaxis()->SetRangeUser(-45., 1.05*AmpMax[0]);
  //dummy->GetXaxis()->SetRangeUser(t0, 50.+25.*EH.nSlice);
  dummy->GetXaxis()->SetRangeUser(t0, t1);
  dummy->GetYaxis()->SetTitleSize(.1);
  dummy->GetYaxis()->SetTitleOffset(.5);
  dummy->GetYaxis()->SetLabelSize(.08);
  dummy->GetXaxis()->SetTitleSize(.1);
  dummy->GetXaxis()->SetTitleOffset(.75);  dummy->GetXaxis()->SetLabelSize(.08);
  if (Module->GetPedWin0(0)>t0) t0=Module->GetPedWin0(0);
      
  EventCanvas->cd(13);
  gStyle->SetOptStat(0);
  gPad->SetBottomMargin(0.2);
  gPad->SetRightMargin(0.01);
  gPad->SetTopMargin(0.01);
  dummy->DrawCopy();

  displayLine->SetLineWidth(30);
  displayLine->SetLineColor(kYellow);
  displayLine->DrawLine(t0, 0., Module->GetPedWin1(0), 0.);
  EventCanvas->Update();

  for (int  iChan=0; iChan<2; iChan++) {
    TChannel *Channel = Module->GetChannel(iChan);
    if (Channel->GetStatus()) {
      TSignal *Signal = Channel->GetSignalShort(0);
      if (Signal->GetStatus()) {
        TGraphErrors *Graph = Signal->GetGraph();
	if (Graph->GetN()) {
          int iColor=iChan+1;
	  Graph->SetMarkerColor(iColor);
	  Graph->SetMarkerStyle(21);
	  Graph->SetMarkerSize(0.15);
	  Graph->SetLineColor(iColor);
          Graph->Draw("LPZz same");

          double IntegralA=Signal->GetIntegratorLevel()+Signal->GetIntegratorPedestal();
          displayLine->SetLineColor(iColor);
          displayLine->SetLineWidth(1);
          displayLine->SetLineStyle(2);
          displayLine->DrawLine(t0, IntegralA, t1, IntegralA);
          displayLine->SetLineColor(iColor);
          displayLine->SetLineWidth(2);
          displayLine->DrawLine(Signal->GetIntegratorT1(), -45., Signal->GetIntegratorT1(), 1.05*AmpMax[0]);
          displayLine->SetLineColor(iColor);
          displayLine->SetLineWidth(2);
          displayLine->DrawLine(Signal->GetIntegratorT2(), -45., Signal->GetIntegratorT2(), 1.05*AmpMax[0]);

	}
      }
    }
  }  

  EventCanvas->cd(14);
  gStyle->SetOptStat(0);
  gPad->SetBottomMargin(0.2);
  gPad->SetRightMargin(0.01);
  gPad->SetTopMargin(0.01);
  dummy->DrawCopy();

  displayLine->Draw("same");

  for (int  iChan=2; iChan<4; iChan++) {
    TChannel *Channel = Module->GetChannel(iChan);
    if (Channel->GetStatus()) {
      TSignal *Signal = Channel->GetSignalShort(0);
      if (Signal->GetStatus()) {
        TGraphErrors *Graph = Signal->GetGraph();
	if (Graph->GetN()) {
          int iColor=iChan+1;
	  Graph->SetMarkerColor(iColor);
	  Graph->SetMarkerStyle(21);
	  Graph->SetMarkerSize(0.15);
	  Graph->SetLineColor(iColor);
          Graph->Draw("LPZz same");

          double IntegralA=Signal->GetIntegratorLevel()+Signal->GetIntegratorPedestal();
          displayLine->SetLineColor(iColor);
          displayLine->SetLineWidth(1);
          displayLine->SetLineStyle(2);
          displayLine->DrawLine(t0, IntegralA, t1, IntegralA);
          displayLine->SetLineColor(iColor);
          displayLine->SetLineWidth(2);
          displayLine->DrawLine(Signal->GetIntegratorT1(), -45., Signal->GetIntegratorT1(), 1.05*AmpMax[0]);
          displayLine->SetLineColor(iColor);
          displayLine->SetLineWidth(2);
          displayLine->DrawLine(Signal->GetIntegratorT2(), -45., Signal->GetIntegratorT2(), 1.05*AmpMax[0]);
	}
      }
    }
  }  

  EventCanvas->Update(); 
  EventCanvas->Show(); 
  EventCanvas->Update(); 
 
  if (showMode) DisplaySpike(Setup, ProcStatus, CherBuff);


  Dbg=false;
  int Rep=ProcStatus->GetReportMode();
  //Rep=ProcStatus->WhatToDo("[DisplayAllPusles]", -100);
  //ProcStatus->SetReportMode(Rep);
  //printf("[DisplayAllPulses] #0 Rep=%d\n", Rep);
  
  if (Rep>0) {
    //EventCanvas->Close();
    //SpikeCanvas->Close();
  }
  dummy->Delete();
  displayLine->Delete();
  displayLatex->Delete();
  //printf("[DisplayAllPulses] #4 Rep=%d\n", Rep);
  return Rep; 
}



