int LoadDetectorMap(Int_t Run, TModule* Setup) {
  std::ifstream loadDetADCmap;
  char DetADCmap[100];
  int nADC=0; 
  if (Run<98) {
    nADC=80;
    sprintf(DetADCmap,"../maps/ADC_to_CHAN_2007.map");
  } else if ( Run>151 && Run<246) {
    nADC=96;
    sprintf(DetADCmap,"../maps/ADC_to_CHAN_2008.map");
  } else if ( Run<456 ) {
    nADC=96;
    //sprintf(DetADCmap,"../maps/ADC_to_CHAN_11-2008.map");
    sprintf(DetADCmap,"../maps/ADC_to_CHAN_06-2009.map");
  } else if ( Run<652 ) { 
    nADC=96;
    sprintf(DetADCmap,"../maps/ADC_to_CHAN_11-2009.map");
  } else {
    nADC=96;
    sprintf(DetADCmap,"../maps/ADC_to_CHAN_04-2010.map");
  }  
  loadDetADCmap.open(DetADCmap);
  if(loadDetADCmap.is_open()) {
    for (int i=0;i<nADC;i++) loadDetADCmap >> kMd[i];
    for (int i=0;i<nADC;i++) loadDetADCmap >> kCh[i];
    for (int i=0;i<nADC;i++) loadDetADCmap >> kDl[i];
    for (int i=0;i<nADC;i++) loadDetADCmap >> kGn[i];
    for (int iMod=0;iMod<nMod;iMod++) {
      TModule *myModule = &Setup[iMod];
      for (int iChan=0;iChan<4;iChan++) {
        TChannel *myChannel = myModule->GetChannel(iChan); 
	bool Status;  
        loadDetADCmap >> Status;
        if (Status) myChannel->On(); else myChannel->Off();        
      }    
      double t1, t2;
      loadDetADCmap >> t1 >> t2;
      myModule->SetPedWindow(t1, t2);
        
    }
  } else {
    printf("[LoadDetectorMap] No Detector-to-ADC map file found for Run#%d file->%s\n", Run, DetADCmap);
    loadDetADCmap.clear();
  }
  loadDetADCmap.close();
  return nADC;
}


