// loads results of single MIP: thresholds and statistics
bool LoadMIP2dataGroup(Int_t Run, TModule* Setup) {
bool result=true;
std::ifstream dFile;
char dFileName[100];
double dip0L, mip, dip1L, ped0, ped1, ped2; 
sprintf(dFileName, "reports/MIP/SummaryMIPcuts_v0613step2.dat");
dFile.open(dFileName);
if(dFile.is_open()) {
  for (int iCh=0; iCh<3; iCh++) {
    int iHVgroup = SetMIPrunHVgroup(Run, iCh);
    if (iHVgroup==-1) {
      printf("[LoadMIP2dataGroup] No HV group data found for Run#%d, %s(#%d) in file->%s\n", 
             Run, Setup[4].GetChannel(iCh)->GetName(), iCh, dFileName);
      //exit(-1);
      return false;
    }
    for (int iHV=0; iHV<6; iHV++) {
      int jCh=-1;
      int jHV=-1;
      dFile >> jCh >> jHV >> ped0 >> ped1 >> ped2>> dip0L >> mip;
      dip0L=0.5*mip;
      dip1L=1.25*mip;
      if (jHV==iHVgroup) {
        Setup[4].GetChannel(jCh)->SetMIP2cuts(dip0L, mip, dip1L);
        printf("[LoadMIP2dataGroup] loaded for %10s(%d) HV#%d MIP cuts = (%5.1f, %5.1f, %5.1f)\n",
               Setup[4].GetChannel(jCh)->GetName(), jCh, iHVgroup, dip0L, mip, dip1L);
      }
    }
  }
  result=true;
} else {
  printf("[LoadMIP2dataGroup] No PMT MIP2 group data found for Run#%d in file->%s\n", Run, dFileName);
  dFile.clear();
  exit(-1);
  result=false;
}

dFile.close();
return result;
}


