// returns HV 'grout' 0 to 6 for run and scintillator, S123-in runs only!
int SetMIPrunHVgroup(int run, int iScint) { 
int result=-1;

if (iScint<0 || iScint>2) {
  printf("[SetMIPrunHVgroup] wrong scintillator number #%d, bye\n", iScint);
  exit(-1);
} else if (iScint==0) { // S1 HV groups
  if      ((run>859 && run<889) || (run>899 && run<1020)) result=0; // group 0
  else if ((run>889 && run<898) || run==1046)             result=1; // group 1
  else if (run>1019 && run<1042)                          result=2; // group 2
  else if (run>1093 && run<1100)                          result=3; // group 3
  else if (run==1101)                                     result=4; // group 4
  else if (run>1101 && run<1118)                          result=5; // group 5
} else if (iScint==1) { // S2 HV groups
  if      ((run>859 && run<889) || (run>899 && run<1020)) result=0; // group 0
  else if ((run>889 && run<898))                          result=1; // group 1
  else if (run>1019 && run<1042)                          result=2; // group 2
  else if (run>1093 && run<1100)                          result=3; // group 3
  else if (run==1101)                                     result=4; // group 4
  else if (run>1101 && run<1118)                          result=5; // group 5
  else if (run==1046)                                     result=6; // group 6 // bad run
} else if (iScint==2) { // S3 HV groups
  if      ((run>859 && run<889) || (run>899 && run<1020)) result=0; // group 0
  else if (run>889 && run<898)                            result=1; // group 1
  else if (run>1019 && run<1042)                          result=2; // group 2
  else if (run>1093 && run<1100)                          result=3; // group 3
  else if (run==1101)                                     result=4; // group 4
  else if (run>1101 && run<1118)                          result=5; // group 5
}

if (result==-1) {
  printf("[SetMIPrunHVgroup] wrong combination sc.number=%d run=%d, bye\n", iScint, run);
  //exit(-1);
}
return result;
}

int SetMIPrunHVgroup(int run, int iScint, double &HV) { 
int result=-1;

if (iScint<0 || iScint>2) {
//  printf("[SetMIPrunHVgroup] wrong scintillator number #%d, bye\n", iScint);
} else if (iScint==0) { // S1 HV groups
  if      ((run>859 && run<889) || (run>899 && run<1020)) {result=0; HV=1.301;} // group 0
  else if ((run>889 && run<898) || run==1046)             {result=1; HV=1.227;} // group 1
  else if (run>1019 && run<1042)                          {result=2; HV=1.370;} // group 2
  else if (run>1093 && run<1100)                          {result=3; HV=1.039;} // group 3
  else if (run==1101)                                     {result=4; HV=1.254;} // group 4
  else if (run>1101 && run<1118)                          {result=5; HV=1.398;} // group 5
} else if (iScint==1) { // S2 HV groups
  if      ((run>859 && run<889) || (run>899 && run<1020)) {result=0; HV=1.336;} // group 0
  else if ((run>889 && run<898))                          {result=1; HV=1.261;} // group 1
  else if (run>1019 && run<1042)                          {result=2; HV=1.441;} // group 2
  else if (run>1093 && run<1100)                          {result=3; HV=1.104;} // group 3
  else if (run==1101)                                     {result=4; HV=1.327;} // group 4
  else if (run>1101 && run<1118)                          {result=5; HV=1.476;} // group 5
  else if (run==1046)                                     {result=6; HV=0.;} // group 6 // bad run
} else if (iScint==2) { // S3 HV groups
  if      ((run>859 && run<889) || (run>899 && run<1020)) {result=0; HV=1.572;} // group 0
  else if (run>889 && run<898)                            {result=1; HV=1.485;} // group 1
  else if (run>1019 && run<1042)                          {result=2; HV=1.746;} // group 2
  else if (run>1093 && run<1100)                          {result=3; HV=1.320;} // group 3
  else if (run==1101)                                     {result=4; HV=1.587;} // group 4
  else if (run>1101 && run<1118)                          {result=5; HV=1.765;} // group 5
}

if (result==-1) {
  //printf("[SetMIPrunHVgroup] wrong combination sc.number=%d run=%d, bye\n", iScint, run);
  //exit(-1);
}
return result;
}


int SetMIPrunHVgroup(int run, int iScint, double &HV, double &mipCut0, double &mipCut1) { 
int result=-1;

if (iScint<0 || iScint>2) {
//  printf("[SetMIPrunHVgroup] wrong scintillator number #%d, bye\n", iScint);
} else if (iScint==0) { // S1 HV groups
  if      ((run>859 && run<889) || (run>899 && run<1020)) { // group 0
    result=0; 
    HV=1.301;
    mipCut0=75.;
    mipCut1=220.;
  } else if ((run>889 && run<898) || run==1046)           { // group 1
    result=1; 
    HV=1.227;
    mipCut0=50.;
    mipCut1=120.;
  } else if (run>1019 && run<1042)                        { // group 2
    result=2;
    HV=1.370;
    mipCut0=150.;
    mipCut1=350.;    
  } else if (run>1093 && run<1100)                        { // group 3
    result=3; 
    HV=1.039; 
    mipCut0=6.;
    mipCut1=16.;    
  } else if (run==1101)                                   { // group 4
    result=4; 
    HV=1.254; 
    mipCut0=40.;
    mipCut1=110.;   
  } else if (run>1101 && run<1118)                        { // group 5
    result=5; 
    HV=1.398;
    mipCut0=100.;
    mipCut1=300.;  
  } 
} else if (iScint==1) { // S2 HV groups
  if      ((run>859 && run<889) || (run>899 && run<1020)) { // group 0
    result=0; HV=1.336;
    mipCut0=70.;
    mipCut1=160.;    
  } else if ((run>889 && run<898))                        { // group 1
    result=1; HV=1.261;
    mipCut0=30.;
    mipCut1=85.; 
  } else if (run>1019 && run<1042)                        { // group 2
    result=2; HV=1.441;
    mipCut0=150.;
    mipCut1=450.; 
  } else if (run>1093 && run<1100)                        { // group 3
    result=3; HV=1.104;
    mipCut0=7.;
    mipCut1=17.; 
  } else if (run==1101)                                   {  // group 4
    result=4; HV=1.327;
    mipCut0=40.;
    mipCut1=110.; 
  } else if (run>1101 && run<1118)                        {  // group 5
    result=5; HV=1.476;
    mipCut0=100.;
    mipCut1=300.; 
  } 
} else if (iScint==2) { // S3 HV groups
  if      ((run>859 && run<889) || (run>899 && run<1020)) { // group 0
    result=0; HV=1.572;
    mipCut0=30.;
    mipCut1=90.;    
  } else if (run>889 && run<898)                          { // group 1
    result=1; HV=1.485;
    mipCut0=20.;
    mipCut1=55.;    
  } else if (run>1019 && run<1042)                        { // group 2
    result=2; HV=1.746;
    mipCut0=100.;
    mipCut1=320.;
  } else if (run>1093 && run<1100)                        { // group 3
    result=3; HV=1.320;
    mipCut0=7.;
    mipCut1=19.;
  } else if (run==1101)                                   { // group 4
    result=4; HV=1.587;
    mipCut0=30.;
    mipCut1=110.;
  } else if (run>1101 && run<1118)                        { // group 5
    result=5; HV=1.765;
    mipCut0=90.;
    mipCut1=270.;
  } 
}

if (result==-1) {
  //printf("[SetMIPrunHVgroup] wrong combination sc.number=%d run=%d, bye\n", iScint, run);
  //exit(-1);
}
return result;
}
