struct SpillType { // uses averaged laps!
  double data0[5000];
  double data1[5000];
  double data2[5000];
  double time[5000];
  double aMax;
  int nLaps;

void SetNlaps(int n) {nLaps=n; aMax=0.;}
int  GetNlaps()      {return nLaps;}
double GetAmax()     {return aMax;}

void Reset() {
  nLaps=-1;
  aMax=0.;
  for (int i=0; i<5000; i++) {
    data0[i]=0.;
    data1[i]=0.;
    data2[i]=0.;
    time[i]=0.;
  }
}

void AddLap(int i, double w, double a, double s, double t) {
  if (i>-1 && i<5000) {
    data0[i]+=w;
    data1[i]+=a;
    data2[i]+=s;
    time[i] +=t;
    if (data1[i]/data0[i]>aMax) aMax=data1[i]/data0[i];    
  } else {
    printf("\n\n[SpillType->addLap] bad index i=%d, bye\n------------------------\n", i);
    exit(-1);
  }
}

double GetLapW(int i) {
  if (i<0 && i>=5000) {
    printf("\n\n[SpillType->getLapW] bad index i=%d, bye\n------------------------\n", i);
    exit(-1);    
  }
  return data0[i];
}

double GetLapT(int i) {
  if (i<0 && i>=5000) {
    printf("\n\n[SpillType->getLapA] bad index i=%d, bye\n------------------------\n", i);
    exit(-1);    
  }
  if (data0[i]==0.) return 0.;
  return time[i]/data0[i];
}

double GetLapA(int i) {
  if (i<0 && i>=5000) {
    printf("\n\n[SpillType->getLapA] bad index i=%d, bye\n------------------------\n", i);
    exit(-1);    
  }
  if (data0[i]==0.) return 0.;

  return data1[i]/data0[i];
}


double GetLapR(int i) {
  if (i<0 && i>=5000) {
    printf("\n\n[SpillType->getLapR] bad index i=%d, bye\n------------------------\n", i);
    exit(-1);    
  }
  if (data0[i]==0.) return 0.;
  double r=data2[i]/data0[i]-data1[i]*data1[i]/data0[i]/data0[i];
  r=sqrt(r);
  return r;
}
double GetLapR2(int i) {
  if (i<0 && i>=5000) {
    printf("\n\n[SpillType->getLapR] bad index i=%d, bye\n------------------------\n", i);
    exit(-1);    
  }
  if (data0[i]==0.) return 0.;
  double r=data2[i]/data0[i]-data1[i]*data1[i]/data0[i]/data0[i];
  return r;
}
};


