class TimingCut1 {
private:
  int Npoints;
  double FirstPointLowEdge;
  double step;
  double *weight;
  char fileName[100];
public:
  TimingCut1(const char* xName) {
    Npoints = 0;
    sprintf(fileName, "%s", xName);
  }
  const char* GetName() {return fileName;}

  bool LoadData() {
    std::ifstream timingCutData;
    bool result=true; 
    double amax=0.;
    int imax=-10;
    timingCutData.open(fileName, ios::in);
    result = result && (timingCutData >> Npoints>> FirstPointLowEdge >> step);
    weight = new double[Npoints];
    
    for (int i=0; i<Npoints; i++) {
      result = result && (timingCutData >> weight[i]);
      if (weight[i]>amax) {amax=weight[i]; imax=i;}
    }

    timingCutData.close();

    printf("[TimingCut1->LoadData] for %s imax=%d amax=%f\n", fileName, imax, amax);
    for (int i=0; i<Npoints; i++) {
      weight[i]/=amax;
    }

    return result;
  }

  double GetWeight(double x) {
    double x1=(x-FirstPointLowEdge)/step;
    int ip=(int)x1;
    if (ip<0)              return weight[0];
    else if (ip>Npoints-1) return weight[Npoints-1];
    else                   return weight[ip];
  }
};

