bool interpolate(int nIN, double *timeIN, double *ampIN, int nOUT, double *timeOUT, double *ampOUT) {
// uses timeIN, ampIN and timeOUT to calculate ampOUT as interpolation of ampIN
// 
bool result=true;
double t1=0.;
double t2=0.;
double t3=0.;
double t4=0.;
double y1=0.;
double y2=0.;
double y3=0.;
double y4=0.;

//printf("[interpolate] input size = %d output size =%d\n", nIN, nOUT);

if (timeIN[0]-25.<timeOUT[0]) {
  printf("[interpolate] timeIN[0]<timeOUT[0] %f<%f\n",  timeIN[0], timeOUT[0]);
  exit(-1);
}
if (timeIN[nIN-1]+25.>timeOUT[nOUT-1]) {
  printf("[interpolate] timeIN[nIN-1]>timeOUT[nOUT-1] %f<%f\n",  timeIN[nIN-1], timeOUT[nOUT-1]);
  exit(-1);
}

int iIN=0;
double w1=0.;

for (int iOUT=0; iOUT<nOUT; iOUT++) {

  if (timeOUT[iOUT]<timeIN[0]-12.5 || timeOUT[iOUT]>timeIN[nIN-1]+12.5) {
    ampOUT[iOUT]=0.;
    continue;
  }

  while (timeOUT[iOUT]>timeIN[iIN] && iIN<nIN) iIN++;

  if (iIN==0) {
    t1=timeIN[0]-25.0;
    t2=timeIN[0]-12.5;
    t3=timeIN[0];
    t4=timeIN[1];
    y1=0.0;
    y2=0.0;
    y3=ampIN[0];
    y4=ampIN[1];
  } else if (iIN==1) {
    iIN=1;
    t1=timeIN[0]-12.5;
    t2=timeIN[0];
    t3=timeIN[1];
    t4=timeIN[2];
    y1=0.0;
    y2=ampIN[0];
    y3=ampIN[1];
    y4=ampIN[2];
  } else if (iIN==nIN-1) {
    t1=timeIN[nIN-3];
    t2=timeIN[nIN-2];
    t3=timeIN[nIN-1];
    t4=timeIN[nIN-1]+12.5;
    y1=ampIN[nIN-3];
    y2=ampIN[nIN-2];
    y3=ampIN[nIN-1];
    y4=0.0;
  } else if (iIN==nIN) {
    t1=timeIN[nIN-2];
    t2=timeIN[nIN-1];
    t3=timeIN[nIN-1]+12.5;
    t4=timeIN[nIN-1]-25.0;
    y1=ampIN[nIN-2];
    y2=ampIN[nIN-1];
    y3=0.0;
    y4=0.0;
  } else {
    t1=timeIN[iIN-2];
    t2=timeIN[iIN-1];
    t3=timeIN[iIN];
    t4=timeIN[iIN+1];
    y1=ampIN[iIN-2];
    y2=ampIN[iIN-1];
    y3=ampIN[iIN];
    y4=ampIN[iIN+1];    
  }

  w1=(t3-timeOUT[iOUT])/(t3-t2);
  ampOUT[iOUT]=      w1*parabola2012(timeOUT[iOUT], t1, y1, t2, y2, t3, y3)+
               (1.0-w1)*parabola2012(timeOUT[iOUT], t2, y2, t3, y3, t4, y4);

}

return result;
}

/*
bool interpolateL(int nIN, double *timeIN, double *ampIN, int nOUT, double *timeOUT, double *ampOUT) {
// uses timeIN, ampIN and timeOUT to calculate ampOUT as interpolation of ampIN
// 
bool result=true;
double t1=0.;
double t2=0.;
double t3=0.;
double t4=0.;
double y1=0.;
double y2=0.;
double y3=0.;
double y4=0.;

//printf("[interpolate] input size = %d output size =%d\n", nIN, nOUT);

if (timeIN[0]-25.<timeOUT[0]) {
  printf("[interpolate] timeIN[0]<timeOUT[0] %f<%f\n",  timeIN[0], timeOUT[0]);
  exit(-1);
}
if (timeIN[nIN-1]+25.>timeOUT[nOUT-1]) {
  printf("[interpolate] timeIN[nIN-1]>timeOUT[nOUT-1] %f<%f\n",  timeIN[nIN-1], timeOUT[nOUT-1]);
  exit(-1);
}

int iIN=0;
double w1=0.;
double dtIN=0.5*(timeIN[2]-timeIN[0]);

for (int iOUT=0; iOUT<nOUT; iOUT++) {

  if (timeOUT[iOUT]<timeIN[0]-dtIN || timeOUT[iOUT]>timeIN[nIN-1]+dtIN) {
    ampOUT[iOUT]=0.;
    continue;
  }

  while (timeOUT[iOUT]>timeIN[iIN]-dtIN/2. && iIN<nIN) iIN++;

  if (iIN==1) {
    t1=0.;
  }
  w1=(t3-timeOUT[iOUT])/(t3-t2);
  ampOUT[iOUT]=      w1*parabola2012(timeOUT[iOUT], t1, y1, t2, y2, t3, y3)+
               (1.0-w1)*parabola2012(timeOUT[iOUT], t2, y2, t3, y3, t4, y4);

}

return result;
}
*/
