void doRC(int n, double dt, double RC, double* input, double* output) {
  double rcf=1.0-exp(-dt/RC);
  output[0]=0.0;
  for (int i=1; i<n; i++) {
    double v=0.5*(input[i-1]+input[i]);
    output[i]=output[i-1]+(v-output[i-1])*rcf;
  }
}

void doCR(int n, double dt, double RC, double* input, double* output) {
  double rcf=exp(-dt/RC);
  output[0]=0.0;
  double vold=0.;
  for (int i=1; i<n; i++) {
    double v=0.5*(input[i-1]+input[i]);
    output[i]=output[i-1]*rcf+v-vold;
    vold=v;
  }
}
void doRC2CR(int n, double dt, double RC, double* input, double* output) {
  doRC(n, dt, RC, input, output);
  //for (int i=0; i<200 && i<n; i++) {
  //  printf("[doRC2CR] step1 i=%3d  in=%.1f\t out=%.1f\n", i, input[i], output[i]);
  //} 
  doRC(n, dt, RC, output, input); 
  //for (int i=0; i<200 && i<n; i++) {
  //  printf("[doRC2CR] step2 i=%3d  in=%.1f\t out=%.1f\n", i, output[i], input[i]);
  //}
  doCR(n, dt, RC, input, output);
  //for (int i=0; i<200 && i<n; i++) {
  //  printf("[doRC2CR] step3 i=%3d  in=%.1f\t out=%.1f\n", i, input[i], output[i]);
  //} 
  //printf("[doRC2CR] RC=%.1f n=%d dt=%f\n", RC, n, dt);
}

