//#include <classes/TReference.h>

TReference *xReference;
double Fit1(Double_t *x, Double_t *par);
double Fit2(Double_t *x, Double_t *par);
double Fit3(Double_t *x, Double_t *par);
 
class TSignal {
private:
  char Title[200]; // reserved for variouse usages
  char Name[40];
  int iChan;
  int iMod;
  int iGain;
  int iDelay;
  int Status;
  bool dumpIt;
  double HighCutForFit;
  double dTsample;
  TGraphErrors *signalShape;
  TGraphErrors *residualShape;
  TGraphErrors *previousShape;
  TReference *Reference;
  //TH2F     *pulse2d;
  TH1D     *pulse1Drelative;
  TProfile *pulseShape;
  TProfile *pulseShapeSplit;
  TProfile *pulseShapeA;
  TProfile *pulseShapeI;

  TH1D     *corrRFphase;  // phase relative to RF for Empty Events
  TH1D     *corrRFphase1; // phase relative to RF for Empty Events - EXTRA to deal with phase 'jump'
  TH1D     *corrRFampl;   // amplirude relative to RF for Empty Events
  TH1D     *corrRFped;    // RF fit pedestal, ADC
  
  double corrRFdT;  // parameters found at the end of the run analysis from histograms above;
  double corrRFa;   // stored at (..., "reports/RFcorrection/run%04d_RF_correction.dat", EH->run)
  double corrRFp;   // loaded by LoadRFcorrection in main file via Signal->SetRFcorrection(dT, A, P)                    

  int nShapeI;
  int nShapeSplit;
  
  double maxFuzz;
  double Tshape0, Tshape1, Tshape2;
  double *accRate0, *accRate1;// to accumulate rate for intensity bins in pulseShapeI
  double *splitRate;
  double *splitSum;
  double Apar[25], Tpar[25];// parabola peaks timed by S123+Ch, for shapes
  double TLdown[25], TRdown[25], Thalf[25]; // left and right half-fall, width at half;
  double Tnear[25];  // pedestal and peak helper time markers
  double Tped0, Tped1; // pedestal window, loaded from ADC_to_CHAN map file;
  double Anear[25];  // 'peak' near Tbunch //
  double Anois[25];  // 'noise' before Tbunch //
  double Anodd[25];  // 'odd noise' before Tbunch //
  double Sodd[25];  // 'odd pedestal' before Tbunch //
  double Aped[25];  // 'pedestal' before Tbunch //
  double PeakAverage1, PeakAverage0, ZeroAverage1, ZeroAverage0;
 
  int nSlice;
  int nCut;
  int Nfit;
  double TfitInterval;
  double TfitStart;
  double TfitIntervalSimple;
  double TfitStartSimple;


  double raw[512];  // raw amplitudes
  double old[512];  // raw amplitudes from previous events
  bool   oldIsSet;  // indicates of old buffer is not empty;
  int    nTrains;     // number of 'trains' of identical amplitudes in two events
  int    mTrain[256]; // size of train;
  int    iTrain[256]; // start index of a train;
  int    lTrain[512]; // trains spectrum;
  int    wTrain[512]; // identicals spectrum;
  double aTrain;      // average train size;
  int    xTrain;      // maximum train in event;  
  int    sTrain;      // total identicals in event;  
  bool   isClone;     // true if more than 200 same as in previous reading  
  bool   isTrain;     // true if more than 50 same as in previous reading  

  double amp1[512]; // pedestal subtracted, same for entire event
  double ampS[512]; // special for mod#5 ch#2, used in RF sin(x) wave reconstruction;
  double amp2[512]; // no antena signal subtraction                                                                
  double ampF[512]; // used in old fit procedure  
  double ampOdd[512]; //      
  double err2[512]; // error for fit, combination of the noise and subtraced fit accuracy;
  double amp3[512]; // samples before the fitting function is subtracted;
  double ampX[512]; // for online baseline subtraction
  
  double time[512]; // takes into account that delay is not exactly 12.5ns
  double timeUniform[512];  // 12.5 ns delay assumption; Necessary for smooth GlobalPhase detection; 
  bool   doFit[512]; // set for exluding some points from fit 
  bool   under[512]; // set for signal ADC underflow 
  bool   overf[512]; // set for signal ADC overflow 
  bool   adcOver;   // ADC overflow=4095;
  bool   adcUnder;  // ADC underflow=0;  
  double PedWindow0[25], PedWindow1[25]; // pedestal windows, use for Pedestal calculation;
  double PedAverage[25], PedRMS[25];
  int    PedSamples[25];
  int    firstSample[25];
  int    lastSample[25];
  double PedestalTailCorr[25]; // pedestal derived from a+b*c*exp(-c*t) fit of a pedestal window area to account for the tails
  double PedRMSbest;
  double PedRMSmean;
  double PedMean;
  double PedRMSworst;
  double PedPrePed;
  //int    nCut; // number of sampls dropped during pre-ped computation

// data of 165ns untervals, set by RF bunching
  double bunchRFmin[50];
  double bunchRFmax[50];
  double bunchRFrms[50]; 
  double bunchRFavr[50]; 
  double bunchRFrmsODD[50]; 
  double bunchRFavrODD[50]; 
  double bunchRFs0[50]; 
  double bunchRFs1[50]; 
  double bunchRFs2[50]; 
  double bunchRFs0odd[50]; 
  double bunchRFs1odd[50]; 
  double bunchRFs2odd[50]; 
  bool   bunchRFset[50];
  double bunchRFsig[50];
  double bunchRFdet[50];

  double bunchNoise;    // noise for the ProcStatus->GetBunchAction(j)==2
  double bunchNoiseOdd; // odd noise (a1-0.5*(a0+12)) for the ProcStatus->GetBunchAction(j)==2

  double EmptyEventPedestal;
  double EmptyEventNoise;
  double EmptyEventS0;
  double EmptyEventS1;
  double EmptyEventS2;
  bool   EmptyEventPedestalSet;

  int  NPedWindows;                      // total number of windows
  int  NGoodWindows;                     // total number of good windows in all channels
  bool GoodPedWindow[25];                // flags useful pedestal windows
  int FirstGoodWindow;
  TH1D *GoodWindowNoise;

  TGraphErrors *signalFit;   // array of GraphErrors to fit
  int T0[25];   // first sample of a bunch fit
  int T1[25];   // last sample of a bunch fit
  int    Ifit[25]; // what level of fit was used
  double Txxx[25]; // peak origin time (global bunch time)
  double Tfit[25]; // peak 0 time
  double Afit[25]; // peak 0 amplitude
  double Sfit[25]; // stretch 0 factor
  double Tfit1[25]; // peak 1 time
  double Afit1[25]; // peak 1 amplitude
  double Sfit1[25]; // stretch 1 factor
  double Ofit[25]; // offset
  double TfitE[25]; // peak time
  double AfitE[25]; // peak amplitude
  double SfitE[25]; // stretch factor
  double OfitE[25]; // offset
  double Afit1E[25]; // peak amplitude
  double Sfit1E[25]; // stretch factor
  double Tfit1E[25]; // offset
  double Qfit[25]; // chi2
  int    iWin[25]; // closest good pedestal window
  double rWin[25]; // noise from closest window
  double aOff[25]; // offset estimation based on first 3 samples of fitted interval (if available)
  double wOff[25]; // actual samples count  for aOff[];
  double AmpMaxfit[25];
  double AmpMinfit[25];
  double AmpMax;
  double AmpMin;
  double AmpMax0; // without noise added //
  double AmpMin0;
  int nFitReal;
  double integratorPedestal;// offset at 0 intensity, used for integrator only;
  double integratorLevel;   // reconstructed signal, used for integrator only;
  double integratorNoise;   // reconstructed noise, used for integrator only;
  double integratorT1, integratorT2; // time interval for the integrator signal computation;
  int ResponseStatus[25];  // response status per bunch -10 failed fit
                           //                           -1 shaper overflow (Afit>2000) 
                           //                            0 normal
                           //                           10 two close peaks
                           //                          -11 two widely spaced peaks (>100ns)
  double Response[25], ResponseCal[25];                      
  double Time[25];
  // parabola fit around the S1...6 bunch and other bunch features //
  double ApMax[25], ApMaxCal[25], TpMax[25], ApMin[25], ApMinCal[25], TpMin[25], Sum8[25], Sum8cal[25];
  double T0halfMax[25], T1halfMax[25], T0halfMin[25], T1halfMin[25], T0cross[25], T0foot[25];
  double tMaxLocal[25], tMinLocal[25];
  double maxLocal[25], minLocal[25];
  int iMax[25], iMin[25];
  bool Underflow[25], Overflow[25], goodParab[25];

  // Time difference with Beam Counters Timing //
  double TriggerOffset;
  double TriggerOffsetE;
  double TriggerOffsetW;
  double SignalCorrection;
  
  char func1name[100];
  char func2name[100];
  char func3name[100];

  double sinPar[5]; // parameters for par[0]+par[1]*sin(par[2]*(t-par[3])); par[4]=period (ns)
  double sinRes;    // fit residuals

  double T0baseline[25]; // baseline center
  double A0baseline[25]; // baseline at T0baseline;
  double SLbaseline[25]; // linear slope
  int    i0bunch[25];
  int    i1bunch[25];
//
//-> Fourier transform stuff
  // noise reduction section
  TVirtualFFT *FFT;
  TVirtualFFT *FFT_BACK;
  double FFTaReal[512];
  double FFTaImag[512];
  double FFTaFull[512];
  double FFTphase[512];
  double FFTaRealX[512]; // from 'antenna' channel
  double FFTaImagX[512]; // from 'antenna' channel
  double FFTaFullX[512]; // from 'antenna' channel
  double FFTphaseX[512]; // from 'antenna' channel
  double FFTscale[512];  // pickup scale for given run; 
  double FFToffst[512];  // pickup offset for given run;
  double FFTshift[512];  // pickup phase shift for given run;
  double FFTshiftW[512];  // pickup phase shift width for given run;
  double FFTwidthCut;  // do not use frequency if FFTshiftW>FFTFFTwidthCut;
  double FFT10scale[512];  // pickup scale for given run; 
  double FFT10offst[512];  // pickup offset for given run;
  double FFT10shift[512];  // pickup phase shift for given run;
  double FFTpick[512];   // computed pickup estimation, HG raw units 
  long double FFTsum00[512];   // counter for linear fit, weghted
  long double FFTsumNN[512];   // counter for linear fit
  long double FFTsum01;        // counter for linear fit
  long double FFTsumX1[512];   // <x> for linear fit
  long double FFTsumX2[512];   // <x2> for linear fit
  long double FFTsumXY[512];   // <xy> for linear fit
  long double FFTsumY1[512];   // <y> for linear fit
  long double FFTsumY2[512];   // <y2> for linear fit
  long double FFTsum1phi1[512]; // phase shift 1 [-pi, pi]
  long double FFTsum1phi2[512]; // phase shift 2 [0, 2*pi]
  long double FFTsum2phi1[512]; // phase shift 1 [-pi, pi]
  long double FFTsum2phi2[512]; // phase shift 2 [0, 2*pi]
  double  FFT10sum00;    // counter for linear fit  -  error evaluation
  double FFT10sumX1[512];    // <x> for linear fit      -  error evaluation
  double FFT10sumX2[512];    // <x2> for linear fit     -  error evaluation
  double FFT10sumXY[512];    // <xy> for linear fit     -  error evaluation
  double FFT10sumY1[512];    // <y> for linear fit      -  error evaluation
  double FFT10sum1phi1[512]; // phase shift 1 [-pi, pi] -  error evaluation
  double FFT10sum1phi2[512]; // phase shift 2 [0, 2*pi] -  error evaluation
  double FFT10sum2phi1[512]; // phase shift 1 [-pi, pi] -  error evaluation
  double FFT10sum2phi2[512]; // phase shift 2 [0, 2*pi] -  error evaluation
  double aScale;
  double FFTmax;
  bool   ScaleSet[512];

  // shape reconstruction section
  TVirtualFFT *FFTreconstruction;
  TVirtualFFT *FFTreconstruction_BACK;
  int nSizeTail;        // 2000 for LONG signal, 1000 for SHORT  size of signal for FFT
  int nSizeTail2;       // 1000 for LONG signal, 500 for SHORT - size of workspace for FFT
  double *signalTail;   // for the signal with first pedestal tail subtracted and fake tail attached
  double *signalFinal;  // result of FFT reconstruction
  double *slopeTail;    // slope of transfer function
  double *shiftTail;    // phase shift of transfer function
  double *fftAmp;
  double *fftPhi;
  double *fftR;
  double *fftI;
  double Te;
  double Tc;
  double *Wcos;
  double *Wsin;
  double tailAcos[25];  // A for exp()*cos() in pedestal window
  double tailAsin[25];  // A for exp()*sin() in pedestal window
  double wPoly[4];      // polynomial coefs for residual baseline fit Sum(w[k]*(x-<x>)^k), k=0,1,2,3;
  double xAvr;
  double xP[7]; // x[k]=Sum((x-<x>)^k)/N
  double yP[4]; // y[k]=Sum(y*(x-<x>)^k)/N
  double polyCorr[502];
  
//<- end of Fourier transform stuff

//->Resolving S1, S2, S3, Cherenkov shapes
  double RC; // time constant for the RC2CR shaping
  double aIn1ns[7000];   // input for shaper - as derived from fitting parameters
  double aInSave[7000];
  double aOut1ns[7000];  // shaper output
  double aOutSamp[512];  // output samples (252 or 504)
  double bunchPar[181]; // parameters of 'input' pulse;
  double bunchParStep[181]; // parameters step;
  // 0....44 t0
  // 45...90 width>0
  // 91..134 a0
  //135..179 a1


  double pi2;

  TF1 *pulseFunc1;
  TF1 *pulseFunc2;
  TF1 *pulseFunc3;

  ProcessingStatus* ProcStatus;

  TH2F *SelectedSplit;
  
  bool Dbg;
  
public:

  TSignal() {
    Dbg=false;
    dumpIt=false;
    pi2=4.0*asin(1.0);
    nSlice=0;
    Status=0;
    NPedWindows=0;
    NGoodWindows=0;
    PedRMSmean=0.;
    PedMean=0.;
    PedRMSbest=10000.;
    PedRMSworst=0.;
    signalShape   = new TGraphErrors();
    residualShape = new TGraphErrors();
    previousShape = new TGraphErrors();
    signalFit     = new TGraphErrors[25];
    Tshape0=-200.;
    Tshape1=1000;
    Tshape2=900;
    Te=2000.;
    Tc=17000.;
    for (int i=0;i<25;i++) {
      signalFit[i].SetLineColor(kBlue);
      signalFit[i].SetMarkerColor(kBlue);
    }
    HighCutForFit=3000.;
    integratorPedestal=0.0;
    integratorLevel=0.0;
    integratorNoise=0.0;
    integratorT1=5470.;
    integratorT1=5530.;
    iDelay=-1;
    PeakAverage1=0.0;
    PeakAverage0=0.0;
    ZeroAverage1=0.0;
    ZeroAverage0=0.0;
    SignalCorrection=1.0;
    TriggerOffset=0.0;    

    nTrains=0;
    xTrain=0;
    aTrain=0.0;
    isClone=false;
    isTrain=false;

    nShapeI=10;
    accRate0 = new double[nShapeI];
    accRate1 = new double[nShapeI];
    nShapeSplit=50;
    splitRate = new double[nShapeSplit];
    splitSum = new double[nShapeSplit];

    EmptyEventPedestalSet=false;
    EmptyEventPedestal=0.0;
    EmptyEventNoise=0.0;
    EmptyEventS0=0.0;
    EmptyEventS1=0.0;
    EmptyEventS2=0.0;

    for (int i=0; i<25; i++) PedestalTailCorr[i]=0.0;

    corrRFdT=0.0;
    corrRFa=0.0;
    corrRFp=0.0;

    RC=45.;
  }

  double GetSignalCorection() {return SignalCorrection;}
  void   SetSignalCorrection(double Corr) {SignalCorrection=Corr;}
  void   AdjustSignalCorrection(double Adjust) {SignalCorrection *= Adjust;}
  
  void SetPedWindow(double t0, double t1) {
    Tped0=t0;
    Tped1=t1;
  }

  void SetTriggerOffset(double Toffset) {
    TriggerOffset=Toffset;
  }
  double GetTriggerOffset() {
    return TriggerOffset;
  }

  void SetTriggerOffsetW(double W) {
    TriggerOffsetW=W;
  }
  double GetTriggerOffsetW() {
    return TriggerOffsetW;
  }

  void SetTriggerOffsetE(double E) {
    TriggerOffsetE=E;
  }
  double GetTriggerOffsetE() {
    return TriggerOffsetE;
  }


  void SetProcStatus(ProcessingStatus *PS) {
    ProcStatus=PS;
    //printf("[TSignal]    setting ProcessingStatus object for %s\n", Name);
  }
  bool   GetDumpIt()    {return dumpIt;}
  double GetFuzz()      {return maxFuzz;}
  double GetPed()       {return PedMean;}
  double GetRMSmean()   {return PedRMSmean;}
  double GetMax()       {return AmpMax;}
  double GetMin()       {return AmpMin;}
  double GetMax0()      {return AmpMax0;}
  double GetMin0()      {return AmpMin0;}
  double GetRaw(int i)  {return raw[i];}
  double GetOld(int i)  {return old[i];}
  double GetAmp1(int i) {return amp1[i];}
  double GetAmp2(int i) {return amp2[i];}
  double GetAmpX(int i) {return ampX[i];}
  double GetErr2(int i) {return err2[i];}
  double GetAmp3(int i) {return amp3[i];}
  double GetTime(int i) {return time[i];}
  double GetTimeUniform(int i) {return timeUniform[i];}
  int    GetNslice()    {return nSlice;}
  int    GetModule()    {return iMod;}
  int    GetChannel()   {return iChan;}
  int    GetGain()      {return iGain;}
  int    GetDelay()     {return iDelay;}
  int    GetIfit(int N) {return Ifit[N];}
  void   SetIfit(int N, int I) {Ifit[N]=I;}
  int    GetNfit()      {return Nfit;}
  double GetTfitInterval() {return TfitInterval;}
  double GetdTsample()     {return dTsample;}

  int    GetStatus()       {return Status;}
  void   SetStatus(int St) {Status=St;}
  void   On()              {Status=1;}
  void   Off()             {Status=0;}

  double GetTshape0() {return Tshape0;}
  double GetTshape1() {return Tshape1;}
  double GetTshape2() {return Tshape2;}

  int    GetI0(int bunch) {return i0bunch[bunch];}
  int    GetI1(int bunch) {return i1bunch[bunch];}

  void   SetDumpIt(bool b){
    printf("[TSignal->SetDumpIt] dump mode=%d set for %s\n", b, Name);
    dumpIt=b;
  }
  void SetModule(int Module)   {
    iMod=Module;
    TfitStartSimple=-30.;
    TfitIntervalSimple=70.;
    if (iMod>3) {
      TfitStart=-100.;
      TfitInterval=450.;
    } else if (iMod==0) { /* HEC */
      TfitStart=-150.;
      TfitInterval=250.;
    } else if (iMod==1)  { /* EMEC */
      TfitStart=-150.;
      TfitInterval=220.;
    } else  {  /* FCal */
      TfitStart=-150.;
      TfitInterval=220.;
    }
  }
  void SetChannel(int Channel) {
    iChan=Channel;
    if (iMod==6) { // set Integrator pedestal

      //      if (iChan==0)      integratorPedestal=-34.47;
      //      else if (iChan==1) integratorPedestal=-34.77;
      //      else if (iChan==2) integratorPedestal=-35.91;
      //      else               integratorPedestal=-34.72;

       if (iChan==0)      integratorPedestal=0.;
       else if (iChan==1) integratorPedestal=0.;
       else if (iChan==2) integratorPedestal=0.;
       else               integratorPedestal=0.;

    }
  }
  void SetGain(int Gain)       {
    iGain=Gain;
    if (iGain==1 && iMod>3) HighCutForFit=1000.; /// restriction for 2007 data
  }
  void SetDelay(int Delay)     {iDelay=Delay;}
  void AssignReference(TReference *Ref) {
    Reference=Ref;
    //printf("[TSignal->AssignReference] Refrence %s was assigned\n", Reference->GetName());
  }

  void SetMax(double a)       {AmpMax=a;}
  void SetMin(double a)       {AmpMin=a;}
  void SetMax0(double a)      {AmpMax0=a;}
  void SetMin0(double a)      {AmpMin0=a;}


  void SetName(const char* xName, int Gain, int Delay) {
    char Xname[100];
    //printf("setting name to channel %s gain=%d delay=%d\n", xName, Gain, Delay);
    if (Delay>-1) sprintf(Name, "%s Gain=%d Delay=%d", xName, Gain, Delay);
    else          sprintf(Name, "%s Gain=%d Long", xName, Gain);

    sprintf(func1name, "%s fit1", Name);
    sprintf(func2name, "%s fit2", Name);
    sprintf(func3name, "%s fit3", Name);
    pulseFunc1 = new TF1(func1name, Fit1, -50., 6500., 4);
    pulseFunc2 = new TF1(func2name, Fit2, -50., 6500., 4);
    pulseFunc3 = new TF1(func3name, Fit3, -50., 6500., 4);
    pulseFunc1->SetNpx(1500);
    pulseFunc1->SetLineWidth(2);
    pulseFunc1->SetLineColor(kRed);
    pulseFunc2->SetNpx(1500);
    pulseFunc2->SetLineWidth(2);
    pulseFunc2->SetLineColor(kGreen);
    pulseFunc3->SetNpx(1500);
    pulseFunc3->SetLineWidth(2);
    pulseFunc3->SetLineColor(kGreen);


    sprintf(Xname, "SplitPulse_%s", Name);
    SelectedSplit = new TH2F(Xname, Xname, 100, Tshape0, Tshape2, 1000, -1200., 2800.);
    SelectedSplit->SetMarkerColor(kGray+2);

    sprintf(Xname, "phase %s", Name);
    corrRFphase = new TH1D(Xname, Xname, 650, -200., 450.);
    corrRFphase -> GetXaxis() ->SetTitle("T-T_{RF}, ns");
    corrRFphase -> GetYaxis() ->SetTitle("Empty Events");

    sprintf(Xname, "phase1 %s", Name);
    corrRFphase1 = new TH1D(Xname, Xname, 650, -200., 450.);
    corrRFphase1 -> GetXaxis() ->SetTitle("T-T_{RF}, ns");
    corrRFphase1 -> GetYaxis() ->SetTitle("Empty Events");

    sprintf(Xname, "A/A(RF) %s", Name);
    corrRFampl = new TH1D(Xname, Xname, 500, 0., 0.1);
    corrRFampl -> GetXaxis() ->SetTitle("A/A_{RF}");
    corrRFampl -> GetYaxis() ->SetTitle("Empty Events");

    sprintf(Xname, "Pedestal %s", Name);
    corrRFped = new TH1D(Xname, Xname, 500, 1200., 1250.);
    corrRFped -> GetXaxis() ->SetTitle("Pedestal, ADC");
    corrRFped -> GetYaxis() ->SetTitle("Empty Events");


    sprintf(Xname, "%s shape 2d", Name);
    //pulse2d =    new TH2F(Xname, Xname, 200, Tshape0, Tshape1, 101, -1.1, 1.1);

    sprintf(Xname, "%s relative 1d", Name);
    pulse1Drelative = new TH1D(Xname, Xname, 52, -0.01, 1.03);

    sprintf(Xname, "%s shape", Name);
    int nprofBins=int(0.5*(Tshape1-Tshape0)); // 2ns bins
    pulseShape = new TProfile(Xname, Xname, nprofBins, Tshape0, Tshape2);
    sprintf(Xname, "%s shape Average", Name);
    pulseShapeA = new TProfile(Xname, Xname, nprofBins, Tshape0, Tshape1);

    pulseShapeI = new TProfile[nShapeI];
    for (int i=0; i<nShapeI; i++) {
      sprintf(Xname, "%s shape #%d", Name, i);
      pulseShapeI[i].SetNameTitle(Xname, Xname);
      pulseShapeI[i].SetBins(nprofBins, Tshape0, Tshape1);
      accRate0[i]=0.0;
      accRate1[i]=0.0;
    }   

    pulseShapeSplit = new TProfile[nShapeSplit];
    for (int i=0; i<nShapeSplit; i++) {
      sprintf(Xname, "%s shape PeakRange#%d", Name, i);
      pulseShapeSplit[i].SetNameTitle(Xname, Xname);
      pulseShapeSplit[i].SetBins(int((Tshape2-Tshape0)/5.), Tshape0, Tshape2);
    }   



    sprintf(Xname, "%s noise", Name);
    GoodWindowNoise = new TH1D(Xname, Xname, 51, -25.5, 25.5);
    GoodWindowNoise -> SetStats(1);    

    
    return;
  }
  const char* GetName() {return Name;}

  void SetSlices(int n) {
    nSlice=n;
    if (nSlice<300) dTsample=25.0;
    else            dTsample=12.5;
    if (nSlice>512) {
      printf ("[Signal->SetSlices] too many samples (%d) requested!\n", nSlice);
      exit(-2);
    }
    if (iMod>3) { // set cut for samples count in a good pedestal window //
      if (nSlice>300) nCut=6;
      else nCut=3;
    } else {
      if (nSlice>300) nCut=5;
      else nCut=2;
    }
    for (int i=0;i<nSlice;i++) {
      lTrain[i]=0;
      old[i]=0.0;
      raw[i]=0.0;
      amp1[i]=0.0;
      //if (i==0) printf("[TSignal] point#0  amp1[0] set to %f\n", amp1[i]);
      amp2[i]=0.0;
      amp3[i]=0.0;
      ampX[i]=0.0;
      time[i]=0.0;
      ScaleSet[i]=false;
      FFTaReal[i]=0.0;
      FFTaImag[i]=0.0;
      FFTaFull[i]=0.0;
      FFTphase[i]=0.0;
      FFTaReal[i]=0.0;
      FFTaImag[i]=0.0;
      FFTaFull[i]=0.0;
      FFTphase[i]=0.0;
      FFTpick[i]=0.0;
      FFTscale[i]=0.0;
      FFTshift[i]=0.0;
      FFTshiftW[i]=0.0;
      FFToffst[i]=0.0;
      FFT10scale[i]=0.0;
      FFT10shift[i]=0.0;
      FFT10offst[i]=0.0;       
    }
    aScale=1.0/sqrt(double(nSlice));
    FFT      = TVirtualFFT::FFT(1, &nSlice, "R2C ES K"); // straight transform, used to compute pickup spectrum
    FFT_BACK = TVirtualFFT::FFT(1, &nSlice, "C2R M K");  // reverse transform, to be used to calculate the pickup
                                                           // using the empty channel signal fft
    this->ClearFFTsums();
    this->ClearFFT10sums();
    return;
  }


  void ClearFFTsums() {
    //printf("[TModule->ClearFFTsums] start nSlice=%d\n", nSlice);
    for (int i=0; i<nSlice; i++) {
      FFTsum00[i] = 0.0;
      FFTsumNN[i] = 0.0;
      FFTscale[i]=1.0;
      FFToffst[i]=0.0;
      FFTshift[i]=0.0;
      FFTshiftW[i]=0.0;
      FFTsumX1[i]=0.0;
      FFTsumX2[i]=0.0;
      FFTsumXY[i]=0.0; 
      FFTsumY1[i]=0.0;
      FFTsumY2[i]=0.0;
      FFTsum1phi1[i]=0.0;
      FFTsum1phi2[i]=0.0;
      FFTsum2phi1[i]=0.0;
      FFTsum2phi2[i]=0.0;
      ScaleSet[i]=false;
    }
    return;
  }

  long double GetSum(int kSum, int i) {
    long double result=0.;
    if (i<0 || i>=nSlice/2) {
      printf("[TSignal->GetSum] wrong index=%d\n", i);
      exit(-1);
    }
    if (kSum==0) {
      result=FFTsum00[i];
    } else if (kSum==1) {
      result=FFTsumNN[i];
    } else if (kSum==2) {
      result=FFTsumX1[i];
    } else if (kSum==3) {
      result=FFTsumX2[i];
    } else if (kSum==4) {
      result=FFTsumXY[i];
    } else if (kSum==5) {
      result=FFTsumY1[i];
    } else if (kSum==6) {
      result=FFTsumY2[i];
    } else if (kSum==7) {
      result=FFTsum1phi1[i];
    } else if (kSum==8) {
      result=FFTsum1phi2[i];
    } else if (kSum==9) {
      result=FFTsum2phi1[i];
    } else if (kSum==10) {
      result=FFTsum2phi2[i];
    } else {
      printf("[TSignal->GetSum] wrong kSum=%d\n", kSum);
      exit(-1);
    }
    return result;
  }

// used to load saved FFT sums to compute the pickup conversion
  void SetSumFFT(int kSum, int i, long double sum) {
    if (i<0 || i>=nSlice/2) {
      printf("[TSignal->SetSum] wrong index=%d\n", i);
      exit(-1);
    }
    if (kSum==0) {
      FFTsum00[i]=sum;
    } else if (kSum==1) {
      FFTsumNN[i]=sum;
    } else if (kSum==2) {
      FFTsumX1[i]=sum;
    } else if (kSum==3) {
      FFTsumX2[i]=sum;
    } else if (kSum==4) {
      FFTsumXY[i]=sum;
    } else if (kSum==5) {
      FFTsumY1[i]=sum;
    } else if (kSum==6) {
      FFTsumY2[i]=sum;
    } else if (kSum==7) {
      FFTsum1phi1[i]=sum;
    } else if (kSum==8) {
      FFTsum1phi2[i]=sum;
    } else if (kSum==9) {
      FFTsum2phi1[i]=sum;
    } else if (kSum==10) {
      FFTsum2phi2[i]=sum;
    } else {
      printf("[TSignal->SetSum] wrong kSum=%d\n", kSum);
      exit(-1);
    }
    //if (iMod==0 && iChan==4 && iGain==1 && i<20 && kSum==0) printf("  out >     i=%2d a=%f\n", i, (double) sum);

    return;
  }

  void ClearFFT10sums() {
    //printf("[TModule->ClearFFT10sums] start nSlice=%d\n", nSlice);
    FFT10sum00 = 0.0;
    for (int i=0; i<nSlice; i++) {
      FFT10sumX1[i]=0.0;
      FFT10sumX2[i]=0.0;
      FFT10sumXY[i]=0.0;
      FFT10sumY1[i]=0.0;
      FFT10sum1phi1[i]=0.0;
      FFT10sum1phi2[i]=0.0;
      FFT10sum2phi1[i]=0.0;
      FFT10sum2phi2[i]=0.0;
    }
    return;
  }


  void StraightFFTransform() {
    //printf("[TSignal->StraightFFTransform] for %s nSlice=%d scale=%f\n", Name, nSlice, aScale);
    //for (int i=0; i<20; i++) {
    //  printf("     %3d raw=%.1f\t amp1=%.1f\t amp2=%.1f\n", i, raw[i], amp1[i], amp2[i]); 
    //}
    FFT->SetPoints(amp1);
    FFT->Transform();
    FFT->GetPointsComplex(FFTaReal, FFTaImag);
    return;
  }

  void TestFFT_BACKransform() { // test of reverse FFT transform
    FFT_BACK->SetPointsComplex(FFTaReal, FFTaImag);
    FFT_BACK->Transform();
    FFT_BACK->GetPoints(amp1);
    for (int i=0; i<nSlice; i++) {
      amp1[i]/=(double)nSlice; 
      //if (i==0 && dumpIt) printf("[TSignal] point#1  amp1[0] set to %f\n", amp1[i]);
    }
    return;
  }

   

  void ComputeFFTAmpPhase() {
    FFTmax=0.;
    //printf("[TSignal->ComputeFFTAmpPhase] for %s nSlice=%d scale=%f\n", Name, nSlice, aScale);
    for (int i=0; i<nSlice/2; i++) {
      //printf("    [TSignal->ComputeFFTAmpPhase]   #%4d Real=%.1f\t Img=%.1f\t", i, FFTaReal[i], FFTaImag[i]); 
      FFTaFull[i]=aScale*sqrt(FFTaReal[i]*FFTaReal[i]+FFTaImag[i]*FFTaImag[i]);
      FFTphase[i]=atan2(FFTaImag[i], FFTaReal[i]);
      if (FFTaFull[i]>FFTmax) FFTmax=FFTaFull[i];
      //if (i<20) printf("      %3d Amp=%.1f\t Phase=%.2f\n", i, FFTaFull[i], FFTphase[i]);
    }
    return;
  }

  void FilterFFT(double cut1, double cut2) {
    for (int i=0; i<nSlice/2; i++) {
      if (i>cut1 || FFTaFull[i]<cut2*FFTmax) {
        FFTaFull[i]=0.0;
        FFTaReal[i]=0.0;
        FFTaImag[i]=0.0;
      }
    }
    return;
  }

  bool CheckLowFrequencyFFT(int Nbins, int Nbad, double Thr) {
    int nCount=0;
    for (int i=1; i<Nbins && i<nSlice/2; i++) {
      if (FFTaFull[i]>Thr) nCount++;
    }
    return (nCount>=Nbad);
  }

  double GetLowFrequencyFFT(int N) {
    double sL=0.0;
    double s0=0.0;
    for (int i=1; i<nSlice/2; i++) {
      if (i<N) sL+=FFTaFull[i]*FFTaFull[i];
      s0+=FFTaFull[i]*FFTaFull[i];
    }
    return sL/s0;
  }

  double GetFFTampMAX() {
    return FFTmax;
  }

  double GetFFTamp(int i) {
    if (i<0 || i>=nSlice) {
      printf("[Module->GetFFTamp] wrong index i=%d\n", i);
      exit(-1);
    }
    return FFTaFull[i];
  }

  double GetFFTpha(int i) {
    if (i<0 || i>=nSlice) {
      printf("[Module->GetFFTpha] wrong index i=%d\n", i);
      exit(-1);
    }
    return FFTphase[i];
  }

  double GetFFTampX(int i) { // access to stored Antenna amplitude spectrum
    if (i<0 || i>=nSlice) {
      printf("[Module->GetFFTamp] wrong index i=%d\n", i);
      exit(-1);
    }
    return FFTaFullX[i];
  }

  double GetFFTphaX(int i) { // access to stored Antenna phase spectrum

    if (i<0 || i>=nSlice) {
      printf("[Module->GetFFTpha] wrong index i=%d\n", i);
      exit(-1);
    }
    return FFTphaseX[i];
  }



  void SetFFTCorrection(int i, double s, double d) {
    if (i<0 || i>=nSlice) {
      printf("[Module->SetCorrection] wrong index i=%d\n", i);
      exit(-1);
    }
    FFTscale[i]=s;
    FFTshift[i]=d;
    ScaleSet[i]=true;
    return;
  }

  void SetFFTpointExtComp(int i, double re, double im) { // import Re and Im from ModuleX
    if (i<0 || i>=nSlice) {
      printf("[Module->SetFFTpointExtComp] wrong index i=%d\n", i);
      exit(-1);
    }
    FFTaRealX[i]=re;
    FFTaImagX[i]=im;
    return;
  }

  void SetFFTpointExtReal(int i, double amp, double phase) { // import Amp and Phase from ModuleX
    if (i<0 || i>=nSlice) {
      printf("[Module->SetFFTpointExtReal] wrong index i=%d\n", i);
      exit(-1);
    }
    FFTaFullX[i]=amp;
    FFTphaseX[i]=phase;
    return;
  }

  void SetFFTwidthCut(double cut) {FFTwidthCut=cut;}

  void ComputeFFTcorrection() {
    if (dumpIt) printf("[TSignal->ComputeFFTcorrection] doing signal %s nSlice=%d scale=%f\n", 
                        Name, nSlice, aScale);
    for (int i=0; i<nSlice/2; i++) {
      FFTaRealX[i]=0.0;
      FFTaImagX[i]=0.0;
      if (dumpIt) printf("[TSignal->ComputeFFTcorrection] %3d set=%d ampX=%6.1f phiX=%5.2f scale=%.2f\t shift=%5.2f ",
             i, ScaleSet[i], FFTaFullX[i], FFTphaseX[i], FFTscale[i], FFTshift[i]);
      if (!ScaleSet[i]) {
        FFTaFullX[i]=0.0;
        FFTphaseX[i]=0.0;
        continue;
      }
      if (FFTshiftW[i]>FFTwidthCut) {
        FFTaFullX[i]=0.0;
        FFTphaseX[i]=0.0;
        continue;
      }
      if (FFTaFullX[i]>0.0) {        
        FFTaFullX[i]*=FFTscale[i];
        FFTaFullX[i]+=FFToffst[i];
      } else {
        FFTaFullX[i]=0.0;
      }
      FFTphaseX[i]+=FFTshift[i];
      if (dumpIt) printf(" new amp=%6.1f phase=%5.2f\n", FFTaFullX[i], FFTphaseX[i]);
      FFTaRealX[i]=FFTaFullX[i]*cos(FFTphaseX[i]);
      FFTaImagX[i]=FFTaFullX[i]*sin(FFTphaseX[i]);  
      while (FFTphaseX[i]>=TMath::Pi()) FFTphaseX[i]-=2.0*TMath::Pi();    
      while (FFTphaseX[i]<-TMath::Pi()) FFTphaseX[i]+=2.0*TMath::Pi();    
    }
    FFT_BACK->SetPointsComplex(FFTaRealX, FFTaImagX);
    FFT_BACK->Transform();
    FFT_BACK->GetPoints(FFTpick);
    for (int i=0; i<nSlice; i++) {
      FFTpick[i]*=aScale;
      if (dumpIt) printf("[TSignal->ComputeFFTcorrection] %3d A=%6.1f corr=%6.1f\n", i, amp2[i], FFTpick[i]);
      amp1[i]=amp2[i]-FFTpick[i];
    }    
  }

  double GetFFTcorrection(int i) { // get FFT correction
    return FFTpick[i];
  } 

  void AccumFFTfit() { // accumulates slope for a vs aX, average for phi-phiX
    FFTsum01+=1.0;
    for (int i=0; i<nSlice/2; i++) {
      double w=1.0;
      //w=(FFTaFullX[i]+FFTaFull[i])/FFTmax;
      //w=FFTaFullX[i]*FFTaFullX[i];
      FFTsum00[i]+=w;
      if (FFTaFullX[i]>0.0) FFTsumNN[i]+=1.0;
      FFTsumX1[i]+=FFTaFullX[i]*w;
      FFTsumY1[i]+=FFTaFull[i]*w;
      FFTsumY2[i]+=FFTaFull[i]*FFTaFull[i]*w;
      FFTsumX2[i]+=FFTaFullX[i]*FFTaFullX[i]*w;
      FFTsumXY[i]+=FFTaFullX[i]*FFTaFull[i]*w;
      double ph1=FFTphase[i]-FFTphaseX[i];
      double ph2=ph1;
      if      (ph1<-TMath::Pi()) ph1+=2.0*TMath::Pi();
      else if (ph1>=TMath::Pi()) ph1-=2.0*TMath::Pi();
      if      (ph2<-0.0)             ph2+=2.0*TMath::Pi();
      else if (ph2>=2.0*TMath::Pi()) ph2-=2.0*TMath::Pi();
      FFTsum1phi1[i]+=ph1*w;
      FFTsum2phi1[i]+=ph1*ph1*w;
      FFTsum1phi2[i]+=ph2*w;
      FFTsum2phi2[i]+=ph2*ph2*w;
    }
    return;
  }
  
  void ComputeFFTparameters () {
    printf("[TModule->ComputeFFTparameters] for %s\n", Name);
    for (int i=0; i<nSlice/2; i++) {
      //printf("[TModule->ComputeFFTparameters] slice#%3d N=%.0f Sw=%f\n", 
      //        i, (double) FFTsumNN[i], (double) FFTsum00[i]);
      if (FFTsum00[i]==0.0 || FFTsumNN[i]<5.) {
        ScaleSet[i]=false;
        FFTscale[i]=0.0;
        FFToffst[i]=0.0;
        FFTshift[i]=0.0;
        FFTshiftW[i]=100.;
      } else {
        FFTsumXY[i]/=FFTsum00[i];
        FFTsumX1[i]/=FFTsum00[i];
        FFTsumX2[i]/=FFTsum00[i];
        FFTsumY1[i]/=FFTsum00[i];
        FFTsumY2[i]/=FFTsum00[i];

//        FFTscale[i]=(FFTsumXY[i]-FFTsumX1[i]*FFTsumY1[i])/(FFTsumX2[i]-FFTsumX1[i]*FFTsumX1[i]);
//        FFToffst[i]=FFTsumY1[i]-FFTscale[i]*FFTsumX1[i];

        FFTscale[i]=FFTsumXY[i]/FFTsumX2[i];
        FFToffst[i]=0.0;


        FFTsum1phi1[i]/=FFTsum00[i];
        FFTsum1phi2[i]/=FFTsum00[i];
        FFTsum2phi1[i]/=FFTsum00[i];
        FFTsum2phi2[i]/=FFTsum00[i];
        FFTsum2phi1[i]-=FFTsum1phi1[i]*FFTsum1phi1[i];
        FFTsum2phi2[i]-=FFTsum1phi2[i]*FFTsum1phi2[i];
        if (FFTsum2phi1[i]<0.0) FFTsum2phi1[i]=0.0; 
        if (FFTsum2phi2[i]<0.0) FFTsum2phi2[i]=0.0; 
        FFTsum2phi1[i]=sqrt(FFTsum2phi1[i]);
        FFTsum2phi2[i]=sqrt(FFTsum2phi2[i]);//      
        if (FFTsum2phi1[i]>FFTsum2phi2[i]) { // pick one with smaller Sigma to awoid 2pi split xproblem
          FFTshift[i]=FFTsum1phi2[i];
          FFTshiftW[i]=FFTsum2phi2[i];
        } else {
          FFTshift[i]=FFTsum1phi1[i];
          FFTshiftW[i]=FFTsum2phi1[i];
        }
        ScaleSet[i]=true;
      }
    }

    for (int i=0; i<nSlice/2; i++) {
      if (ScaleSet[i] && i<20) {
        printf("            [%3d] Slope=%.2f\t Offset=%.2f\t PhaseShift=%.2f(+/-%.2f)\n",
                i, FFTscale[i], FFToffst[i], FFTshift[i], FFTshiftW[i]); 
      }
    }
    return;
  }

  double GetAccumStat() {return FFTsum01;}

  void AccumFFT10fit() { // accumulates slope for a vs aX, average for phi-phiX
    FFT10sum00+=1.0;
    for (int i=0; i<nSlice/2; i++) {
      FFT10sumX1[i]+=FFTaFullX[i];
      FFT10sumY1[i]+=FFTaFull[i];
      FFT10sumX2[i]+=FFTaFullX[i]*FFTaFullX[i];
      FFT10sumXY[i]+=FFTaFullX[i]*FFTaFull[i];
      double ph1=FFTphase[i]-FFTphaseX[i];
      double ph2=ph1;
      if      (ph1<-TMath::Pi()) ph1+=2.0*TMath::Pi();
      else if (ph1>=TMath::Pi()) ph1-=2.0*TMath::Pi();
      if      (ph2<-0.0)             ph2+=2.0*TMath::Pi();
      else if (ph2>=2.0*TMath::Pi()) ph2-=2.0*TMath::Pi();
      FFT10sum1phi1[i]+=ph1;
      FFT10sum2phi1[i]+=ph1*ph1;
      FFT10sum1phi2[i]+=ph2;
      FFT10sum2phi2[i]+=ph2*ph2;
    }
    return;
  }

  double GetAccumStat10 () {return FFT10sum00;}

  void ComputeFFT10parameters () {
    for (int i=0; i<nSlice/2; i++) {
      FFT10sumXY[i]/=FFT10sum00;
      FFT10sumX1[i]/=FFT10sum00;
      FFT10sumX2[i]/=FFT10sum00;
      FFT10sumY1[i]/=FFT10sum00;
      FFT10scale[i]=(FFT10sumXY[i]-FFT10sumX1[i]*FFT10sumY1[i])/(FFT10sumX2[i]-FFT10sumX1[i]*FFT10sumX1[i]);
      FFT10offst[i]=FFT10sumY1[i]-FFT10scale[i]*FFT10sumX1[i];
      FFT10sum1phi1[i]/=FFT10sum00;
      FFT10sum1phi2[i]/=FFT10sum00;
      FFT10sum2phi1[i]/=FFT10sum00;
      FFT10sum2phi2[i]/=FFT10sum00;
      FFT10sum2phi1[i]-=FFT10sum1phi1[i]*FFT10sum1phi1[i];
      FFT10sum2phi2[i]-=FFT10sum1phi2[i]*FFT10sum1phi2[i];
      if (FFT10sum2phi1[i]<0.0) FFT10sum2phi1[i]=0.0; 
      if (FFTsum2phi2[i]<0.0) FFTsum2phi2[i]=0.0; 
      FFT10sum2phi1[i]=sqrt(FFT10sum2phi1[i]);
      FFT10sum2phi2[i]=sqrt(FFT10sum2phi2[i]);
      if (FFT10sum2phi1[i]>FFT10sum2phi2[i]) { // pick one with smaller Sigma to awoid 2pi split xproblem
        FFT10shift[i]=FFT10sum1phi2[i];
      } else {
        FFT10shift[i]=FFT10sum1phi1[i];
      }
    }
    return;
  }

  double GetFFTcorrectionSlope(int i) {
    if (i<0 || i>=nSlice) {
      printf("[Module->GetFFTcorrectionSlope] wrong index i=%d\n", i);
      exit(-1);
    }
    return FFTscale[i];
  }

  double GetFFTcorrectionOffset(int i) {
    if (i<0 || i>=nSlice) {
      printf("[Module->GetFFTcorrectionOffset] wrong index i=%d\n", i);
      exit(-1);
    }
    return FFToffst[i];
  }

  double GetFFTphaseShift(int i) {
    if (i<0 || i>=nSlice) {
      printf("[Module->GetFFTcorrectionOffset] wrong index i=%d\n", i);
      exit(-1);
    }
    return FFTshift[i];
  }

  void Clear() {
    for (int i=0;i<nSlice;i++) {
      raw[i]=0.0;
      amp1[i]=0.0;
      //if (i==0 && dumpIt) printf("[TSignal] point#2  amp1[0] set to %f\n", amp1[i]);
      amp2[i]=0.0;
      amp3[i]=0.0;
      ampX[i]=0.0;
      time[i]=0.0;
      ScaleSet[i]=false;
      FFTaReal[i]=0.0;
      FFTaImag[i]=0.0;
      FFTaFull[i]=0.0;
      FFTphase[i]=0.0;
      FFTaReal[i]=0.0;
      FFTaImag[i]=0.0;
      FFTaFull[i]=0.0;
      FFTphase[i]=0.0;
      FFTpick[i]=0.0;
      FFTscale[i]=0.0;
      FFTshift[i]=0.0;
      FFTshiftW[i]=0.0;
      FFToffst[i]=0.0;
      FFT10scale[i]=0.0;
      FFT10shift[i]=0.0;
      FFT10offst[i]=0.0;       
    }
    this->ClearFFTsums();
    this->ClearFFT10sums();
  }


  void SetIntegrator(double T1, double T2) {
    integratorT1=T1;
    integratorT2=T2;
  }
  double GetIntegratorT1()    {return integratorT1;}
  double GetIntegratorT2()    {return integratorT2;}
  double GetIntegratorLevel() {return integratorLevel;}
  double GetIntegratorNoise() {return integratorNoise;}

  bool CalculateIntegrator() {
    Dbg=false;
    int i1=(int) (integratorT1/25.-2.);
    double s=0.0;
    integratorLevel=0.0;
    integratorNoise=0.0;
    for (int i=i1;i<nSlice;i++) {
      if (time[i]>integratorT2) break;
      if (time[i]>integratorT1) {
	s+=1.0;
	integratorNoise+=amp1[i]*amp1[i];
	integratorLevel+=amp1[i];
      }
    }
    if (s>0.0) {
      integratorLevel/=s;
      integratorNoise/=s;
      integratorNoise-=integratorLevel*integratorLevel;
      integratorNoise=sqrt(integratorNoise);
    } else {
      printf("[Signal->CalculateIntegrator] no samples to calculate Integrator signal\n");
      printf("                        T1=%f T2=%f Sums-> s=%f s2=%f integratorLevel=%f\n",
	     integratorT1, integratorT2, s, integratorNoise, integratorLevel);
      return false;
    }
    if (Dbg) {
      printf("[Signal->CalculateIntegrator]  T1=%f T2=%f Sums-> s=%.1f+/-%.2f integratorLevel=%f\n",
	     integratorT1, integratorT2, s, integratorNoise, integratorLevel);
    }
    //Dbg=false;
    return true;
  }

  void   SetIntegratorPedestal() {integratorPedestal=integratorLevel;}
  double GetIntegratorPedestal() {return integratorPedestal;}
  void   SubtractIntegratorPedestal() {integratorLevel-=integratorPedestal;}



  void SetRaw(int i, double a)  {
    if (i==0) {
      adcOver=false;
      adcUnder=false;
    }
    if (i<nSlice) {
      raw[i]=a;
      if (a==0.0) adcUnder=true;
      if (a==4095.0) adcOver=true;
      if (a>3900) { // exclude questionable area from the fit
	int j1=i-1, j2=i+1;
	if (j1<0) j1=0;
	if (j2>nSlice) j2=nSlice;
        for (int j=j1;j<j2;j++) {
          if (Dbg) printf("***** [SetRaw] %s -> set doFit[%d] to FALSE, overflow\n", Name, j);          
          doFit[j]=false;
          overf[j]=true;
          under[j]=false;
	}
      } else if (a<100) { // exclude questionable area from the fit
	int j1=i-1, j2=i+1;
	if (j1<0) j1=0;
	if (j2>nSlice) j2=nSlice;
        for (int j=j1;j<j2;j++) {
          if (Dbg) printf("***** [SetRaw] %s -> set doFit[%d] to FALSE, underflow\n", Name, j);          
          doFit[j]=false;
          under[j]=true;
          overf[j]=false;
	}
      } else {
        doFit[i]=true;
        overf[i]=false;
        under[i]=false;
      } 
    } else {
      printf("[Signal->SetRaw] %s wrong i=%d > slices=%d\n", Name, i , nSlice);
      exit(-1);
    }
  }

  void SetDummyFit(int N) {
    Ofit[N]=0.0;
    Afit[N]=0.0;
    Tfit[N]=Txxx[N];
    Sfit[N]=1.0;
    Afit1[N]=0.0;
    Tfit1[N]=0.0;
    Sfit1[N]=1.0;
    Qfit[N]=-1.0;
  }

  void SetTbunch(int ib, double T) {
    Txxx[ib]=T;
  }  

  bool GetDoFit(int i) {
    if (i<0 || i>=nSlice) {
      printf("[TSignal->GetDoFit] wrong index %d\n", i);
      exit(-1);
    }
    return doFit[i];
  }
  bool GetOverf(int i) {
    if (i<0 || i>=nSlice) {
      printf("[TSignal->GetOverf] wrong index %d\n", i);
      exit(-1);
    }
    return overf[i];
  }
  bool GetUnder(int i) {
    if (i<0 || i>=nSlice) {
      printf("[TSignal->GetUnder] wrong index %d\n", i);
      exit(-1);
    }
    return under[i];
  }
  void SetOverf(int i, bool set) {
    if (i<0 || i>=nSlice) {
      printf("[TSignal->SetOverf] wrong index %d\n", i);
      exit(-1);
    }
    overf[i]=set;
  }
  void SetUnder(int i, bool set) {
    if (i<0 || i>=nSlice) {
      printf("[TSignal->SetUnder] wrong index %d\n", i);
      exit(-1);
    }
    under[i]=set;
  }


  void SetAmp1(int i, double a) {
    if (i<nSlice && i>-1) {
      amp1[i]=a;
      //if (i==0 && dumpIt) printf("[TSignal] point#3  amp1[0] set to %f\n", amp1[i]);
      ampX[i]=0.0;
    } else {
      printf("[Signal->SetAmp1] wrong i=%d > slices=%d\n", i , nSlice);
      exit(-1);
    }
  }

  void SetAmp2(int i, double a) {
    if (i<nSlice && i>-1) amp2[i]=a;
    else {
      printf("[Signal->SetAmp2] wrong i=%d > slices=%d\n", i , nSlice);
      exit(-1);
    }
  }

  bool FitP3(double Tbunch, int bunch) {

    bool Dbg=false;

    if (iMod==1) Dbg=true; // EMEC

    //EventHeader *EH = ProcStatus->GetEventHeader();
    //int ReportMode  = ProcStatus->GetReportMode();

    if (Dbg) {
      printf("\n\n[TSignal->Fit3P] %s Tbunch=%.1f bunch#%d\n", Name, Tbunch, bunch);
      printf("                    FitInterval=%f FitStart=%f\n", TfitIntervalSimple, TfitStartSimple);
    }

    Nfit=int (TfitIntervalSimple/dTsample+1);
    int i1=int((Tbunch+TfitStartSimple-time[0])/dTsample+1);
    if (i1<0) i1=0;
    int i2=i1+Nfit;
    if (i2>nSlice-1) {
      i2=nSlice-1;
    }

    if (Dbg) printf("[TSignal->Fit3P] Nfit=%d i1=%d i2=%d dTsample=%f\n",
                    Nfit, i1, i2, dTsample);
    int nPoints=i2-i1+1;
    int iPeak=0;
    int iDip=0;
    AmpMaxfit[bunch]=-10000.;
    AmpMinfit[bunch]=10000.;
    nFitReal=0;
    rWin[bunch]=0.;
    aOff[bunch]=0.;
    wOff[bunch]=0.;
    
    for (int i=i1;i<i2;i++) {
      if (Dbg) printf(" [Signal->FitP3]  min/max search %4i t=%6.1f A=%6.1f Err=%4.1f doFit=%d", 
                     i,time[i], amp1[i], err2[i], doFit[i]);  
      rWin[bunch]+=err2[i];
   
      if (amp1[i]>AmpMaxfit[bunch] && time[i]>Tbunch-50. && time[i]<Tbunch+50.) {
        AmpMaxfit[bunch]=amp1[i];
	iPeak=i;
        if (Dbg) printf(" max=%d ", iPeak);
      } else {
        if (Dbg) printf(" ");
      }
      if (amp1[i]<AmpMinfit[bunch] && time[i]>Tbunch) {
        AmpMinfit[bunch]=amp1[i];
	iDip=i;
        if (Dbg) printf(" dip=%d\n", iDip);
      } else {
        if (Dbg) printf("\n");
      }
    } // loop over the samples // 

    rWin[bunch]/=i2-i1+1;
    printf("[Signal->FitP3]  fitting %d points\n", nPoints);      
    signalFit[bunch].Set(nPoints);

    for (int i=i1; i<i1+nPoints; i++) {
      if (Dbg) printf("[Signal->FitP3]       %4i t=%6.1f A=%6.1f Err=%4.1f doFit=%d\n", 
                     i, time[i], amp1[i], err2[i], doFit[i]);  
      signalFit[bunch].SetPoint(i-i1, time[i], amp1[i]);
      signalFit[bunch].SetPointError(i-i1, 0.0, err2[i]);
    }
    
    pulseFunc3->SetParameters(AmpMaxfit[bunch], Tbunch, 0.1, 0.01);
    pulseFunc3->SetParLimits(0, -100., 100.+AmpMaxfit[bunch]);
    pulseFunc3->SetParLimits(1, Tbunch-30., Tbunch+30.);
    pulseFunc3->SetParLimits(2, 0.,   1.0);
    pulseFunc3->SetParLimits(3, 0.,   0.5);

    signalFit[bunch].Fit(func3name, "QBN");

    for (int ip=0; ip<4; ip++) {
      if (Dbg) printf("[TSignal->FitP3] par#%d=%f (%f)\n", ip, 
             pulseFunc3->GetParameter(ip), 
             pulseFunc3->GetParError(ip));
    }    

    Tfit[bunch]=pulseFunc3->GetParameter(1);
    Afit[bunch]=pulseFunc3->GetParameter(0);

    return true;
     
  }

  double Fit(double T, int N, int iFit) {
    
    //Dbg=true;
    EventHeader *EH = ProcStatus->GetEventHeader();
    int ReportMode  = ProcStatus->GetReportMode();
 
    xReference=Reference;
    double T1best=0., dTbest=0., fAbest=0., Obest=0.0, Abest=0.0, s1best=0.0, s2best=0.0, chi2best=1000000.;
    double AfitLimit=100000.0; // no limit for maximum signal - if there is suspicion of overflow
    int iPeak=-1, iDip=-1;
    bool CutPeak=false;
    Txxx[N]=T;
    if (ReportMode==-1) return 100.;

    Nfit=int (TfitInterval/dTsample);
    int i1=int((T+TfitStart)/dTsample);
    int i1n=i1+3;
    if (i1<0) i1=0;
    int i2=i1+Nfit;
    if (i2>nSlice-1) {
      i2=nSlice-1;
      //i1=i2-Nfit;
    }
    int nPoints=i2-i1-1;
 
    if (Dbg || ReportMode==10021) {
      printf("[Signal->Fit]      Evt#%d FitMode=%d Bunch#%d\n", EH->event, iFit, N);
      printf("[Signal->Fit]      Tbunch=%.1f TfitStart=%.1f \n", T, TfitStart);
      printf("[Signal->Fit] use Refrence %s ReportMode=%d\n", Reference->GetName(), ReportMode);
      printf("              i1=%d i2=%d\n", i1, i2);
    }

    AmpMaxfit[N]=-10000.;
    AmpMinfit[N]=10000.;
    nFitReal=0;
    rWin[N]=0.;
    aOff[N]=0.;
    wOff[N]=0.;
    for (int i=i1;i<i2;i++) {
      if (Dbg) printf(" [Signal->Fit]       %4i t=%6.1f A=%6.1f Err=%4.1f doFit=%d", 
                     i,time[i], ampF[i], err2[i], doFit[i]);  
      rWin[N]+=err2[i];

      if (ampF[i]>AmpMaxfit[N] && time[i]>T-50. && time[i]<T-50.) {
        AmpMaxfit[N]=ampF[i];
	iPeak=i;
        if (Dbg) printf(" max=%d ", iPeak);
      } else {
        if (Dbg) printf(" ");
      }
      if (ampF[i]<AmpMinfit[N] && time[i]>T) {
        AmpMinfit[N]=ampF[i];
	iDip=i;
        if (Dbg) printf(" dip=%d\n", iDip);
      } else {
        if (Dbg) printf("\n");
      }

      if (doFit[i]) {
	if (iGain==0 || ampF[i]<1200.) {
          if (i<i1n) { // true offset estimation (may be changed by fit biases)
            aOff[N]+=ampF[i];
            wOff[N]+=1.0;
	  }
          nFitReal++;
	} else {
	  CutPeak=true;
	}
      }
    }

    rWin[N]/=i2-i1+1;
    if (wOff[N]>0.0) aOff[N]/=wOff[N];

    if (Dbg || ReportMode==10021) {
      printf("[Signal->Fit] %s bunch#%d iPeak=%d Amax=%f i1=%d i2=%d ==============\n", 
             Name, N, iPeak, AmpMaxfit[N], i1, i2);
      for (int i=i1;i<i2;i++) {
        if (i>-1 && i<nSlice) {
          printf("   [Signal->Fit]    %4i t=%6.1f raw=%6.0f A=%6.1f Err=%4.1f Under=%d Over=%d doFit=%d\n", 
                i,time[i], raw[i], ampF[i], err2[i], under[i], overf[i], doFit[i]); 
	} 
      }
    }

    // checking for special conditions ...//

    if (Dbg) printf("[Signal->Fit] %s iPeak=%3d t=%6.1f under=%d overf=%d doFit=%d\n",
	   Name, iPeak, time[iPeak], under[iPeak], overf[iPeak], doFit[iPeak]);
    if (Dbg) printf("[Signal->Fit] %s  iDip=%3d t=%6.1f under=%d overf=%d doFit=%d\n",
	   Name, iDip, time[iDip], under[iDip], overf[iDip], doFit[iDip]);

    if (iMod>3 && (iDip==-1 || iPeak==-1)) {
      if (iPeak==-1 && Dbg) printf("[Signal->Fit] %s -> missing Peak\n", Name);
      if (iDip==-1 && Dbg) printf("[Signal->Fit] %s -> missing Dip\n", Name);
      SetDummyFit(N);
      return Qfit[N];
    }

    if (nFitReal<nPoints/4 || nFitReal<6+3*iFit) {
      if (Dbg) printf("[Signal->Fit] %s too few points to fit, %d of %d\n", Name, nFitReal, Nfit);
      SetDummyFit(N);
      return Qfit[N];
    }
    if (iMod>3 && AmpMaxfit[N]<0.0) {
      if (Dbg) printf("[Signal->Fit] %s Negative peak, consider it an artefact, %f\n", Name, AmpMaxfit[N]);
      SetDummyFit(N);
      return Qfit[N];
    }

    int j1=iPeak-3;
    int j2=iPeak+5;
    if (j1<0) j1=0;
    if (j2>nSlice) j2=nSlice;
    for (int j=j1;j<j2;j++) {
      if (!doFit[j] && j>4 && iMod>3) {
        if (Dbg) printf("[Signal->Fit] %s -> peak proximity to no-fit zone\n", Name);
        SetDummyFit(N);
        return Qfit[N];
      }
    }
    //   .... no special conditions found  //

    signalFit[N].Set(nFitReal);
    nFitReal=0;
    
    for (int i=i1;i<i2;i++) {
      double r1=0.3*AmpMaxfit[N]*Reference->GetRer(time[i]-T); // get the accuracy of  fitting function;
      double rx=r1*r1;
      rx=sqrt(rx+err2[i]*err2[i]);
      
      if (doFit[i] && (iGain==0 || (ampF[i]<1200. && iMod>3) || (raw[i]<3900.) )) {
        signalFit[N].SetPoint(nFitReal, time[i], ampF[i]);
        if (raw[i]>50) signalFit[N].SetPointError(nFitReal, 0.0, rx);
	else signalFit[N].SetPointError(nFitReal, 0.0, rx+AmpMaxfit[N]);
        nFitReal++;
      }
      if (Dbg && ReportMode<10005 && ReportMode>10000) printf("[Signal->Fit]      #%3d t=%6.1f a=%6.1f Nose=%.2f FitErr=%.2f\n",
      		      i, time[i], ampF[i], rWin[N], r1/AmpMaxfit[N]);
    }


    //printf("[Signal->Fit] %s Dbg=%d ReportMode=%d\n", Name, Dbg, ReportMode);

    if (Dbg || ReportMode==10021) printf("[Signal->Fit] fitting using reference %s\n",
		      Reference->GetName());
    if (Dbg || ReportMode==10021) {
      printf("[Signal->Fit] %s start -> Off=%4.1f, Max=%.1f T=%.1f Stretch=%.2f\n",
	     Name, 0.0, AmpMaxfit[N], T, 1.05);
      printf("[Signal->Fit]    start -> noise=%.2f\n", rWin[N]);
    }

    double offMax=0.0, offMin=0.0;
    if (aOff[N]>0.0) {
      offMax=1.5*aOff[N]+3.0*rWin[N];
      offMin=-3.0*rWin[N];
    } else {
      offMin=1.5*aOff[N]-3.0*rWin[N];
      offMax=3.0*rWin[N];
    }
    if (doFit[iPeak]) {
      AfitLimit=1.5*AmpMaxfit[N]+3.0*rWin[N]; // maximum is ok, set upper limit 
    } else {
      AfitLimit=75000.;
      //ReportMode=10006;
    }
    if (CutPeak) {  // create fake peak estimation for fititng overflows;
      //printf("[Signal->Fit] %s Peak#%d is clipped \n", Name, N);
      AfitLimit=75000.;
    }
    if (iFit==0) {
      Ifit[N]=iFit;
      double a=AmpMaxfit[N]-3.0*rWin[N];
      if (a<-3.0*rWin[N]) a=-3.0*rWin[N];
      pulseFunc1->SetParameters(aOff[N], AmpMaxfit[N], T, 1.05);
      pulseFunc1->SetParLimits(0, offMin, offMax);
      pulseFunc1->SetParLimits(1, a, AfitLimit);
      pulseFunc1->SetParLimits(2, T-30., T-30.);
      pulseFunc1->SetParLimits(3, 0.75, 1.5);
      signalFit[N].Fit(func1name, "QBN");
    } else if (iFit==1) {
      if (Qfit[N]<1.5) return Qfit[N]; // do not perform re-fit if this exact fit was good
      Ifit[N]=iFit;
      //printf("[Signal->Fit] 2-peak fitting for %s\n", Name); 
      double a1, a2;
      a1=Afit[N]-3.0*rWin[N];
      a2=Afit[N];
      if (a2<0.) a2=-a2;
      a2=10.0*a2+6.0*rWin[N];

      if (a1<-3.0*rWin[N]) a1=-3.0*rWin[N];
      for (double fA=0.25; fA<0.99; fA+=0.25) {
	for (double T1=Tfit[N]-5.; T1>Tfit[N]-75; T1-=50.) {
          for (double dT=Tfit[N]-T1; T1+dT<Tfit[N]+200.; dT+=75.) {
            pulseFunc2->SetParameters(Ofit[N], Afit[N], Tfit[N]-25., 1.05, fA, dT, 1.05);
            pulseFunc2->SetParLimits(0,offMin, offMax); // offset
            pulseFunc2->SetParLimits(1, a1,  a2); // sum of amplitudes
            pulseFunc2->SetParLimits(2, T1-75., Tfit[N]); // first pulse
            pulseFunc2->SetParLimits(3, 0.50, 1.5); // stretch for the first pulse
            pulseFunc2->SetParLimits(4, fA-0.25, fA+0.25);// fraction in the second pulse
            pulseFunc2->SetParLimits(5, 5.0, dT+50.); // time between the peaks
            pulseFunc2->SetParLimits(6, 0.75, 1.5); // stretch for the second pulse
            signalFit[N].Fit(func2name, "QBN");      
            double c2=pulseFunc2->GetChisquare()/(nFitReal-7.);
            if (c2<chi2best) {
	      chi2best=c2;
              Obest=pulseFunc2->GetParameter(0);
              Abest=pulseFunc2->GetParameter(1);
              T1best=pulseFunc2->GetParameter(2);
              s1best=pulseFunc2->GetParameter(3);
              fAbest=pulseFunc2->GetParameter(4);
              dTbest=pulseFunc2->GetParameter(5);
              s2best=pulseFunc2->GetParameter(6);
	    }
            //printf("          chi2=%.2f, best=%.2f\n", c2, chi2best);
            if (chi2best<1.5) break;
	  }
	}
      }
      
      pulseFunc2->SetParameters(Obest, Abest, T1best, s1best, fAbest, dTbest, s2best);
      pulseFunc2->SetParLimits(0, Obest-10., Obest+10.); // offset
      pulseFunc2->SetParLimits(1, Abest-3.0*rWin[N], 1.25*Abest+3.0*rWin[N]); // sum of amplitudes
      pulseFunc2->SetParLimits(2, T1best-25., T1best+25.); // first pulse
      pulseFunc2->SetParLimits(3, 0.75*s1best, 1.25*s1best); // stretch for the first pulse
      pulseFunc2->SetParLimits(4, 0.75*fAbest, 1.25*fAbest);// fraction in the second pulse
      pulseFunc2->SetParLimits(5, dTbest-5., dTbest+5.); // time between the peaks
      pulseFunc2->SetParLimits(6, 0.75*s2best, 1.25*s2best); // stretch for the second pulse
      signalFit[N].Fit("fit2", "QBN");      
      
    } else {
      printf("[Signal->Fit] %s  iFit=%d not implemented\n", Name, iFit);
      exit(-1);
    }

    if (iFit==0) {
      Ofit[N]=pulseFunc1->GetParameter(0);
      Afit[N]=pulseFunc1->GetParameter(1);
      Tfit[N]=pulseFunc1->GetParameter(2);
      Sfit[N]=pulseFunc1->GetParameter(3);
      OfitE[N]=pulseFunc1->GetParError(0);
      AfitE[N]=pulseFunc1->GetParError(1);
      TfitE[N]=pulseFunc1->GetParError(2);
      SfitE[N]=pulseFunc1->GetParError(3);
      Qfit[N]=pulseFunc1->GetChisquare()/(nFitReal-4.);
      if (Afit[N]<2.5 && Qfit[N]>3.0) Qfit[N]=3.0; //to prefent re-fit due to  noise

      pulseFunc1->SetParameter(0,Ofit[N]);
      pulseFunc1->SetParameter(1,Afit[N]);
      pulseFunc1->SetParameter(2,Tfit[N]);
      pulseFunc1->SetParameter(3,Sfit[N]);
    } else if (iFit==1) {
      Ofit[N]=pulseFunc2->GetParameter(0);
      Afit[N]=pulseFunc2->GetParameter(1);
      Tfit[N]=pulseFunc2->GetParameter(2);
      Sfit[N]=pulseFunc2->GetParameter(3);
      Afit1[N]=pulseFunc2->GetParameter(4);
      Tfit1[N]=pulseFunc2->GetParameter(5);
      Sfit1[N]=pulseFunc2->GetParameter(6);
      OfitE[N]=pulseFunc2->GetParError(0);
      AfitE[N]=pulseFunc2->GetParError(1);
      TfitE[N]=pulseFunc2->GetParError(2);
      SfitE[N]=pulseFunc2->GetParError(3);
      Afit1E[N]=pulseFunc2->GetParError(4);
      Tfit1E[N]=pulseFunc2->GetParError(5);
      Sfit1E[N]=pulseFunc2->GetParError(6);
      Qfit[N]=pulseFunc2->GetChisquare()/(nFitReal-7.);

      pulseFunc2->SetParameter(0,Ofit[N]);
      pulseFunc2->SetParameter(1,Afit[N]);
      pulseFunc2->SetParameter(2,Tfit[N]);
      pulseFunc2->SetParameter(3,Sfit[N]);
      pulseFunc2->SetParameter(4,Afit1[N]);
      pulseFunc2->SetParameter(5,Tfit1[N]);
      pulseFunc2->SetParameter(6,Sfit1[N]);
    }
    // save the signal befor subtraction
    for (int i=0;i<nSlice;i++) {
      amp3[i]=ampF[i];
      previousShape->SetPoint(i, time[i], amp3[i]);
      previousShape->SetPointError(i, 0., PedRMSmean);
    }

    if (Dbg || ReportMode<10007 && ReportMode>10000) {
      if (iFit==0) {
        printf("[Signal->Fit] %s   end -> Off=%4.1f, Max=%6.1f T=%.1f Stretch=%.2f Chi2=%.2f\n",
	       Name, Ofit[N], Afit[N], Tfit[N], Sfit[N], Qfit[N]);
      } else if (iFit==1) {
        printf("[Signal->Fit] %s   end -> Off=%4.1f, Max1=%6.1f T1=%6.1f Stretch1=%4.2f\n",
	       Name, Ofit[N], Afit[N]*(1.0-Afit1[N]), Tfit[N], Sfit[N]);
	printf("                                                ");
        printf("Max2=%6.1f T2=%6.1f Stretch2=%4.2f Chi2=%.2f\n",
	       Afit[N]*Afit1[N], Tfit[N]+Tfit1[N], Sfit1[N], Qfit[N]);
      }
    }

    if (under[iDip] && iGain==1 && iFit==1) { // do not count as bad? //
      if (Dbg) printf("[Signal->Fit] %s -> Dip Underflow\n", Name);
      Qfit[N]=-1.0;
    }
    
    if (Dbg) printf("[Signal->Fit] done, ReportMode=%d\n\n", ReportMode);
    ReportMode=ProcStatus->WhatToDo("[Signal->Fit]", 10021);
    Dbg=false;
    return Qfit[N];
  }

  void SubtractFit(double T, int N, int iFit) {
    if (iFit==0) {
      pulseFunc1->SetParameter(0,Ofit[N]);
      pulseFunc1->SetParameter(1,Afit[N]);
      pulseFunc1->SetParameter(2,Tfit[N]);
      pulseFunc1->SetParameter(3,Sfit[N]);
    // subtract fit curve from the signal 
      for (int i=0;i<nSlice;i++) {
        if (time[i]>Tfit[N]-80. && time[i]<Tfit[N]+100.) {
          doFit[i]=false;
          if (Dbg) printf("****[SubtractFit] %s -> set doFit[%d] to FALSE\n", Name, i);
	} 
        amp3[i]=ampF[i];
        double r1=0.2*Afit[N]*Reference->GetRer(time[i]-T); // get the accuracy of  fitting function;
        //printf ("[Signal->Fit] t=%5.1f Fold=%5.1f Ffit=%5.1f Error old=%5.2f Added=%5.2f New=%5.2f\n",
	//	time[i], ampF[i], pulseFunc1->Eval(time[i]), err2[i], r1, sqrt(err2[i]*err2[i]+r1*r1));
        ampF[i]-=pulseFunc1->Eval(time[i]);
	err2[i]=sqrt(err2[i]*err2[i]+r1*r1);
        residualShape->SetPoint(i, time[i], ampF[i]);
        residualShape->SetPointError(i, 0., PedRMSmean);
      }

    } else if (iFit==1) {
      pulseFunc2->SetParameter(0,Ofit[N]);
      pulseFunc2->SetParameter(1,Afit[N]);
      pulseFunc2->SetParameter(2,Tfit[N]);
      pulseFunc2->SetParameter(3,Sfit[N]);
      pulseFunc2->SetParameter(4,Afit1[N]);
      pulseFunc2->SetParameter(5,Tfit1[N]);
      pulseFunc2->SetParameter(6,Sfit1[N]);
    // subtract fit curve from the signal 
      for (int i=0;i<nSlice;i++) {
        if (time[i]>Tfit[N]-70. && time[i]<Tfit[N]+Tfit1[N]+60.) { 
          doFit[i]=false; 
          if (Dbg) printf("*****[SubtractFit] %s -> set doFit[%d] to FALSE\n", Name, i);
	}
        amp3[i]=ampF[i];
        ampF[i]-=pulseFunc2->Eval(time[i]);
        double r1=0.3*Afit[N]*Reference->GetRer(time[i]-Tfit[N]); // get the accuracy of  fitting function;
        //printf ("[Signal->Fit] #%3d old=%5.2f Added=%5.2f New=%5.2f\n",
	//	i, err2[i], r1, sqrt(err2[i]*err2[i]+r1*r1));
	err2[i]=sqrt(err2[i]*err2[i]+r1*r1);
        residualShape->SetPoint(i, time[i], ampF[i]);
        residualShape->SetPointError(i, 0., PedRMSmean);
      }
    }
  }

  double GetFitOffset(int i) {return Ofit[i];}
  double GetFitTime(int i)   {return Tfit[i];}
  double GetFitPeak(int i)   {return Afit[i];}
  double GetFitWidth(int i)  {return Sfit[i];}
  double GetFitTime1(int i)   {return Tfit1[i];}
  double GetFitPeak1(int i)   {return Afit1[i];}
  double GetFitWidth1(int i)  {return Sfit1[i];}

  double GetFitOffsetE(int i) {return OfitE[i];}
  double GetFitTimeE(int i)   {return TfitE[i];}
  double GetFitPeakE(int i)   {return AfitE[i];}
  double GetFitWidthE(int i)  {return SfitE[i];}
  double GetFitTime1E(int i)   {return Tfit1E[i];}
  double GetFitPeak1E(int i)   {return Afit1E[i];}
  double GetFitWidth1E(int i)  {return Sfit1E[i];}

  double GetFitChi2(int i)   {return Qfit[i];}
  //----------------------------------------------//
  void SetFitOffset(int i, double Offset) {Ofit[i]=Offset;}
  void SetFitTime(int i,   double T)      {Tfit[i]=T;}
  void SetFitPeak(int i,   double A)      {Afit[i]=A;}
  void SetFitWidth(int i,  double S)      {Sfit[i]=S;}
  void SetFitTime1(int i,  double T)      {Tfit1[i]=T;}
  void SetFitPeak1(int i,  double A)      {Afit1[i]=A;}
  void SetFitWidth1(int i, double S)      {Sfit1[i]=S;}

  void SetFitOffsetE(int i, double OffsetE) {OfitE[i]=OffsetE;}
  void SetFitTimeE(int i,   double TE)      {TfitE[i]=TE;}
  void SetFitPeakE(int i,   double AE)      {AfitE[i]=AE;}
  void SetFitWidthE(int i,  double SE)      {SfitE[i]=SE;}
  void SetFitTime1E(int i,  double TE)      {Tfit1E[i]=TE;}
  void SetFitPeak1E(int i,  double AE)      {Afit1E[i]=AE;}
  void SetFitWidth1E(int i, double SE)      {Sfit1E[i]=SE;}

  void SetFitChi2(int i, double Q)   {Qfit[i]=Q;}
  //----------------------------------------------//
  void ComputeResponse(int i) { // response for bunch #i
    double Tx=0.0;
    int npass=0;
    int ReportMode = ProcStatus->GetReportMode();

    if (ReportMode==10005) {
      printf("[Signal->ComputeResponse] %8s bunch#%d iFit=%d \n", Name, i, Ifit[i]);
    }
    if (ProcStatus->GetUseFit()) { // use fit results to calculate  time and response //
      ResponseStatus[i]=0;
      Response[i]=0.0;
      Time[i]=Tfit[i];
      if (Ifit[i]==0) {
        Response[i]=Afit[i]/Sfit[i];
        Time[i]=Tfit[i];
        if (ReportMode==10005) printf("[Signal->ComputeResponse]         A=%.1f T=%.1f\n", Response[i], Time[i]); 
      } else if (Ifit[i]==1) {
        //if (Tfit[i]>Txxx[i]-100. && Tfit[i]>0.) { /* commented on 2009-04-28 */
        if (Tfit[i]>Txxx[i]-75. && Tfit[i]>0.) { 
          Response[i]+=(1.0-Afit1[i])*Afit[i]/Sfit[i];
          Tx+=(1.0-Afit1[i])*Tfit[i]*Afit[i]/Sfit[i];
	  npass++;
        }
        //if (Tfit[i]+Tfit1[i]<Txxx[i]+125. && Tfit[i]+Tfit1[i] < time[nSlice-1]) { /* commented on 2009-04-28 */
        if (Tfit[i]+Tfit1[i]<Txxx[i]+100. && Tfit[i]+Tfit1[i] < time[nSlice-1]) {
          Response[i]+=Afit1[i]*Afit[i]/Sfit1[i];
          Tx+=Afit1[i]*(Tfit[i]+Tfit1[i])*Afit[i]/Sfit1[i];
	  npass++;
        }
        if (npass!=2) {
	  if (Dbg) printf("[Signal->ComputeResponse] %s bunch#%d -> skipping %d peak(s) : T0=%.1f Tx=%.1f T1=%.1f A0=%.1f A1=%.1f\n",
	         Name, i, 2-npass, Tfit[i], Txxx[i], Tfit[i]+Tfit1[i], 
                 (1.0-Afit1[i])*Afit[i]/Sfit[i], 
	         Afit1[i]*Afit[i]/Sfit1[i]);
        }
        if (ReportMode==10005) printf("[ComputeResponse] npass=%d Tx=%.1f T1=%.1f T2=%.1f A1=%.1f A2=%.1f \n", 
	  			 npass, Txxx[i], Tfit[i], Tfit[i]+Tfit1[i], (1.0-Afit1[i])*Afit[i]/Sfit[i], Afit1[i]*Afit[i]/Sfit1[i]);
        if (npass) ResponseStatus[i]=10; 
        else ResponseStatus[i]=-11;
      } else { 
        printf("[Signal->ComputeResponse] %s unknown Ifit=%d\n", Name, Ifit[i]);
        exit(-1);
      }
      if (npass && Response[i]>10.) Time[i]=Tx/Response[i];
      if (Qfit[i]==-1.0) ResponseStatus[i]=-10;
      if (Afit[i]>750. && iMod>3 && ProcStatus->GetRunHeader()->run<463
           || Afit[i]>1600. )  ResponseStatus[i]=-1;// 'shaper overflow'
    } else { // use TpMax and ApMax as estimation of the time and response //
      ResponseStatus[i]=1;
      if ((ApMax[i]>750. && iMod>3 && ProcStatus->GetRunHeader()->run<463) || // case for old shaper!
           ApMax[i]>1600.)  ResponseStatus[i]=-1;// 'shaper overflow'
      Response[i]=ApMax[i];
      Time[i]=TpMax[i];
      if (Dbg || ReportMode==10015) printf("[Signal->ComputeResponse] Parabola for %20s bunch#%d Status=%d T=%6.1f A=%.1f\n", Name, i, ResponseStatus[i], Time[i], Response[i]);
    }

    if (ProcStatus->GetRunHeader()->Attn && iMod<4) {// correct calorimeters for the 20dB attenuator at high luminocity //
      ResponseCal[i] = Response[i]*ProcStatus->GetRunHeader()->AttnCorr;
      Sum8cal[i]     = Sum8[i]*ProcStatus->GetRunHeader()->AttnCorr;
    } else {
      ResponseCal[i] = Response[i]; 
      Sum8cal[i]     = Sum8[i];
    }
    if (Dbg || ReportMode==10005 || ReportMode==10015) {
      printf("[Signal->ComputeResponse] Bnch#%d %s Response=%.1f T=%.1f\n", i, Name, Response[i], Time[i]);
    }
  }
  
  int    GetResponseStatus(int i) {return ResponseStatus[i];}
  double GetResponseADC(int i)    {return Response[i];}
  double GetResponseSum8(int i)   {return Sum8[i];}
  double GetResponseSum8cal(int i){return Sum8cal[i];}
  double GetResponseCal(int i)    {return ResponseCal[i];}
  double GetResponseTime(int i)   {return Time[i];}
  double GetResponseParab(int i)  {return ApMax[i];}
  double GetADCMax(int i)         {return amp1[iMax[i]];}


  void SetTime(int i, double a) {
    if (i>-1 && i<nSlice) {
      time[i]=a; 
      //printf("time#%d set to %f\n", i, time[i]);
      if (i==2) {
        dTsample=0.5*(time[2]-time[0]);
      }
    } else {
      printf("[TSignal->SetTime] %s wrong i=%d > slices=%d\n", Name, i , nSlice);
      exit(-1);
    }
  }

  void SetTimeUniform(int i, double a) {
    if (i>-1 && i<nSlice) {
      timeUniform[i]=a; 
    } else {
      printf("[TSignal->SetTimeUniform] %s wrong i=%d > slices=%d\n", Name, i , nSlice);
      exit(-1);
    }
  }

  

  void SetNGoodWindows(int n) {NGoodWindows=n;}
  int  GetNGoodWindows()      {return NGoodWindows;}
  bool GetPedWinX(int i)      {return GoodPedWindow[i];}

  bool GoodNoiseConditions(double T) { // returns true if closest (prior to T) PedWindow is GOOD
    int iw=0;
    if (PedWindow1[iw]>=T) return false; // no PedWindow prior to T
    while (PedWindow1[iw+1]<T && iw+1<NPedWindows) {
     iw++;
    }
    return GoodPedWindow[iw];
  } 

  bool ComputePrePed() {
    double s0=0.0;
    double s1=0.0;
    double s2=0.0;
    double sigma=1.0e10;
    double average=1200.;
    bool result=true;
    int nCutOld=-1;
    nCut=0;
    
    //printf("[    TSignal->ComputePrePed] %s\n", Name);
    for (int iLoop=0; iLoop<5; iLoop++) {
      //printf("[    TSignal->ComputePrePed] Loop=%d\n", iLoop);
      s0=0.0;
      s1=0.0;
      s2=0.0;
      nCut=0;
      for (int i=0; i<nSlice; i++) {
        if (raw[i]>average+3.0*sigma || raw[i]<average-3.0*sigma) {
          nCut++;
        } else {
          s0+=1.0;
          s1+=raw[i];
          s2+=raw[i]*raw[i];
        }
      }
      if (nCut>50 && !(adcOver || adcUnder)) {
        printf("\n\n\n[TSignal->ComputePrePed]  Burst#%d Evt#%d(%d)\n", 
              ProcStatus->GetBurstHeader()->burst,
              ProcStatus->GetEventHeader()->event,
              ProcStatus->GetEventHeader()->burstEvent);
        printf("[TSignal->ComputePrePed] %s    %d samples dropped!\n", Name, nCut);
        printf("[TSignal->ComputePrePed] adcUnder=%d adcOver=%d\n", adcUnder, adcOver );
        printf("[TSignal->ComputePrePed] Average=%.1f sigma=%.1f bottom=%.1f top=%.1f\n",
                average, sigma, average-3.0*sigma, average+3.0*sigma);
        //for (int i=0; i<nSlice; i++) printf("       #%3d raw=%.1f\n", i, raw[i]);
        ProcStatus->SetReportMode(1);
      }
      if (s0<5.) {
        s1=1200.;
        s2=1.5;
        result=false;
      } else {
        s1/=s0;
        s2/=s0;
        s2-=s1*s1;
        if (s2>0.25) sigma=sqrt(s2);
        else sigma=0.5;
      }
      average=s1;
      if (nCut==nCutOld) break;
      nCutOld=nCut;
    }
    PedPrePed=average;    
    //printf("[    TSignal->ComputePrePed] done\n");
    return result;     
  }

  double GetPrePed() {
    return PedPrePed;
  }

  bool ComputeVarianceByBunch() {
    //if (iMod==1 && iChan==1 && iGain==1) printf("[TSignal->ComputeVarianceByBunch] %s\n", Name);
    double Tg=ProcStatus->GetEventHeader()->GetTimeGlobal();
    double Trf=ProcStatus->GetEventHeader()->GetRFperiod();
    //printf("[TSignal->ComputeVarianceByBunch] Tglobal=%.2f Period=%.2f\n", Tg, Trf);
    for (int ib=0; ib<50; ib++) {
      bunchRFmin[ib]=1.0e10;
      bunchRFmax[ib]=-1.0e10;
      bunchRFrms[ib]=0.0;
      bunchRFavr[ib]=0.0;
      bunchRFs0[ib]=0.0;
      bunchRFs1[ib]=0.0;
      bunchRFs2[ib]=0.0;
      bunchRFs0odd[ib]=0.0;
      bunchRFs1odd[ib]=0.0;
      bunchRFs2odd[ib]=0.0;
      bunchRFset[ib]=false;
    }

    //printf("[TSignal->ComputeVarianceByBunch] doing sample sums\n");
    for (int i=0; i<nSlice; i++) {
      int ib=int((time[i]-Tg)/Trf);
      if (ib<0) continue;
      //printf("      i=%3d ib=%2d\n", i, ib);
      if (raw[i]>bunchRFmax[ib]) bunchRFmax[ib]=raw[i];
      if (raw[i]<bunchRFmin[ib]) bunchRFmin[ib]=raw[i];
      bunchRFs0[ib]+=1.0;
      bunchRFs1[ib]+=raw[i];
      bunchRFs2[ib]+=raw[i]*raw[i];
      if (i>0 && i<nSlice-1) {
        double odd=raw[i]-0.5*(raw[i-1]+raw[i+1]);
        bunchRFs0odd[ib]+=1.0;
        bunchRFs1odd[ib]+=odd;
        bunchRFs2odd[ib]+=odd*odd;
      }
    }
    for (int ib=0; ib<50; ib++) {
      if (bunchRFs0[ib]<4) {
        bunchRFset[ib]=false; // not enough samples in the bunch
      } else {
        bunchRFset[ib]=true;
        bunchRFavr[ib]=bunchRFs1[ib]/bunchRFs0[ib];
        bunchRFrms[ib]=bunchRFs2[ib]/bunchRFs0[ib];
        bunchRFrms[ib]-=bunchRFavr[ib]*bunchRFavr[ib];

        bunchRFavrODD[ib]=bunchRFs1odd[ib]/bunchRFs0odd[ib];
        bunchRFrmsODD[ib]=bunchRFs2odd[ib]/bunchRFs0odd[ib];
        bunchRFrmsODD[ib]-=bunchRFavrODD[ib]*bunchRFavrODD[ib];

        if (bunchRFrms[ib]<0.01)bunchRFrms[ib]=0.1;
        else bunchRFrms[ib]=sqrt(bunchRFrms[ib]);

        if (bunchRFrmsODD[ib]<0.01)bunchRFrmsODD[ib]=0.1;
        else bunchRFrmsODD[ib]=sqrt(bunchRFrmsODD[ib]);
        //if (iMod==1 && iChan==1 && iGain==1) {
        //  printf("         bunch#%d  \trms=%.2f \trmsOdd=%.2f \tAmp=%0f\n ", 
        //          ib, bunchRFrms[ib], bunchRFrmsODD[ib], bunchRFmax[ib]-bunchRFmin[ib]);
        //}
      }

    }
    return true;
  }


  bool checkRFbunch(int ib) {
    printf("[TSignal->checkRFbunch] %s ib=%d check=%d\n", Name, ib, bunchRFset[ib]);
    if (ib<0 || ib>49) return false;
    return bunchRFset[ib];
  }
  double GetRFrms(int ib) {
    if (bunchRFset[ib]) return bunchRFrms[ib];
    return 0.0;
  }
  double GetRFavr(int ib) {
    if (bunchRFset[ib]) return bunchRFavr[ib];
    return 0.0;
  }
  double GetRFrmsODD(int ib) {
    if (bunchRFset[ib]) return bunchRFrmsODD[ib];
    return 0.0;
  }
  double GetRFavrODD(int ib) {
    if (bunchRFset[ib]) return bunchRFavrODD[ib];
    return 0.0;
  }
   double GetRFamp(int ib) {
    if (bunchRFset[ib]) return bunchRFmax[ib]-bunchRFmin[ib];
    return 0.0;
  }
  double GetRFmax(int ib) {
    if (bunchRFset[ib]) return bunchRFmax[ib];
    return 0.0;
  }
  double GetRFmin(int ib) {
    if (bunchRFset[ib]) return bunchRFmin[ib];
    return 0.0;
  }
    
  void ComputeRFsig(int iOff) {
    double Ssig1;
    double Ssig0;
    double s0;
    double s1;
    double s2;

    Ssig0=0.0;
    Ssig1=0.0;
    
    s0=0.0;
    s1=0.0;
    s2=0.0;
    if (iOff<0 || iOff>29) {
      printf("[TSignal->ComputeRFsig] wrong offset=%d\n", iOff);
      exit(-1);
    }
    for (int j=-iOff; j<50; j++) {
      int i=j+iOff;
      if (j<0) continue; 
      while (i<0)  i+=30;
      while (i>29) i-=30;
      if (bunchRFs0[j]!=0.0) {
        if (ProcStatus->GetBunchAction(i)==2) {
          s0+=bunchRFs0odd[j];
          s1+=bunchRFs1odd[j];
          s2+=bunchRFs2odd[j];
          //if (iMod==1 && iChan==1 && iGain==1) {
          //  printf("[TSignal->ComputeRFsig] %d+%d->%d\t to noise (%.1f, %.1f, %.1f)\n",
          //         j, iOff, i, bunchRFs0[j], bunchRFs1[j], bunchRFs2[j]);
          //}
        } else if (ProcStatus->GetBunchAction(i)==1) {
          Ssig1+=bunchRFmax[j]-bunchRFmin[j];
          Ssig0+=1.0;
          //if (iMod==1 && iChan==1 && iGain==1)  {
          //  printf("[TSignal->ComputeRFsig] %d+%d->%d\t to signal (%.1f, %.1f)\n", j, iOff, i, Ssig0, Ssig1);
          //}
        }
      }
    }
    if (s0==0.0) {
      printf("[TSignal->ComputeSignificance] no statistics for noise! s0=%f\n", s0);
      exit(-1);
    }
    s1/=s0;
    s2/=s0;
    s2-=s1*s1; 
    if (s2<0.0001) {
      s2=0.01;
    } else { 
      s2=sqrt(s2);
    }
    bunchRFdet[iOff]=Ssig1/Ssig0;
    bunchRFsig[iOff]=s2;
    //if (iMod==1 && iChan==1 && iGain==1) {
    //  printf("[TSignal->ComputeRFsig] #%2d signal=%.1f\t noise=%.2f\t S=%.1f\n",
    //         iOff, Ssig1/Ssig0, s2, bunchRFdet[iOff]/bunchRFsig[iOff]);
    //}
  }

  double GetRFsig(int i) {
    if (i<0 || i>29) return 0.0;
    return bunchRFsig[i];
  }
  double GetRFdet(int i) {
    if (i<0 || i>29) return 0.0;
    return bunchRFdet[i];
  }
  void ComputeBunchNoise() {
    int iOff=ProcStatus->GetEventHeader()->GetFirstBunch();
    //double w=0.0;
    //double s=0.0;
    //double wOdd=0.0;
    //double sOdd=0.0;
    for (int j=-iOff; j<50; j++) {
      int i=j+iOff;
      while (i<0)  i+=30;
      while (i>29) i-=30;
      if (ProcStatus->GetBunchAction(j)==2) {
/**** digging here ****/
      }       
    }
  }

  void UpdateEmptyEventPedestal() {

    double s0=0.0;
    double s1=0.0;
    double s2=0.0;
    double r1=0.0;
    double r2=10000.0;
    int nDrop=0;

    for (int step=0; step<3; step++) {
      s0=0.0;
      s1=0.0;
      s2=0.0;
      //double a0=raw[0];
      for (int i=0; i<nSlice; i++) {
        double a=raw[i];
        if (nSlice>300) a=amp1[i];
        if (step==0 || (a<r1+3.0*r2 && a>r1-3.0*r2)) {
          s0+=1.0; 
          s1+=a;
          s2+=a*a;
        }
      } 
      s1/=s0;
      s2/=s0;
      s2-=s1*s1;
      s2=sqrt(s2);
      r1=s1;
      r2=s2;
/*
      if (iMod==0) {
        printf("[TSignal->UpdateEmptyEventPedestal] %10s step#%d N=%d ped=%6.1f rms=%5.2f\n",
             Name, step, int(s0), r1, r2);
      }
*/
    }

 
    for (int i=0; i<nSlice; i++) {
      double a=raw[i];
      if (nSlice>300) a=amp1[i]; 
      if (a<r1+3.0*r2 && a>r1-3.0*r2) {
        EmptyEventS0+=1.0;
        EmptyEventS1+=a;
        EmptyEventS2+=a*a;
      } else {
        nDrop++;
      }
    }

    if (EmptyEventS0>0.0) {
      EmptyEventPedestal=EmptyEventS1/EmptyEventS0;
      EmptyEventNoise=EmptyEventS2/EmptyEventS0;
      EmptyEventNoise-=EmptyEventPedestal*EmptyEventPedestal;
      EmptyEventNoise=sqrt(EmptyEventNoise);
      //printf("[TSignal->EmptyEventPedestal] %10s ---> final ped=%6.1f rms=%6.1f\n",
      //       Name, EmptyEventPedestal, EmptyEventNoise);
      EmptyEventPedestalSet=true;
      for (int i=0; i<25; i++) PedestalTailCorr[i]=EmptyEventPedestal;
    } else {
      EmptyEventPedestal=0.0;
      EmptyEventNoise=0.0;
      EmptyEventPedestalSet=false;
    }
    
    PedRMSmean=EmptyEventNoise;

    if (Dbg) printf("[TSignal->UpdateEmptyEventPedestal] %10s ped=%6.1f rms=%5.2f\n",
            Name, EmptyEventPedestal, EmptyEventNoise);

    if (nDrop*10>nSlice) {
      printf("\n\n\n[TSignal->UpdateEmptyEventPedestal]  Burst#%d Evt#%d(%d)\n", 
              ProcStatus->GetBurstHeader()->burst,
              ProcStatus->GetEventHeader()->event,
              ProcStatus->GetEventHeader()->burstEvent);
      printf("[TSignal->UpdateEmptyEventPedestal] %s dropped %d of %d samples!\n",
             Name, nDrop, nSlice);
      printf("[TSignal->UpdateEmptyEventPedestal]  ---> prelim ped=%6.1f rms=%6.1f\n",
             r1, r2);
      //1ProcStatus->SetReportMode(1);
      for (int i=0; i<nSlice; i++) {
        //printf("      %3d raw=%7.1f a=%7.1f ", i, raw[i], amp1[i]);
        double a=raw[i];
        if (nSlice>300) a=amp1[i]; 
        if (a<r1+3.0*r2 && a>r1-3.0*r2) {
          //printf("\n");
        } else {
          //printf("  drop\n");
        }
        
      }
      printf("[TSignal->UpdateEmptyEventPedestal]  --->  final ped=%6.1f rms=%6.1f\n",
             EmptyEventPedestal, EmptyEventNoise);
      //int iqq=0;
      //printf("Push->");
      //cin >> iqq;
      //if (iqq==0) exit(-1);
      //if (iqq==1) ProcStatus->SetReportMode(1);
    }

    return;
  }

  void ClearEmptyEventPedestal() {
    EmptyEventPedestalSet=false;
    EmptyEventPedestal=0.0;
    EmptyEventNoise=0.0;
    EmptyEventS0=0.0;
    EmptyEventS1=0.0;
    EmptyEventS2=0.0;    
  }

  bool   CheckEmptyEventPedestal() {return EmptyEventPedestalSet;}
  double GetEmptyEventPedestal()   {return EmptyEventPedestal;}
  double GetEmptyEventNoise()      {return EmptyEventNoise;}


  void SetPedestalWindow(int iw, bool good, double tl, double th) {
    if (iw==0) NGoodWindows=0;
    NPedWindows=iw+1;
    PedWindow0[iw]=tl;
    PedWindow1[iw]=th;
    GoodPedWindow[iw]=good;
    if (good) NGoodWindows++;
    firstSample[iw]=-1;
    lastSample[iw]=-1;
    for (int i=0; i<nSlice; i++) {
      if (time[i]<PedWindow0[iw]) continue;
      if (firstSample[iw]==-1) {
        firstSample[iw]=i;
      } 
      lastSample[iw]=i;
      if (time[i]>PedWindow1[iw]) break;
    }
  }

  int GetLastSample(int iw) { // returns last sample of the PED WINDOW
    if (iw<0 || iw>=NPedWindows) {
      printf("[TSignal->GetLastSample] wrong pedestal window index %d nWindows=%d\n", iw, NPedWindows);
      exit(-1);
    }
    return lastSample[iw];
  }
  int GetFirstSample(int iw) { // returns first sample of the PED WINDOW
    if (iw<0 || iw>=NPedWindows) {
      printf("[TSignal->FirstSample] wrong pedestal window index %d nWindows=%d\n", iw, NPedWindows);
      exit(-1);
    }
    return firstSample[iw];
  }

  bool PerformTailFit(int iw) {
    bool result=true;
    if (dumpIt) printf("\n[TSignal->PerformTailFit] Tail fit for %s,\t window#%d (%d...%d)\t", Name, iw, firstSample[iw], lastSample[iw]);
    if (PedWindow1[iw]-PedWindow0[iw]<200.) {
      GoodPedWindow[iw]=false;
      result=false;
    }
// calculate "differential noise" as a variance of (a(i)-0.5*(a(i-1)+a(i+1))   
    PedSamples[iw]=0;
    PedAverage[iw]=0.0;
    PedRMS[iw]=0.0;
    for (int i=firstSample[iw]; i<lastSample[iw]; i++) {
      if (i==0) continue;
      if (i==nSlice-1) break;
      double a=amp1[i]-0.5*(amp1[i-1]+amp1[i+1]);
      PedSamples[iw]++;
      PedAverage[iw]+=a;
      PedRMS[iw]+=a*a;
    }
    PedAverage[iw]/=PedSamples[iw];
    PedRMS[iw]/=PedSamples[iw];
    PedRMS[iw]-=PedAverage[iw]*PedAverage[iw];
    if (PedRMS[iw]>0.0) {
      PedRMS[iw]=sqrt(PedRMS[iw]);
    } else {
      PedRMS[iw]=0.01;
    }
    if (dumpIt) printf(" Nsamp=%d RMS=%.1fADC\n", PedSamples[iw], PedRMS[iw]);

    double x01=0.; // Sum(c^2)
    double x02=0.; // Sum(s^2)
    double x12=0.; // Sum(c*s)
    double x31=0.; // Sum(c*y);
    double x32=0.; // Sum(s*y);
    for (int i=0; i<lastSample[iw]-firstSample[iw]; i++) {
      x01+=Wcos[i]*Wcos[i];
      x02+=Wsin[i]*Wsin[i];
      x12+=Wcos[i]*Wsin[i];
      x31+=Wcos[i]*amp1[firstSample[iw]+i];
      x32+=Wsin[i]*amp1[firstSample[iw]+i];
    }
    double det=x01*x02-x12*x12;
    //if (dumpIt) printf("[TSignal->PerformTailFit] x01=%f\t x02=%f\t x12=%f\t x31=%f\t x32=%f\t det=%f \n",
    //        x01, x02, x12, x31, x32, det);
    tailAcos[iw]=(x31*x02-x32*x12)/det;
    tailAsin[iw]=(x32*x01-x31*x12)/det;
    double res0=0.;
    double res1=0.;
    for (int i=0; i<lastSample[iw]-firstSample[iw]; i++) {
      double f=Wcos[i]*tailAcos[iw]+Wsin[i]*tailAsin[iw];
      double diff=amp1[firstSample[iw]+i]-f;
      res0+=diff;
      res1+=diff*diff;
    }    
    res0/=PedSamples[iw];
    res1/=PedSamples[iw];
    res1-=res0*res0;
    res1=sqrt(res1);
    if (dumpIt) {
      printf("[TSignal->PerformTailFit]  Acos=%.2f\t Asin=%.2f\n", tailAcos[iw], tailAsin[iw]);
      printf("[TSignal->PerformTailFit]  fit residual AVR=%f RMS=%f\n", res0, res1);
    }
    if (dumpIt) {
      for (int i=0; i<lastSample[iw]-firstSample[iw]; i++) {
        printf("    %3d A[%3d]=%6.1f Afit=%6.1f Acos=%6.1f Asin=%6.1f\n", 
               i, firstSample[iw]+i,  amp1[firstSample[iw]+i], 
               tailAcos[iw]*Wcos[i]+tailAsin[iw]*Wsin[i], 
               tailAcos[iw]*Wcos[i], tailAsin[iw]*Wsin[i]);
      }  
    }  
    return result;
  }

  double GetTailAmplitude(int iw, int is) { 
// returns baseline fit at sample #is from the beginning of the PEDESTAL WINDOW
    if (iw<0 || iw>=NPedWindows) {
      printf("[TSignal->GetTailAmplitude] wrong pedestal window index %d nWindows=%d\n", iw, NPedWindows);
      exit(-1);
    }
    if (is<0 || is>=nSizeTail) {
      printf("[TSignal->GetTailAmplitude] wrong pedestal window index %d nTail=%d\n", is, nSizeTail);
      exit(-1);
    }
    return tailAcos[iw]*Wcos[is]+tailAsin[iw]*Wsin[is];
  }

  void PrepareTailed() {
// copy amplitudes from amp1 to signalTail, 
//  sarting at firstSample[0] and ending at lastSample[last]-1 
    int iTail=0;
    int iw=NPedWindows-1;
    for (int i=0; i<nSizeTail; i++) signalTail[i]=0.0;
    for (int i=firstSample[0]; i<lastSample[iw]; i++) {
      signalTail[iTail]=amp1[i];
      iTail++;
    }
// attach the last ped-window tail to make signal looooong 
    int i0=lastSample[iw]-firstSample[iw];
    for (int i=0; iTail<nSizeTail; i++) {
      if (i+i0>=nSizeTail) {
        printf("TSignal->PrepareTailed] index %d too large (max=%d)\n", i+lastSample[iw], nSizeTail);
      }
      signalTail[iTail]=tailAcos[iw]*Wcos[i+i0]+tailAsin[iw]*Wsin[i+i0];
      iTail++;
    }
// subtract the first pedestal window fit
    for (int i=0; i<nSizeTail; i++) {
      signalTail[i]-=tailAcos[0]*Wcos[i]+tailAsin[0]*Wsin[i];
    }
  }

  double GetTailedSignal(int i) {
    if (i<0 || i>=nSizeTail) {
      printf("TSignal->GetTailedSignal] bad index %d (nSizeTail=%d)\n", i, nSizeTail);
    }
    return signalTail[i];
  }

// this one does pedestal for windows 'as added'
  int CalcPedestalWindow(int iw) {
    //if (iMod<4) Dbg=true;
    //Dbg=false;

    if (iw==0) PedRMSbest=100000.;
    PedSamples[iw]=0;
    PedAverage[iw]=0.0;
    GoodPedWindow[iw]=true;
    PedRMS[iw]=0.0;
    int i=int ((PedWindow0[iw]-time[0])/25.)-2;
    if (i<0) i=0;
    if (Dbg) printf("[Signal->CalcPedestalWindow] %s  for Window#%d iStart=%i tl=%6.1f th=%6.1f ->", 
                    Name, iw, i, PedWindow0[iw], PedWindow1[iw]);
    while (time[i]<PedWindow1[iw] && i<nSlice) {
      if (time[i]>=PedWindow0[iw]) {
        PedSamples[iw]++;
        PedAverage[iw]+=raw[i];
        PedRMS[iw]+=raw[i]*raw[i];
      }
      i++;
    }
    if (PedSamples[iw]>nCut) {
      PedAverage[iw]/=(double)PedSamples[iw];
      PedRMS[iw]/=(double)PedSamples[iw];
      PedRMS[iw]-=PedAverage[iw]*PedAverage[iw];
      PedRMS[iw]=sqrt(PedRMS[iw]);
      if (PedRMS[iw]<PedRMSbest && PedRMS[iw]!=0.0) PedRMSbest=PedRMS[iw]; 
      if (Dbg) printf(" [Signal->CalcPedestalWindow] %s window#%d  A=%6.1f RMS=%.1f N=%d\n",Name, iw,  PedAverage[iw],  PedRMS[iw], PedSamples[iw]);
      NGoodWindows++;
    } else {
      PedAverage[iw]=0.;
      PedRMS[iw]=0.;
      GoodPedWindow[iw]=false;
      if (Dbg) printf(" [Signal->CalcPedestalWindow] %s window#%d failed N=%d\n", Name, iw, PedSamples[iw]);
      return 0;
    }
    return PedSamples[iw];
  }

 // this does all windows in one loop (intended for Long Pulses) ==========================================
  void SetNoise() {
    //if (iMod<4 && iDelay>-1) Dbg=true;
    //Dbg=false;
    //int ReportMode = ProcStatus->GetReportMode();
    int iw=0;
    bool inWindow=false;
    for (int i=0;i<NPedWindows;i++) {
      GoodPedWindow[i]=true;
    }

    PedRMSbest=10000.;
    maxFuzz=0.0;
    for (int i=0;i<nSlice;i++) {
      if (time[i]<PedWindow1[iw] && time[i]>=PedWindow0[iw]) {
	if (!inWindow) { // first sample for this window //
          //if (Dbg) printf("[Signal->SetNoise] %s entering window#%d t=%.1f Window=(%.1f...%.1f) \n",
          //                Name, iw, time[i], PedWindow0[iw], PedWindow1[iw]);
          inWindow=true;
          PedAverage[iw]=0.0;
          PedRMS[iw]=0.0;
          PedSamples[iw]=0;
	}
        PedSamples[iw]++;
        PedAverage[iw]+=amp1[i];
        PedRMS[iw]+=amp1[i]*amp1[i];
      } else {
        if (inWindow && iw<NPedWindows) { // just left the Pedestal Window, do the math //
          inWindow=false;
          GoodPedWindow[iw]=(PedSamples[iw]>nCut);
          if (GoodPedWindow[iw]) {
            PedAverage[iw]/=PedSamples[iw];
            PedRMS[iw]/=PedSamples[iw];
            PedRMS[iw]-=PedAverage[iw]*PedAverage[iw];
            PedRMS[iw]=sqrt(PedRMS[iw]);
            if (PedRMS[iw]<PedRMSbest && GoodPedWindow[iw]) {
              PedRMSbest=PedRMS[iw];
              if (PedRMSbest<0.5) PedRMSbest=0.5;
	    }
	  }
          if (Dbg) printf("[Signal->SetNoise] %s done with window#%d, samples=%d, <A>=%.1f RMS=%.2f RMS-best=%.2f Status=%d\n", 
                          Name, iw, PedSamples[iw], PedAverage[iw], PedRMS[iw], PedRMSbest, GoodPedWindow[iw]);
          iw++;
	}
      }
    }
    if (Dbg) {
      printf("[Signal->SetNoise] for %s raw NGoodWindows=%d, RMS-best=%.2f\n", Name, iw, PedRMSbest);
      for (int i=0;i<iw;i++) {
        printf("[Signal->SetNoise] %d status=%d\n", i, GoodPedWindow[i]);
      }
    }
    NGoodWindows=CleanPedestalWindows(1);
    if (Dbg) printf("[Signal->SetNoise]     %s filtered NGoodWindows=%d\n\n\n", Name, NGoodWindows);
    if (NGoodWindows==0) {
      printf("*************************************************************************\n");
      printf("[Signal->SetNoise]     %s filtered NGoodWindows=%d\n", Name, NGoodWindows);
      printf("*************************************************************************\n\n");
      ProcStatus->SetReportMode(1);
    }
    for (int i=2; i<nSlice;i++) {
      /// here we are looking for irregular amplitude fluctuation typical for clones
      double fuzz=fabs(amp1[i]-2.0*amp1[i-1]+amp1[i-2])/
                    (10.*(PedRMSmean+1.5*(iGain+1.0))+fabs(amp1[i])+fabs(amp1[i-1])+fabs(amp1[i-2])
                     +0.1*fabs(amp1[i]-amp1[i-2]));
      //if (fuzz>maxFuzz) maxFuzz=fuzz;
      if (fuzz>1.0) {
        maxFuzz+=fuzz;
        if (Dbg) {
          printf("[TSignal]%12s is spiky at #%.0fns spike_norm=%4.2f sum=%4.2f\t", 
                 Name, time[i-1], fuzz, maxFuzz);
          printf("[TSignal]      noise=%3.1f signal->(%6.1f, %6.1f, %6.1f)\n", 
                 PedRMSmean, amp1[i-2], amp1[i-1], amp1[i]);
          printf("[TSignal]      estimated spike size = %.1fADC\n\n",
                 amp1[i-1]-0.5*(amp1[i-2]+amp1[i]));
        }
      }
    }

    //Dbg=false;
    return;
  }

  double GetSignalAverage(double T1, double T2) { // computes average;
    double a=0;
 
    if (T2<time[0] || T1>time[nSlice-1]) return 0.;

    int i1=int((T1-time[0])/dTsample)-2;
    int i2=int((T2-time[0])/dTsample)+2;
    if (i1<0) i1=0;
    if (i2<0) i2=0;
    if (i1>nSlice-1) i1=nSlice-1;
    if (i2>nSlice) i2=nSlice;

    int sCount=0;
    for (int i=i1; i<i2; i++) {
      if (time[i]>T1 && time[i]<T2) {
        a+=amp1[i];
        sCount++;
      }
    }
    a/=sCount;
    return a;
  }

  double GetSignalAverageRaw(double T1, double T2) { // computes average;
    double a=0;
 
    if (T2<time[0] || T1>time[nSlice-1]) return 0.;

    int i1=int((T1-time[0])/dTsample)-2;
    int i2=int((T2-time[0])/dTsample)+2;

    //printf("[GetSignalAverageRaw] T1=%.1f T2=%.1f i1=%d i2=%d\n", T1, T2, i1, i2);

    if (i1<0) i1=0;
    if (i2<0) i2=0;
    if (i1>nSlice-1) i1=nSlice-1;
    if (i2>nSlice) i2=nSlice;

    int sCount=0;
    for (int i=i1; i<i2; i++) {
      if (time[i]>T1 && time[i]<T2) {
        //printf("    adding i=%d a=%f \n", i, raw[i]);
        a+=raw[i];
        sCount++;
      }
    }
    //printf("[GetSignalAverageRaw] sum=%f nSlice=%d\n", a, sCount);
    a/=sCount;
    return a;
  }

   double GetSignalVariance(double T1, double T2) { // computes RMS

    double a2=0;
    double a1=0;
 
    if (T2<time[0] || T1>time[nSlice-1]) return 0.;

    int i1=int((T1-time[0])/dTsample)-2;
    int i2=int((T2-time[0])/dTsample)+2;
    if (i1<0) i1=0;
    if (i2<0) i2=0;
    if (i1>nSlice-1) i1=nSlice-1;
    if (i2>nSlice) i2=nSlice;

    int sCount=0;
    for (int i=i1; i<i2; i++) {
      if (time[i]>T1 && time[i]<T2) {
        a1+=amp1[i];
        a2+=amp1[i]*amp1[i];
        sCount++;
      }
    }

    if (sCount==0) {
      printf("[GetSignalVariance] noie problem for %s, count=0\n", Name);
      exit(-1);
    }
    a1/=(double)sCount;
    a2/=(double)sCount;
    a2-=a1*a1;
    if (a2<=0.0) {
      //printf("[GetSignalVariance] noie problem for %s\n", Name);
      //for (int i=i1; i<i2; i++) {
      //  if (time[i]>T1 && time[i]<T2) {
      //    printf("[GetSignalVariance]     sample #%3d %.1f\n ",i, amp1[i]);
      //  }
      //}
      a2=0.0;
    }
    a2=sqrt(a2);

    //printf("[TSignal->Variance]       %10s %2d samples -> a1=%5.2f a2=%5.2f\n", Name, sCount, a1, a2);
    
    return a2;
  }

   double GetSignalVarianceSmooth(double T1, double T2) { // computes RMS relative to a 'smooth' signal
// use a(i)-0.5*(a(i-1)+a(i+1) instead of a(i);

    double a2=0;
    double a1=0;
 
    if (T2<time[0] || T1>time[nSlice-1]) return 0.;

    int i1=int((T1-time[0])/dTsample)-2;
    int i2=int((T2-time[0])/dTsample)+2;
    if (i1<1) i1=1;
    if (i2<1) i2=1;
    if (i1>nSlice-2) i1=nSlice-2;
    if (i2>nSlice-1) i2=nSlice-1;

    int sCount=0;
    for (int i=i1; i<i2; i++) {
      if (time[i]>T1 && time[i]<T2) {
        double a=amp1[i]-0.5*(amp1[i-1]+amp1[i+1]);
        a1+=a;
        a2+=a*a;
        sCount++;
      }
    }
    if (sCount != 0) {
      a1/=(double)sCount;
      a2/=(double)sCount;
      a2-=a1*a1;
      if (a2<=0.0) a2=0.0;
      a2=sqrt(a2);
    } else {
      a1=0.0;
      a2=0.0;
      printf("[TSignal->GetSignalVarianceSmooth] %s No samples for SmoothVariance! t0=%.1f t[%d]=%.1f t[%d]=%.1f T1=%.1f T2=%.1f\n",
             Name, time[0], i1, time[i1], i2, time[i2], T1, T2);
      exit(-1);
    }
    
    //printf("[TSignal->VarianceSmooth] %10s %2d samples -> a1=%5.2f a2=%5.2f\n", Name, sCount, a1, a2);

    return a2;
  }

   double GetSignalVarianceSharp(double T1, double T2) { // computes RMS relative to a 'smooth' signal
// use a(i)+0.5*(a(i-1)+a(i+1) instead of a(i);

    double a2=0;
    double a1=0;
 
    if (T2<time[0] || T1>time[nSlice-1]) return 0.;

    int i1=int((T1-time[0])/dTsample)-2;
    int i2=int((T2-time[0])/dTsample)+2;
    if (i1<1) i1=1;
    if (i2<1) i2=1;
    if (i1>nSlice-2) i1=nSlice-2;
    if (i2>nSlice-1) i2=nSlice-1;

    int sCount=0;
    for (int i=i1; i<i2; i++) {
      if (time[i]>T1 && time[i]<T2) {
        double a=amp1[i]+0.5*(amp1[i-1]+amp1[i+1]);
        a1+=a;
        a2+=a*a;
        sCount++;
      }
    }
    if (sCount != 0) {
      a1/=sCount;
      a2/=sCount;
      a2-=a1*a1;
      if (a2<=0.0) a2=0.0;
      a2=sqrt(a2);
    } else {
      a1=0.0;
      a2=0.0;
      printf("[TSignal->GetSignalVarianceSmooth] %s No samples for SmoothVariance! T0=%.1f T1=%.1f\n",
             Name, T1, T2);
      exit(-1);
    }
    
    //printf("[TSignal->VarianceSharp] %10s %2d samples -> a1=%5.2f a2=%5.2f\n", Name, sCount, a1, a2);

    return a2;
  }

    
  double GetPedAverage(int i) {if (-1<i && i<NPedWindows) return PedAverage[i];    else return -1;}
  double GetPedRMS(int i)     {if (-1<i && i<NPedWindows) return PedRMS[i];        else return -1;}
  double GetPedSamples(int i) {if (-1<i && i<NPedWindows) return PedSamples[i];    else return -1;}
  bool   GetPedStatus(int i)  {if (-1<i && i<NPedWindows) return GoodPedWindow[i]; else return -1;}
  double GetHistRMS()         {return GoodWindowNoise->GetRMS();}
  void   ResetNoiseHist()     {GoodWindowNoise->Reset();}

  int CleanPedestalWindows(int iCall) {
    //if (iMod<4 && iDelay>-1)  Dbg=true;
    int ReportMode = ProcStatus->GetReportMode();
    //Dbg=false;
    //Dbg=true;

    FirstGoodWindow=-1;
    PedRMSmean=0.0;
    PedRMSworst=1000000.0;
    if (ReportMode==10003 || Dbg) {
      printf("[Signal->CleanPedestalWindows]---> %s, RMS-best=%.2f Call from #%d\n", Name, PedRMSbest, iCall);
      for (int i=0;i<NPedWindows;i++) {
        printf("[Signal->CleanPedestalWindows] %d status=%d\n", i, GoodPedWindow[i]);
      }
    }

    if (NPedWindows>1) {

      while (PedRMSworst>2.0*PedRMSmean || PedRMSworst>5.0*PedRMSbest) {
        PedRMSmean=0.0;
        PedRMSworst=0.0;
        int iWorst=-1;
        int n=0;
        for (int iw=0;iw<NPedWindows;iw++) {
	  if (GoodPedWindow[iw]) {
            PedRMSmean+=PedRMS[iw];
            n++;
            if (PedRMS[iw]>PedRMSworst) {
              PedRMSworst=PedRMS[iw];
              iWorst=iw;
	    }
	  }
	  if (ReportMode==10003 || Dbg) {
            printf("[Signal->CleanPedestalWindows] %s checking window#%d status=%d RMS=%.2f Worst=%.2f iWorst=%d Best=%.2f\n",
                 Name, iw, GoodPedWindow[iw], PedRMS[iw], PedRMSworst, iWorst, PedRMSbest);
	  }
        }
        PedRMSmean /= n;
        NGoodWindows = n;
      
        if (PedRMSworst>2.0*PedRMSmean || PedRMSworst>5.0*PedRMSbest) {
	  if (ReportMode==10003 || Dbg) {
            printf("[Signal->CleanPedestalWindows] %s dropping window#%d RMS=%.2f MeanRMS=%.2f WorstRMS=%.2f BestRMS=%.2f\n", 
                   Name, iWorst, PedRMSworst, PedRMSmean, PedRMSworst, PedRMSbest);
            for (int i=0;i<nSlice;i++) {
              if (time[i]<PedWindow1[iWorst] && time[i]>=PedWindow0[iWorst]) {
                printf("        %3d, t=%6.1f Raw=%.1f A=%.1f\n", i, time[i], raw[i], amp1[i]); 
	      }
	    }
	  }
          GoodPedWindow[iWorst]=false;
          NGoodWindows--;
          if (NGoodWindows==0) return 0;
        }
      }

      if (ReportMode==10003 || Dbg) {
        for (int i=0; i<NPedWindows; i++) {
	  printf("         PedWindow#%d Samples=%d RMS=%.2f Status=%d\n",
	          i, PedSamples[i], PedRMS[i], GoodPedWindow[i]);
        }
        printf("[Signal->CleanPedestalWindows]  %s %d good windows of %d, PedRMS=%.2f\n\n",
	       Name, NGoodWindows, NPedWindows, PedRMSmean); 
      }
    } else {
      NGoodWindows=NPedWindows;
    }

    FirstGoodWindow=-1;
    int iSample=0;
    for (int iw=0;iw<NPedWindows;iw++) {
      if (GoodPedWindow[iw]) {
        if (FirstGoodWindow==-1) FirstGoodWindow=iw; 
        while (time[iSample]<PedWindow1[iw] && iSample<nSlice) {
          if (time[iSample]>PedWindow0[iw]) GoodWindowNoise->Fill(raw[iSample]-PedAverage[iw]);
          iSample++;
        }
      }
    }

    SetNoisePointByPoint();

    if (Dbg || ReportMode==10003) {
      printf("[Signal->CleanPedestalWindows]  %s **Finised** noise is set\n\n", Name);
      ReportMode=ProcStatus->WhatToDo("[Signal->CleanPedestalWindows]", 3); 
    }
    //Dbg=false;
    return NGoodWindows;
    
  }

  void SetNoisePointByPoint() {
    int iw=0;
    bool NegativeStart=true;
    double RMS=PedRMSmean;
    double RMSmin=0.2+0.3*iGain;

    if (RMS<RMSmin) RMS=RMSmin;

    for (int i=0;i<nSlice;i++) {
      // take care of some bad fit-hostile cases here //
      if (NegativeStart && 
          amp1[i]<-3.0*RMS &&
          time[i]<PedWindow0[FirstGoodWindow]) { //exclude  negative tail of t<0 signal
        if (Dbg) printf("******[SetNoisepointByPoint] %s sample#%3d doFit dropped ********\n", Name, i);
	doFit[i]=false;
      } else {
	NegativeStart=false;
      }

      if (iw<NPedWindows) {
        if (time[i]>PedWindow0[iw]) { // get new noise value ?       
	  if (GoodPedWindow[iw]) { // ok, grab noise from current window
            RMS=PedRMS[iw];
	  }
          iw++;                 // point to next window    
	}
      }
      if (RMS<RMSmin) RMS=RMSmin;
      err2[i]=RMS;
    }
  }

  bool OverflowDetected(double thr) { 
    for (int i=0; i<nSlice; i++) {
      //if (amp1[i]>thr || amp1[i]<-0.32*thr || raw[i]>3800 || raw[i]<100) return true;
      if (amp1[i]>thr || raw[i]>3900 || raw[i]<50) return true;
    }
    return false;
  }

  void SubtractPedestals() {
    // subtracts pedestals from Short signals and applies SignalCorrection
    // creates amp1[] from raw[]

    Dbg=false;
    FirstGoodWindow=-1;
    PedMean=0.0;
    PedRMSmean=0.0;
    AmpMax=-10000.0;
    AmpMin=10000.0;
    AmpMax0=-10000.0;
    AmpMin0=10000.0;
    if (Dbg) printf("[Signal->SubtractPedestals] %s ->pedestal Subtraction Nwin=%d Ngood=%d ", 
                    Name, NPedWindows, NGoodWindows);
    if (iMod==5 && iChan==2 && iGain==0) {// LG RF, pedestal is already subtracted //
      PedMean=0.;
      PedRMSmean=0.;      
    } else {
      if (EmptyEventPedestalSet) {
        PedMean=EmptyEventPedestal;
        PedRMSmean=EmptyEventNoise;   
      } else {
        PedMean=0.;
        PedRMSmean=0.;   
      }
    }
    //Dbg=true;
    if (Dbg) printf("[TSignal->SubtractPedestals]  Channel %s -> Ped=%.1f RMS=%.2f\n", Name, PedMean, PedRMSmean);
    maxFuzz=0.0;
    for (int i=0;i<nSlice;i++) {  
      if (iMod!=5 || iChan!=2 || iGain!=0) {// for LG RF, pedestal is already subtracted //
        amp1[i]=SignalCorrection*(raw[i]-PedMean);  
        //if (i==0 && dumpIt) printf("[TSignal] point#5  amp1[0] set to %f\n", amp1[i]);
        ampX[i]=0.0;      
      }
      if (i>1) { /// here we are looking for irregular amplitude fluctuation typical for clones
        double fuzz=fabs(amp1[i]-2.0*amp1[i-1]+amp1[i-2])/
                    (100.+fabs(amp1[i])+fabs(amp1[i-1])+fabs(amp1[i-2]));
        if (fuzz>maxFuzz) maxFuzz=fuzz;
      }
      amp2[i]=amp1[i];  
      ampF[i]=amp1[i];  
      if (amp1[i]+2.0*PedRMSmean>AmpMax) AmpMax=amp1[i]+2.0*PedRMSmean;
      if (amp1[i]-2.0*PedRMSmean<AmpMin) AmpMin=amp1[i]-2.0*PedRMSmean;
      if (amp1[i]>AmpMax0) AmpMax0=amp1[i];
      if (amp1[i]<AmpMin0) AmpMin0=amp1[i];
      //if (Dbg) printf("[TSignal->SubtractPedestals]    %3d a=%.1f\t min=%.1f\t max=%.1f\n",
      //                i, amp1[i], AmpMax0, AmpMin0);
    }
    if (Dbg) printf("[TSignal->SubtractPedestals] %s maxFuzz=%f\n", Name, maxFuzz);
    
    Dbg=false;
  }

  void SetGraph() {
    //Dbg=true;
    if (Dbg) printf("[Signal->SetGraph] %s, setting Pulse Shape witn %d slices, Noise=%.3f\n",
		    Name,  nSlice, PedRMSmean);
    if (Status) {
      signalShape->Set(nSlice);
      residualShape->Set(nSlice);
      previousShape->Set(nSlice);
      for (int i=0;i<nSlice;i++) {
        signalShape->SetPoint(i, time[i], amp1[i]);
        signalShape->SetPointError(i, 0., PedRMSmean);
        previousShape->SetPoint(i, time[i], amp3[i]);
        previousShape->SetPointError(i, 0., PedRMSmean);
        if (Dbg && i<5) printf("[Signal->SetGraph]  %3d t=%6.1f A=%6.1f noise=%f\n", 
                               i, time[i], amp1[i], PedRMSmean); 
      }
    }
    //Dbg=false;
  }
  
  TGraphErrors* GetGraph() {
    return ((TSignal*)this)->signalShape;
  }
  TGraphErrors* GetGraphOld() {
    return ((TSignal*)this)->previousShape;
  }
  TGraphErrors* GetGraphResidual() {
    return ((TSignal*)this)->residualShape;
  }

  void DrawGraphFit(int N) {
    signalFit[N].Draw("LPZz same");
  }

  void ClearPulseShape() {
    pulse1Drelative->Reset();
    //pulse2d->Reset();
    pulseShape->Reset();
    pulseShapeA->Reset();
    for (int i=0;i<nShapeI;i++) pulseShapeI[i].Reset();
    PeakAverage1=0.0;
    PeakAverage0=0.0;    
    ZeroAverage1=0.0;
    ZeroAverage0=0.0;    
  }


  void ClearPulseShapeSplit() {
    for (int i=0;i<nShapeSplit;i++) {
      pulseShapeSplit[i].Reset();
      SelectedSplit->Reset();
      splitRate[i]=0.0;
      splitSum[i]=0.0;
    }
  }

  void SavePulseShapeSplit() {
    std::ofstream ShapeFile;
    char FileName[100];
    //printf("[TSignal->SavePulseShapeSplit] %s", Name);
    sprintf(FileName,"../pulses2009/Split_run%d_mod%d_chan%d_gain%d_delay%d", 
            ProcStatus->GetEventHeader()->run, iMod, iChan, iGain, iDelay);
    ShapeFile.open(FileName, ios::out);
    ShapeFile << nShapeSplit << "\n";
    for (int i=0;i<nShapeSplit;i++) {
      //printf("[TSignal->SavePulseShapeSplit] saving Split Shape for %s, bin#%d\n", Name, i);
      ShapeFile << i << " " << pulseShapeSplit[i].GetNbinsX() << "\n";
      for (int ib=1; ib<=pulseShapeSplit[i].GetNbinsX(); ib++) {
        ShapeFile << ib << " " << pulseShapeSplit[i].GetBinCenter(ib)  << " " 
                               << pulseShapeSplit[i].GetBinContent(ib) << " " 
                               << pulseShapeSplit[i].GetBinError(ib)   << " " 
                               << pulseShapeSplit[i].GetBinEntries(ib) << "\n"; 
      }
    }
    ShapeFile.close();
  }




  double GetPeakAverage() {
    if (PeakAverage0==0.0) return 0.0;
    else                   return PeakAverage1/PeakAverage0;
  }

  double GetZeroAverage() {
    if (ZeroAverage0==0.0) return 0.0;
    else                   return ZeroAverage1/ZeroAverage0;
  }

  //TH2F* GetPulseShape2D() {
 //   return pulse2d;
 // }

  TH1D* GetPulse1Drelative() {
    return pulse1Drelative;
  }

  TH2F* GetSelectSplit() {
    return SelectedSplit;
  }

  int GetNshapeI() {return nShapeI;}
  int GetNshapeSplit() {return nShapeSplit;}


  TProfile* GetPulseShape() {
    return pulseShape;
  }

  TProfile* GetPulseShapeA() {
    return ((TSignal*)this)->pulseShapeA;
  }

  TProfile* GetPulseShapeProfileI(int iBin) {
    return &pulseShapeI[iBin];
  }

  TProfile* GetPulseShapeProfileSplit(int iBin) {
    return &pulseShapeSplit[iBin];
  }

  double GetSplitRate(int iBin) {
    if (iBin<0 || iBin>=nShapeSplit) return 0;
    else return splitRate[iBin];
  }

  double GetSplitSum(int iBin) {
    if (iBin<0 || iBin>=nShapeSplit) return 0;
    else return splitSum[iBin];
  }


  TF1 * GetFunc1() {return pulseFunc1;}
  TF1 * GetFunc2() {return pulseFunc2;}


  void Dump(double Tbunch, int bunch) {

    std::ofstream dumpFile;
    char dumpName[200];
    char dumpTime[200];
    int i1=(int)((Tbunch+Tshape0)/dTsample-10.);
    if (i1<0) i1=0;
    int i2=(int)((Tbunch+Tshape1)/dTsample+10.);
    if (i2>nSlice-1) i2=nSlice-1;
    EventHeader *EH = ProcStatus->GetEventHeader();
    sprintf(dumpName,"dump/%s_run_%04d_spill_%04d_event_%05d_%03d_bunch_%d.dump",
            Name, ProcStatus->GetRun(), EH->burst, EH->event, EH->burstEvent, bunch);
    for (int i=0; i<200; i++) {
      if (dumpName[i]==' ') dumpName[i]='_';
      if (dumpName[i]=='=') dumpName[i]='_';
      if (dumpName[i]=='#') dumpName[i]='_';
    }
    dumpFile.open(dumpName);
    dumpFile << ProcStatus->GetRun() << " " << EH->burst << " " << EH->event << " " << EH->burstEvent << " " 
             << ProcStatus->GetNbunches() << " " << bunch << endl;
    sprintf(dumpTime,"%.2f, %.2f", time[i1], time[i1+1]);
    dumpFile << dumpTime << endl;
    dumpFile << i1 << " " << i2 << endl;
    for (int i=i1; i<i2; i++) {
      dumpFile << amp1[i] << endl;
    }    
    dumpFile.close();
    return;
  }

  void FillPulseShapeA(double Tbunch) {

    //if (!GoodNoiseConditions(Tbunch)) return;

    int i1=(int)((Tbunch+Tshape0)/dTsample-10.);
    if (i1<0) i1=0;
    int i2=(int)((Tbunch+Tshape1)/dTsample+10.);
    if (i2>nSlice-1) i2=nSlice-1;
    for (int i=i1; i<i2; i++) {
      if (raw[i]>3900 || raw[i]<50) return;  // do not fill pulses with over/under-flow !
      if (iMod<4 ) {
        if (iGain==0 && amp1[i]>1500.) return;
        if (iGain==1 && amp1[i]>1500.) return;
      } else {
        if (amp1[i]>2200.) return;
      }
    }
    for (int i=i1; i<i2; i++) {
      pulseShapeA->Fill(time[i]-Tbunch, amp1[i]);
    }
    return;
  }

  void FillPulseShapeI(double Tbunch, double Cherenkov, double CherIntegral, double BeamIntensityLog, double HighLowSwitch) {

    //if (!GoodNoiseConditions(Tbunch)) return;

    int i1=(int)((Tbunch+Tshape0)/dTsample-10.);
    int i2=(int)((Tbunch+Tshape1)/dTsample+10.);
    double Apeak=-1000.;
    for (int i=i1; i<i2; i++) if (amp1[i]>Apeak) Apeak=amp1[i];

    if (iMod<4 && Apeak<HighLowSwitch) {
      int iBin = (int)(10*CherIntegral/BeamIntensityLog);
      accRate0[iBin]+=1.0;
      accRate1[iBin]+=CherIntegral;
      if (iBin<0) iBin=0;
      else if (iBin>19) iBin=19;
      for (int i=i1; i<i2; i++) {
        pulseShapeI[iBin].Fill(time[i]-Tbunch+20., amp1[i]/Cherenkov);
      }
    }
  }  
  
  void FillPulseShapeSplit(double Tbunch) {
    
    //if (!GoodNoiseConditions(Tbunch)) return;

    int i1=(int)((Tbunch+Tshape0)/dTsample-10.);
    int i2=(int)((Tbunch+Tshape2)/dTsample+10.);
    if (i1<0) i1=0;
    if (i2>nSlice) i2=nSlice;

    //if (iChan==0 && iMod==1) printf("[FillPulseShapeSplit] %s\t\t Tbunch=%6.1f i1=%3d i2=%3d \n", Name, Tbunch, i1, i2);

    double Apeak=-1000.;
    double lMax=0.;
    int iPeak=0;
    double Adip=1000.;
    double lMin=5000.;
    int iDip=0;
    for (int i=i1; i<i2; i++) {
      if (raw[i]>3900) return; // exclude overflows
      if (raw[i]<50)   return; // exclude underflows
      if (time[i]-Tbunch<40. && time[i]-Tbunch>-40.) {
        double s=0;
        int i1a=i-1;
        if (i1a<0) i1a=0;
        int i2a=i1a+3;
        if (i2a>nSlice) {i2a=nSlice; i1a=i2a-3;}
        for (int j=i1a; j<i2a; j++) s+=amp1[j];
        if (s>Apeak) {Apeak=s; iPeak=i;}
        if (s<Adip)  {Adip=s; iDip=i;}
        if (raw[i]>lMax) lMax=raw[i];
        if (raw[i]<lMin) lMin=raw[i];
      }
    }


    Apeak=amp1[iPeak];

    for (int ib=0;ib<25;ib++) {
      if (-50.<Tbunch-Tfit[ib] && Tbunch-Tfit[ib]<50.) Apeak=Afit[ib];
    }
    int iBin=(int) (Apeak*nShapeSplit/3000);
    //if (iChan==0 && iMod==1) printf("[FillPulseShapeSplit]        ipeak=%3d Apeak=%.1f -> bin=%d\n", iPeak, Apeak, iBin); 
    if (iBin<0) iBin=0;
    else if (iBin>=nShapeSplit) iBin=nShapeSplit-1;
    splitRate[iBin]+=1.0;
    splitSum[iBin]+=Apeak;
/*
    if (Apeak>100.) {
      printf("[TSignal->FillPulseShapeSplit] %s\t Tbunch=%.1f Apeak=%.1f Tpeak-Tbunch=%.1f\n",
           Name, Tbunch, Apeak, time[iPeak]-Tbunch);
    }
*/
    for (int i=i1; i<i2; i++) {
      pulseShapeSplit[iBin].Fill(time[i]-Tbunch, amp1[i]);
      if (iBin==8*(iGain+1)) {
        SelectedSplit->Fill(time[i]-Tbunch, amp1[i]);
      }
    }
  }  
  



  void FillPulseShapeX(double Tbunch, int bunch) {
    bool Dbg=false;

    if (EmptyEventNoise==0.0) return;

    if (Dbg) {
      printf("[TSignal->FillPulseShape] %s bunch#%d Tbunch=%.1f NoiseCondition=%d\n",
            Name, bunch, Tbunch, GoodNoiseConditions(Tbunch));
    }


    //if (!GoodNoiseConditions(Tbunch)) return;

    int i1=(int)((Tbunch+Tshape0)/dTsample-10.);
    int i2=(int)((Tbunch+Tshape2)/dTsample+10.);
    //int idiff=i2-i1;

    if (Dbg) {
      printf("[TSignal->FillPulseShape]               i1=%d i2=%d\n",
              i1, i2);
    }

    double ampMax=0.0;
    double ampMin=0.0;
    int iMax=-1, iMin=-1;
    bool Junk=false;
    if (i1<1) {
      i1=1;
      //i2=i1+idiff;
    }
    if (i2>nSlice-1) {
      i2=nSlice-1;
      //i1=i2-idiff;
    }
    if (Dbg) {
      printf("[TSignal->FillPulseShape]      adjusted i1=%d i2=%d\n", i1, i2);
    }

    for (int i=i1; i<i2; i++) {
      if (ampX[i]>ampMax && 
        time[i]<Tbunch+200. && 
        time[i]>Tbunch-50.) {
        ampMax=ampX[i]; 
        iMax=i;
      }
      if (ampX[i]<ampMin)  {
        ampMin=ampX[i]; 
        iMin=i;
      } 
      if (time[i]<Tbunch && time[i+1]>=Tbunch) {
        ZeroAverage0+=1.0;
        ZeroAverage1+=((Tbunch-time[i])*ampX[i+1]+(time[i+1]-Tbunch)*ampX[i])/dTsample;        
      }
    }

/*
    for (int i=i1; i<i2 && time[i]-Tbunch<-90. && !Junk; i++) {
      Junk=(amp1[i]>0.2*ampMax || amp1[i]<-0.2*ampMax); // check if there is no junk in front of pulse //
    }   
*/    
    if (Dbg) {
      printf("[TSignal->FillPulseShape]      ZeroAverage0=%.2f ZeroAverage1=%.2f\n", ZeroAverage0, ZeroAverage1);
    }


    PeakAverage1+=ampMax;
    PeakAverage0+=1.0;

    if (Dbg) {
      printf("[TSignal->FillPulseShape]      PeakAverage0=%.2f peakAverage1=%.2f\n", PeakAverage0, PeakAverage1);
    }

    if (ampMax<5.0*EmptyEventNoise || Junk) return; /* do nothing on low signals */

    
    if (iMod<4) { // calorimeters //
      if (ampMax>2500. || ampMin<-700.) return;
    } else if (iMod<6) { // beam //
      if (ampMax>2500. || ampMin<-700.) return;
    }
    
        

    if (ApMax[bunch]>10.0*EmptyEventNoise) {
      if ((iMod<4 && ApMax[bunch]<1500.) || (iMod>3 && iMod<6 && ApMax[bunch]<2200.)) {  
        if (ProcStatus->GetReportMode()==1 && Dbg) {
          printf("[TSignal->FillPulseShape] %s ApMax=%.1f PedRMSmean=%.2f\n",
                  Name, ApMax[bunch], EmptyEventNoise);
        }      
        for (int i=i1; i<i2; i++) {
          pulseShape->Fill(time[i]-TpMax[bunch], ampX[i]/ApMax[bunch]);
        }
      }
    }
  
    Dbg=false;
    
  }
  void FillPulseShape1(double Tbunch, int bunch) {
    bool Dbg=false;

    if (EmptyEventNoise==0.0) return;

    if (Dbg) {
      printf("[TSignal->FillPulseShape] %s bunch#%d Tbunch=%.1f NoiseCondition=%d\n",
            Name, bunch, Tbunch, GoodNoiseConditions(Tbunch));
    }


    //if (!GoodNoiseConditions(Tbunch)) return;

    int i1=(int)((Tbunch+Tshape0)/dTsample-10.);
    int i2=(int)((Tbunch+Tshape2)/dTsample+10.);
    //int idiff=i2-i1;

    if (Dbg) {
      printf("[TSignal->FillPulseShape]               i1=%d i2=%d\n",
              i1, i2);
    }

    double ampMax=0.0;
    double ampMin=0.0;
    int iMax=-1, iMin=-1;
    bool Junk=false;
    if (i1<1) {
      i1=1;
      //i2=i1+idiff;
    }
    if (i2>nSlice-1) {
      i2=nSlice-1;
      //i1=i2-idiff;
    }
    if (Dbg) {
      printf("[TSignal->FillPulseShape]      adjusted i1=%d i2=%d\n", i1, i2);
    }

    for (int i=i1; i<i2; i++) {
      if (amp1[i]>ampMax && 
        time[i]<Tbunch+100. && 
        time[i]>Tbunch-50.) {
        ampMax=amp1[i]; 
        iMax=i;
      }
      if (amp1[i]<ampMin)  {
        ampMin=amp1[i]; 
        iMin=i;
      } 
      if (time[i]<Tbunch && time[i+1]>=Tbunch) {
        ZeroAverage0+=1.0;
        ZeroAverage1+=((Tbunch-time[i])*amp1[i+1]+(time[i+1]-Tbunch)*amp1[i])/dTsample;        
      }
    }

/*
    for (int i=i1; i<i2 && time[i]-Tbunch<-90. && !Junk; i++) {
      Junk=(amp1[i]>0.2*ampMax || amp1[i]<-0.2*ampMax); // check if there is no junk in front of pulse //
    }   
*/    
    if (Dbg) {
      printf("[TSignal->FillPulseShape]      ZeroAverage0=%.2f ZeroAverage1=%.2f\n", ZeroAverage0, ZeroAverage1);
    }


    PeakAverage1+=ampMax;
    PeakAverage0+=1.0;

    if (Dbg) {
      printf("[TSignal->FillPulseShape]      PeakAverage0=%.2f peakAverage1=%.2f\n", PeakAverage0, PeakAverage1);
    }

    if (ampMax<5.0*EmptyEventNoise || Junk) return; /* do nothing on low signals */

    
    if (iMod<4) { // calorimeters //
      if (ampMax>2500. || ampMin<-700.) return;
    } else if (iMod<6) { // beam //
      if (ampMax>2500. || ampMin<-700.) return;
    }
    
        

    if (ApMax[bunch]>10.0*EmptyEventNoise) {
      if ((iMod<4 && ApMax[bunch]<1500.) || (iMod>3 && iMod<6 && ApMax[bunch]<2200.)) {  
        if (ProcStatus->GetReportMode()==1) {
          printf("[TChannel->FillPulseShape] %s ApMax=%.1f PedRMSmean=%.2f\n",
                  Name, ApMax[bunch], EmptyEventNoise);
        }      
        for (int i=i1; i<i2; i++) {
          pulseShape->Fill(time[i]-TpMax[bunch], amp1[i]/ApMax[bunch]);
        }
      }
    }
  
    Dbg=false;
    
  }


  void FillPulseShapeModule(double Tbunch, int bunch, TProfile* Demo) {
    bool Dbg=false;

    if (Dbg) {
      printf("[TSignal->FillPulseShapeModule] %s bunch#%d Tbunch=%.1f NoiseCondition=%d\n",
            Name, bunch, Tbunch, GoodNoiseConditions(Tbunch));
    }


    //if (!GoodNoiseConditions(Tbunch)) return;

    int i1=(int)((Tbunch+Tshape0)/dTsample-10.);
    int i2=(int)((Tbunch+Tshape2)/dTsample+10.);
    //int idiff=i2-i1;

    if (Dbg) {
      printf("[TSignal->FillPulseShapeModule]               i1=%d i2=%d\n",
              i1, i2);
    }

    double ampMax=0.0;
    double ampMin=0.0;
    int iMax=-1, iMin=-1;
    bool Junk=false;
    if (i1<1) {
      i1=1;
      //i2=i1+idiff;
    }
    if (i2>nSlice-1) {
      i2=nSlice-1;
      //i1=i2-idiff;
    }
    if (Dbg) {
      printf("[TSignal->FillPulseShapeModule]      adjusted i1=%d i2=%d\n", i1, i2);
    }

    for (int i=i1; i<i2; i++) {
      if (amp1[i]>ampMax && 
        time[i]<Tbunch+100. && 
        time[i]>Tbunch-50.) {
        ampMax=amp1[i]; 
        iMax=i;
      }
      if (amp1[i]<ampMin)  {
        ampMin=amp1[i]; 
        iMin=i;
      } 
      if (time[i]<Tbunch && time[i+1]>=Tbunch) {
        ZeroAverage0+=1.0;
        ZeroAverage1+=((Tbunch-time[i])*amp1[i+1]+(time[i+1]-Tbunch)*amp1[i])/dTsample;        
      }
    }

/*
    for (int i=i1; i<i2 && time[i]-Tbunch<-90. && !Junk; i++) {
      Junk=(amp1[i]>0.2*ampMax || amp1[i]<-0.2*ampMax); // check if there is no junk in front of pulse //
    }   
*/    
    if (Dbg) {
      printf("[TSignal->FillPulseShapeModule]      ZeroAverage0=%.2f ZeroAverage1=%.2f\n", ZeroAverage0, ZeroAverage1);
    }


    PeakAverage1+=ampMax;
    PeakAverage0+=1.0;

    if (Dbg) {
      printf("[TSignal->FillPulseShapeModule]      PeakAverage0=%.2f peakAverage1=%.2f\n", PeakAverage0, PeakAverage1);
    }

    if (ampMax<5.0*PedRMSmean || Junk) return; /* do nothing on low signals */

    
    if (iMod<4) { // calorimeters //
      if (ampMax>2500. || ampMin<-700.) return;
    } else if (iMod<6) { // beam //
      if (ampMax>2500. || ampMin<-700.) return;
    }
    

    if (ApMax[bunch]>10.0*PedRMSmean) {
      if ((iMod<4 && ApMax[bunch]<1500.) || (iMod>3 && iMod<6 && ApMax[bunch]<2200.)) {        
        for (int i=i1; i<i2; i++) {
          pulseShape->Fill(time[i]-TpMax[bunch], amp1[i]/ApMax[bunch]);
          //Demo->Fill(time[i]-TpMax[bunch], amp1[i]/ApMax[bunch]);
          Demo->Fill(time[i]-Tbunch, amp1[i]/ApMax[bunch]);
        }
      }
    }
  
    Dbg=false;
    
  }

  
  
  double GetAccRate0(int iBin) {return accRate0[iBin];}
  double GetAccRate1(int iBin) {return accRate1[iBin];}
  double GetTpar(int bunch) {return Tpar[bunch];}
  double GetApar(int bunch) {return Apar[bunch];}

  void RecoverScintInput() {
    bool Dbg=true;
    EventHeader *EH = ProcStatus->GetEventHeader();
    double Tb=-100.;
    double chi2old=0.;
    double chi2new=0.;
    int irMax=0;
    for (int ip=0; ip<181; ip++) {
      bunchPar[ip]=0.;
      bunchParStep[ip]=0.;
    }
    bunchPar[180]=RC;
    bunchParStep[180]=10.;
    double T0=EH->GetTimeGlobal();
    double Trf=EH->GetRFperiod();

//    for (int ir=0; Tb<6200.+Trf; ir++) { // add one RF cycle after the event
    for (int ir=0; Tb<6300.; ir++) {
//      Tb=T0+(ir-1.0)*Trf; // add one RF cycle before the event
      Tb=T0+ir*Trf; //
      bunchPar[ir]=Tb;
      bunchPar[45+ir]=40.;
      bunchPar[90+ir]=1000.;
      bunchPar[135+ir]=0.;
      bunchParStep[ir]=3.;
      bunchParStep[45+ir]=30.;
      bunchParStep[90+ir]=500.;
      bunchParStep[135+ir]=100.;
      if (Dbg) printf("[TSignal->RecoverInput] %s RF cycle #%2d T0=%.1f\n", Name, ir, bunchPar[ir]);
      irMax=ir;
    }
    irMax++; // number of RF cycles to study
    if (Dbg) printf("[TSignal->RecoverInput] %s parameters set for %d RF cycles\n", Name, irMax);

    chi2old=0.;
    for (int i=0; i<7000; i++) {
      aIn1ns[i]=0.0;
      aOut1ns[i]=0.0;
    }
    for (int ir=0; ir<irMax; ir++) {
      //int i0=int(bunchPar[ir]+Trf+0.5)-10;
      //int i1=int(bunchPar[ir]+bunchPar[45+ir]+Trf+0.5)+10;
      int i0=int(bunchPar[ir]+0.5)-10;
      int i1=int(bunchPar[ir]+bunchPar[45+ir]+0.5)+10;
      if (i0<0) i0=0;
      if (i1>6300) i1=6300;
      //if (Dbg) printf("[TSignal->RecoverInput] RF cycle #%2d T0=%.1f\t i0=%4d i1=%4d\n", ir, bunchPar[ir], i0, i1); 
      for (int i=i0; i<i1; i++) {
        //if (Dbg && ir<3) printf("[TSignal->RecoverInput] filling the RF cycle #%2d i=%4d T0=%7.1f T1=%7.1f\n",
        //                        ir, i, bunchPar[ir], bunchPar[ir]+bunchPar[45+ir]);
        if (i>=bunchPar[ir] && i<=bunchPar[ir]+bunchPar[45+ir]) {
          aIn1ns[i]=bunchPar[90+ir]*(bunchPar[ir]+bunchPar[45+ir]-i)+
                    bunchPar[135+ir]*(i-bunchPar[ir]);
          aIn1ns[i]/=bunchPar[45+ir];
        }
      }
    }
    for (int i=0; i<7000; i++) {
      aInSave[i]=aIn1ns[i];
    }
    RC=bunchPar[180];
    int n=7000;
    double dt=1.0;
    doRC2CR(n, dt, RC, aIn1ns, aOut1ns);
    if (Dbg) {
      for (int i=0; i<7000; i++) {
        if (i<200) printf("i=%4d aIn=%7.1f\t aOut=%7.1f\n", i, aInSave[i], aOut1ns[i]);
      }
    }
    for (int is=0; is<nSlice; is++) {
      int it=int(0.5+time[is]);
      if (it<0) continue;
      double dd=amp1[is]-aOut1ns[it];
      //if (Dbg) rintf("is=%3d it=%4d amp1=%.1f\t fit=%.1f dd=%.1f chi2old=%f\n", 
      //                is, it, amp1[is], aOut1ns[it], dd, chi2old);
      chi2old+=dd*dd;
    }
    chi2old/=EmptyEventNoise*EmptyEventNoise;
    if (Dbg) printf("[TSignal->RecoverInput] %s chi2old=%f\n", Name, chi2old);
    //exit(-1);


    int nLoop=1000;
    int iLoop=0;
    int iqq=1;
    while (iLoop<nLoop && iqq==1) {
      double stepSum=0.;
      for (int ip=0; ip<181; ip++) {
        if (bunchParStep[ip]==0.) continue;
        double parNew=bunchPar[ip]+bunchParStep[ip];
        if (ip>44 && ip<90) {
          if (parNew<25.) {// this is pulse width, shall be >15ns and <100ns!
            parNew=25.;
            bunchParStep[ip]*=-0.7;
          } else if (parNew>100.) {
            parNew=100.;
            bunchParStep[ip]*=-0.7;
          }
        } else if (ip>89) {
          if (parNew<-5.*EmptyEventNoise) {// this is pulse height, shall be >0!
            parNew=-5.*EmptyEventNoise;
            bunchParStep[ip]*=-0.7;
          }
        }
        stepSum+=bunchParStep[ip]*bunchParStep[ip];
        double parOld=bunchPar[ip];
        bunchPar[ip]=parNew;
        chi2new=0.0;
        for (int i=0; i<7000; i++) {
          aIn1ns[i]=0.0;
          aOut1ns[i]=0.0;
        }
        for (int ir=0; ir<irMax && bunchPar[ir]<6300; ir++) {
          //int i0=int(bunchPar[ir]+0.5+Trf)-10;
          //int i1=int(bunchPar[ir]+bunchPar[45+ir]+0.5+Trf)+10;
          int i0=int(bunchPar[ir]+0.5)-10;
          int i1=int(bunchPar[ir]+bunchPar[45+ir]+0.5)+10;
          if (i0<0) i0=0;
          if (i1>6300) i1=6300;
          for (int i=i0; i<i1; i++) {
            if (i>=bunchPar[ir] && i<=bunchPar[ir]+bunchPar[45+ir]) {
              aIn1ns[i]=bunchPar[90+ir]*(bunchPar[ir]+bunchPar[45+ir]-i)+
                        bunchPar[135+ir]*(i-bunchPar[ir]);
              aIn1ns[i]/=bunchPar[45+ir];
            }
          }
        }
        for (int i=0; i<7000; i++) {
          aInSave[i]=aIn1ns[i];
        }
        RC=bunchPar[180];
        n=7000;
        dt=1.0;
        doRC2CR(n, dt, RC, aIn1ns, aOut1ns);
        for (int is=0; is<nSlice; is++) {
          int it=int(0.5+time[is]);
          if (it<0) continue;
          double dd=amp1[is]-aOut1ns[it];
          chi2new+=dd*dd;
        }
        chi2new/=EmptyEventNoise*EmptyEventNoise;
        //if (Dbg) printf("[TSignal->RecoverInput] ip=%d chi2new=%f ", ip, chi2new);
        if (chi2new<chi2old) {
          chi2old=chi2new;
          bunchParStep[ip]*=1.1; 
          //if (Dbg) printf("moving\n");
        } else { // resore old parameter and reverse step
          bunchParStep[ip]*=-0.7; 
          bunchPar[ip]=parOld;
          //if (Dbg) printf("-\n");
        }        
      }

      if (Dbg) {
        printf("[TSignal->RecoverInput] Display-> chi2=%f step=%f\n", chi2old, stepSum);
        TCanvas *PulseParamCanvas = new TCanvas("PulseParamCanvas1", "Pulse Fit", 0, 0, 1600, 1200);
        TH1F  *dummySignal = new TH1F(Name, Name, 2000, time[0]-100., time[nSlice-1]+100.);
        TLine *localLine = new TLine();
        PulseParamCanvas->cd(0);
        dummySignal->Draw();

        for (int i=0; i<7000; i++) {
          aIn1ns[i]=0.0;
          aOut1ns[i]=0.0;
        }
        for (int ir=0; ir<irMax; ir++) {
          //int i0=int(bunchPar[ir]+0.5+Trf)-10;
          //int i1=int(bunchPar[ir]+bunchPar[45+ir]+0.5+Trf)+10;
          int i0=int(bunchPar[ir]+0.5)-10;
          int i1=int(bunchPar[ir]+bunchPar[45+ir]+0.5)+10;
          if (i0<0) i0=0;
          if (i1>6300) i1=6300;
          for (int i=i0; i<i1; i++) {
            if (i>=bunchPar[ir] && i<=bunchPar[ir]+bunchPar[45+ir]) {
              aIn1ns[i]=bunchPar[90+ir]*(bunchPar[ir]+bunchPar[45+ir]-i)+
                        bunchPar[135+ir]*(i-bunchPar[ir]);
              aIn1ns[i]/=bunchPar[45+ir];
            }
          }
        }
        for (int i=0; i<7000; i++) {
          aInSave[i]=aIn1ns[i];
        }
        RC=bunchPar[180];
        sprintf(Title, "%s iter#%d RC=%.1fns", Name, iLoop, RC);
        n=7000;
        dt=1.0;
        doRC2CR(n, dt, RC, aIn1ns, aOut1ns);


        double ama=0.;
        double ami=0.;
        localLine->SetLineWidth(2);
        localLine->SetLineColor(kBlack);
        for (int is=1; is<nSlice; is++) {
          localLine->DrawLine(time[is-1], amp1[is-1], time[is], amp1[is]);
          if (amp1[is]>ama) ama=amp1[is];
          if (amp1[is]<ami) ami=amp1[is];
        }
        localLine->SetLineColor(kRed);
        double a=0.;
        for (int is=1; is<nSlice; is++) {
          int it=int(0.5+time[is]);
          localLine->DrawLine(time[is-1], a, time[is], aOut1ns[it]);
          a=aOut1ns[it];
          if (a>ama) ama=a;
          if (a<ami) ami=a;
        }
        localLine->SetLineColor(kBlue);
        a=0.;
        double w=RC/10.;
        for (int ir=1; ir<irMax && bunchPar[ir]<6300.; ir++) {
          localLine->DrawLine(bunchPar[ir],                 0.,                 bunchPar[ir],                 bunchPar[90+ir]/w);
          localLine->DrawLine(bunchPar[ir],                 bunchPar[90+ir]/w,  bunchPar[ir]+bunchPar[45+ir], bunchPar[135+ir]/w);
          localLine->DrawLine(bunchPar[ir]+bunchPar[45+ir], bunchPar[135+ir]/w, bunchPar[ir]+bunchPar[45+ir], 0.);
          if (bunchPar[90+ir]/w>ama  && bunchPar[ir]<6300.) ama=bunchPar[90+ir]/w;
          if (bunchPar[135+ir]/w>ama && bunchPar[ir]<6300.) ama=bunchPar[135+ir]/w;
        }
        
        double Tb=-100.;
        localLine->SetLineStyle(2);
        localLine->SetLineColor(kBlack);
        localLine->SetLineWidth(1);
        for (int ir=0; Tb<6200.; ir++) {
          Tb=EH->GetTimeGlobal()+ir*EH->GetRFperiod();
          localLine->DrawLine(Tb, ami, Tb, ama);
        }

        dummySignal->GetYaxis()->SetRangeUser(ami, ama);
        dummySignal->SetTitle(Title); 
        PulseParamCanvas->Update();
        PulseParamCanvas->Show();
        printf("Push!");
        cin>>iqq;
        if (iqq==-1) {
          ProcStatus->SetReportMode(-1);
        } else if (iqq==0) {
          exit(-1);
        } else {
          PulseParamCanvas->Close();
          dummySignal->Delete(); 
          localLine->Delete();         
        }
      }
      iLoop++;
    }

    
  }

  void FindPulseParams(double Tbunch, int bunch) {
    printf("[TSignal->FindPulseParams2012]-> bunch#%d, Tbunch=%.1fns\n", bunch, Tbunch);
// version of 2012-04-08, using average of 3 samples near the bunch 'peak' 
// at TbunchBeam to find Module's response!
  }

  void FindPulseParams2010(double TbunchIN, int bunch) {
//
// 2010-08-03 corrected search for peak - start from 1 not 0 to avoid bad parabola problem
//
    Dbg=false;
    double Tbunch=TbunchIN+50.0; // shift to the ~peak

    EventHeader *EH = ProcStatus->GetEventHeader();
    int ReportMode  = ProcStatus->GetReportMode();

    if (Dbg || ReportMode==10024) {
      printf("\n[Signal->FindPulseParams2010] %s -- T=%.1f bunch#%d Status=%d\n",
              Name, Tbunch, bunch, Status);
    }
    T0halfMax[bunch]=-10000.;
    T1halfMax[bunch]=-10000.; 
    T0halfMin[bunch]=0.; 
    T1halfMin[bunch]=0.; 
    T0cross[bunch]=0.;
    T0foot[bunch]=0.;
    maxLocal[bunch]=-100000.;
    minLocal[bunch]=100000.;
    iMax[bunch]=0;
    iMin[bunch]=0;
    goodParab[bunch]=true;
    ApMax[bunch]=0.0;
    Sum8[bunch]=0.0;

    if (Tbunch>6100.) { // do not bother with late bunch!
      goodParab[bunch]=false;
      return;
    }
    Dbg=false;
// compute sum of samples within +/-Xns around the peak    
    int i0=int(2.0*(Tbunch-50.)/(time[2]-time[0]));
    if (i0<0) i0=0;
    int nAdd=0;
    if (Dbg && iMod==3) printf("[TSignal->Sum8 computation] %s Tbunch=%.1f\n", Name, Tbunch); 

    for (int i=i0; i<nSlice-1 && time[i]<Tbunch+200.0; i++) {
      if (time[i]>Tbunch-75.0) {
        if (Dbg && iMod==3) printf("    t[%d]=%.1f Amp1=%.1f\n", i, time[i], amp1[i]);
        Sum8[bunch]+=amp1[i]; 
        nAdd++;
      }
      if (time[i]>Tbunch+200.0) break;
    }

    if (Dbg && iMod==3) printf("    Sum8=%.1f\n\n", Sum8[bunch]);

    Dbg=false;
// parabola fit and other exercices

    double t1=Tbunch+1200., t0=Tbunch-300.;

    i0=int(2.0*(t0-25.)/(time[2]-time[0]));
    if (i0<1) i0=1; // 2010-08-03
    int i2=0; // last sample of signal
    int iB=0; // last sample of baseline
    double sT=0.0;
    double sA=0.0;
    double wT=0.0;
    for (int i=i0; i<nSlice-1 && time[i]<t1; i++) {
      i2=i;
      if (time[i]<TbunchIN) {
        iB=i;
        wT+=1.0;
        sT+=time[i];
        sA+=amp1[i];
      }
    }    
    i0bunch[bunch]=i0;
    i1bunch[bunch]=i2;
//--> linear fit of the baseline <---
    T0baseline[bunch]=sT/wT;
    A0baseline[bunch]=sA/wT;
    sT=0.0;
    sA=0.0;
    for (int i=i0; i<=iB; i++) {
      double dT=time[i]-T0baseline[bunch];
      double AT=amp1[i]*dT;
      sT+=dT*dT;
      sA+=AT;
    }
    SLbaseline[bunch]=sA/sT;
    for (int i=i0; i<=i2; i++) {
      ampX[i]=amp1[i]-(A0baseline[bunch]+SLbaseline[bunch]*(time[i]-T0baseline[bunch]));
    }    

    for (int i=i0; i<=i2; i++) {
      if (ampX[i]>maxLocal[bunch] && 
          time[i]>Tbunch-75. && 
          time[i]<Tbunch+275.) {
        maxLocal[bunch]=ampX[i]; 
        iMax[bunch]=i;}
    }
    iMin[bunch]=iMax[bunch]+1;
    for (int i=iMax[bunch]; i<=i2; i++) {
      if (ampX[i]<minLocal[bunch]) {
        minLocal[bunch]=ampX[i]; iMin[bunch]=i;
      }
    }
    tMaxLocal[bunch]=time[iMax[bunch]];
    tMinLocal[bunch]=time[iMin[bunch]];

    Underflow[bunch]=(raw[iMin[bunch]]<25);
    Overflow[bunch]=(raw[iMax[bunch]]>3800);
    //if (Underflow[bunch] || Overflow[bunch]) goodParab[bunch]=false;
    if (Overflow[bunch]) goodParab[bunch]=false;

    if (Dbg || ReportMode==10024) {
      printf("[Signal->FindPulseParams2010]     iMax=%d Amax=%.1f iMin=%d Amin=%.1f\n", 
               iMax[bunch], maxLocal[bunch], iMin[bunch], minLocal[bunch]);
    }
    ApMax[bunch]=parabAA(ampX[iMax[bunch]-1], ampX[iMax[bunch]], ampX[iMax[bunch]+1]);
    if (Dbg) printf("[Signal->FindPulseParams2010]      a1=%.1f a2=%.1f a3=%.1f Parabola Curv=%.1f\n",
                    ampX[iMax[bunch]-1], ampX[iMax[bunch]], ampX[iMax[bunch]+1], ApMax[bunch]);
    if (ApMax[bunch]>=0.0) goodParab[bunch]=false; // max parabola is wrong!
/*
    cout << "calling parabNew for MAX -> " << Name << " " <<
                       time[iMax[bunch]-1] << " " << amp1[iMax[bunch]-1]  << " " << 
                       time[iMax[bunch]]  << " " <<    amp1[iMax[bunch]]  << " " << 
                       time[iMax[bunch]+1]  << " " <<  amp1[iMax[bunch]+1]  << " " << 
                       iMax[bunch]  << " " <<  bunch << endl;
*/
    bool ok = parabNew(time[iMax[bunch]-1], ampX[iMax[bunch]-1],
                       time[iMax[bunch]],   ampX[iMax[bunch]],
                       time[iMax[bunch]+1], ampX[iMax[bunch]+1],
                       iMax[bunch], bunch);
    //printf("%10s bunch#%d old T=%.1f A=%.1f ", Name, bunch, Tpar[bunch], Apar[bunch]);  
    //ok = parab2011(Tbunch, bunch);
    //printf("       new T=%.1f A=%.1f\n", Tpar[bunch], Apar[bunch]);

    if (!ok) goodParab[bunch]=false;

    TpMax[bunch]=Tpar[bunch];
    ApMax[bunch]=Apar[bunch];
//////////
    if (TpMax[bunch]-TbunchIN>130. && 
        ApMax[bunch]>150. && 
        iMod<4) {
//      printf("[
//      ProcStatus->SetReportMode(1);
    }
//////////
    if (TpMax[bunch]-time[iMax[bunch]]>50.0 || TpMax[bunch]-time[iMax[bunch]]<-50.) goodParab[bunch]=false; // max parabola is too far from Maximum Bin;
    if (TpMax[bunch]-Tbunch>75.0 || TpMax[bunch]-Tbunch<-75.) goodParab[bunch]=false; // max parabola is too far from Bunch Estimation;


    ApMin[bunch]=parabAA(amp1[iMin[bunch]-1], amp1[iMin[bunch]], amp1[iMin[bunch]+1]);
    if (ApMin[bunch]<=0.0) goodParab[bunch]=false; // min parabola is wrong!
/*    cout << "calling parabNew for MIN -> " << Name << " " <<
                       time[iMin[bunch]-1] << " " << amp1[iMin[bunch]-1]  << " " << 
                       time[iMin[bunch]]  << " " <<    amp1[iMin[bunch]]  << " " << 
                       time[iMin[bunch]+1]  << " " <<  amp1[iMin[bunch]+1]  << " " << 
                       iMax[bunch]  << " " <<  bunch << endl;
*/
    ok = parabNew(time[iMin[bunch]-1],      -amp1[iMin[bunch]-1], // invert the parabola to match parabNew criteria
                       time[iMin[bunch]],   -amp1[iMin[bunch]],
                       time[iMin[bunch]+1], -amp1[iMin[bunch]+1],
                       iMin[bunch], bunch);    
    //if (!ok) goodParab[bunch]=false;

    TpMin[bunch]=Tpar[bunch];
    ApMin[bunch]=-Apar[bunch]; // invert the parabola back
    if (Dbg || ReportMode==10024) printf("[Signal->FindPulseParams2010]    Parabola Max=%.1f, Min=%.1f\n", ApMax[bunch], ApMin[bunch]);

    //Dbg=false;

    int ix0=0, ix1=0, iL=0, ix2=0;
    for (int i=i0; i<iMax[bunch]; i++) {
      if (ampX[i]<0.5*ApMax[bunch]) ix0=i;
      else break; 
    }
    if (ix0<1) ix0=1;
    for (int i=iMax[bunch]; i>i0; i--) {
      if (ampX[i]>0.5*ApMax[bunch]) ix1=i;
      else break; 
    }
    if (Dbg || ReportMode==10024) {
      printf("[Signal->FindPulseParams2010]   Interval for T0 half max ->(t[%d]=%.1f a=%.1f, t[%d]=%.1f a=%.1f)\n", 
         ix0, time[ix0], ampX[ix0], ix1, time[ix1], ampX[ix1]);
    }  
    T0halfMax[bunch]=time[ix1]*(0.5*ApMax[bunch]-ampX[ix0])+time[ix0]*(ampX[ix1]-0.5*ApMax[bunch]);
    T0halfMax[bunch]/=(ampX[ix1]-ampX[ix0]);

    double t11=0.5*(time[ix0]+time[ix0-1]);
    double a11=0.5*(ampX[ix0]+ampX[ix0-1]);
    //printf("     ix0=%d amp1[ix0]=%.1f amp1[ix0-1]=%.1f a11=%.1f\n",
    //       ix0, amp1[ix0], amp1[ix0-1], a11);
    if (a11==0.0) {
      T0foot[bunch]=t11;
    } else {
      double rat=0.5*ApMax[bunch]/a11;
      if (rat>1.0) {
        T0foot[bunch]=(t11*rat-T0halfMax[bunch])/(rat-1.0);
      } else {
        T0foot[bunch]=t11;
      }
    }

    ix0=0;
    ix1=0;
    for (int i=iMax[bunch]; i<iMin[bunch]; i++) {
      if (ampX[i]>0.) ix0=i;
      else break; 
    }
    for (int i=iMin[bunch]; i>ix0; i--) {
      if (ampX[i]<0) ix1=i; 
    }    
    T0cross[bunch]=-time[ix1]*ampX[ix0]+time[ix0]*ampX[ix1];
    T0cross[bunch]/=(ampX[ix1]-ampX[ix0]);

    ix0=0;
    ix1=0;
    for (int i=iMax[bunch]; i<nSlice && time[i]<T0cross[bunch]; i++) {
      if (ampX[i]>0.5*ApMax[bunch]) ix0=i;
      iL=i; 
    }
    if (Dbg || ReportMode==10024) {
      printf("[Signal->FindPulseParams2010] Last Sample after iMax=%d and A>0.5*Amax = t[%d]=%.1f\n", iMax[bunch], ix0, time[ix0]);
      printf("[Signal->FindPulseParams] Last sample before 0-crossing t[%d]=%.1f\n", iL, time[iL]);
    }
    ix1=ix0+1;  
    for (int i=iL; i>iMax[bunch]; i--) {
      if (ampX[i]<0.5*ApMax[bunch]) ix1=i;
      else break; 
    }    
    if (Dbg || ReportMode==10024) {
      printf("[Signal->FindPulseParams2010] First Sample after iMax=%d and A<0.5*Amax = t[%d]=%.1f\n", iMax[bunch], ix1, time[ix1]);
    }  
    T1halfMax[bunch]=time[ix1]*(0.5*ApMax[bunch]-ampX[ix0])+time[ix0]*(ampX[ix1]-0.5*ApMax[bunch]);
    T1halfMax[bunch]/=(ampX[ix1]-ampX[ix0]);

    ix0=0;
    ix1=0;
    for (int i=iL; i<iMin[bunch]; i++) {
      if (amp1[i]>0.5*ApMin[bunch]) ix0=i;
      else break;
    }
    for (int i=iMin[bunch]; i>iL; i--) {
      if (amp1[i]<0.5*ApMin[bunch]) ix1=i;
    }
    T0halfMin[bunch]=time[ix1]*(0.5*ApMin[bunch]-amp1[ix0])+time[ix0]*(amp1[ix1]-0.5*ApMin[bunch]);
    T0halfMin[bunch]/=(amp1[ix1]-amp1[ix0]);

    //ix0=-100;
    ix0=iMin[bunch];
    ix1=0;
    ix2=-100;
 
    if (Dbg)  printf("[TSignal->FindPulseParam2010] %s bunch#%d minSample#%d minA=%.2f t1=%.1f\n", 
             Name, bunch, iMin[bunch], ApMin[bunch], t1);

    for (int i=iMin[bunch]; i<nSlice && time[i]<t1; i++) {
      if (Dbg) printf("    sample#%3d t=%.1f amp=%.1f \n", i, time[i], amp1[i]); 
      if (amp1[i]<0.5*ApMin[bunch]) ix0=i;
      if (ix2==-100 && amp1[i]>0.5*ApMin[bunch]) ix2=i;
      iL=i;
      if (Dbg) printf("            iL=%d ix0=%d ix2=%d\n", iL, ix0, ix2);
    }
    
    bool in=false;
    for (int i=iL; i>iMin[bunch]; i--) {
      if (amp1[i]>0.5*ApMin[bunch]) {
        ix1=i;
        in=true;
      } else if (in) break;
    }

    if (Dbg || ReportMode==10024) {
     printf("[Signal->FindPulseParams2010] ix0=%d ix1=%d ix2=%d iLast=%d\n", 
       ix0, ix1, ix2, iL);
    }
    
    T1halfMin[bunch]=time[ix1]*(0.5*ApMin[bunch]-amp1[ix0])+time[ix0]*(amp1[ix1]-0.5*ApMin[bunch]);
    T1halfMin[bunch]/=(amp1[ix1]-amp1[ix0]);

    if (ProcStatus->GetRunHeader()->Attn) { // correct for the 20dB attenuator at high luminocity //
      ApMaxCal[bunch]=ApMax[bunch]*ProcStatus->GetRunHeader()->AttnCorr;
      ApMinCal[bunch]=ApMin[bunch]*ProcStatus->GetRunHeader()->AttnCorr;
    } else {
      ApMaxCal[bunch]=ApMax[bunch];
      ApMinCal[bunch]=ApMin[bunch];
    }

    if (!ProcStatus->GetUseFit()) { // use Tpeak and Apeak as estimation of the time and response //
      if (Dbg || ReportMode==10015) {
        printf("[Signal->FindPulseParams2010] %20s bunch#%d Status=%d T=%6.1f A=%.1f\n", 
                Name, bunch, ResponseStatus[bunch], Time[bunch], Response[bunch]);
      }
    }    

    
    if (T0cross[bunch]-TpMax[bunch]>125.0 || 
        T0cross[bunch]-TpMax[bunch]<20.) goodParab[bunch]=false; // bad zero crossing time;
    if (T0foot[bunch]-TpMax[bunch]>-20.    || 
        T0foot[bunch]-Tbunch<-75.) goodParab[bunch]=false; // bad pulse start time;


    if (Dbg || ReportMode==10024) {
      printf("[Signal->FindPulseParams2010] HalMax=(%.1f...%.1f), Tcross=%.1f\n", 
               T0halfMax[bunch], T1halfMax[bunch], T0cross[bunch]);
      printf("[Signal->FindPulseParams2010] HalMin=(%.1f...%.1f), Tfoot=%.1f\n", 
              T0halfMin[bunch], T1halfMin[bunch], T0foot[bunch]);
    }

    Dbg=false;

    if (Dbg || ReportMode==10024 && ApMax[bunch]>10.) { 
      char TitleC[200];
      sprintf(TitleC,"Run#%d Spill#%d Evt#%d(%d) Bunch#%d %s", EH->run, EH->burst, EH->event, EH->burstEvent, bunch, Name);
      TCanvas *PulseParamCanvas = new TCanvas("PulseParams", TitleC, 500, 0, 800, 800);
      printf("[TSignal->FindPulseParams2010] creating new canvas PulseParams %s\n", TitleC);    
      SetGraph();
      printf("[Signal->FindPulseParams2010] GraphPoints=%d t0=%.1f t1=%.1f A=%.1f...%.1f\n", 
              signalShape->GetN(), t0, t1, minLocal[bunch], maxLocal[bunch]);
      PulseParamCanvas->cd(0);
      double dd=0.05*(maxLocal[bunch]-minLocal[bunch]);
      TH1F *dummySignal = new TH1F(Name, TitleC, 200, t0, t1);
      //TH1F *dummySignal = new TH1F(Name, TitleC, 200, t0, t1-500.);
      dummySignal->GetYaxis()->SetRangeUser(minLocal[bunch]-dd, maxLocal[bunch]+dd);
      dummySignal->Draw();
      PulseParamCanvas->Update();

      TLine *HalfMax = new TLine(T0halfMax[bunch], 0.5*ApMax[bunch], T1halfMax[bunch], 0.5*ApMax[bunch]);
      HalfMax->SetLineWidth(3);
      HalfMax->SetLineColor(kGreen);
      HalfMax->Draw();
      TLine *HalfMin = new TLine(T0halfMin[bunch], 0.5*ApMin[bunch], T1halfMin[bunch], 0.5*ApMin[bunch]);
      HalfMin->SetLineWidth(3);
      HalfMin->SetLineColor(kGreen);
      HalfMin->Draw();
      TLine *Cross = new TLine(T0cross[bunch], 0.5*ApMax[bunch], T0cross[bunch], 0.5*ApMin[bunch]);
      Cross->SetLineWidth(2);
      Cross->SetLineColor(kGreen);
      Cross->Draw();

      TLine *TB = new TLine(Tbunch, maxLocal[bunch]+dd, Tbunch, minLocal[bunch]-dd);
      TB->SetLineWidth(3);
      TB->SetLineColor(kRed);
      TB->Draw();

      TLine *Tlmax = new TLine(TpMax[bunch], 0., TpMax[bunch], ApMax[bunch]);
      Tlmax->SetLineWidth(3);
      Tlmax->SetLineColor(kBlue);
      Tlmax->Draw();

      TLine *Tlmin = new TLine(TpMin[bunch], 0., TpMin[bunch], ApMin[bunch]);
      Tlmin->SetLineWidth(3);
      Tlmin->SetLineColor(kBlue);
      Tlmin->Draw();

      TLine *Tlfoot = new TLine(T0foot[bunch], 0.2*ApMax[bunch], T0foot[bunch], -0.2*ApMax[bunch]);
      Tlfoot->SetLineWidth(3);
      Tlfoot->SetLineColor(kBlue);
      Tlfoot->Draw();

      TLine *Tlfoot1 = new TLine(T0foot[bunch], 0., T0halfMax[bunch], 0.5*ApMax[bunch]);
      Tlfoot1->SetLineWidth(1);
      Tlfoot1->SetLineColor(kBlue);
      Tlfoot1->Draw();

      PulseParamCanvas->Update();

      signalShape->Draw("LPZz same");


      PulseParamCanvas->Update();
      
      int ReportMode = ProcStatus->WhatToDo("[FindPulseParams2010]", 10024);
      if (ReportMode>0) {
        PulseParamCanvas->Close();
        dummySignal->Delete();
      }
    }
  }

  bool GetUnderflowStatus(int bunch) {return Underflow[bunch];}
  bool GetOverflowStatus(int bunch)  {return Overflow[bunch];}
  double GetApMaxCal(int bunch)    {return ApMaxCal[bunch];}
  double GetApMinCal(int bunch)    {return ApMinCal[bunch];}
  double GetApMaxADC(int bunch)    {return ApMax[bunch];}
  double GetApMinADC(int bunch)    {return ApMin[bunch];}
  double GetTpMax(int bunch)       {return TpMax[bunch];}
  double GetTpMin(int bunch)       {return TpMin[bunch];}
  double GetTfoot(int bunch)       {return T0foot[bunch];}
  double GetTcross(int bunch)      {return T0cross[bunch];}
  double GetTmaxLocal(int bunch)   {return tMaxLocal[bunch];}
  double GetTminLocal(int bunch)   {return tMinLocal[bunch];}
  double GetMaxLocal(int bunch)    {return maxLocal[bunch];}
  double GetMinLocal(int bunch)    {return minLocal[bunch];}
  bool   GetParabStatus(int bunch) {return goodParab[bunch];}

  double GetThalfMax(int bunch)    {
    return T1halfMax[bunch]-T0halfMax[bunch];
  }
  double GetThalfMin(int bunch)    {
    return T1halfMin[bunch]-T0halfMin[bunch];
  }

  double parabAA(double y1, double y2, double y3) {
    return 0.5*(y1+y3-2.0*y2);
  }
  double parabT0(double y1, double y2, double y3) {
    double dT=0.5*(y3-y1)/(2.0*y2-y1-y3);
    //cout << "(" << y1 << ", " << y2 << ", " << y3 << ")->" << dT << endl; 
    return dT;
  }

  void SaveRaw() {
    for (int i=0;i<nSlice;i++) {
      old[i]=raw[i];
    }
    oldIsSet=true;
  }

  void DumpOldRaw(int nDump) {
    printf("[TSignal->DumpOldRaw] %s  --->\n", Name);
    int MyDump=nDump;
    if (MyDump>nSlice) MyDump=nSlice;
    if (MyDump==0) MyDump=20;
    printf(" sample  previous   current\n");
    for (int i=0;i<MyDump;i++) {
      printf("%4d  %6.0f  %6.0f", i, old[i]-PedMean, raw[i]-PedMean);
      if (raw[i]==old[i]) {
        printf(" =");
      } else {
        printf("  ");
      }
      if (i>0) {
        if (raw[i]==old[i-1]) {
          printf(" >");
        } else {
          printf("  ");
        }
        if (raw[i-1]==old[i]) {
          printf(" <");
        } else {
          printf("  ");
        }
      }
      printf("\n");
    }
  }

  void ClearOld() {oldIsSet=false;};

  int CountTrains() {
    isClone=false;
    isTrain=false;
    nTrains=0;
    xTrain=0;
    sTrain=0;
    aTrain=0.0;
    bool inTrain=false;

    if (!oldIsSet) return nTrains;
    
    for (int i=1;i<nSlice;i++) {
      if (old[i]==raw[i-1] || raw[i]==old[i]) { // entering the Train
        sTrain++;
        if (!inTrain) {
          inTrain=true;
          mTrain[nTrains]=1;
          iTrain[nTrains]=i;
        } else {
          mTrain[nTrains]++;
        }
      } else {
        if (inTrain) { // leaving the Train
          if (mTrain[nTrains]>200) isClone=true;
          else if (mTrain[nTrains]>50) {
            isTrain=true;
            printf("[TSignal] found train of %d samples\n", mTrain[nTrains]);
          }
          lTrain[mTrain[nTrains]]++;
          aTrain+=mTrain[nTrains];
          if (mTrain[nTrains]>xTrain) xTrain=mTrain[nTrains];
          nTrains++;
          inTrain=false;
        }
      }

      //printf("[TSignal->CountTrains] %s sample#%d\t Raw=%4d Old=%4d\n", Name, i, raw[i], old[i]);
    }
    if (inTrain) { // signal's ends with train of identicals //
      //printf("Signal %s ends with %d identicals\n", Name, mTrain[nTrains]);
      if (mTrain[nTrains]>200) isClone=true;
      else if (mTrain[nTrains]>50) {
        isTrain=true;
        printf("[TSignal] found train of %d samples\n", mTrain[nTrains]);
      }
      lTrain[mTrain[nTrains]]++;
      if (mTrain[nTrains]>xTrain) xTrain=mTrain[nTrains];
      aTrain+=mTrain[nTrains];
      nTrains=1;
    }
    if (nTrains>0) aTrain/=nTrains;
    wTrain[sTrain]++;
    return nTrains;
  }

  void ClearTrains() {
    for (int i=0;i<nSlice;i++) {
      lTrain[i]=0;
      wTrain[i]=0;
    }
  }

  bool IsClone() {return isClone;}
  bool IsTrain() {return isTrain;}

  int GetTrains() {return nTrains;}
  int GetIdentical() {return sTrain;}


  int GetTrainSize(int it) {
    if (it<nTrains && it>=0) {
      return mTrain[it];
   } else {
     printf("[TSignal->GetTrain] nTrains=%d wrong train request it=%d\n", nTrains, it); 
     return -1;
   }
  }

  int GetTrainStat(int it) {
    if (it<=nSlice && it>=0) {
      return lTrain[it];
    } else {
      printf("[TSignal->GetTrain] nSlice=%d wrong train size request it=%d\n", nSlice, it); 
      return -1;
    }
  }
 
  int GetSameStat(int it) {
    if (it<=nSlice && it>=0) {
      return wTrain[it];
    } else {
      printf("[TSignal->GetSame] nSlice=%d wrong train size request it=%d\n", nSlice, it); 
      return -1;
    }
  }

   int GetTrainPosition(int it) {
    if (it<nTrains && it>=0) {
      return iTrain[it];
   } else {
     printf("[TSignal->GetTrain] nTrains=%d wrong train request it=%d\n", nTrains, it); 
     return -1;
   }
  }


  double GetAtrain() {
    return aTrain;
  }

  int GetmaxTrain() {
    return xTrain;
  }

  void PrintTrains0() { // summary
    printf("[TSignal->Trains] %s\t %4d trains, average=%.1f longest=%4d total=%d\n", Name, nTrains, aTrain, xTrain, sTrain); 
  }

  void PrintTrains1() { // train length stats
    for (int i=1; i<nSlice; i++) {
      if (lTrain[i]>0) printf("   %4d -> %d counted\n", i, lTrain[i]);
    }
  }

  void PrintTrains2() { // train details
    for (int i=1; i<nTrains; i++) {
      printf("      train#%4d -> start=%4d size=%d\n", i, iTrain[i], mTrain[i]);
    }
  }
  void PrintTrains3() { // train details
    printf("------- Signal-> %s\n", Name);
    for (int i=1; i<nTrains; i++) {
      if (lTrain[i]>0) printf("   %4d -> %d counted\n", i, lTrain[i]);
    }
  }

  double GetPedestalTailCorr(int bunch)  {
    if (bunch<0 || bunch>24) return 0.0;
    return PedestalTailCorr[bunch];
  }
  void   SetPedestalTailCorr(double PTC, int bunch) {
    if (bunch<0 || bunch>24) return;
    PedestalTailCorr[bunch]=PTC;
  }

  void ComputeThalfOld(double Tbunch, int bunch) { // computes Thalf for a bunch

    int iNear=-1;
    double dTnear=100000.;
    int i0=int((Tbunch-time[0])/12.5)-2;
    int i1=int((Tbunch-time[0])/12.5)+3;
    if (i0<1) i0=1; 
    if (i1>nSlice-1) i1=nSlice-1;
      //printf("%10s bunch#%d samples [%d,%d]\n", Name, ib, i0, i1);
    for (int is=i0; is<i1; is++) {
      if (fabs(time[is]-Tbunch)<dTnear) {
        iNear=is;
        dTnear=fabs(time[is]-Tbunch);
      }
    }

    int iNearNew=iNear;
    if (amp1[iNear-1]>amp1[iNearNew]) {
      iNearNew=iNear-1;
    }
    if (amp1[iNear+1]>amp1[iNearNew]) {
      iNearNew=iNear+1;
    }
    iNear=iNearNew;
      //printf("    sample nearest to bunch is=%d dT=%.2f A=(%.1f, %.1f %.1f)\n", 
      //       iNear, dTnear, amp1[iNear-1], amp1[iNear], amp1[iNear+1]);
    Anear[bunch]=amp1[iNear];
      //printf("    Amax=%.1f\n", amp1[iNear]);
    int iL=-1000;
    int iR=-1000;
    double Ahalf=0.5*Anear[bunch];

    for (int is=iNear; is>0; is--) {
      iL=is;
      if (amp1[is]<Ahalf) break;
    }
    TLdown[bunch]=(time[iL]*(amp1[iL+1]-Ahalf)+time[iL+1]*(Ahalf-amp1[iL]))/(amp1[iL+1]-amp1[iL]);
      //printf("     Tleft=%.1f iLeft=%d\n", TLdown[ib], iL);
  
    for (int is=iNear; is<nSlice; is++) {
        //printf("    i0=%d is=%d iR=%d Ahalf=%.1f A(is)=%.1f\n", i0, is, iR, Ahalf, amp1[is]);
      if (amp1[is]<Ahalf) break;
      iR=is;
    }
    TRdown[bunch]=(time[iR+1]*(amp1[iR]-Ahalf)+time[iR]*(Ahalf-amp1[iR+1]))/(amp1[iR]-amp1[iR+1]);
      //printf("     Tright=%.1f iRight=%d\n", TRdown[ib], iR);
    Thalf[bunch]=TRdown[bunch]-TLdown[bunch];
    
  }

  double GetTRdown(int ib) {
    return TRdown[ib];
  }
  double GetTLdown(int ib) {
    return TLdown[ib];
  }
  double GetThalf(int ib) {
    return Thalf[ib];
  }



  void ComputeThalf(double Tbunch, int bunch) { // computes Thalf for a bunch

    if (ProcStatus->GetReportMode()==1) Dbg=true;
    if (Dbg) printf("[ComputeThalf(int, double)]-> %s bunch#%d Tbunch=%.1f\n", Name, bunch, Tbunch);
    int iNear=-1;
    double dTnear=100000.;
    int i0=int((Tbunch-time[0])/12.5)-3;
    int i1=int((Tbunch-time[0])/12.5)+4;
    if (i0<1) i0=1; 
    if (i1>nSlice-1) i1=nSlice-1;
    int iLeft=i0;
    int iRight=i1;
    //printf("%10s bunch#%d samples [%d,%d]\n", Name, ib, i0, i1);
    for (int is=i0; is<i1; is++) {
      if (time[is]<Tbunch) iLeft=is;
      if (fabs(time[is]-Tbunch)<dTnear) {
        iNear=is;
        dTnear=fabs(time[is]-Tbunch);
      }
    }
    iLeft=iNear-1;
    iRight=iNear+1;
    if (iLeft<0)   iLeft=0;
    if (iRight>nSlice-1) iRight=nSlice-1;
    double s4=0.0;
    double s3=0.0;
    double s2=0.0;
    double s1=0.0;
    double s2Y=0;
    double s1Y=0;
    double s0Y=0;
    double s0=0;

    if (Dbg) printf("    samples: ");
    for (int is=iLeft-1; is<iRight+2; is++) {
      double d=time[is]-Tbunch;
      if (Dbg) printf(" [%d]=(t=%.1f, a=%.1f)", is, time[is], amp1[is]),
      s4+=d*d*d*d;
      s3+=d*d*d;
      s2+=d*d;
      s1+=d;
      s0+=1.0;
      s0Y+=amp1[is];
      s1Y+=amp1[is]*d;
      s2Y+=amp1[is]*d*d;
    }
    s4/=s0;
    s3/=s0;
    s2/=s0;
    s1/=s0;
    s2Y/=s0;
    s1Y/=s0;
    s0Y/=s0; 
    double det0=s4*s2+2.0*s3*s2*s1-s2*s2*s2-s3*s3-s4*s1*s1;
    double detA=s2Y*(s2-s1*s1)+   s1Y*(s1*s2-s3)   +s0Y*(s1*s3-s2*s2);
    double detB=s2Y*(s1*s2-s3)+   s1Y*(s4-s2*s2)   +s0Y*(s2*s3-s1*s4);
    double detC=s2Y*(s1*s3-s2*s2)+s1Y*(s2*s3-s1*s4)+s0Y*(s2*s4-s3*s3);
    if (Dbg) printf("\n det0=%.2f detA=%.2f  detB=%.2f  detC=%.2f\n", 
                     det0, detA, detB, detC);


    Tnear[bunch]=time[iNear];
    if (det0==0.) {
      Anear[bunch]=amp1[iNear];
      if (Dbg) printf("   case#1 det0=0 \n");
    } else {
      detA/=det0;
      detB/=det0;
      detC/=det0;
      if (detA>=0.) {
        Anear[bunch]=amp1[iNear];
        if (Dbg) printf("   case#2 A>0 \n");
      } else {
        double t00=-0.5*detB/detA;
        double Tpar=Tbunch+t00;
        if (Tpar>time[iRight+1] || Tpar<time[iLeft-1]) { // peak far away
          Anear[bunch]=amp1[iNear];
          if (Dbg) printf("   case#3 bad peak time=%.1f [%.1f, %.1f]\n", Tpar, time[iLeft-1], time[iRight+1]);
        } else {
          Anear[bunch]=detA*t00*t00+detB*t00+detC;
          Tnear[bunch]=Tpar;
        }
      }
      if (Dbg) printf("    A=%.1f\n-----------\n", Anear[bunch]);
    }   
// compute pedestal and noise in front of the bunch...
    double w=0.0;
    Anois[bunch]=0.0;
    Anodd[bunch]=0.0;
    Aped[bunch]=0.0;
    Sodd[bunch]=0.0;
    for (int is=iNear; is>0 && time[is]>Tnear[bunch]-Tped0; is--) {
      if (time[is]<Tnear[bunch]-Tped1) {
        w+=1.0;
        Aped[bunch]+=amp1[is];
        Sodd[bunch]+=ampOdd[is];
        Anois[bunch]+=amp1[is]*amp1[is];
        Anodd[bunch]+=ampOdd[is]*ampOdd[is];
      }
    }
    Aped[bunch]/=w;
    Anois[bunch]/=w;
    Sodd[bunch]/=w;
    Anodd[bunch]/=w;
    Anois[bunch]-=Aped[bunch]*Aped[bunch];
    Anodd[bunch]-=Sodd[bunch]*Sodd[bunch];
    Anois[bunch]=sqrt(Anois[bunch]);
    Anodd[bunch]=sqrt(Anodd[bunch]);
// ---- subtract pedestal ---?
    Anear[bunch]-=Aped[bunch];
// ----
    int iL=-1000;
    int iR=-1000;
    double Ahalf=0.5*Anear[bunch];

    for (int is=iNear; is>0; is--) {
      iL=is;
      if (amp1[is]<Ahalf) break;
    }
    TLdown[bunch]=(time[iL]*(amp1[iL+1]-Ahalf)+time[iL+1]*(Ahalf-amp1[iL]))/(amp1[iL+1]-amp1[iL]);
      //printf("     Tleft=%.1f iLeft=%d\n", TLdown[ib], iL);
  
    for (int is=iNear; is<nSlice; is++) {
        //printf("    i0=%d is=%d iR=%d Ahalf=%.1f A(is)=%.1f\n", i0, is, iR, Ahalf, amp1[is]);
      if (amp1[is]<Ahalf) break;
      iR=is;
    }
    TRdown[bunch]=(time[iR+1]*(amp1[iR]-Ahalf)+time[iR]*(Ahalf-amp1[iR+1]))/(amp1[iR]-amp1[iR+1]);
    //printf("     Tright=%.1f iRight=%d\n", TRdown[ib], iR);
    Thalf[bunch]=TRdown[bunch]-TLdown[bunch];
    if (Dbg) printf("[ComputeThalf(int, double)]->Done;\n");
    Dbg=false;
  }
//-----------------------------------------------------------------//
  bool parab2011(double Tbunch, int bunch) {
    //if (ProcStatus->GetReportMode()==1) Dbg=true;
    if (Dbg) printf("[ComputeThalf(int, double)]-> %s bunch#%d Tbunch=%.1f\n", Name, bunch, Tbunch);
    int iNear=-1;
    double dTnear=100000.;
    int i0=int((Tbunch-time[0])/12.5)-3;
    int i1=int((Tbunch-time[0])/12.5)+4;
    if (i0<1) i0=1; 
    if (i1>nSlice-1) i1=nSlice-1;
    int iLeft=i0;
    int iRight=i1;
    //printf("%10s bunch#%d samples [%d,%d]\n", Name, ib, i0, i1);
    for (int is=i0; is<i1; is++) {
      if (time[is]<Tbunch) iLeft=is;
      if (fabs(time[is]-Tbunch)<dTnear) {
        iNear=is;
        dTnear=fabs(time[is]-Tbunch);
      }
    }
    iLeft=iNear-1;
    iRight=iNear+1;
    double s4=0.0;
    double s3=0.0;
    double s2=0.0;
    double s1=0.0;
    double s2Y=0;
    double s1Y=0;
    double s0Y=0;
    double s0=0;

    if (Dbg) printf("    samples: ");
    for (int is=iLeft-1; is<iRight+2; is++) {
      double d=time[is]-Tbunch;
      if (Dbg) printf(" [%d]=(t=%.1f, a=%.1f)", is, time[is], amp1[is]),
      s4+=d*d*d*d;
      s3+=d*d*d;
      s2+=d*d;
      s1+=d;
      s0+=1.0;
      s0Y+=amp1[is];
      s1Y+=amp1[is]*d;
      s2Y+=amp1[is]*d*d;
    }
    s4/=s0;
    s3/=s0;
    s2/=s0;
    s1/=s0;
    s2Y/=s0;
    s1Y/=s0;
    s0Y/=s0; 
    double det0=s4*s2+2.0*s3*s2*s1-s2*s2*s2-s3*s3-s4*s1*s1;
    double detA=s2Y*(s2-s1*s1)+   s1Y*(s1*s2-s3)   +s0Y*(s1*s3-s2*s2);
    double detB=s2Y*(s1*s2-s3)+   s1Y*(s4-s2*s2)   +s0Y*(s2*s3-s1*s4);
    double detC=s2Y*(s1*s3-s2*s2)+s1Y*(s2*s3-s1*s4)+s0Y*(s2*s4-s3*s3);
    if (Dbg) printf("\n det0=%.2f detA=%.2f  detB=%.2f  detC=%.2f\n", 
                     det0, detA, detB, detC);


    Tpar[bunch]=time[iNear];
    if (det0==0.) {
      Apar[bunch]=amp1[iNear];
      if (Dbg) printf("   case#1 det0=0 \n");
    } else {
      detA/=det0;
      detB/=det0;
      detC/=det0;
      if (detA>=0.) {
        Apar[bunch]=amp1[iNear];
        if (Dbg) printf("   case#2 A>0 \n");
      } else {
        double t00=-0.5*detB/detA;
        double Tp=Tbunch+t00;
        if (Tp>time[iRight+1] || Tp<time[iLeft-1]) { // peak far away
          Apar[bunch]=amp1[iNear];
          if (Dbg) printf("   case#3 bad peak time=%.1f [%.1f, %.1f]\n", Tp, time[iLeft-1], time[iRight+1]);
        } else {
          Apar[bunch]=detA*t00*t00+detB*t00+detC;
          Tpar[bunch]=Tp;
        }
      }
      if (Dbg) printf("    A=%.1f\n-----------\n", Apar[bunch]);
    }   
    return true;
  } 


  bool parabNew(double t1, double y1, double t2, double y2, double t3, double y3, int i0, int bunch) { 

    bool Dbg=false;

    if (iMod==1 && iChan==3 && false) {
      Dbg=true;
      printf("[TSignal->parabNew] ***Dump*** %s bunch#%d\n", Name, bunch);
    }

    if (y2<y1 || y2<y3) { // wrong case!!!
      Tpar[bunch]=t2;
      Apar[bunch]=(y1+y2+y3)/3.0;
      if (y1*y1+y2*y2+y3*y3<36.0*(PedRMSmean*PedRMSmean+1.) || i0>nSlice-3) { // signals are small or late, who carez!
        Dbg=false; 
        return true;
      }
      if (Dbg) {
        printf("[TSignal->parabNew] ***WrongCase*** y2<y1 || y2<y3 %s bunch#%d i0=%d\n", Name, bunch, i0);
        printf("                   slice#%d of %d\n", i0, nSlice);
        printf("                   t1=%6.1f t2=%6.1f t3=%6.1f\n", t1, t2, t3);  
        printf("                ** y1=%6.1f y2=%6.1f y3=%6.1f -> %6.1f noise=%.1f\n", 
                                   y1, y2, y3, y1*y1+y2*y2+y3*y3, PedRMSmean);  
        ProcStatus->SetReportMode(1);
      }
      Dbg=false; 
      return false;
    }
    if (t2<t1 || t3<t2) { // wrong case!!!
      printf("[TSignal->parabNew] ***WrongCase*** t2<t1 || t3<t2 %s bunch#%d i0=%d\n", Name, bunch, i0);
      printf("                ** t1=%6.1f t2=%6.1f t3=%6.1f\n", t1, t2, t3);  
      printf("                   y1=%6.1f y2=%6.1f y3=%6.1f\n", y1, y2, y3);  
      Tpar[bunch]=-1000.;
      Apar[bunch]=-1000.;
      exit(-1);
      Dbg=false; 
      return false;
    }

    double det0 = t1*t2*(t1-t2) + t1*t3*(t3-t1) + t2*t3*(t2-t3);

    if (det0==0.0) {
      printf("[TSignal->parabNew] ***WrongCase*** det0==0.0 %s bunch#%d i0=%d\n", Name, bunch, i0);
      printf("          det=0.!  t1=%6.1f t2=%6.1f t3=%6.1f\n", t1, t2, t3);  
      Tpar[bunch]=-1000.;
      Apar[bunch]=-1000.;
      exit(-1);
      Dbg=false; 
      return false;
    }

    double a = y1*(t2-t3) + y2*(t3-t1) + y3*(t1-t2);
    double b = y1*(t3*t3-t2*t2) + y2*(t1*t1-t3*t3) + y3*(t2*t2-t1*t1);
    double c = y1*t2*t3*(t2-t3) + y2*t3*t1*(t3-t1) + y3*t1*t2*(t1-t2);

    a/=det0;
    b/=det0;
    c/=det0;

    if (a!=0.0) { 
      Tpar[bunch]=-0.5*b/a;
      Apar[bunch]=c+Tpar[bunch]*(b+Tpar[bunch]*a);
    } else {
      Tpar[bunch]=t2;
      Apar[bunch]=y2;
    }

    if (Dbg && nSlice>400) {
      printf(" sample   time -> %7.1f, %7.1f, %7.1f\n", t1, t2, t3);
      printf(" sample signal -> %7.1f, %7.1f, %7.1f\n", y1, y2, y3);
      printf("       Trec=%7.1f Arec=%7.1f\n\n", Tpar[bunch], Apar[bunch]);
    }
    Dbg=false;     
    return true;
  }

  bool computeSinParams() {
// fit of the RF sin wave
    bool result=true;
    double pst[4];
    double pst0[4];
    double chi2old, chi2new;
    double par[4]; // parameters for par[0]+par[1]*sin(par[2]*(t-par[3]));
    double pan[4];

    double wT=0.; 
    double sT=0.;
    double rT=0.;
    double wT1=0.; 
    double sT1=0.;
    double rT1=0.;
    double wT2=0.; 
    double sT2=0.;
    double rT2=0.;
    double tp=-100000.; 
    double tm=-100000.;
    double tcross=0.;
    double amx=-1.0e10;
    double ami=1.0e10;
    double avr=0.;

    //Dbg=true;
    //Dbg=true;

    avr=0.0;
    amx=-1.0e10;
    ami=1.0e10;
    for (int is=0; is<nSlice; is++) {
      avr+=raw[is];
      if (raw[is]>amx) amx=raw[is];
      if (raw[is]<ami) ami=raw[is];
    }
    avr/=double(nSlice);
    par[0]=avr;
    par[1]=0.5*(amx-ami);
    
    if (Dbg) printf("[TSignal->computeSinParams] fitting RF for %s\n", Name);
    if (Dbg) printf("[TSignal->computeSinParams] a0=%.1f Amp=%.1f\n", par[0], par[1]);

    for (int is=0; is<nSlice; is++) {ampS[is]=raw[is]-avr;}

    tp=-100000.; 
    tm=-100000.;
    sT=0.0;
    rT=0.0;
    wT=0.0;
    for (int is=1; is<nSlice; is++) {
      if (ampS[is-1]<=0.0 && ampS[is]>0.0) {
        tcross=(ampS[is]*time[is-1]-ampS[is-1]*time[is])/(ampS[is]-ampS[is-1]);
        if (tp>-1000.) {
          wT+=1.0;
          sT+=(tcross-tp);
          rT+=(tcross-tp)*(tcross-tp);
          //printf("[TSignal->computeSinParams] T=%.2f\t <T>=%.2f\n", tcross-tp, sT/wT);
        }
        tp=tcross;
      } else if (ampS[is-1]>=0.0 && ampS[is]<0.0) {
        tcross=(ampS[is]*time[is-1]-ampS[is-1]*time[is])/(ampS[is]-ampS[is-1]);
        if (tm>-1000.) {
          wT+=1.0;
          sT+=(tcross-tm);
          rT+=(tcross-tm)*(tcross-tm);
          //printf("[TSignal->computeSinParams] T=%.2f\t <T>=%.2f\n", tcross-tm, sT/wT);
        }
        tm=tcross;        
      }
    }
    sT/=wT;
    rT/=wT;
    rT-=sT*sT;
    if (rT<0.0) rT=0.0;
    else rT=sqrt(rT);
    par[2]=sT; // period
    pst0[2]=rT/sT;
    if (Dbg) printf("[TSignal->computeSinParams]      Period=%.2f+/-%.2f ns\n", sT, rT);
    par[2]=165.; //ns
    pst0[2]=0.1; //ns

/////// compute T0
    sT1=0.;
    wT1=0.;
    rT1=0.;
    sT2=0.;
    wT2=0.;
    rT2=0.;
    tp=-10000.;
    tm=-10000.;
    int iCount0=0;
    int iCount1=0;
    for (int is=1; is<nSlice; is++) {
      if (ampS[is-1]<=0.0 && ampS[is]>0.0) {
        tcross=(ampS[is]*time[is-1]-ampS[is-1]*time[is])/(ampS[is]-ampS[is-1]);
        wT1+=1.0;
        double tx=tcross-iCount0*par[2];
        sT1+=tx;
        rT1+=tx*tx;
        tp=tcross;
        iCount0++;
      }
    }

    sT1/=wT1;
    rT1/=wT1;
    rT1-=sT1*sT1;
    if (rT1<0.0) rT1=0.0;
    else rT1=sqrt(rT1);
    sT=sT1;
    rT=rT1;
    
    if (Dbg) printf("[TSignal->computeSinParams]      Phase=%.1f+/-%.1f ns\n", sT, rT);
    if (rT>2.) { // bad calculations, repeat the analysis with dump //
      sT1=0.;
      wT1=0.;
      rT1=0.;
      sT2=0.;
      wT2=0.;
      rT2=0.;
      tp=-10000.;
      tm=-10000.;
      iCount0=0;
      iCount1=0;
      for (int is=1; is<nSlice; is++) {
        printf(" [TSignal->computeSinParams]  is=%3d amp=%6.2f  ", is, ampS[is]);
        if (ampS[is-1]<0.0 && ampS[is]>=0.0) {
          tcross=(ampS[is]*time[is-1]-ampS[is-1]*time[is])/(ampS[is]-ampS[is-1]);
          wT1+=1.0;
          double tx=tcross-iCount0*par[2];
          printf("Tx=%.2f\t",tx);
          sT1+=tx;
          rT1+=tx*tx;
          printf("#0=%2d Tcross=%.2f\t <T0>=%.2f\n", iCount0, tcross, sT1/wT1);
          tp=tcross;
          iCount0++;
        } else {
          printf("\n");
        }
      }
      sT1/=wT1;
      rT1/=wT1;
      rT1-=sT1*sT1;
      if (rT1<0.0) rT1=0.0;
      else rT1=sqrt(rT1);

      printf("[TSignal->computeSinParams]  sT1=%.2f sT2=%.2f\n", sT1, sT2);
      sT=sT1;
      rT=rT1;
      printf("[TSignal->computeSinParams]      Phase=%.2f+/-%.2f ns\n", sT, rT);
    }

    par[3]=sT;
    
    par[2]=165.; //ns
    pst0[2]=0.02; //ns
    pst0[2]/=par[2]; // dT->dT/T

    par[2]=4.0*asin(1.)/par[2]; // angular frequency
    par[0]=0.0;                 // already subtracted!
    
    pst0[0]=0.1*par[1];
    pst0[1]=0.1*par[1];
    pst0[2]=pst0[2]*par[2]; // got to from dT/T = df/f to df
    pst0[3]=1.0;

    chi2old=0.;
    for (int is=0; is<nSlice; is++) {
      double a=par[0]+par[1]*sin(par[2]*(time[is]-par[3]));
      double diff=a-ampS[is];
      chi2old+=diff*diff;
    }
    chi2old/=(nSlice-5.);
    if (Dbg) printf("[TSignal->computeSinParams] staring fit with chi2/N=%f\n", chi2old);

    double pStep0, pStep;
    pStep0=0.0;
    for (int ip=0; ip<4; ip++) {
      pst[ip]=pst0[ip];
      pStep0+=1.0;
    }

    pStep=pStep0;
    int iLoop=0;
    while(iLoop<1000 && pStep>1.0e-3) {  // iteration loop
      pStep=0.0;
      for (int ips=0; ips<4; ips++) { // loop over parameters

        for (int ip=0; ip<4; ip++) {
          if (ip==ips) {
            pan[ip]=par[ip]+pst[ip];
          } else {
            pan[ip]=par[ip];
          }
        }

        chi2new=0.0;
        for (int is=0; is<nSlice; is++) {
          double a=pan[0]+pan[1]*sin(pan[2]*(time[is]-pan[3]));
          double diff=a-ampS[is];
          chi2new+=diff*diff;
        }
        chi2new/=(nSlice-5.);
        if (chi2new>chi2old) {
          pst[ips]*=-0.7;
        } else {
          par[ips]=pan[ips];
          pst[ips]*=1.1;
          chi2old=chi2new;
        }
        pStep+=(pst[ips]*pst[ips])/(pst0[ips]*pst0[ips]);
      }
      //printf("     #%10d pars=(%f\t %f\t %f\t %f)\t step=%f\t chi2=%f\n", iLoop, par[0], par[1], par[2], par[3], pStep, chi2old);  
 
      iLoop++;
    }
    par[4]=4.0*asin(1.)/par[2]; // back to period, ns
    //if (par[3]>par[4]) par[3]-=par[4]; // adjust phase to [0...T]

    if (Dbg) printf("     #%10d pars=(%.2f\t %.1f\t %.1f\t %.1f)\t step=%f\t chi2=%f\n", iLoop, par[0], par[1], par[4], par[3], pStep, chi2old);  
    for (int ip=0; ip<5; ip++) {
      sinPar[ip]=par[ip];
    }
//    for (int is=0; is<nSlice; is++) {amp1[is]=SignalCorrection*(raw[is]-par[0]-avr);}
    for (int is=0; is<nSlice; is++) {amp1[is]=raw[is]-par[0]-avr;}
    sinRes=sqrt(chi2old);
    EmptyEventPedestalSet=true;

    if (par[3]<135. && Dbg) {
      printf("[TSignal->computeSinParams] bad phase, sT=%.2f par[3]=%.2f\n", sT, par[3]);
      ProcStatus->SetReportMode(1);
    }
    return result;
  }

void FillRFcorr() {
  double Tg=ProcStatus->GetEventHeader()->GetTimeGlobal();
  double Arf=ProcStatus->GetEventHeader()->GetRFamp();
  double dT=sinPar[3]-Tg;
  corrRFphase->Fill(dT);
  if (dT<50.) dT+=165.;
  corrRFphase1->Fill(dT);
  corrRFampl->Fill(sinPar[1]/Arf); 
  corrRFped->Fill(sinPar[0]);
}

void SetRFcorrection(double dT, double A, double P) {
  corrRFdT=dT;
  corrRFa=A;
  corrRFp=P;
}

void SubtractRFcross() {
  double Tg=ProcStatus->GetEventHeader()->GetTimeGlobal();
  double Arf=ProcStatus->GetEventHeader()->GetRFamp();
  double RF=ProcStatus->GetEventHeader()->GetRFfreq();
  for (int i=0; i<nSlice; i++) {
    double corr=corrRFp+corrRFa*Arf*sin(RF*(time[i]-Tg-corrRFdT));
    raw[i]-=corr;
  }
}

void ResetRFcorr() {
  corrRFphase->Reset();
  corrRFphase1->Reset();
  corrRFampl->Reset(); 
  corrRFped->Reset(); 
}

TH1D* GetRFcorrPhase() {
  return corrRFphase;   
}
TH1D* GetRFcorrPhase1() {
  return corrRFphase1;   
}
TH1D* GetRFcorrAmpl() {
  return corrRFampl;   
}
TH1D* GetRFcorrPed() {
  return corrRFped;   
}


void computeSinCross() { 
// fits sin wave to the non-RF channel, period is taken form the RF data
// parameters are offset, amplitude, phase
    double RFfreq=ProcStatus->GetEventHeader()->GetRFfreq();
    double rfT=4.0*asin(1.)/RFfreq;
    double Tg=ProcStatus->GetEventHeader()->GetTimeGlobal();
    double A0=0.;
    double Ac=0.;
    double T0=Tg-10.;
    double chi2old=1.0e10;
    double chi2new=0.0;
    int    iLoop=0;
    double stepT0=10.;
    double s0=double(nSlice);
    double s1=0.; //S(sin())
    double s2=0.; //S(sin()^2) 
    double y1=0.; //S(y);
    double y2=0.; //S(y*y);
    double y3=0.; //S(y*sin());

    for (int i=0; i<nSlice; i++) {
      y1+=raw[i]; 
      y2+=raw[i]*raw[i];
    }
   
    while (iLoop<1000 && fabs(stepT0)>0.1) {

      double T0new=T0+stepT0;
      s1=0.0;
      s2=0.0;
      y3=0.0; // pre-compute best A0 and Ac for given T0new
      for (int i=0; i<nSlice; i++) {
        double f=sin(RFfreq*(time[i]-T0new));
        s1+=f;
        s2+=f*f;
        y3+=f*raw[i];
      }
      double det0=s0*s2-s1*s1;
      double detA0=y1*s2-y3*s1;
      double detAc=s0*y3-y1*s1;
      A0=detA0/det0;
      Ac=detAc/det0;
      //printf("[TSignal->computeSinCross] %10s iteration#%03d a=%5.2f A=%5.2f\n",
      //       Name, iLoop, A0, Ac);
      double chi2comp=y2+s0*A0*A0+Ac*Ac*s2-2.0*A0*y1-2*Ac*y3+2*A0*Ac*s1;
           
       
    //compute chi2new;
      chi2new=0.0;
      chi2new=chi2comp;
/*
      for (int i=0; i<nSlice; i++) {
        double dd=raw[i]-(A0+Ac*sin(RFfreq*(time[i]-T0new)));
        chi2new+=dd*dd;
      }
*/
      //printf("[TSignal->computeSinCross]  chi2old=%.1f chi2new=%.1f  T=%.2f step=%.2f\n",
      //        chi2old, chi2new, T0, stepT0);

      if (chi2new<chi2old) {
        stepT0*=1.1;
        T0=T0new;
        chi2old=chi2new;
      } else {
        stepT0*=-0.65;
      }

      iLoop++;
    }
    sinPar[0]=A0;
    if (Ac<0.0) {
      Ac=-Ac;
      T0+=0.5*rfT;
    }
    sinPar[1]=Ac;
    sinPar[2]=RFfreq;
    sinPar[3]=T0;
    sinRes=chi2old/(nSlice-1.0); 
    if (ProcStatus->GetReportMode()==1) {
      printf("[TSignal->computeSinCross] %10s Fit n=%3d, dT0=%6.2f A0=%.1f\t Amp=%.1f\t chi2/Ndf=%.2f\n", 
              Name, iLoop, T0-Tg, A0, Ac, sinRes);
    }  
  }

  double getSinParam(int ip) {
    if (ip<0 || ip>4) {
      printf("[TSignal->getSinParam] requesting wrong parameter ip=%d\n", ip);
      exit(-1);
    }
    return sinPar[ip]; 
  }  

  double getSinWave(double t) {
    return sinPar[1]*sin(sinPar[2]*(t-sinPar[3]));
  }
 
  double getSinRes() {return sinRes;}

  void Scale(double scale) {
    //printf("[TSignal->Scale] scaling RF by factor %.3f, Arf=%.1f Anew=%.1f\n",
    //                         scale, sinPar[1], scale*sinPar[1]);
    for (int i=0; i<nSlice; i++) {
      amp1[i]*=scale;
      //if (i==0 && dumpIt) printf("[TSignal] point#6  amp1[0] set to %f\n", amp1[i]);
    }
  }

  void SetFFTsize(int n) {
    nSizeTail=n; 
    nSizeTail2=n/2;
    FFTreconstruction      = TVirtualFFT::FFT(1, &nSizeTail, "R2C ES K");
    FFTreconstruction_BACK = TVirtualFFT::FFT(1, &nSizeTail, "C2R M K");
    signalTail = (double*) calloc(nSizeTail, sizeof(double));
    signalFinal= (double*) calloc(nSizeTail, sizeof(double));
    slopeTail  = (double*) calloc(nSizeTail, sizeof(double));
    shiftTail  = (double*) calloc(nSizeTail, sizeof(double));
    fftAmp     = (double*) calloc(nSizeTail, sizeof(double));
    fftPhi     = (double*) calloc(nSizeTail, sizeof(double));
    fftR       = (double*) calloc(nSizeTail, sizeof(double));
    fftI       = (double*) calloc(nSizeTail, sizeof(double));
    Wcos       = (double*) calloc(nSizeTail, sizeof(double)); // e(-t/Te)*cos(t/Tc)
    Wsin       = (double*) calloc(nSizeTail, sizeof(double)); // e(-t/Te)*sin(t/Tc)
    for (int i=0; i<nSizeTail; i++) {
      signalFinal[i]=0.0;
      signalTail[i]=0.0;
      slopeTail[i]=0.0;
      shiftTail[i]=0.0;
      fftPhi[i]=0.0;
      fftR[i]=0.0;
      fftI[i]=0.0;
    }
  }

  int GetFFTsize() {
    return nSizeTail;
  } 

  void SetTransferFunction(int i, double gain, double phi) {
    if (i<0 || i>nSizeTail2) {
      printf("TSignal->SetTransferFunction] wrong index %d\n", i);
      exit(-1);
    }
    slopeTail[i]=gain/20.; // correct for nominal 20V/mA
    shiftTail[i]=phi;
  }

  void SetFFTtail(double T1, double T2) {
    Te=T1;
    Tc=T2;
    for (int i=0; i<nSizeTail; i++) {
      double t=i*dTsample;
      double ee=exp(-t/Te);
      Wcos[i]=ee*cos(pi2*t/Tc);
      Wsin[i]=ee*sin(pi2*t/Tc);
    }    
  }

  void DoFFTshape() {
    for (int i=0; i<nSizeTail; i++) {
      signalFinal[i]=0.0;
      fftAmp[i]=0.0;
      fftPhi[i]=0.0;
      fftR[i]=0.0;
      fftI[i]=0.0;
    }
    FFTreconstruction->SetPoints(signalTail);
    FFTreconstruction->Transform();
    FFTreconstruction->GetPointsComplex(fftR, fftI);
   
    for (int i=0; i<nSizeTail; i++) {
      fftR[i]/=(double)nSizeTail;
      fftI[i]/=(double)nSizeTail;
    }
    
    for (int i=0; i<nSizeTail2; i++) {
      fftAmp[i]=sqrt(fftR[i]*fftR[i]+fftI[i]*fftI[i]); 
      fftPhi[i]=atan2(fftI[i], fftR[i]);

      fftAmp[i]/=slopeTail[i]; 
      fftPhi[i]-=shiftTail[i];
      fftR[i]=fftAmp[i]*cos(fftPhi[i]);
      fftI[i]=fftAmp[i]*sin(fftPhi[i]);
    }
    
    FFTreconstruction_BACK->SetPointsComplex(fftR, fftI);
    FFTreconstruction_BACK->Transform();
    FFTreconstruction_BACK->GetPoints(signalFinal);

    double sped=0.;
    double wped=0.;
    int i0=firstSample[0];
    for (int iw=0; iw<NPedWindows; iw++) {
      for (int i=firstSample[iw]; i<lastSample[iw]; i++) {
        wped+=1.0;
        sped+=signalFinal[i-i0];
      }
    }
    sped/=wped;
    for (int i=0; i<nSizeTail; i++) {
      signalFinal[i]-=sped;
    }
    
  }

  void FixFFTbaseline() { // fixes residual baseline variation by fitting polynomial to pedestal intervals

    int nCorr=4;
    //nCorr=2;
    int nx=nCorr*2-1;
    bool dump=(nSlice==504 && iMod==0 && iGain==1 && iChan==4);

    for (int k=0; k<nx; k++) xP[k]=0.;
    for (int k=0; k<nCorr; k++) yP[k]=0.;
    for (int iw=0; iw<NGoodWindows; iw++) {
      for (int i=firstSample[iw]; i<lastSample[iw]; i++) {
        xP[0]+=1.0;
        xP[1]+=time[i];
      }
    }
    xAvr=xP[1]/xP[0];
    xP[1]=0.0;

    for (int iw=0; iw<NGoodWindows; iw++) {
      for (int i=firstSample[iw]; i<lastSample[iw]; i++) {
        double dt=time[i]-xAvr;
        double addx=dt; // 
        for (int k=1; k<nx; k++) {
          xP[k]+=addx;
          addx*=dt;
        }
        double addy=signalFinal[i-firstSample[0]];
        for (int k=0; k<nCorr; k++) {
          yP[k]+=addy;
          addy*=dt;
        }        
      }
    }
    for (int k=1; k<nx; k++) {
      xP[k]/=xP[0];
    }
    for (int k=0; k<nCorr; k++) {
      yP[k]/=xP[0];
    }
    if (dump) {
      //printf("[TSignal->FixFFTbaseline] nPoints=%f\n", xP[0]);
      for (int k=0; k<nx; k++) {
        printf("[TSignal->FixFFTbaseline]    <x^%d>=%e\n", k, xP[k]);
      }
      for (int k=0; k<nCorr; k++) {
        printf("[TSignal->FixFFTbaseline]    <y*x^%d>=%e\n", k, yP[k]);
      }
      
    }
    xP[0]=1.;
    //xP[1]=0.0;
    
    double detArr[4][4];
    double detSub[4][4]; // subdeterminant 3x3 for elemnt [i][j]
    double a33[3][3];
    double det0;
//  main determinant
    for (int i=0; i<nCorr; i++) {
      for (int j=0; j<nCorr; j++) {
        detArr[i][j]=xP[i+j];
      }
    }
    for (int ik=0; ik<nCorr; ik++) {
      for (int jk=0; jk<nCorr; jk++) {
        int i1=0;
        for (int i=0; i<nCorr; i++) {
          if (i==ik) continue;
          int j1=0;
          for (int j=0; j<nCorr; j++) {
            if (j==jk) continue;
            a33[i1][j1]=detArr[i][j];
            j1++;
          }
          i1++;
        }
        detSub[ik][jk]=a33[0][0]*a33[1][1]*a33[2][2]+a33[1][0]*a33[2][1]*a33[0][2]+a33[2][0]*a33[0][1]*a33[1][2]-
                       a33[0][2]*a33[1][1]*a33[2][0]-a33[0][1]*a33[1][0]*a33[2][2]-a33[0][0]*a33[1][2]*a33[2][1];
      }
    }

    det0=0.0;
    double w=1.;
    for (int i=0; i<nCorr; i++) {
      det0+=w*detArr[0][i]*detSub[0][i];
      w=-w;
    }

    double w0=1.;
    for (int ip=0; ip<nCorr; ip++) {
      double det=0;
      w=w0;
      for (int i=0; i<nCorr; i++) {
        det+=w*yP[i]*detSub[ip][i];
        w=-w;
      }
      
      wPoly[ip]=det/det0;
      w0=-w0;
    }

    int i00=firstSample[0];
    int i01=lastSample[NGoodWindows-1];
    if (dump) {
      printf("[TSignal->FixFFTbaseline] %s Polynomial coefs=%e\t %e\t %e\t %e\n",
             Name, wPoly[0], wPoly[1], wPoly[2], wPoly[3]);
      printf("[TSignal->FixFFTbaseline] %s time range=%f to %fns, <t>=%f\n",
             Name, time[i00], time[i01], xAvr);
    }
    for (int i=i00; i<i01; i++) {
      int i1=i-i00;
      double dt=time[i]-xAvr;
      double w=dt;
      polyCorr[i1]=wPoly[0];
      for (int k=1; k<nCorr; k++) {
        polyCorr[i1]+=wPoly[k]*w;
        w*=dt;
      }
      signalFinal[i1]-=polyCorr[i1];
    }
    
  }

  double GetPolyCorrection(int i) {
    if (i<0 || i>=nSlice) {
      printf("[TSignal->GetPolyCorrection] bad index %d, shall be [0...%d[\n", i, nSlice); 
      return 0.0;
    }
    return polyCorr[i];
  }
  

  double GetFinalSignal(int i) {
    if (i<0 || i>=nSizeTail) {
      printf("[TSignal->GetSignalFinal] bad index %d, shall be [0...%d[\n", i, nSizeTail); 
      return 0.0;
    }
    return signalFinal[i];
  }
  
};






double Fit1(Double_t *x, Double_t *par) {
  Double_t f, stretch, offpeak;
//par[0,1,2,3] pedestal, amplitude, t0, stretch
  stretch=par[3];
  
  stretch=par[3]-1.;
  offpeak=(x[0]-par[2])/50.;
  if (offpeak>1.0) stretch/=offpeak;
  stretch+=1.0; 
  
  f=par[0]+par[1]*xReference->GetRef((x[0]-par[2])*stretch);
  return f;
}


double Fit2(Double_t *x, Double_t *par) {
  Double_t f, stretch2, offpeak2, stretch1, offpeak1;
//par[0,1,2,3,4,5,6] pedestal, amplitude1+2, t1, stretch1, a2fraction, dt=t2-t1, stretch2
  stretch1=par[3];  
  stretch1=par[3]-1.;
  offpeak1=(x[0]-par[2])/50.;
  if (offpeak1>1.0) stretch1/=offpeak1;
  stretch1+=1.0; 
  
  stretch2=par[6];  
  stretch2=par[6]-1.;
  offpeak2=(x[0]-par[2]-par[5])/50.;
  if (offpeak2>1.0) stretch2/=offpeak2;
  stretch2+=1.0; 
  
  f=par[0]+par[1]*((1.0-par[4])*xReference->GetRef((x[0]-par[2])*stretch1)+
                         par[4]*xReference->GetRef((x[0]-par[2]-par[5])*stretch2));
  return f;
}

double Fit3(Double_t *x, Double_t *par) {
// special cubic polynome
  double dT=x[0]-par[1];
  double f=par[0]*(1.0+par[2]*dT*dT*(1.0+par[3]*dT));
  return f;
}


